﻿class SFXCameraAction_QuickTurn extends SFXCameraMode_Interpolate;

var int CurrentOffsetApplied;

function InitializeTransition(SFXCameraMode FromMode, SFXCameraMode ToMode, float Time, bool PreserveTarget)
{
    From = FromMode;
    To = ToMode;
    CurrentOffsetApplied = 0;
    bComplete = false;
    CurrentTime = 0;
    TotalTime = Time;
    if (TotalTime == 0)
    {
        TotalTime = 1E-05;
    }
    To.Owner = From.Owner;
}

function Tick(float TimeDelta)
{
    local float OffsetDelta;
    From.Tick(TimeDelta);
    if (From != To)
    {
        To.Tick(TimeDelta);
    }
    m_pov = From.m_pov;
    CurrentTime += TimeDelta;
    if (CurrentTime >= TotalTime)
    {
        bComplete = true;
        CurrentTime = TotalTime;
    }
    OffsetDelta = CurrentTime / TotalTime * 32767 - CurrentOffsetApplied;
    From.m_pov.Rotation.Yaw += OffsetDelta;
    CurrentOffsetApplied += OffsetDelta;
}

defaultproperties
{
    DefaultTime=0,7
}
