﻿class SFXShield_Energy_Player extends SFXShield_Energy
    hidecategories(Navigation)
    config(Weapon);

var config float DamageGateInterval;

var float DamageGateStartTime;

simulated function ApplyDamage(out float Damage, out TraceHitInfo HitInfo, out Vector HitLocation, out Vector Momentum, class<SFXDamageType> DamageType, Controller InstigatedBy, Actor DamageCauser)
{
    if (CurrentShields > 0)
    {
        DamageGateStartTime = WorldInfo.TimeSeconds;
    }
    ApplyDamage(Damage, HitInfo, HitLocation, Momentum, DamageType, InstigatedBy, DamageCauser);
    if (DamageType.Default.bIgnoresBleedout == false)
    {
        if (CurrentShields <= 0 && Owner.TimeSince(DamageGateStartTime) < DamageGateInterval)
        {
            Damage = 0;
        }
    }
}

defaultproperties
{
    DamageGateInterval=1
    bRechargeable=true
    bFastCoverRegen=true
    bAbsorbDamageOnBreak=true
}
