﻿class BioAnimNodeBlendByFireSequence extends AnimNodeBlendList
    hidecategories(Object,Object,Object)
    native;

const SHOTS_PER_LOOP_CYCLE = 5.0f;
enum EBioAnimNodeBlendByFireSequenceChild
{
    BIO_ANIM_NODE_BLEND_BY_FIRE_SEQUENCE_CHILD_IDLE,
    BIO_ANIM_NODE_BLEND_BY_FIRE_SEQUENCE_CHILD_START,
    BIO_ANIM_NODE_BLEND_BY_FIRE_SEQUENCE_CHILD_LOOP,
    BIO_ANIM_NODE_BLEND_BY_FIRE_SEQUENCE_CHILD_DEPRECATED,
    BIO_ANIM_NODE_BLEND_BY_FIRE_SEQUENCE_CHILD_END,
};

var transient float SliderPosition;

var transient Vector FlashLocation;

var transient int FlashCount;

var transient bool CacheUpdated;

var transient array<AnimNodeSequence> CachedAnimSeqEnd;

var transient array<AnimNodeSequence> CachedAnimSeqLoop;

var transient int QueuedTransition;

var() float BlendDuration;

final event NotifyWeaponAnimationPlaying(bool Playing)
{
    local Pawn Pawn;
    local SFXWeapon Weapon;
    Pawn = Pawn(SkelComponent.Owner);
    if (Pawn != None && Pawn.Weapon != None)
    {
        Weapon = SFXWeapon(Pawn.Weapon);
        if (Weapon != None)
        {
            Weapon.bFiringAnimationPlaying = Playing;
        }
    }
}

final event float GetPlayRate(AnimNodeSequence Seq)
{
    local float SeqLength;
    local float TimeForOneShot;
    local float TimeForAllShots;
    local float FireRate;
    local Pawn Pawn;
    local SFXWeapon Weapon;
    Pawn = Pawn(SkelComponent.Owner);
    if (Pawn != None && Pawn.Weapon != None)
    {
        Weapon = SFXWeapon(Pawn.Weapon);
        if (Weapon != None)
        {
            if (Weapon.bScaleAnimDurationByFireRate)
            {
                FireRate = Weapon.GetRateOfFire() / 60;
                SeqLength = Seq.GetAnimPlaybackLength();
                TimeForOneShot = SeqLength / 5;
                TimeForAllShots = TimeForOneShot * FireRate;
                if (SeqLength == 0)
                {
                    return 1;
                }
                return TimeForAllShots / SeqLength;
            }
        }
    }
    return 1;
}

defaultproperties
{
    BlendDuration=0,5
    QueuedTransition=-1
    Children=None
}
