﻿class BioAppearanceVehicle extends BioBaseAppearance
    hidecategories(Object,Advanced,Collision,Movement,Debug)
    native;

struct native BioVehicleAttachmentInfo
{
    var() /* 00000008 */ ActorComponent oComponentToAttach;

    var() Name nmAttachSocket;

    var(SkeletalMeshAttachment) array<MaterialInterface> aMeshMaterials;

}

struct native BioVehicleTurretInfo
{
    var(Weapon) Name nmAttachSocket;

    var(Weapon) Name nmTurretYawBone;

    var(Weapon) Name nmTurretPitchBone;

    var(animation) Name nmYawController;

    var(animation) Name nmPitchController;

}

struct native BioVehicleThrusterInfo
{
    var(Setup) Name nmThrusterSocket;

}

struct native BioVehicleSoundEntityStateInfo
{
    var(Setup) String sStateName;

    var(Setup) String sStateValue;

}

var(Mesh) array<MaterialInterface> m_aMaterials;

var(Mesh) SkeletalMesh m_oVehicleModelMesh;

var(ImpactEffects) BioVehicleTrackSet TrackSet;

var(Scale) float m_fUnitWheelRadius;

var(Scale) float m_fVehicleScale;

var(Camera) Name m_nmCameraHook;

var(Camera) float m_fCameraFollowHeight;

var(Camera) float m_fCameraFollowDistance;

var(Weapon) array<Name> m_aWeaponItemLabel;

var(Damage) float m_fDamageVFXStartThresholdPercent;

var(Damage) BioVFXTemplate m_oDamageVFXTemplate;

var(Damage) Name m_oDamageNodeWeight;

var(Damage) MorphTargetSet m_oDamageMorphSet;

var(BioSound) float m_fSuspensionSoundContactForceThresholdHard;

var(BioSound) float m_fSuspensionSoundContactForceThresholdMedium;

var(BioSound) float m_fSuspensionSoundContactForceThresholdSoft;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsHardDeactivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsHardActivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsMedDeactivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsMedActivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsSoftDeactivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleSpringsSoftActivated;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleInDeceleration;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleInAcceleration;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleThrusterStop;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleThrusterStart;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleStop;

var(BioSound) BioVehicleSoundEntityStateInfo m_VehicleStart;

var(BioSound) SoundCue m_oVehicleSoundCue;

var(Thrusters) array<BioVFXAppearanceVehicleThruster> m_aThrusterVFX;

var(Thrusters) int m_nThrusterVFXIndex;

var(Thrusters) array<BioVehicleThrusterInfo> m_aThrusters;

var(Turrets) array<BioVehicleTurretInfo> m_aTurrets;

var(Attachment) /* 00000008 */ array<BioVehicleAttachmentInfo> m_aAttachment;

var(Physics) Name m_nmPhysicsBone;

var(Physics) PhysicsAsset m_oPhysicsAsset;

var(animation) AnimTree m_oVehicleAnimTree;

var(animation) AnimSet m_oVehicleAnimSet;

var(Preview) /* 00000008 */ transient BioAppearanceVehicleSettings m_oSettings;

defaultproperties
{
    m_oSettings=BioAppearanceVehicleSettings'oSettings'
    m_fSuspensionSoundContactForceThresholdSoft=600
    m_fSuspensionSoundContactForceThresholdMedium=1000
    m_fSuspensionSoundContactForceThresholdHard=1750
    m_fDamageVFXStartThresholdPercent=0,5
    m_aWeaponItemLabel(0)=Vehicle_Cannon
    m_aWeaponItemLabel(1)=Vehicle_MachineGun
    m_fCameraFollowDistance=1500
    m_fCameraFollowHeight=100
    m_nmCameraHook=Chassis
    m_fVehicleScale=3
    m_fUnitWheelRadius=25
    // child object oSettings of type BioAppearanceVehicleSettings
}
