﻿class BioAttributes extends BioBaseComponent
    hidecategories(Object,BioBaseComponent,BioCoreBaseObject,Debug)
    abstract
    native;

enum EBioAttrModType
{
    BIO_ATTR_MOD_SUM,
    BIO_ATTR_MOD_FRACTIONAL,
    BIO_ATTR_MOD_LAYER,
    BIO_ATTR_MOD_BASE_OVERRIDE,
};

struct native BioComplexIntStructAttribute
{
    var int m_Base;

    var int m_modifiers[4];

    var bool m_isBaseOverrideInEffect;

    var array<int> m_baseOverrides;

    var array<bool> m_isBaseOverrideValid;

    var int m_Current;

    var bool m_Dirty;

    var int m_Max;

    var int m_Min;

    var int m_isModifierEnabled[4];

    var native Pointer m_Parent;

    var Bio2DA m_LookupTable;

    var int m_TableColumn;

    var native array<Pointer> m_Children;

    var native array<Pointer> m_FloatChildren;

}

struct native BioComplexFloatStructAttribute
{
    var float m_Base;

    var float m_modifiers[4];

    var bool m_isBaseOverrideInEffect;

    var array<float> m_baseOverrides;

    var array<bool> m_isBaseOverrideValid;

    var float m_Current;

    var bool m_Dirty;

    var float m_Max;

    var float m_Min;

    var int m_isModifierEnabled[4];

    var native Pointer m_Parent;

    var Bio2DA m_LookupTable;

    var int m_TableColumn;

}

var bool m_bIsInitialized;

native final function EnsureInitialized();

native function SetIntAttribute(Name attribute, int nValue, optional int nIndexOfAttributeInArray);

native function SetFloatAttribute(Name attribute, float fValue, optional int nIndexOfAttributeInArray);

native function SetByteAttribute(Name attribute, byte cValue, optional int nIndexOfAttributeInArray);

native function SetStringAttribute(Name attribute, String sValue, optional int nIndexOfAttributeInArray);

native function SetEnumAttribute(Name nmAttributeName, String sValue, optional int nIndexOfAttributeInArray);

native function SetBoolAttribute(Name attribute, bool bValue, optional int nIndexOfAttributeInArray);

native function SetNameAttribute(Name attribute, Name nmValue, optional int nIndexOfAttributeInArray);

native function AddIntAttributeModifier(Name attribute, EBioAttrModType modType, int nValue, optional int nIndexOfAttributeInArray);

native function AddFloatAttributeModifier(Name attribute, EBioAttrModType modType, float fValue, optional int nIndexOfAttributeInArray);

native function int AddIntAttributeBaseOverrideModifier(Name attribute, int Value, optional int nIndexOfAttributeInArray);

native function int AddFloatAttributeBaseOverrideModifier(Name attribute, float Value, optional int nIndexOfAttributeInArray);

native function RemoveIntAttributeModifier(Name attribute, EBioAttrModType modType, int nValue, optional int nIndexOfAttributeInArray);

native function RemoveFloatAttributeModifier(Name attribute, EBioAttrModType modType, float fValue, optional int nIndexOfAttributeInArray);

native function RemoveIntAttributeBaseOverrideModifier(Name attribute, int nIndexOfOverride, optional int nIndexOfAttributeInArray);

native function RemoveFloatAttributeBaseOverrideModifier(Name attribute, int nIndexOfOverride, optional int nIndexOfAttributeInArray);

native function ClearStringAttribute(Name nmAttribute, optional int nIndexOfAttributeInArray);

native final static function float GetCurrentFloatValue(out BioComplexFloatStructAttribute attribute);

native final static function SetBaseFloatValue(out BioComplexFloatStructAttribute attribute, float baseValue);

native final static function float GetBaseFloatValue(out BioComplexFloatStructAttribute attribute);

native final static function String FloatToString(out BioComplexFloatStructAttribute attribute);

native final static function int GetCurrentIntValue(out BioComplexIntStructAttribute attribute);

native final static function SetBaseIntValue(out BioComplexIntStructAttribute attribute, int baseValue);

native final static function int GetBaseIntValue(out BioComplexIntStructAttribute attribute);

native final static function String IntToString(out BioComplexIntStructAttribute attribute);

defaultproperties
{
}
