﻿class BioCameraBehaviorFlourish extends BioCameraBehavior;

var float SpeedDistance;

var float DesiredDistance;

var float SpeedPitch;

var float DesiredPitch;

var float SpeedYaw;

var float ZOffset;

function Tick(float TimeDelta)
{
    local Vector CameraHook;
    local float fCurrentYaw;
    local float fCurrentPitch;
    local float fPitchAdj;
    local float fPitchDir;
    local float fRange;
    local float fRangeAdj;
    local float fRangeDir;
    local Vector vDirection;
    CameraHook = GetActorCameraHook();
    fCurrentYaw = m_pov.Rotation.Yaw;
    fCurrentYaw += SpeedYaw * 182,0444 * TimeDelta;
    fCurrentPitch = m_pov.Rotation.Pitch % 65536;
    fPitchAdj = SpeedPitch * 182,0444 * TimeDelta;
    fPitchDir = 1;
    if (fCurrentPitch > DesiredPitch * 182,0444)
    {
        fPitchDir = -1;
    }
    if (Abs(fCurrentPitch - DesiredPitch * 182,0444) < Abs(fPitchAdj))
    {
        fPitchAdj = Abs(DesiredPitch * 182,0444 - fCurrentPitch);
    }
    fCurrentPitch += fPitchDir * fPitchAdj;
    vDirection = m_pov.Location;
    vDirection -= CameraHook;
    fRange = VSize(vDirection);
    fRangeAdj = SpeedDistance * TimeDelta;
    fRangeDir = 1;
    if (fRange > DesiredDistance)
    {
        fRangeDir = -1;
    }
    if (Abs(fRange - DesiredDistance) < Abs(fRangeAdj))
    {
        fRangeAdj = Abs(fRange - DesiredDistance);
    }
    fRange += fRangeDir * fRangeAdj;
    m_pov.Rotation.Yaw = fCurrentYaw;
    m_pov.Rotation.Pitch = fCurrentPitch;
    m_pov.Rotation.Roll = 0;
    m_pov.Location = CameraHook - m_pov.Rotation * fRange;
    m_pov.FOV = FOV;
}

defaultproperties
{
    ZOffset=200
    SpeedYaw=15
    DesiredPitch=315
    SpeedPitch=40
    DesiredDistance=300
    SpeedDistance=50
    FOV=80
}
