﻿class BioCameraBehaviorGalaxy extends BioCameraBehavior
    config(Game)
    native;

enum EBioGalaxyMap_PlanetType
{
    eBioGM_PlanetType_None,
    eBioGM_PlanetType_Planet,
    eBioGM_PlanetType_Anomaly,
    eBioGM_PlanetType_PlanetAndAnomaly,
    eBioGM_PlanetType_Citadel,
    eBioGM_PlanetType_Prefab,
    eBioGM_PlanetType_PlanetAndRing,
    eBioGM_PlanetType_2DImage,
};

enum EBioGalaxyMapState
{
    GalaxyMapState_None,
    GalaxyMapState_Galaxy,
    GalaxyMapState_Cluster,
    GalaxyMapState_System,
    GalaxyMapState_Planet,
    GalaxyMapState_PlanetScan,
};

struct native BioMassRelayLine
{
    var() int m_nStartClusterIdx;

    var() int m_nEndClusterIdx;

    var() String m_sStartClusterLabel;

    var() String m_sEndClusterLabel;

    var() Vector m_vLeftEndPosition;

    var() Vector m_vRightEndPosition;

    var() Vector m_vMiddlePosition;

    var() Vector m_vDrawScale;

    var() Rotator m_rOrientation;

    var() Actor m_pLeftEndActor;

    var() Actor m_pRighEndActor;

    var() Actor m_pMiddleActor;

    var() bool m_bIsGlowing;

}

struct native SFXGalaxyMapSelector
{
    var SFXGalaxyMapObject m_GalaxyMapObject;

    var Actor m_actor;

// m_Name: StringRefProperty[44]
    var array<???> m_PlotNames;

    var bool m_Visible;

    var int m_Visited;

    var int m_State;

}

var transient array<WwiseBaseSoundObject> m_pShipNoFuelSystemVO;

var transient array<WwiseBaseSoundObject> m_pShipNoFuelClusterReturnVO;

var transient array<WwiseBaseSoundObject> m_pShipNoFuelClusterVO;

var transient array<WwiseBaseSoundObject> m_pShipHalfFuelVO;

var transient float m_fLastNoFuelMessageTime;

var transient WwiseBaseSoundObject m_pShipOutOfFuel_Stop;

var transient WwiseBaseSoundObject m_pShipOutOfFuel_Start;

var transient String m_sShipTravelSound_SystemClusterRTPCName;

var transient String m_sShipTravelSound_FuelQtyRTPCName;

var transient String m_sShipTravelSound_ThrustRTPCName;

var transient String m_sShipTravelSound_SpeedRTPCName;

var transient WwiseBaseSoundObject m_pShipTravelSound_Stop;

var transient WwiseBaseSoundObject m_pShipTravelSound_Start;

var transient WwiseBaseSoundObject m_pBuyProbeSound;

var transient String m_sBuyFuelSound_PctFullRTPCName;

var transient WwiseBaseSoundObject m_pBuyFuelSound_Full;

var transient WwiseBaseSoundObject m_pBuyFuelSoundStop;

var transient WwiseBaseSoundObject m_pBuyFuelSound;

var transient WwiseBaseSoundObject m_pErrorSound;

var /* 00000008 */ transient WwiseAudioComponent m_pAudioComponent;

var transient float ClusterTravelFFTime;

var transient float ClusterTravelShakeTime;

var transient ForceFeedbackWaveform ClusterTravelFF;

var transient ScreenShakeStruct ClusterTravelShake;

// m_srPlanetEventMessage: StringRefProperty[44]
var transient int m_nPlanetEventTransParameter;

var transient int m_nPlanetEventTransition;

var transient int m_nPlanetEventParameter;

var transient int m_nPlanetEventFunction;

var transient int m_nPlanetEventConditional;

var transient array<Actor> m_pDynamicObjects;

var transient array<Actor> m_pDynamicClusterPath;

var transient Bio2DA m_pRelayTable;

var transient Bio2DA m_pPlotPlanetTable;

var transient Bio2DA m_pMapTable;

var transient Bio2DA m_pPlanetTable;

var transient Bio2DA m_pSystemTable;

var transient Bio2DA m_pClusterTable;

var transient float m_fPlanetRotation;

var transient DynamicSMActor m_pTemplatePlanet;

var transient int m_nHighlightWorld;

var transient array<SFXGalaxyMapSelector> m_GalaxySelectors;

var transient array<SFXGalaxyMapSelector> m_ClusterSelectors;

var transient array<SFXGalaxyMapSelector> m_SystemSelectors;

var transient array<Actor> m_pScaleformObjects;

var transient int m_nScanRange;

var transient int m_nActiveWorld;

var transient int m_nExitMap;

var transient int m_nButtonLabel;

var transient String m_sPlanetEvent;

var transient int m_nPlanetMap;

var transient int m_nPlanetImageIndex;

var transient int m_nMissionDescription;

var transient int m_nPlanetDescription;

var transient bool m_bSystemSunVisible;

var transient bool m_bCanExploreCluster;

var transient bool m_bUseInternalPlanetEvent;

var transient bool m_bSelectedPlanetLastFrame;

var transient bool m_bRebuildPlanetRingCache;

var transient bool m_bRefreshPlanetUsable;

var transient bool m_bPaused;

var transient bool m_bPlanetScanable;

var transient bool m_bPlanetUsable;

var transient bool m_bFirstStage;

var transient bool m_bTransitionDown;

var transient Vector m_vLastCameraLocation;

var transient Rotator m_rZoomRotation;

var transient Vector m_vZoomDelta;

var transient Vector m_vZoomLocation;

var transient float m_fZoomTime;

var transient Actor m_pDepotObject;

var transient Actor m_pRedMassRelayObject;

var transient Actor m_pMassRelayObject;

var transient Actor m_pFuelEllipseObject;

var transient Actor m_pMassRelaySystem;

var transient Actor m_pSelectedPlanet;

var transient Actor m_pSelectedSystem;

var transient Actor m_pSelectedCluster;

var transient Actor m_pSelectedObject;

var transient Actor m_pLastSelectedObject;

var transient float m_fPlanarPitch;

var transient float m_fMaxOrbitDistance;

var transient Actor m_pCameraObject;

var transient Actor m_pCrossHairObject;

var transient Actor m_pCenterObject;

var transient String m_sCameraObject;

var transient String m_sCrossHairObject;

var transient String m_sCenterObject;

var transient String m_sSelectableObject;

var transient int m_nCurrentState;

var config float m_fShipClusterDeccel;

var config float m_fShipClusterAccel;

var config float m_fShipSystemDeccel;

var config float m_fShipSystemAccel;

var config float m_fShipControlDeadzone;

var config float m_fShipMaxRotationSpeed;

var config float m_fShipMinRotationSpeed;

var transient float m_fShipCurrentMovementSpeed;

var transient float m_fShipCurrentRotationSpeed;

var transient Vector m_vShipDesiredDirection;

var transient float m_fRotationScalar;

var transient float m_fMovementScalarSystem;

var transient float m_fMovementScalarCluster;

var transient float m_fMovementScalarGalaxy;

var transient float m_fMovementScalar;

var transient BioPlanet m_pCurrentPlanet;

var transient SFXSystem m_pCurrentSystem;

var transient SFXCluster m_pCurrentCluster;

var transient SFXGalaxy m_pGalaxyMap;

native function Tick(float TimeDelta);

native function bool HandleSelectPlanet();

native function HandleRevealLandingSite();

event int GetRemainingProbes()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.GetResource(8);
}

event float GetMaxProbes()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.GetMaxProbes();
}

event int GetNumCredits()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.GetResource(0);
}

event float GetRemainingFuel()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.CurrentFuel;
}

event float GetMaxFuel()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.GetMaxFuel();
}

event float GetFuelEfficiency()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    return oInventory.FuelEfficiency;
}

event BurnFuel(float fFuel)
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    oInventory.CurrentFuel = FMax(oInventory.CurrentFuel - fFuel, 0);
    m_pAudioComponent.SetWwiseRTPC(m_sShipTravelSound_FuelQtyRTPCName, oInventory.CurrentFuel / oInventory.GetMaxFuel());
}

event OutOfFuelPenalty(float fDistToDepot)
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    local EInventoryResourceTypes eLostMineral;
    local EInventoryResourceTypes eTestMineral;
    local int nPenalty;
    local int nCount;
    local int nLargestAmt;
    local int nTestAmt;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    eLostMineral = Rand(7 - 5) + 5;
    nPenalty = Rand(fDistToDepot * 10) + 500;
    nLargestAmt = oInventory.GetResource(eLostMineral);
    if (nPenalty >= nLargestAmt)
    {
        eTestMineral = eLostMineral;
        nCount = 0;
        while (nCount < 3)
        {
            eTestMineral = eTestMineral - 5 + 1 % 3 + 5;
            nTestAmt = oInventory.GetResource(eTestMineral);
            if (nTestAmt > nLargestAmt)
            {
                nLargestAmt = nTestAmt;
                eLostMineral = eTestMineral;
                if (nTestAmt > nPenalty)
                {
                    break;
                }
            }
            nCount++;
        }
        nPenalty = Min(nPenalty, nLargestAmt);
    }
    oInventory.AdjustResource(eLostMineral, -nPenalty, true);
}

event UpdateClusterTravelEffects(float TimeDelta)
{
    if (ClusterTravelShakeTime > 0)
    {
        ClusterTravelShakeTime -= TimeDelta;
    }
    if (ClusterTravelShakeTime <= 0)
    {
        ClusterTravelShakeTime = ClusterTravelShake.TimeDuration;
        SFXPlayerCamera(Owner.PlayerCamera).AddScreenShake(ClusterTravelShake);
    }
    if (ClusterTravelFFTime > 0)
    {
        ClusterTravelFFTime -= TimeDelta;
    }
    if (ClusterTravelFFTime <= 0)
    {
        ClusterTravelFFTime = ClusterTravelFF.Samples[0].Duration;
        Owner.ClientPlayForceFeedbackWaveform(ClusterTravelFF);
    }
}

event SetExplorationAchievementCompleted()
{
    local BioPlayerController oController;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oController.UnlockAchievement(42);
}

function Vector GetCameraLocation()
{
    return m_vLastCameraLocation;
}

native function bool TriggerEvent(Name sEvent, optional Name nParameter);

defaultproperties
{
    m_fMovementScalarGalaxy=100
    m_fMovementScalarCluster=30
    m_fMovementScalarSystem=45
    m_fRotationScalar=20
    m_vShipDesiredDirection=(X=1,Y=0,Z=0)
    m_fShipMinRotationSpeed=540
    m_fShipMaxRotationSpeed=720
    m_fShipControlDeadzone=0,4
    m_fShipSystemAccel=2,5
    m_fShipSystemDeccel=1,5
    m_fShipClusterAccel=0,22
    m_fShipClusterDeccel=0,38
    m_bRebuildPlanetRingCache=true
    m_nScanRange=120
    m_pClusterTable=Bio2DA'Default2DA'
    m_pSystemTable=Bio2DA'Default2DA'
    m_pPlanetTable=Bio2DA'Default2DA'
    m_pMapTable=Bio2DA'Default2DA'
    m_pPlotPlanetTable=Bio2DANumberedRows'GalaxyMap_PlotPlanet'
    m_pRelayTable=Bio2DA'Default2DA'
    ClusterTravelFF=ForceFeedbackWaveform'ResourceFFWave'
    bIsCameraShakeEnabled=false
    bCollisionEnabled=false
    // child object ResourceFFWave of type ForceFeedbackWaveform
}
