﻿class BioCustomAction_KroganCharge extends BioCustomAction
    config(Game)
    native;

var transient bool m_bHitTarget;

var transient array<Actor> m_oHitTargets;

var transient Actor m_oChargeTarget;

var transient EKroganChargeActions m_NextAction;

var transient EKroganChargeActions m_ChargeAction;

var() BodyStance BS_Hit;

var() BodyStance BS_Miss;

var() BodyStance BS_Start;

enum EKroganChargeActions
{
    EKC_Start,
    EKC_Miss,
    EKC_Hit,
};

function BodyStance GetBodyStance(EKroganChargeActions eAction)
{
    switch (eAction);
    case 0;
    return BS_Start;
    jump 52;
    case 1;
    return BS_Miss;
    jump 52;
    case 2;
    return BS_Hit;
    jump 52;
    default;
}

function bool PlayHitAnim(Actor oHitTarget)
{
    if (m_oHitTargets.Find(oHitTarget) == -1)
    {
        m_NextAction = 2;
        m_bHitTarget = true;
        m_oHitTargets.AddItem(oHitTarget);
        return true;
    }
    return false;
}

function StartCustomAction()
{
    StartCustomAction();
    m_ChargeAction = 0;
    m_NextAction = 1;
    if (oPawn.PlayBodyStance(BS_Start, 1, 0,2, 0, false, true, true) != 0)
    {
        oPawn.SetBodyStanceAnimEndNotification(BS_Start, true);
        oPawn.SetBodyStanceRootBoneAxisOption(BS_Start, 2, 2);
        oPawn.Mesh.RootMotionMode = 3;
        oPawn.Velocity = vect(0,0,0);
    }
}

function StopCustomAction()
{
    local BodyStance Stance;
    local float fBlendOutTime;
    StopCustomAction();
    Stance = GetBodyStance(m_ChargeAction);
    oPawn.Mesh.RootMotionMode = oPawn.Mesh.Default.RootMotionMode;
    switch (m_ChargeAction)
    {
        case 0:
            fBlendOutTime = 0,2;
            break;
        case 1:
        case 2:
            fBlendOutTime = 0,1;
            break;
    }
    oPawn.StopBodyStance(Stance, fBlendOutTime);
    oPawn.SetBodyStanceAnimEndNotification(Stance, false);
    oPawn.SetBodyStanceRootBoneAxisOption(Stance, 1, 1, 1);
    m_oChargeTarget = None;
    m_bHitTarget = false;
    m_oHitTargets.Length = 0;
}

function BodyStanceAnimEndNotification(AnimNodeSequence SeqNode, float PlayedTime, float ExcessTime)
{
    local BodyStance Stance;
    if (m_ChargeAction == 0)
    {
        m_ChargeAction = m_NextAction;
        Stance = GetBodyStance(m_NextAction);
        if (oPawn.PlayBodyStance(Stance, 1, 0, 0, false, true, true) != 0)
        {
            oPawn.SetBodyStanceAnimEndNotification(BS_Start, false);
            oPawn.SetBodyStanceRootBoneAxisOption(BS_Start, 1, 1, 1);
            oPawn.SetBodyStanceAnimEndNotification(Stance, true);
            oPawn.SetBodyStanceRootBoneAxisOption(Stance, 2, 2);
        }
    }
    else
    {
        Stance = GetBodyStance(m_ChargeAction);
        oPawn.Mesh.RootMotionMode = oPawn.Mesh.Default.RootMotionMode;
        oPawn.SetBodyStanceRootBoneAxisOption(Stance, 1, 1, 1);
        if (SFXPlayerController(oPawn.Controller) != None)
        {
            SFXPlayerController(oPawn.Controller).EndCustomAction();
        }
        else
        {
            if (SFXAI_Core(oPawn.Controller) != None)
            {
                SFXAI_Core(oPawn.Controller).EndCustomAction();
            }
        }
    }
}

defaultproperties
{
}
