﻿class BioDefine extends Object
    native;

enum EActionComplete_Combat
{
    ACC_Cancelled,
    ACC_Success,
    ACC_Failed,
    ACC_Dead,
    ACC_TargetKilled,
    ACC_TimeOut,
    ACC_LowTargeting,
    ACC_LostSight,
    ACC_Disabled,
    ACC_PowerCooldown,
    ACC_WeaponOverheat,
    ACC_WeaponCoolDown,
};

enum EActionComplete_Movement
{
    ACM_Cancelled,
    ACM_Success,
    ACM_Failed,
    ACM_Dead,
    ACM_LostCover,
    ACM_Disabled,
    ACM_CantSeeTarget,
};

enum EActionComplete_None
{
    ACN_Cancelled,
    ACN_Success,
    ACN_Disabled,
};

enum EDisableType
{
    DT_AI,
    DT_Power,
    DT_Offensive,
};

enum EBioPawnClassification
{
    BPC_General,
    BPC_ActionStation,
    BPC_Ambient,
    BPC_UIWorld,
    BPC_Combat,
    BPC_Player,
    BPC_Party,
};

enum EBioFactionTypes
{
    BIO_Faction_Player,
    BIO_Faction_Commoner,
    BIO_Faction_Ambient,
    BIO_Faction_Defender1,
    BIO_Faction_Defender2,
    BIO_Faction_Hostile1,
    BIO_Faction_Hostile2,
    BIO_Faction_Hacked,
};

enum EBioFactionRelationship
{
    BIO_Relation_Friendly,
    BIO_Relation_Neutral,
    BIO_Relation_Hostile,
};

enum EBioVFXPriority
{
    BIO_VFX_PRIORITY_MIN,
    BIO_VFX_PRIORITY_LOW,
    BIO_VFX_PRIORITY_MEDIUM,
    BIO_VFX_PRIORITY_HIGH,
    BIO_VFX_PRIORITY_ALWAYS,
};

enum EInventoryResourceTypes
{
    INV_RESOURCE_CREDITS,
    INV_RESOURCE_MEDIGEL,
    INV_RESOURCE_SALVAGE,
    INV_RESOURCE_GRENADES,
    INV_RESOURCE_RARE1_EEZO,
    INV_RESOURCE_RARE2_IRIDIUM,
    INV_RESOURCE_RARE3_PALLADIUM,
    INV_RESOURCE_RARE4_PLATINUM,
    INV_RESOURCE_PROBES,
    INV_RESOURCE_FUEL,
};

enum EAttachSlot
{
    EASlot_Holster,
    EASlot_LowerBack,
    EASlot_LeftShoulder,
    EASlot_RightShoulder,
    EASlot_CenterBack,
};

enum ECustomizableElementType
{
    CustomizableType_None,
    CustomizableType_Torso,
    CustomizableType_Shoulders,
    CustomizableType_Arms,
    CustomizableType_Legs,
    CustomizableType_Helmet,
    CustomizableType_Spec,
    CustomizableType_Tint,
    CustomizableType_Pattern,
    CustomizableType_PatternColor,
};

struct native PlayerCustomPatternValue
{
// PatternName: StringRefProperty[44]
    var() Name Stripe1ParameterName;

    var() LinearColor Stripe1ParameterValue;

    var() Name Stripe2ParameterName;

    var() LinearColor Stripe2ParameterValue;

    var() Name Stripe3ParameterName;

    var() LinearColor Stripe3ParameterValue;

}

struct native PlayerCustomPatternColorValue
{
// ColorName: StringRefProperty[44]
    var() Name Stripe1ColorName;

    var() LinearColor Stripe1ColorValue;

    var() Name Stripe2ColorName;

    var() LinearColor Stripe2ColorValue;

    var() Name Stripe3ColorName;

    var() LinearColor Stripe3ColorValue;

}

struct native PlayerCustomSpecValue
{
// SpecName: StringRefProperty[44]
    var() ScalarParameterValue Spec;

    var() ScalarParameterValue SpecPwr;

}

struct native PlayerCustomColor1Value
{
// ColorName: StringRefProperty[44]
    var() Name ParameterName;

    var() LinearColor ParameterValue;

    var() Name PhongParameterName;

    var() LinearColor PhongParameterValue;

}

struct native PlayerCustomColor2Value
{
// ColorName: StringRefProperty[44]
    var() Name ParameterName;

    var() LinearColor ParameterValue;

}

struct native PlayerCustomColor3Value
{
// ColorName: StringRefProperty[44]
    var() Name ParameterName;

    var() LinearColor ParameterValue;

}

struct native PlayerMeshInfo
{
    var() String Male;

    var() String MaleVisor;

    var() String MaleFaceplate;

    var() String MaleMaterialOverride;

    var() String Female;

    var() String FemaleVisor;

    var() String FemaleFaceplate;

    var() String FemaleMaterialOverride;

    var() bool bHasBreather;

    var() bool bHideHead;

    var() bool bHideHair;

}

struct native PlayerSpecInfo
{
    var() ScalarParameterValue SpecParam;

    var() ScalarParameterValue SpecPwrParam;

}

struct native PlayerTintInfo
{
    var() VectorParameterValue TintParam;

    var() VectorParameterValue PhongParam;

}

struct native PlayerPatternInfo
{
    var() VectorParameterValue Stripe1Param;

    var() VectorParameterValue Stripe2Param;

    var() VectorParameterValue Stripe3Param;

}

struct native CustomizableElement
{
    var() int Id;

    var() bool bCustomizable;

    var() int Name;

    var() int Description;

    var() ECustomizableElementType Type;

    var() PlayerMeshInfo Mesh;

    var() PlayerSpecInfo Spec;

    var() PlayerTintInfo Tint;

    var() PlayerPatternInfo Pattern;

    var() array<String> GameEffects;

    var() int PlotFlag;

}

enum EBioPawnHeadGearComponent
{
    BIO_PAWN_HEAD_GEAR_COMPONENT_VISOR,
    BIO_PAWN_HEAD_GEAR_COMPONENT_FACE_PLATE,
    BIO_PAWN_HEAD_GEAR_COMPONENT_HELMET,
};

enum EBioAnimSkidTurnState
{
    eBioAnimSkid_NoState,
    eBioAnimSkid_StartingLeft,
    eBioAnimSkid_StartingRight,
    eBioAnimSkid_TurningLeft,
    eBioAnimSkid_TurningRight,
    eBioAnimSkid_FinishingLeft,
    eBioAnimSkid_FinishingRight,
};

enum ELookAtTransitionType
{
    LookAt_Default,
    LookAt_Snap,
};

enum EBioCapabilityTypes
{
    BioCaps_AllTypes,
    BioCaps_SingleTargetAttack,
    BioCaps_AreaAttack,
    BioCaps_Disable,
    BioCaps_Debuff,
    BioCaps_Defense,
    BioCaps_Heal,
    BioCaps_Buff,
    BioCaps_Suicide,
    BioCaps_Death,
    BioCaps_ERROR,
};

enum EBioArmorType
{
    ARMOR_TYPE_NONE,
    ARMOR_TYPE_CLOTHING,
    ARMOR_TYPE_LIGHT,
    ARMOR_TYPE_MEDIUM,
    ARMOR_TYPE_HEAVY,
};

enum EBioEquipmentType
{
    EQUIPMENT_TYPE_INVALID,
    EQUIPMENT_TYPE_ARMOR,
    EQUIPMENT_TYPE_OMNITOOL,
    EQUIPMENT_TYPE_WEAPON,
    EQUIPMENT_TYPE_BIOAMP,
    EQUIPMENT_TYPE_GRENADE,
};

enum EBioHeadGearType
{
    BIO_HEAD_GEAR_TYPE_HELMET,
    BIO_HEAD_GEAR_TYPE_VISOR,
    BIO_HEAD_GEAR_TYPE_COUNT,
};

enum EBioItemWeaponType
{
    ITEM_WEAPTYPE_MELEE,
    ITEM_WEAPTYPE_RANGED,
};

enum EBioItemWeaponRangedType
{
    ITEM_WEAPON_RANGED_PISTOL,
    ITEM_WEAPON_RANGED_SHOTGUN,
    ITEM_WEAPON_RANGED_ASSAULT_RIFLE,
    ITEM_WEAPON_RANGED_SNIPER,
};

enum EBioItemWeaponMeleeType
{
    ITEM_WEAPON_MELEE_KNIFE,
    ITEM_WEAPON_MELEE_SWORD,
    ITEM_WEAPON_MELEE_AXE,
    ITEM_WEAPON_MELEE_POLEARM,
    ITEM_WEAPON_MELEE_SPEAR,
    ITEM_WEAPON_MELEE_BLUNT,
    ITEM_WEAPON_MELEE_COUNT,
};

enum EBioTechniqueWeapon
{
    BioWepTech_Pistol,
    BioWepTech_Blaster,
    BioWepTech_Assault,
    BioWepTech_Sniper,
    BioWepTech_Grenade,
    BioWepTech_Melee,
};

enum EActionStateVariable
{
    BIO_ACTION_STATE_EXPLORE,
    BIO_ACTION_STATE_COMBAT,
};

defaultproperties
{
}
