﻿class BioEvtSysTrackDOF extends SFXGameInterpTrack
    hidecategories(Object)
    config(Game)
    native
    collapsecategories;

struct native BioDOFTrackData
{
    var() bool bEnableDOF;

    var() float fFalloffExponent;

    var() float fBlurKernelSize;

    var() float fMaxNearBlurAmount;

    var() float fMaxFarBlurAmount;

    var() Color cModulateBlurColor;

    var() float fFocusInnerRadius;

    var() float fFocusDistance;

    var() Vector vFocusPosition;

    var() float fInterpolateSeconds;

}

var transient config float m_fDOFDefaultMaxFarBlur;

var transient config float m_fDOFDefaultMaxNearBlur;

var transient config float m_fDOFDefaultExponent;

var transient config float m_fDOFDefaultBlurKernel;

var() array<BioDOFTrackData> m_aDOFData;

static event bool AllowKeyNaming()
{
    return false;
}

static event String NewKeyDefaultName()
{
    return "DOF";
}

static event String KeyDataArrayName()
{
    return "m_aDOFData";
}

static event String KeyDataDisplayName()
{
    return "DOF Data";
}

static event String GetNewTrackSubMenuName()
{
    return "Bio Conversation";
}

defaultproperties
{
    m_fDOFDefaultBlurKernel=5
    m_fDOFDefaultExponent=5
    m_fDOFDefaultMaxNearBlur=0,9
    m_fDOFDefaultMaxFarBlur=0,8
    TrackInstClass=None
    TrackTitle="Depth of Field"
    bOnePerGroup=true
}
