﻿class BioEvtSysTrackProp extends SFXGameActorInterpTrack
    hidecategories(Object)
    native
    collapsecategories;

enum EDynPropList
{
    DynPropList_Unset,
};

enum EDynPropActionList
{
    DynPropActionList_Unset,
};

struct native BioPropTrackData
{
    var() bool bEquip;

    var() EDynPropList eProp;

    var Name nmProp;

    var() EDynPropActionList eAction;

    var Name nmAction;

    var float fActionDuration;

    var Object pPropMesh;

    var ParticleSystem pActionPartSys;

    var class<Object> pWeaponClass;

}

var transient float m_fLastInterpLength;

var native transient Map_Mirror m_mapWeaponProps;

var transient bool m_bInPreviewUpdate;

var transient bool m_bPropListLoaded;

var() array<BioPropTrackData> m_aPropKeys;

struct native BioWeaponPropActionData
{
    var Function pfnExecute;

    var Function pfnGetTiming;

}

static event bool AllowKeyNaming()
{
    return false;
}

static event String NewKeyDefaultName()
{
    return "Prop";
}

static event String KeyDataArrayName()
{
    return "m_aPropKeys";
}

static event String KeyDataDisplayName()
{
    return "Prop Data";
}

static event String GetNewTrackSubMenuName()
{
    return "Bio Conversation";
}

event SFXWeapon PropGetPawnWeapon(class<SFXWeapon> cWeapon, BioEvtSysTrackPropInst pInst)
{
    local SFXWeapon pCurWpn;
    local SFXWeapon pFoundWeapon;
    local int nSpawned;
    local BioPawn pPawn;
    pFoundWeapon = None;
    pPawn = None;
    if (cWeapon != None && pInst != None && pInst.m_pActor != None)
    {
        pPawn = BioPawn(pInst.m_pActor);
        if (pPawn != None)
        {
            pFoundWeapon = pInst.FindWeaponData(cWeapon, nSpawned);
            if (pFoundWeapon == None)
            {
                if (pPawn.InvManager != None)
                {
                    foreach pPawn.InvManager.InventoryActors(Class'SFXWeapon', pCurWpn)
                    {
                        if (ClassIsChildOf(pCurWpn.Class, cWeapon))
                        {
                            if (pFoundWeapon == None || pCurWpn.GetAIRating() > pFoundWeapon.GetAIRating())
                            {
                                pFoundWeapon = pCurWpn;
                            }
                        }
                    }
                }
                if (pFoundWeapon != None)
                {
                    pInst.AddWeaponData(cWeapon, pFoundWeapon, false);
                }
                else
                {
                    pFoundWeapon = pPawn.Spawn(cWeapon, pPawn);
                    if (pFoundWeapon != None)
                    {
                        pFoundWeapon.SetOwner(pPawn);
                        pFoundWeapon.Instigator = pPawn;
                        pInst.AddWeaponData(cWeapon, pFoundWeapon, true);
                    }
                }
                jump 456;
            }
        }
    }
    if (pFoundWeapon == None)
    {
    }
    return pFoundWeapon;
}

event PropEquipWeapon(class<SFXWeapon> cWeapon, BioEvtSysTrackPropInst pInst)
{
    local Name nmRightHand;
    local SkeletalMeshSocket pSocket;
    local SFXWeapon pFoundWeapon;
    local int nSpawned;
    local BioPawn pPawn;
    if (pInst == None || pInst.m_pActor == None || cWeapon == None)
    {
        return;
    }
    pPawn = BioPawn(pInst.m_pActor);
    if (pPawn == None || pPawn.Mesh == None)
    {
        return;
    }
    pFoundWeapon = pInst.FindWeaponData(cWeapon, nSpawned);
    if (pFoundWeapon == None || pFoundWeapon.Mesh == None)
    {
        return;
    }
    nmRightHand = pPawn.GetRightHandSocketName();
    pSocket = pPawn.Mesh.GetSocketByName(nmRightHand);
    if (pSocket != None)
    {
        if (pPawn.Mesh.IsComponentAttached(pFoundWeapon.Mesh, pSocket.BoneName) == true)
        {
            return;
        }
        jump 308;
    }
    pFoundWeapon.DetachWeapon();
    pFoundWeapon.AttachWeaponTo(pPawn.Mesh, nmRightHand);
    pFoundWeapon.bInstantExpansion = true;
    pFoundWeapon.Expand();
    return;
}

event PropUnequipWeaponForInst(class<SFXWeapon> cWeapon, BioEvtSysTrackPropInst pInst)
{
    local SFXWeapon pFoundWeapon;
    local int nSpawned;
    local BioPawn pPawn;
    if (cWeapon == None || pInst == None || pInst.m_pActor == None)
    {
        return;
    }
    pPawn = BioPawn(pInst.m_pActor);
    if (pPawn == None || pPawn.Mesh == None)
    {
        return;
    }
    pFoundWeapon = pInst.FindWeaponData(cWeapon, nSpawned);
    if (pFoundWeapon == None || pFoundWeapon.Mesh == None)
    {
        return;
    }
    PropUnequipWeapon(pPawn, pFoundWeapon, nSpawned);
    pInst.RemoveWeaponData(cWeapon);
}

event PropUnequipWeapon(BioPawn pActor, SFXWeapon pWeapon, int nSpawned)
{
    local Name nmRightHand;
    local SkeletalMeshSocket pSocket;
    if (pActor == None || pWeapon == None || pActor.Mesh == None || pWeapon.Mesh == None)
    {
        return;
    }
    nmRightHand = pActor.GetRightHandSocketName();
    pSocket = pActor.Mesh.GetSocketByName(nmRightHand);
    if (pSocket != None)
    {
        if (pActor.Mesh.IsComponentAttached(pWeapon.Mesh, pSocket.BoneName) == true)
        {
            pWeapon.DetachWeapon();
        }
    }
    pWeapon.bInstantExpansion = true;
    pWeapon.Collapse();
    PropWepActionExecuteDisableIK(pWeapon, pActor);
    PropWepActionExecuteHideAmmoInstant(pWeapon, pActor);
    if (nSpawned == 1)
    {
        pWeapon.SetOwner(None);
        pWeapon.Instigator = None;
        pWeapon.Destroy();
    }
    else
    {
        pWeapon.AttachWeaponTo(pActor.Mesh, pActor.AttachSlots[pWeapon.CharacterSlot]);
    }
}

static event SkeletalMesh GetWeaponMesh(class<SFXWeapon> cWeapon)
{
    if (cWeapon != None)
    {
        return SkeletalMeshComponent(cWeapon.Default.Mesh).SkeletalMesh;
    }
    return None;
}

native static function float FindPartSysMaxDuration(ParticleSystem pParticleSystem, out int nLooping);

function PropWepActionExecuteFire(SFXWeapon pWeapon, BioPawn pActor)
{
    if (pWeapon == None)
    {
        return;
    }
    pWeapon.PlayFireEffectsOnce(0);
}

static function float PropWepActionTimingFire(SFXWeapon pWeapon)
{
    local int nLooping;
    if (pWeapon == None || pWeapon.PSC_MuzFlashEmitter == None || pWeapon.PSC_MuzFlashEmitter.Template == None)
    {
        return 0;
    }
    return FindPartSysMaxDuration(pWeapon.PSC_MuzFlashEmitter.Template, nLooping);
}

function PropWepActionExecuteExpand(SFXWeapon pWeapon, BioPawn pActor)
{
    if (pWeapon == None)
    {
        return;
    }
    pWeapon.bForceReplayAnimation = true;
    pWeapon.bInstantExpansion = false;
    pWeapon.Expand();
}

static function float PropWepActionTimingExpand(SFXWeapon pWeapon)
{
    local SkeletalMeshComponent pMeshComp;
    local AnimSet pAnimSet;
    local AnimSequence pCurAnim;
    local int idx;
    if (pWeapon != None)
    {
        pMeshComp = SkeletalMeshComponent(pWeapon.Mesh);
        if (pMeshComp != None && pMeshComp.AnimSets.Length > 0)
        {
            pAnimSet = pMeshComp.AnimSets[0];
            if (pAnimSet != None)
            {
                idx = 0;
                while (idx < pAnimSet.Sequences.Length)
                {
                    pCurAnim = pAnimSet.Sequences[idx];
                    if (pCurAnim != None && pCurAnim.SequenceName == 'WPN_Expand')
                    {
                        return pCurAnim.SequenceLength;
                    }
                    idx++;
                }
            }
        }
    }
    return 0;
}

function PropWepActionExecuteCollapse(SFXWeapon pWeapon, BioPawn pActor)
{
    if (pWeapon == None)
    {
        return;
    }
    pWeapon.bForceReplayAnimation = true;
    pWeapon.bInstantExpansion = false;
    pWeapon.Collapse();
}

static function float PropWepActionTimingCollapse(SFXWeapon pWeapon)
{
    local SkeletalMeshComponent pMeshComp;
    local AnimSet pAnimSet;
    local AnimSequence pCurAnim;
    local int idx;
    if (pWeapon != None)
    {
        pMeshComp = SkeletalMeshComponent(pWeapon.Mesh);
        if (pMeshComp != None && pMeshComp.AnimSets.Length > 0)
        {
            pAnimSet = pMeshComp.AnimSets[0];
            if (pAnimSet != None)
            {
                idx = 0;
                while (idx < pAnimSet.Sequences.Length)
                {
                    pCurAnim = pAnimSet.Sequences[idx];
                    if (pCurAnim != None && pCurAnim.SequenceName == 'WPN_Collapse')
                    {
                        return pCurAnim.SequenceLength;
                    }
                    idx++;
                }
            }
        }
    }
    return 0;
}

function PropWepActionExecuteReload(SFXWeapon pWeapon, BioPawn pActor)
{
    if (pWeapon == None)
    {
        return;
    }
    pWeapon.PlayReloadEject();
}

static function float PropWepActionTimingReload(SFXWeapon pWeapon)
{
    local int nLooping;
    if (pWeapon == None || pWeapon.PSC_MuzFlashEmitter == None || pWeapon.PSC_MuzFlashEmitter.Template == None)
    {
        return 0;
    }
    return FindPartSysMaxDuration(pWeapon.PSC_ShellCasing.Template, nLooping);
}

function PropWepActionExecuteFireWithTracer(SFXWeapon pWeapon, BioPawn pActor)
{
    local bool bSavedSuppress;
    local float fSavedTracerDistance;
    local bool bSavedForced;
    local Vector vHitLocation;
    local Vector vTmp;
    local Rotator rTmp;
    local SkeletalMeshComponent pMeshCmp;
    if (pWeapon == None)
    {
        return;
    }
    vHitLocation = vect(0,0,0);
    pMeshCmp = SkeletalMeshComponent(pWeapon.Mesh);
    if (pMeshCmp != None && pWeapon.MuzzleSocketName != 'None')
    {
        if (pMeshCmp.GetSocketWorldLocationAndRotation(pWeapon.MuzzleSocketName, vTmp, rTmp))
        {
            vHitLocation = vTmp + 1000 * Normal(rTmp);
        }
    }
    bSavedSuppress = pWeapon.bSuppressTracers;
    fSavedTracerDistance = pWeapon.ShowTracerDistance;
    bSavedForced = pWeapon.bForceSpawnTracer;
    pWeapon.bSuppressTracers = false;
    pWeapon.ShowTracerDistance = 0;
    pWeapon.bForceSpawnTracer = true;
    pWeapon.PlayFireEffectsOnce(0, vHitLocation);
    pWeapon.bSuppressTracers = bSavedSuppress;
    pWeapon.ShowTracerDistance = fSavedTracerDistance;
    pWeapon.bForceSpawnTracer = bSavedForced;
}

static function float PropWepActionTimingFireWithTracer(SFXWeapon pWeapon)
{
    return PropWepActionTimingFire(pWeapon);
}

function PropWepActionExecuteEnableIK(SFXWeapon pWeapon, BioPawn pActor)
{
    local SkelControlBase pSkelControl;
    local float fOldBlend;
    if (pActor != None && pActor.Mesh != None)
    {
        pSkelControl = pActor.Mesh.FindSkelControl('LeftArm');
        if (pSkelControl != None)
        {
            pSkelControl.bSetStrengthFromAnimNode = false;
            fOldBlend = pSkelControl.BlendInTime;
            pSkelControl.BlendInTime = 0,2;
            pSkelControl.SetSkelControlActive(true);
            pSkelControl.BlendInTime = fOldBlend;
        }
    }
}

static function float PropWepActionTimingEnableIK(SFXWeapon pWeapon)
{
    return 0,2;
}

function PropWepActionExecuteDisableIK(SFXWeapon pWeapon, BioPawn pActor)
{
    local SkelControlBase pSkelControl;
    if (pActor != None && pActor.Mesh != None)
    {
        pSkelControl = pActor.Mesh.FindSkelControl('LeftArm');
        if (pSkelControl != None)
        {
            pSkelControl.bSetStrengthFromAnimNode = true;
            pSkelControl.SetSkelControlActive(false);
        }
    }
}

static function float PropWepActionTimingDisableIK(SFXWeapon pWeapon)
{
    return 0;
}

function PropWepActionExecuteShowAmmo(SFXWeapon pWeapon, BioPawn pActor);

static function float PropWepActionTimingShowAmmo(SFXWeapon pWeapon)
{
    return 0;
}

function PropWepActionExecuteHideAmmoInstant(SFXWeapon pWeapon, BioPawn pActor);

static function float PropWepActionTimingHideAmmoInstant(SFXWeapon pWeapon)
{
    return 0;
}

function PropWepActionExecuteHideAmmoFade(SFXWeapon pWeapon, BioPawn pActor);

static function float PropWepActionTimingHideAmmoFade(SFXWeapon pWeapon)
{
    return 0;
}

defaultproperties
{
    TrackInstClass=None
    TrackTitle="Prop"
}
