﻿class BioGestureAnimSetMgr extends Object
    native;

enum EBioGesturePriority
{
    eBioGesturePriority_None,
    eBioGesturePriority_Kismet,
    eBioGesturePriority_Conversations,
    eBioGesturePriority_ActionStations,
    eBioGesturePriority_Always,
};

struct native SFXGestureData
{
    var Name nmPoseSet;

    var Name nmPoseAnim;

    var Name nmGestureSet;

    var Name nmGestureAnim;

    var Name nmTransitionSet;

    var Name nmTransitionAnim;

    var() float fPlayRate;

    var() float fStartOffset;

    var() float fEndOffset;

    var bool bInvalidData;

    var bool bOneShotAnim;

    var() float fStartBlendDuration;

    var() float fEndBlendDuration;

    var() float fWeight;

    var() bool bChainToPrevious;

    var() bool bPlayUntilNext;

    var array<int> aChainedGestures;

    var bool bUseDynAnimSets;

    var() bool bSnapToPose;

    var float fTransBlendTime;

}

struct native BioGestDataKey
{
    var SFXGestureData tRawData;

    var BioGestChainTree pChainTree;

    var bool bUseDynamicAnimSets;

}

var native Map_Mirror m_mapAnimSetRefCount;

var EBioGesturePriority m_eGesturePriority;

var array<BioGestDataKey> m_aNewGestureData;

var transient float m_fGestureBlendTime;

var transient bool m_bKillPoseNow;

var transient bool m_bKillGesturesNow;

var bool m_bPoseRMSettingChanged;

var bool m_bEnablePoseRMRotation;

var bool m_bIgnoreConvGestures;

var bool m_bLeavingGestures;

var bool m_bAutoLeaveGestures;

var bool m_bEnteringGestures;

var bool m_bInGestures;

event EnterGesturesMode(bool bAutoLeave, EBioGesturePriority eEntranceRequestPriority, optional bool bForceGestureKill, optional float fBlendTime = 0,2)
{
    if (eEntranceRequestPriority >= m_eGesturePriority)
    {
        BioPawn(Outer).StopMovement(true);
        m_bInGestures = true;
        m_bAutoLeaveGestures = bAutoLeave;
        m_aNewGestureData.Length = 0;
        m_fGestureBlendTime = fBlendTime;
        m_bPoseRMSettingChanged = true;
        if (m_bLeavingGestures)
        {
            m_bKillGesturesNow = true;
            m_bKillPoseNow = true;
        }
        else
        {
            m_bKillGesturesNow = false;
            m_bKillPoseNow = false;
        }
        m_eGesturePriority = eEntranceRequestPriority;
    }
    else
    {
        if (bForceGestureKill)
        {
            m_bKillGesturesNow = true;
            m_aNewGestureData.Length = 0;
            m_bPoseRMSettingChanged = true;
        }
    }
}

event LeaveGesturesMode(EBioGesturePriority eLeaveRequestPriority)
{
    if (eLeaveRequestPriority >= m_eGesturePriority)
    {
        m_eGesturePriority = 0;
        m_bInGestures = false;
        m_aNewGestureData.Length = 0;
        m_bKillGesturesNow = false;
        m_bKillPoseNow = false;
        m_bLeavingGestures = true;
        m_fGestureBlendTime = 0,2;
    }
}

defaultproperties
{
    m_bPoseRMSettingChanged=true
}
