﻿class BioHUD extends HUD
    hidecategories(Navigation)
    config(Game)
    transient
    native;

var transient MaterialInstanceConstant m_oTargetDetected;

var transient Texture2D SafeAreaTexture;

var const Color DarkGreyColor;

var const Color OrangeColor;

var const Color YellowColor;

var() transient float LastSaveEndTime;

var() transient float LastSaveStartTime;

var const int m_topRowY;

var const int m_farrightColumnX;

var const int m_rightColumnX;

var const int m_leftColumnX;

var const int m_charWidth;

var const int m_lineHeight;

var transient int m_textY;

var transient int m_textX;

var float m_fSafeYOffset;

var float m_fSafeXOffset;

var int nFontTestType;

var config float SafeAreaRatioY;

var config float SafeAreaRatioX;

var transient float m_fCanvasOrgY;

var transient float m_fCanvasOrgX;

var Material oGUIMaterial;

var transient float m_fNextTimeToShowCover;

var transient Actor m_oActorForInfoDisplay;

var transient config bool m_bUseGeneratedItemNames;

var transient bool m_bGUIResourcesLoaded;

var() transient bool bDisplayingSave;

var transient bool m_bShowCoverNames;

var transient bool m_bShowCoverRotation;

var transient bool m_bShowCover;

var transient bool m_bLockActorInfo;

var transient bool m_bDisplayActorInfo;

var bool bFontTest;

var bool bDisplaySafeArea;

var bool m_bShowPlayerLocation;

var /* 00000008 */ BioMoviePlayer m_moviePlayer;

var /* 00000008 */ BioDebugMenu m_oDebugMenu;

var /* 00000008 */ BioMessageBox m_messageBox;

var array<delegate<DebugDraw> > DebugDrawList;

const HUD_SEGMENTS = 64.0f;
native function ProfileConversationBug(BioActorBehavior targetActorBehavior);

native function ProfileConversation(BioActorBehavior targetActorBehavior);

native function ProfileGestures(BioActorBehavior targetActorBehavior);

native function ProfileAnim(BioActorBehavior targetActorBehavior);

native function ProfileCover(BioActorBehavior targetActorBehavior);

native function ProfileLookAt(BioActorBehavior targetActorBehavior);

native function ProfileDesignBudgetGeneral();

native function DisplayIcon(MaterialInstanceConstant oMatInstance, Vector vWorldLocation, optional bool bScaleWithDistance, optional float fMinTextureSize, optional float fMaxTextureSize, optional float fScaleRange);

native function Name GetNameOfEnumEntry(int nIndex, String EnumName);

native function int DisplayStateStack(int X, int Y, BioAiController oController);

native function int DisplaySquad_QA(int X, int Y, BioPawnBehavior targetBehavior);

native function int DisplaySquadMember(int X, int Y, BioPawnBehavior targetBehavior, BioPawn oBP);

native function ViewportDeProject(LocalPlayer LocalPlayerOwner, Vector ScreenLocation, out Vector OutLocation, out Vector OutDirection);

event LinearColor ProxyMakeLinearColor(float R, float G, float B, float A)
{
    return MakeLinearColor(R, G, B, A);
}

event ProxyCanvasSetPos(float X, float Y)
{
    Canvas.SetPos(X, Y);
}

event ProxyCanvasDrawMaterialTile(MaterialInstanceConstant Mat, float XL, float YL)
{
    Canvas.DrawMaterialTile(Mat, XL, YL);
}

event Vector ProxyCanvasProject(Vector V)
{
    return Canvas.Project(V);
}

event ProfileConversationExtra(BioConversation oCurConv)
{
    local BioStage stg;
    local LocalPlayer pLocalPlayer;
    if (oCurConv.IsAmbient())
    {
        DrawText("Ambient Conversation", "");
        if (oCurConv.m_fInterruptRange == -1)
        {
            DrawText("   Set not interruptable by range", "");
        }
        else
        {
            DrawText("   Interrupt Range:", "" $ oCurConv.m_fInterruptRange > 0 ? oCurConv.m_fInterruptRange : BioWorldInfo(WorldInfo).m_fConversationInterruptDistance);
            DrawText("   Speaker Dist:", "" $ VSize(oCurConv.m_pConversationPlayer.Location - oCurConv.m_pSpeaker.Location));
        }
        return;
    }
    stg = oCurConv.m_stage;
    DrawText("", "");
    if (oCurConv.m_pKismetStart != None && !oCurConv.m_pKismetStart.m_bLookAtActive)
    {
        DrawText("Look At DISABLED by PlayConversation", "");
    }
    if (stg == None)
    {
        DrawText("No stage", "");
        return;
    }
    if (oCurConv.m_bHasAttachedCameraTrack)
    {
        DrawText("Matinee Camera", "");
    }
    else
    {
        DrawText("Camera: ", "" $ stg.m_sCurrentCamera);
        DrawText("Stage: ", "");
        DrawText("   Height Adjust   ", stg.m_bDoHeightAdjustment ? "True" : "False");
    }
    pLocalPlayer = LocalPlayer(BioWorldInfo(WorldInfo).GetLocalPlayerController().Player);
    if (pLocalPlayer == None || pLocalPlayer.CurrentPPInfo.LastSettings.bEnableDOF == false)
    {
        DrawText("No DOF Active", "");
    }
    else
    {
        if (oCurConv.m_bHasAttachedDOFTrack == true)
        {
            DrawText("DOF Track Active", "");
        }
        else
        {
            if (stg.m_bDOFActive == true && oCurConv.m_bHasAttachedCameraTrack == false)
            {
                DrawText("Stage DOF Active", "");
            }
            else
            {
                DrawText("World DOF Active", "");
            }
        }
        DrawText("   FocusInnerRadius   ", "" $ pLocalPlayer.CurrentPPInfo.LastSettings.DOF_FocusInnerRadius);
        DrawText("   FocusDistance   ", "" $ pLocalPlayer.CurrentPPInfo.LastSettings.DOF_FocusDistance);
    }
    if (!oCurConv.m_bEnableLookAtWithStage)
    {
        DrawText("Look At DISABLED", "");
    }
    else
    {
        if (!stg.m_bLookAtActive)
        {
            DrawText("Look At DISABLED for this stage", "");
        }
        else
        {
            if (BioWorldInfo(WorldInfo).m_fLookAtDelays.Length < 2)
            {
                DrawText("Look at config error", "");
            }
            else
            {
                DrawText("Look At On", "");
            }
        }
    }
    stg.ProfileStage(self);
    DrawText("", "");
    if (oCurConv.m_stage.m_fHeightAdjust != 0 && oCurConv.m_bHasAttachedCameraTrack == false)
    {
        DrawText("Height Adjust: ", "" $ oCurConv.m_stage.m_fHeightAdjust);
        DrawText("  Spk Ht: ", "Feet(" $ oCurConv.m_stage.m_fSpeakerFeetZ $ ") EyeHeight(" $ oCurConv.m_stage.m_fSpeakerEyeHeight $ ")");
        DrawText("  Stage Ht: ", "" $ oCurConv.m_stage.m_fStageZ);
    }
    else
    {
        DrawText("No height adjust", "");
    }
}

function DisplaySafeArea()
{
    if (bDisplaySafeArea)
    {
        Canvas.SetPos(Canvas.SizeX * SafeAreaRatioX, Canvas.SizeY * SafeAreaRatioY);
        Canvas.SetDrawColor(255, 255, 255, 50);
        Canvas.DrawTile(SafeAreaTexture, Canvas.SizeX * 1 - SafeAreaRatioX * 2, Canvas.SizeY * 1 - SafeAreaRatioY * 2, 0, 0, SafeAreaTexture.SizeX, SafeAreaTexture.SizeY);
    }
}

exec function ToggleSafeArea()
{
    bDisplaySafeArea = !bDisplaySafeArea;
}

function DrawTestFont(int Y, String sFontName, int nPoint, optional bool bScaled = false, optional float fScale = 0)
{
    local Font oFont;
    local String Str;
    Str = "The quick brown fox jumps." @ nPoint;
    if (bScaled == false)
    {
        sFontName = sFontName $ nPoint;
    }
    oFont = Font(DynamicLoadObject(sFontName, Class'Font', true));
    if (oFont != None)
    {
        Canvas.Font = oFont;
        Canvas.SetPos(0, Y);
        Canvas.bCenter = true;
        if (bScaled == true)
        {
            Canvas.DrawTextScaled(Str, fScale, fScale);
        }
        else
        {
            DrawFakeShadowText(0, Y, WhiteColor, Str);
        }
    }
}

function DrawTestFontString(int Y, String sFontName, String sTestString)
{
    local Font oFont;
    oFont = Font(DynamicLoadObject(sFontName, Class'Font', true));
    if (oFont != None)
    {
        Canvas.Font = oFont;
        Canvas.SetPos(0, Y);
        Canvas.bCenter = true;
        DrawFakeShadowText(0, Y, WhiteColor, sTestString);
    }
}

function DoFontTest()
{
    local String sFontName;
    local String sTestString;
    local Texture2D oTexture;
    Canvas.Reset();
    switch (nFontTestType)
    {
        case 0:
            oTexture = Texture2D(DynamicLoadObject("FontTest.BioMass", Class'Texture2D', true));
            if (oTexture != None)
            {
                Canvas.SetPos(Canvas.SizeX - oTexture.SizeX / 2, 0);
                Canvas.DrawTile(oTexture, oTexture.SizeX, oTexture.SizeY, 0, 0, oTexture.SizeX, oTexture.SizeY);
            }
            break;
        case 1:
            sFontName = "FontTest.BioMassFont";
            Canvas.SetDrawColor(255, 255, 255, 255);
            DrawTestFont(88, sFontName, 30);
            DrawTestFont(144, sFontName, 24);
            DrawTestFont(198, sFontName, 20);
            DrawTestFont(250, sFontName, 18);
            DrawTestFont(304, sFontName, 14);
            DrawTestFont(355, sFontName, 12);
            DrawTestFont(407, sFontName, 11);
            DrawTestFont(459, sFontName, 10);
            DrawTestFont(513, sFontName, 9);
            break;
        case 2:
            oTexture = Texture2D(DynamicLoadObject("FontTest.BioMass", Class'Texture2D', true));
            if (oTexture != None)
            {
                Canvas.SetPos(Canvas.SizeX - oTexture.SizeX / 2, 0);
                Canvas.DrawTile(oTexture, oTexture.SizeX, oTexture.SizeY, 0, 0, oTexture.SizeX, oTexture.SizeY);
            }
            sFontName = "FontTest.BioMassFont";
            Canvas.SetDrawColor(255, 255, 255, 255);
            DrawTestFont(88, sFontName, 30);
            DrawTestFont(144, sFontName, 24);
            DrawTestFont(198, sFontName, 20);
            DrawTestFont(250, sFontName, 18);
            DrawTestFont(304, sFontName, 14);
            DrawTestFont(355, sFontName, 12);
            DrawTestFont(407, sFontName, 11);
            DrawTestFont(459, sFontName, 10);
            DrawTestFont(513, sFontName, 9);
            break;
        case 3:
            oTexture = Texture2D(DynamicLoadObject("FontTest.AEROLight", Class'Texture2D', true));
            if (oTexture != None)
            {
                Canvas.SetPos(Canvas.SizeX - oTexture.SizeX / 2, 0);
                Canvas.DrawTile(oTexture, oTexture.SizeX, oTexture.SizeY, 0, 0, oTexture.SizeX, oTexture.SizeY);
            }
            break;
        case 4:
            sFontName = "FontTest.AeroLightFont";
            Canvas.SetDrawColor(255, 255, 255, 255);
            DrawTestFont(83, sFontName, 30);
            DrawTestFont(139, sFontName, 24);
            DrawTestFont(193, sFontName, 20);
            DrawTestFont(245, sFontName, 18);
            DrawTestFont(296, sFontName, 14);
            DrawTestFont(350, sFontName, 12);
            DrawTestFont(402, sFontName, 11);
            DrawTestFont(454, sFontName, 10);
            DrawTestFont(508, sFontName, 9);
            break;
        case 5:
            oTexture = Texture2D(DynamicLoadObject("FontTest.AEROLight", Class'Texture2D', true));
            if (oTexture != None)
            {
                Canvas.SetPos(Canvas.SizeX - oTexture.SizeX / 2, 0);
                Canvas.DrawTile(oTexture, oTexture.SizeX, oTexture.SizeY, 0, 0, oTexture.SizeX, oTexture.SizeY);
            }
            sFontName = "FontTest.AeroLightFont";
            Canvas.SetDrawColor(255, 255, 255, 255);
            DrawTestFont(88, sFontName, 30);
            DrawTestFont(144, sFontName, 24);
            DrawTestFont(198, sFontName, 20);
            DrawTestFont(250, sFontName, 18);
            DrawTestFont(304, sFontName, 14);
            DrawTestFont(355, sFontName, 12);
            DrawTestFont(407, sFontName, 11);
            DrawTestFont(459, sFontName, 10);
            DrawTestFont(513, sFontName, 9);
            break;
        case 6:
            sFontName = "FontTest.ArialUnicodeFont36";
            sTestString = LoadTestTextStringFromFile();
            DrawTestFontString(88, sFontName, sTestString);
    }
}

simulated event PostRender()
{
    local BioPlayerController PlayerCtrl;
    local float fOldCanvasOrgX;
    local float fOldCanvasOrgY;
    local float fGuiAlpha;
    local String sLocation;
    local BioWorldInfo oBioWorldInfo;
    PostRender();
    if (!m_bGUIResourcesLoaded)
    {
        LoadGUIResources();
    }
    Canvas.Font = Class'Engine'.GetSmallFont();
    fGuiAlpha = 255 * 1 - BioPlayerController(PlayerOwner).PlayerCamera.FadeAmount;
    if (bFontTest)
    {
        DoFontTest();
        return;
    }
    PlayerCtrl = BioPlayerController(PlayerOwner);
    oBioWorldInfo = BioWorldInfo(WorldInfo);
    m_fCanvasOrgX = Canvas.OrgX;
    m_fCanvasOrgY = Canvas.OrgY;
    if (oGUIMaterial != None)
    {
        Canvas.SetPos(0, 0);
        Canvas.DrawMaterialTile(oGUIMaterial, SizeX, SizeY);
    }
    m_messageBox.Draw(Canvas);
    m_oDebugMenu.Draw(Canvas);
    if (Canvas.OrgY != 0)
    {
        Canvas.SetDrawColor(0, 0, 0, fGuiAlpha);
        Canvas.SetPos(0, -Canvas.OrgY);
        Canvas.DrawRect(Canvas.SizeX, Canvas.OrgY);
        Canvas.SetPos(0, Canvas.SizeY);
        Canvas.DrawRect(Canvas.SizeX, Canvas.OrgY);
    }
    if (m_bDisplayActorInfo)
    {
        UpdateActorInfo();
    }
    if (m_bShowPlayerLocation)
    {
        sLocation = "PlayerLocation: (" $ PlayerCtrl.Pawn.Location.X $ ", " $ PlayerCtrl.Pawn.Location.Y $ ", " $ PlayerCtrl.Pawn.Location.Z $ ")";
        Canvas.bCenter = true;
        DrawFakeShadowText(Canvas.SizeX / 2, Canvas.SizeY / 2, YellowColor, sLocation);
    }
    if (m_bShowCover)
    {
        if (WorldInfo != None && m_fNextTimeToShowCover <= WorldInfo.TimeSeconds)
        {
            UpdateCover(m_bShowCoverRotation);
            m_fNextTimeToShowCover = WorldInfo.TimeSeconds + 1;
        }
    }
    if (m_bShowCoverNames)
    {
        UpdateCoverNames();
    }
    if (oBioWorldInfo != None)
    {
        if (oBioWorldInfo.m_oPropertyEditor != None)
        {
            oBioWorldInfo.m_oPropertyEditor.DrawToHUD(self);
        }
    }
    fOldCanvasOrgX = Canvas.OrgX;
    fOldCanvasOrgY = Canvas.OrgY;
    Canvas.OrgX = m_fCanvasOrgX;
    Canvas.OrgY = m_fCanvasOrgY;
    m_moviePlayer.Draw(Canvas);
    DisplaySafeArea();
    Canvas.OrgX = fOldCanvasOrgX;
    Canvas.OrgY = fOldCanvasOrgY;
    BioCheatManager(PlayerCtrl.CheatManager).RenderHUD(self);
}

function DrawHUD()
{
    local BioCheatManager CheatManager;
    local int idx;
    idx = 0;
    while (idx < DebugDrawList.Length)
    {
        __DebugDraw__Delegate = DebugDrawList[idx];
        DebugDraw(self);
        idx++;
    }
    CheatManager = BioCheatManager(PlayerOwner.CheatManager);
    if (CheatManager != None)
    {
        CheatManager.DrawCurrentProfile();
    }
    if (SFXGame(WorldInfo.Game).gameconfig.bShowScore)
    {
        SFXPRI(PlayerOwner.PlayerReplicationInfo).DrawScore();
    }
    if (Class'Engine'.IsSplitScreen())
    {
        DrawDebugCrossHair();
    }
}

function DrawSelection()
{
    local Vector TargetLocation;
    local BioPlayerController PC;
    local SFXSelectionModule SelMod;
    local SFXSimpleUseModule UseMod;
    local bool bInRange;
    local BioPawn BP;
    local MaterialInstanceConstant MIC;
    local float Size;
    PC = BioPlayerController(PlayerOwner);
    if (PC.GameModeManager2.ShouldShowSelection() == false)
    {
        return;
    }
    if (PC.m_oPlayerSelection.m_oCurrentSelectionTarget == None || PC.m_oPlayerSelection.m_bCurrentSelectionIsCombatTarget)
    {
        return;
    }
    SelMod = PC.m_oPlayerSelection.m_oCurrentSelectionTarget.GetModule(Class'SFXSelectionModule');
    BP = BioPawn(PC.m_oPlayerSelection.m_oCurrentSelectionTarget);
    if (BP != None && BP.GetAimNodeLocation(4, TargetLocation))
    {
    }
    else
    {
        if (SelMod != None)
        {
            TargetLocation = SelMod.GetSelectionPoint();
        }
        else
        {
            TargetLocation = PC.m_oPlayerSelection.m_oCurrentSelectionTarget.Location;
        }
    }
    UseMod = PC.m_oPlayerSelection.m_oCurrentSelectionTarget.GetModule(Class'SFXSimpleUseModule');
    if (UseMod != None)
    {
        bInRange = VSize(TargetLocation - PC.Pawn.Location) < UseMod.fUseRange;
    }
    else
    {
        if (BioActorBehavior(PC.m_oPlayerSelection.m_oCurrentSelectionTarget.oBioComponent) != None)
        {
            bInRange = BioActorBehavior(PC.m_oPlayerSelection.m_oCurrentSelectionTarget.oBioComponent).IsWithinUseRange(PC.Pawn.Location);
        }
    }
    TargetLocation = Canvas.Project(TargetLocation);
    Canvas.SetDrawColor(255, 0, 0, 255);
    Size = FClamp(5000 * 1 - TargetLocation.Z, 50, 100);
    Canvas.SetPos(TargetLocation.X - Size, TargetLocation.Y - Size);
    MIC = MaterialInstanceConstant(Class'SFXGameConfig'.Default.SelectionMaterial);
    MIC.SetScalarParameterValue('Useable', bInRange ? 1 : 0);
    Canvas.DrawMaterialTile(Class'SFXGameConfig'.Default.SelectionMaterial, Size * 2, Size * 2, 0, 0, 1, 1);
}

function DrawDebugCrossHair()
{
    local float Inaccuracy;
    local Color White;
    White = MakeColor(255, 255, 255, 255);
    Inaccuracy = 10;
    Canvas.Draw2DLine(CenterX - Inaccuracy - 5, CenterY, CenterX - Inaccuracy, CenterY, White);
    Canvas.Draw2DLine(CenterX + Inaccuracy + 5, CenterY, CenterX + Inaccuracy, CenterY, White);
    Canvas.Draw2DLine(CenterX, CenterY - Inaccuracy - 5, CenterX, CenterY - Inaccuracy, White);
    Canvas.Draw2DLine(CenterX, CenterY + Inaccuracy + 5, CenterX, CenterY + Inaccuracy, White);
}

function SetDebugDraw(delegate<DebugDraw> DebugDrawFunc)
{
    local int idx;
    idx = DebugDrawList.Find(DebugDrawFunc);
    if (idx == -1)
    {
        DebugDrawList[DebugDrawList.Length] = DebugDrawFunc;
    }
    else
    {
        if (idx != -1)
        {
            DebugDrawList.Remove(idx, 1);
        }
    }
}

function bool IsDrawing(delegate<DebugDraw> DebugDrawFunc)
{
    local int idx;
    idx = DebugDrawList.Find(DebugDrawFunc);
    if (idx >= 0)
    {
        return true;
    }
    return false;
}

delegate DebugDraw(BioHUD H);

function DrawEngineHUD();

function DrawFakeShadowText(int X, int Y, Color DrawColor, String sText)
{
    local float fGuiAlpha;
    fGuiAlpha = 255 * 1 - BioPlayerController(PlayerOwner).PlayerCamera.FadeAmount;
    Canvas.SetDrawColor(0, 0, 0, fGuiAlpha);
    Canvas.SetPos(X - 2, Y - 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X - 2, Y);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X - 2, Y + 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X + 2, Y - 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X + 2, Y);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X + 2, Y + 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X, Y - 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X, Y + 2);
    Canvas.DrawText(sText, false);
    Canvas.SetPos(X, Y);
    Canvas.DrawColor = DrawColor;
    Canvas.DrawColor.A = fGuiAlpha;
    Canvas.DrawText(sText, false);
}

function float SmartWrapStringToArray(String sText, out array<String> OutArray, int nTextWidth)
{
    local float fontWidth;
    local float fontHeight;
    local float textWidth;
    local float textHeight;
    local int dlines;
    OutArray.Length = 0;
    Canvas.WrapStringToArray(sText, OutArray, nTextWidth, "\");
    dlines = OutArray.Length;
    if (dlines == 1)
    {
        Canvas.StrLen(OutArray[0], textWidth, textHeight);
        return textWidth;
    }
    Canvas.StrLen("X", fontWidth, fontHeight);
    textWidth = Canvas.ClipX / 2;
    OutArray.Remove(0, OutArray.Length);
    Canvas.WrapStringToArray(sText, OutArray, textWidth, "\");
    textWidth = textWidth + fontWidth;
    if (!OutArray.Length <= dlines) jump 158;
    return textWidth;
}

native function String LoadTestTextStringFromFile();

function ConnectBoxes(float X1, float Y1, float nSize1, float X2, float Y2, float nSize2)
{
    local float fAngle;
    local float fAngleInv;
    local float X2Start;
    local float Y2Start;
    local float X1Start;
    local float Y1Start;
    if (BoxesIntersecting(X1, Y1, nSize1, X2, Y2, nSize2) == false)
    {
        fAngle = Atan(X2 - X1, Y2 - Y1);
        fAngleInv = fAngle - 3,141593;
        if (fAngleInv < -3,141593)
        {
            fAngleInv = fAngleInv + 2 * 3,141593;
        }
        GetBoxCoordsFromAngle(X2, Y2, nSize2, fAngle, X2Start, Y2Start);
        GetBoxCoordsFromAngle(X1, Y1, nSize1, fAngleInv, X1Start, Y1Start);
        CDrawVertLine(X1Start, Y1Start, Y1Start + Y2Start - Y1Start / 2);
        CDrawHorzLine(X1Start, X2Start, Y1Start + Y2Start - Y1Start / 2);
        CDrawVertLine(X2Start, Y1Start + Y2Start - Y1Start / 2, Y2Start);
        return;
    }
}

function CDrawHorzLine(float X1, float X2, float Y)
{
    if (X1 > X2)
    {
        Canvas.SetPos(X2 + 0,5, Y + 0,5);
        Canvas.DrawRect(X1 - X2 + 0,5, 1);
    }
    else
    {
        Canvas.SetPos(X1 + 0,5, Y + 0,5);
        Canvas.DrawRect(X2 - X1 + 0,5, 1);
    }
}

function CDrawVertLine(float X, float Y1, float Y2)
{
    if (Y1 > Y2)
    {
        Canvas.SetPos(X + 0,5, Y2 + 0,5);
        Canvas.DrawRect(1, Y1 - Y2 + 0,5);
    }
    else
    {
        Canvas.SetPos(X + 0,5, Y1 + 0,5);
        Canvas.DrawRect(1, Y2 - Y1 + 0,5);
    }
}

function bool BoxesIntersecting(int X1, int Y1, int nSize1, int X2, int Y2, int nSize2)
{
    local int nXT;
    local int nYT;
    local int nST;
    if (nSize2 > nSize1)
    {
        nXT = X1;
        nYT = Y1;
        nST = nSize1;
        X1 = X2;
        Y1 = Y2;
        nSize1 = nSize2;
        X2 = nXT;
        Y2 = nYT;
        nSize2 = nST;
    }
    if (PointInsideBox(X2 - nSize2 * 0,5, Y2 - nSize2 * 0,5, X1, Y1, nSize1) == true)
    {
        return true;
    }
    if (PointInsideBox(X2 - nSize2 * 0,5, Y2 + nSize2 * 0,5, X1, Y1, nSize1) == true)
    {
        return true;
    }
    if (PointInsideBox(X2 + nSize2 * 0,5, Y2 - nSize2 * 0,5, X1, Y1, nSize1) == true)
    {
        return true;
    }
    if (PointInsideBox(X2 + nSize2 * 0,5, Y2 + nSize2 * 0,5, X1, Y1, nSize1) == true)
    {
        return true;
    }
    return false;
}

function GetBoxCoordsFromAngle(float X, float Y, float Size, float Angle, out float XSt, out float YSt)
{
    if (Angle <= 3,141593 * 0,25 && Angle >= -3,141593 * 0,25)
    {
        YSt = Y - Size * 0,5;
        XSt = X + Size * 0,5 - Size * Angle - -3,141593 * 0,25 * 2 / 3,141593;
    }
    if (Angle > 3,141593 * 0,25 && Angle < 3,141593 * 0,75)
    {
        YSt = Y - Size * 0,5 + Size * Angle - 3,141593 * 0,25 * 2 / 3,141593;
        XSt = X - Size * 0,5;
    }
    if (Angle < -3,141593 * 0,25 && Angle > -3,141593 * 0,75)
    {
        YSt = Y - Size + Size * 0,5 - Size * Angle - -3,141593 * 0,25 * 2 / 3,141593;
        XSt = X + Size * 0,5;
    }
    if (Angle >= 3,141593 * 0,75 || Angle <= -3,141593 * 0,75)
    {
        YSt = Y + Size * 0,5;
        if (Angle > 3,141593 * 0,75)
        {
            XSt = X - Size * 0,5 + Size * Angle - 3,141593 * 0,75 * 2 / 3,141593;
        }
        else
        {
            XSt = X + Size - Size * 0,5 + Size * Angle - -3,141593 * 0,75 * 2 / 3,141593;
        }
    }
}

function bool PointInsideBox(float X, float Y, float CX, float CY, float nSize)
{
    if (X >= CX - nSize * 0,5 && X <= CX + nSize * 0,5 && Y >= CY - nSize * 0,5 && Y <= CY + nSize * 0,5)
    {
        return true;
    }
    return false;
}

function CDrawSquare(int nSize)
{
    local int X;
    local int Y;
    X = Canvas.CurX;
    Y = Canvas.CurY;
    Canvas.SetPos(X - nSize * 0,5 + 0,5, Y - nSize * 0,5 + 0,5);
    Canvas.DrawRect(nSize, nSize);
}

function DrawCircle(float fX, float fY, float Radius)
{
    local int idx;
    local float X1;
    local float Y1;
    local float X2;
    local float Y2;
    local float XPos;
    local float YPos;
    XPos = Canvas.CurX;
    YPos = Canvas.CurY;
    X1 = fX + Radius;
    Y1 = fY;
    idx = 0;
    while (idx < 64 + 1)
    {
        X2 = fX + Radius * Cos(2 * 3,141593 * idx / 64);
        Y2 = fY + Radius * Sin(2 * 3,141593 * idx / 64);
        Canvas.Draw2DLine(X1, Y1, X2, Y2, Canvas.DrawColor);
        X1 = X2;
        Y1 = Y2;
        idx++;
    }
    Canvas.CurX = XPos;
    Canvas.CurY = YPos;
}

event DrawText(String valuename, String Value, optional Color LabelColor = MakeColor(255, 255, 0), optional Color DataColor = MakeColor(0, 255, 0))
{
    DrawTextWithColor(valuename, Value, MakeColor(255, 255, 0), MakeColor(0, 255, 0));
}

event DrawTextWithColor(String valuename, String Value, Color LabelColor, Color DataColor)
{
    local float strX;
    local float dummyStrY;
    local float Alpha;
    Alpha = 255 * 1 - BioPlayerController(PlayerOwner).PlayerCamera.FadeAmount;
    Canvas.StrLen(valuename, strX, dummyStrY);
    Canvas.SetPos(m_textX + 1, m_textY + 1);
    Canvas.SetDrawColor(0, 0, 0, Alpha);
    Canvas.DrawText(valuename);
    Canvas.SetPos(m_textX, m_textY);
    Canvas.SetDrawColor(LabelColor.R, LabelColor.G, LabelColor.B, Alpha);
    Canvas.DrawText(valuename);
    Canvas.SetPos(m_textX + strX + m_charWidth + 1, m_textY + 1);
    Canvas.SetDrawColor(0, 0, 0, Alpha);
    Canvas.DrawText(Value);
    Canvas.SetPos(m_textX + strX + m_charWidth, m_textY);
    Canvas.SetDrawColor(DataColor.R, DataColor.G, DataColor.B, Alpha);
    Canvas.DrawText(Value);
    m_textY += m_lineHeight;
}

exec function SetGUITexture(String sMaterial)
{
    oGUIMaterial = Material(DynamicLoadObject(sMaterial, Class'Material', true));
}

native function LoadGUIResources();

exec function DisplayActorInfo()
{
    m_bDisplayActorInfo = !m_bDisplayActorInfo;
}

exec function LockActorInfo()
{
    local Actor oActor;
    local Vector vHitLocation;
    local Vector vHitNormal;
    m_bLockActorInfo = !m_bLockActorInfo;
    if (m_bLockActorInfo)
    {
        if (SFXPlayerCamera(BioWorldInfo(WorldInfo).GetLocalPlayerController().PlayerCamera).GetTrace(oActor, vHitLocation, vHitNormal))
        {
            m_oActorForInfoDisplay = oActor;
        }
    }
    else
    {
        m_oActorForInfoDisplay = None;
    }
}

exec function SetActorForActorInfo(Name nmActor)
{
    local Actor oActor;
    foreach AllActors(Class'Actor', oActor)
    {
        if (nmActor == oActor.Name)
        {
            break;
        }
    }
    if (oActor == None)
    {
        return;
    }
    m_oActorForInfoDisplay = oActor;
    m_bLockActorInfo = true;
}

exec function ShowLocation()
{
    m_bShowPlayerLocation = true;
}

exec function HideLocation()
{
    m_bShowPlayerLocation = false;
}

function UpdateActorInfo()
{
    local BioPlayerController oPlayerController;
    local Actor oActor;
    local Vector vHitLocation;
    local Vector vHitNormal;
    local float fGuiAlpha;
    local float fX;
    local float fY;
    local BioPawn oPawn;
    oPlayerController = BioPlayerController(PlayerOwner);
    if (oPlayerController == None || oPlayerController.Pawn == None)
    {
        return;
    }
    if (m_oActorForInfoDisplay == None)
    {
        if (SFXPlayerCamera(oPlayerController.PlayerCamera).GetTrace(oActor, vHitLocation, vHitNormal) == false)
        {
            return;
        }
    }
    else
    {
        oActor = m_oActorForInfoDisplay;
    }
    oPawn = BioPawn(oActor);
    fGuiAlpha = 255 * 1 - BioPlayerController(PlayerOwner).PlayerCamera.FadeAmount;
    Canvas.SetDrawColor(255, 255, 255, fGuiAlpha);
    fX = Canvas.SizeX - Canvas.SizeX * SafeAreaRatioX - 300;
    fY = Canvas.SizeY * 0,5 - 140;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Player loc=(" $ oPlayerController.Pawn.Location $ ")");
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Tag=" $ oActor.Tag);
    if (oPawn != None && oPawn.m_oBehavior != None)
    {
        fY += 15;
        Canvas.SetPos(fX, fY);
        Canvas.DrawText("Game name=" $ oPawn.m_oBehavior.GetActorGameName());
    }
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object name=(" $ oActor $ ")");
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object loc=(" $ oActor.Location $ ")");
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object velocity=(" $ oActor.Velocity $ ")");
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object acceleration=(" $ oActor.Acceleration $ ")");
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object physics mode=(" $ oActor.Physics $ ")");
    if (oActor.Base != None)
    {
        fY += 15;
        Canvas.SetPos(fX, fY);
        Canvas.DrawText("Object base=(" $ oActor.Base.Tag $ ")");
    }
    if (oActor.CollisionComponent != None)
    {
        oActor.DrawDebugBox(oActor.CollisionComponent.Bounds.Origin, oActor.CollisionComponent.Bounds.BoxExtent, 0, 0, 255, false);
    }
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object rotation=(" $ oActor.Rotation $ ")");
    oActor.DrawDebugLine(oActor.Location, oActor.Location + oActor.Rotation * 100, 0, 0, 255, false);
    fY += 15;
    Canvas.SetPos(fX, fY);
    Canvas.DrawText("Object desired rotation=(" $ oActor.DesiredRotation $ ")");
    if (VSize(oActor.DesiredRotation - oActor.Rotation) > 1)
    {
        oActor.DrawDebugLine(oActor.Location, oActor.Location + oActor.DesiredRotation * 100, 0, 255, 0, false);
    }
}

exec function ShowCover(optional bool bShowRotation = false)
{
    m_bShowCover = !m_bShowCover;
    m_bShowCoverRotation = bShowRotation;
    if (m_bShowCover == false)
    {
        FlushPersistentDebugLines();
    }
}

native function UpdateCover(bool bShowRotation);

exec function ShowCoverNames()
{
    m_bShowCoverNames = !m_bShowCoverNames;
}

exec function UpdateCoverNames()
{
    local BioWorldInfo oWorldInfo;
    local SFXPlayerCamera oCameraManager;
    local Vector vCameraLocation;
    local Vector vCameraRotation;
    local CoverLink oCoverLink;
    local Vector vLocation;
    local Vector vDirection;
    local CoverSlotMarker oCoverSlotMarker;
    local String sText;
    local Pawn oSlotOwner;
    oWorldInfo = BioWorldInfo(WorldInfo);
    if (oWorldInfo == None || Canvas == None)
    {
        return;
    }
    oCameraManager = SFXPlayerCamera(oWorldInfo.GetLocalPlayerController().PlayerCamera);
    if (oCameraManager == None)
    {
        return;
    }
    Canvas.SetDrawColor(255, 255, 255, 255);
    vCameraLocation = oWorldInfo.GetLocalPlayerController().PlayerCamera.CameraCache.POV.Location;
    vCameraRotation = oWorldInfo.GetLocalPlayerController().PlayerCamera.CameraCache.POV.Rotation;
    foreach AllActors(Class'CoverLink', oCoverLink)
    {
        if (oCoverLink != None)
        {
            vDirection = oCoverLink.Location - vCameraLocation;
            if (VSizeSq(vDirection) <= 4000000)
            {
                if (Normal(vDirection) Dot vCameraRotation >= 0,1)
                {
                    vLocation = Canvas.Project(oCoverLink.Location);
                    Canvas.SetPos(vLocation.X - 40, vLocation.Y - 30);
                    sText = oCoverLink.Name $ " (" $ oCoverLink.Claims.Length $ ")";
                    Canvas.DrawText(sText);
                }
            }
        }
    }
    Canvas.SetDrawColor(255, 0, 0, 255);
    foreach AllActors(Class'CoverSlotMarker', oCoverSlotMarker)
    {
        if (oCoverSlotMarker != None)
        {
            vDirection = oCoverSlotMarker.Location - vCameraLocation;
            if (VSizeSq(vDirection) <= 4000000)
            {
                if (Normal(vDirection) Dot vCameraRotation >= 0,1)
                {
                    vLocation = Canvas.Project(oCoverSlotMarker.Location);
                    Canvas.SetPos(vLocation.X - 40, vLocation.Y - 30);
                    if (oCoverSlotMarker.OwningSlot.Link != None && oCoverSlotMarker.OwningSlot.SlotIdx >= 0 && oCoverSlotMarker.OwningSlot.SlotIdx < oCoverSlotMarker.OwningSlot.Link.Slots.Length && oCoverSlotMarker.OwningSlot.Link.Slots[oCoverSlotMarker.OwningSlot.SlotIdx].SlotOwner != None)
                    {
                        oSlotOwner = oCoverSlotMarker.OwningSlot.Link.Slots[oCoverSlotMarker.OwningSlot.SlotIdx].SlotOwner.Pawn;
                        sText = oCoverSlotMarker.Name $ " (" $ oSlotOwner $ ")";
                        Canvas.DrawText(sText);
                    }
                    else
                    {
                        Canvas.DrawText(oCoverSlotMarker.Name);
                    }
                }
            }
        }
    }
}

native exec function DisplayRouteInfo(Pawn pPawn, Color PathColor, optional bool bDrawPathOnly);

exec function ShowReachSpecs(Name nmNavigationPoint)
{
    local NavigationPoint oNavPoint;
    local int nIndex;
    local ReachSpec oReachSpec;
    foreach AllActors(Class'NavigationPoint', oNavPoint)
    {
        if (nmNavigationPoint == oNavPoint.Name)
        {
            break;
        }
    }
    if (oNavPoint == None)
    {
        return;
    }
    nIndex = 0;
    while (nIndex < oNavPoint.PathList.Length)
    {
        oReachSpec = oNavPoint.PathList[nIndex];
        if (oReachSpec != None && oReachSpec.Start != None && oReachSpec.End.Nav != None)
        {
            if (oReachSpec.IsBlocked())
            {
                oNavPoint.DrawDebugLine(oReachSpec.Start.Location, oReachSpec.End.Nav.Location, 255, 0, 0, true);
            }
            else
            {
                oNavPoint.DrawDebugLine(oReachSpec.Start.Location, oReachSpec.End.Nav.Location, 0, 255, 0, true);
            }
            if (oReachSpec.IsBlocked())
            {
                jump 394;
            }
        }
        nIndex++;
    }
    return;
}

function DrawAngstIcon(Actor oActor)
{
    local Vector ScreenCoords;
    local float X;
    local float Y;
    local float YL;
    local Vector CamLoc;
    local Rotator CamRot;
    if (WorldInfo == None || WorldInfo.bShowDebugText == false)
    {
        return;
    }
    PlayerOwner.GetPlayerViewPoint(CamLoc, CamRot);
    if (oActor != None && TimeSince(oActor.LastRenderTime) < 1 && oActor.Location - CamLoc Dot CamRot > 0)
    {
        X = Canvas.CurX;
        Y = Canvas.CurY;
        YL = Canvas.CurYL;
        ScreenCoords = Canvas.Project(oActor.Location);
        Canvas.CurX = ScreenCoords.X;
        Canvas.CurY = ScreenCoords.Y;
        Canvas.DrawText(":( - Angst");
        Canvas.CurX = X;
        Canvas.CurY = Y;
        Canvas.CurYL = YL;
    }
}

event DisplayNavWeight(Actor ProfileTarget, NavigationPoint Nav)
{
    local Vector ScreenCoords;
    local float X;
    local float Y;
    local float YL;
    local Vector CamLoc;
    local Rotator CamRot;
    local Color CurrentColor;
    PlayerOwner.GetPlayerViewPoint(CamLoc, CamRot);
    if (Nav.Location - CamLoc Dot CamRot > 0 && Nav.m_fNodeWeight > -100)
    {
        X = Canvas.CurX;
        Y = Canvas.CurY;
        YL = Canvas.CurYL;
        CurrentColor = Canvas.DrawColor;
        ScreenCoords = Canvas.Project(Nav.Location);
        if (Nav.m_fNodeWeight > 0)
        {
            Canvas.DrawColor = GreenColor;
        }
        else
        {
            Canvas.DrawColor = RedColor;
        }
        Canvas.CurX = ScreenCoords.X;
        Canvas.CurY = ScreenCoords.Y;
        Canvas.DrawText(Nav.m_fNodeWeight);
        Canvas.CurX = X;
        Canvas.CurY = Y;
        Canvas.CurYL = YL;
        Canvas.DrawColor = CurrentColor;
    }
}

native function bool IsFinalReleaseBuild();

defaultproperties
{
    m_messageBox=BioMessageBox'MessageBox'
    m_oDebugMenu=BioDebugMenu'DebugMenu'
    m_moviePlayer=BioMoviePlayer'moviePlayer'
    m_bUseGeneratedItemNames=true
    SafeAreaRatioX=0,05
    SafeAreaRatioY=0,05
    m_fSafeXOffset=60
    m_fSafeYOffset=35
    m_lineHeight=11
    m_charWidth=12
    m_leftColumnX=100
    m_rightColumnX=600
    m_farrightColumnX=900
    m_topRowY=70
    YellowColor=(B=0,G=255,R=255,A=255)
    OrangeColor=(B=0,G=165,R=255,A=255)
    DarkGreyColor=(B=64,G=64,R=64,A=255)
    SafeAreaTexture=Texture2D'DefaultDiffuse'
    // child object DebugMenu of type BioDebugMenu
    // child object MessageBox of type BioMessageBox
    // child object moviePlayer of type BioMoviePlayer
}
