﻿class BioInGamePropertyEditor extends Object
    native;

var String m_sActionMappingName;

var String m_sStateNodeName;

var String m_sNewLoadSaveNodeName;

var String m_sAnimNodeName;

var String m_sCameraRootName;

var String m_sEditableRootName;

var String m_sFileName;

var String m_sFooterText;

var float m_fColumnHeight;

var float m_fPropertyEditorRelativeColumnY;

var float m_fPropertyEditorRelativeColumnThreeX;

var float m_fPropertyEditorRelativeColumnTwoX;

var float m_fPropertyEditorRelativeColumnOneX;

var float m_fPropertyEditorSizeY;

var float m_fPropertyEditorSizeX;

var float m_fHUDRelativePropertyEditorOriginY;

var float m_fHUDRelativePropertyEditorOriginX;

var bool m_bSortByName;

var bool m_bSortByType;

var bool m_bDebugBones;

var bool m_bIsActive;

var BioPropertyEditorBaseNode m_oPropertyEditorNodes;

native function bool Initialize();

native function bool ActivateSystem();

native function bool DeactivateSystem();

native function bool UpdateSystem(float fDeltaTime);

native function bool WriteTreeDataToHUD(BioHUD oHUD);

native function bool CreateNodeTestData();

native function bool PerformActivateAction();

native function bool PerformDeactivateAction();

native function bool PerformUpAction();

native function bool PerformDownAction();

native function bool PerformRightAction();

native function bool PerformLeftAction();

native function bool ActivateMainMenu();

native function bool PerformLeftTriggerAction();

native function bool PerformRightTriggerAction();

native function bool PerformLeftShoulderAction();

native function bool PerformRightShoulderAction();

native function DrawBones(BioHUD oHUD);

event CreateGameplayNodes(BioPropertyEditorBaseNode Parent)
{
    local SFXInventoryManager Inv;
    local Inventory A;
    Inv = SFXGame(Class'Engine'.GetCurrentWorldInfo().Game).GetPlayerResourcesManager();
    CreateCommand(Parent, "Aim-assist Preset: Nancy(Preston)", "setaimassistvalues (x=0,y=2) 0.1  (x=0.2, y=0.3)");
    CreateCommand(Parent, "Aim-assist Preset: Sally(Vincent)", "setaimassistvalues (x=0,y=1) 0.05 (x=0.2, y=0.3)");
    CreateCommand(Parent, "Aim-assist Preset: Off", "setaimassistvalues (x=0,y=0) 0.0  (x=0.0, y=0.0)");
    foreach Inv.InventoryActors(Class'Inventory', A)
    {
        CreateObjectNode(Parent, A, A.Name);
    }
}

function CreateObjectNode(BioPropertyEditorBaseNode Parent, Object O, String ObjName)
{
    local BioPropertyEditorPropertyNode oControlNode;
    oControlNode = new(self,Class'BioPropertyEditorPropertyNode');
    oControlNode.m_sNodeDisplayName = ObjName;
    oControlNode.m_oParent = Parent;
    oControlNode.m_sDeliminator = "";
    oControlNode.SetObject(O);
    oControlNode.MakeNodes("");
    Parent.m_aChildren.AddItem(oControlNode);
}

function CreateCommand(BioPropertyEditorBaseNode Parent, String CmdName, String Command)
{
    local BioPropertyEditorLevelNode oControlNode;
    oControlNode = new(self,Class'BioPropertyEditorLevelNode');
    oControlNode.m_sNodeDisplayName = CmdName;
    oControlNode.m_sCommand = Command;
    oControlNode.m_oTop = self;
    Parent.m_aChildren.AddItem(oControlNode);
}

function DrawToHUD(BioHUD oHUD)
{
    local Canvas oCanvas;
    local float fBorderSpacing;
    local int I;
    local int minimum;
    local int FootHeaderHeight;
    local BioPropertyEditorBaseNode oFocusedControlNode;
    local BioPropertyEditorBaseNode oSelectableSiblingsParent;
    local Color Col;
    if (m_bDebugBones)
    {
        DrawBones(oHUD);
    }
    if (!m_bIsActive)
    {
        return;
    }
    oCanvas = oHUD.Canvas;
    fBorderSpacing = 30;
    FootHeaderHeight = 28;
    oCanvas.SetDrawColor(255, 255, 255, 200);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX, m_fHUDRelativePropertyEditorOriginY);
    oCanvas.DrawTile(Texture2D'Black', m_fPropertyEditorSizeX, m_fPropertyEditorSizeY, 0, 0, 32, 32);
    oCanvas.SetDrawColor(0, 0, 155, 100);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX, m_fHUDRelativePropertyEditorOriginY);
    oCanvas.DrawTile(Texture2D'Black', m_fPropertyEditorSizeX, FootHeaderHeight, 0, 0, 32, 32);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX, m_fHUDRelativePropertyEditorOriginY + m_fPropertyEditorSizeY - FootHeaderHeight);
    oCanvas.DrawTile(Texture2D'Black', m_fPropertyEditorSizeX, FootHeaderHeight, 0, 0, 32, 32);
    oCanvas.SetDrawColor(255, 255, 255, 150);
    oCanvas.Font = Class'Engine'.GetMediumFont();
    oCanvas.SetDrawColor(255, 255, 255, 200);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX, m_fHUDRelativePropertyEditorOriginY);
    oCanvas.DrawText("Menu", true);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX + m_fPropertyEditorRelativeColumnTwoX, m_fHUDRelativePropertyEditorOriginY);
    oCanvas.DrawText("Hierarchy View", true);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX + m_fPropertyEditorRelativeColumnThreeX, m_fHUDRelativePropertyEditorOriginY);
    oCanvas.DrawText("Selectables", true);
    oCanvas.Font = Class'Engine'.GetMediumFont();
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX, m_fHUDRelativePropertyEditorOriginY + fBorderSpacing);
    I = 0;
    while (I < m_oPropertyEditorNodes.m_aChildren.Length)
    {
        if (m_oPropertyEditorNodes.m_aTraversedStack.Length == 0 && I == m_oPropertyEditorNodes.m_nCurrentlySelectedChild)
        {
            Col = m_oPropertyEditorNodes.m_aChildren[I].getColour();
            Col.R = Clamp(255, 0, 255);
            Col.G = Clamp(55, 0, 255);
            Col.B = Clamp(5, 0, 255);
            oCanvas.SetDrawColor(Col.R, Col.G, Col.B);
        }
        else
        {
            Col = m_oPropertyEditorNodes.m_aChildren[I].getColour();
            oCanvas.SetDrawColor(Col.R, Col.G, Col.B);
        }
        oCanvas.DrawText(filterString(m_oPropertyEditorNodes.m_aChildren[I].getDisplayText(false)), true);
        I++;
    }
    oCanvas.Font = Class'Engine'.GetSmallFont();
    oCanvas.SetDrawColor(128, 128, 128, 230);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX + m_fPropertyEditorRelativeColumnTwoX, m_fHUDRelativePropertyEditorOriginY + fBorderSpacing);
    if (m_oPropertyEditorNodes.m_aTraversedStack.Length > 0)
    {
        oFocusedControlNode = m_oPropertyEditorNodes.m_aTraversedStack[m_oPropertyEditorNodes.m_aTraversedStack.Length - 1];
        I = 0;
        while (I < oFocusedControlNode.m_aTraversedStack.Length)
        {
            Col = oFocusedControlNode.m_aTraversedStack[I].getColour();
            oCanvas.SetDrawColor(Col.R, Col.G, Col.B, 230);
            oCanvas.DrawText(filterString(oFocusedControlNode.m_aTraversedStack[I].getDisplayText(false)), true);
            I++;
        }
    }
    oCanvas.Font = Class'Engine'.GetSmallFont();
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX + m_fPropertyEditorRelativeColumnThreeX, m_fHUDRelativePropertyEditorOriginY + fBorderSpacing);
    if (m_oPropertyEditorNodes.m_aTraversedStack.Length > 0)
    {
        oFocusedControlNode = m_oPropertyEditorNodes.GetSelectablesParent();
        oSelectableSiblingsParent = oFocusedControlNode.GetSelectablesParent();
        if (oSelectableSiblingsParent.m_aChildren.Length > 0)
        {
            minimum = oSelectableSiblingsParent.m_nScrollBoxSize;
            if (oSelectableSiblingsParent.m_aChildren.Length < minimum)
            {
                minimum = oSelectableSiblingsParent.m_aChildren.Length;
            }
            I = oSelectableSiblingsParent.m_nScrollBoxFirstIndex;
            while (I < oSelectableSiblingsParent.m_nScrollBoxFirstIndex + minimum)
            {
                if (I == oSelectableSiblingsParent.m_nCurrentlySelectedChild)
                {
                    Col = oSelectableSiblingsParent.m_aChildren[I].getColour();
                    Col.R = Clamp(Col.R * 2, 0, 255);
                    Col.G = Clamp(Col.G * 2, 0, 255);
                    Col.B = Clamp(Col.B * 2, 0, 255);
                    oCanvas.SetDrawColor(Col.R, Col.G, Col.B, 230);
                }
                else
                {
                    Col = oSelectableSiblingsParent.m_aChildren[I].getColour();
                    oCanvas.SetDrawColor(Col.R, Col.G, Col.B, 230);
                }
                oCanvas.DrawText(filterString(oSelectableSiblingsParent.m_aChildren[I].getDisplayText(true)), true);
                I++;
            }
        }
    }
    oCanvas.Font = Class'Engine'.GetMediumFont();
    oCanvas.SetDrawColor(255, 255, 255, 200);
    oCanvas.SetPos(m_fHUDRelativePropertyEditorOriginX + 120, m_fHUDRelativePropertyEditorOriginY + m_fPropertyEditorSizeY - 25);
    oCanvas.DrawText(m_sFooterText, true);
    WriteTreeDataToHUD(oHUD);
}

function String filterString(String Input)
{
    local String output;
    if (Len(Input) > 42)
    {
        output = Left(Input, 42);
        output = output $ "...";
        return output;
    }
    else
    {
        return Input;
    }
}

defaultproperties
{
    m_bSortByType=true
    m_bSortByName=true
    m_sFooterText="In Game Property Editor"
    m_sFileName="EditedInGameProperties.txt"
    m_sEditableRootName="Editable World Objects"
    m_sCameraRootName="Cameras"
    m_sAnimNodeName="Anim. / Character Edit"
    m_sNewLoadSaveNodeName="NEW: Load / Save Game"
    m_sStateNodeName="Load / Save State Only"
    m_sActionMappingName="Action Mappings (controlled character)"
}
