﻿class BioInterface_Appearance_Pawn extends BioInterface_Appearance
    hidecategories(Object,Object,Object)
    native
    editinlinenew;

struct native CreatureSpeeds
{
    var() float fGroundSpeed;

    var() float fAirSpeed;

    var() float fWaterSpeed;

    var() float fClimbSpeed;

    var() float fWalkSpeed;

    var() float fSprintSpeed;

    var() float fExploreSprintSpeed;

    var() float fTacticalSpeed;

    var() float fTacWalkSpeed;

    var() float fTacCrouchSpeed;

    var() float fTacCrouchWalkSpeed;

    var() float fTurnSpeedHigh;

    var() float fTurnSpeedLow;

    var() float fTurnSpeedCombat;

    var() float fTurnSpeedCombatCrouch;

    var() float fTurnSpeedCombatSprint;

    var() float fStandardFriction;

    var() float fAccelRate;

    var() float fMaxDSAccel;

    var() float fMaxDSDecel;

    var() float fMaxDSAccelTac;

    var() float fMaxDSDecelTac;

    var() float fMaxDSAccelTacCrouch;

    var() float fMaxDSDecelTacCrouch;

}

var Bio2DA m_oCreatureSpeedsTable;

var Name m_nmBloodColor;

var Name m_nmCreatureSpeed;

var bool m_bHeadGearVisiblePreference;

var BioPawnHeadGearVisibility m_cachedHeadGearVisibility;

var BioPawnHeadGearVisibility m_headGearVisibilityRunTimeOverride;

var(AppearanceInstance) const BioPawnHeadGearVisibility m_headGearVisibilityOverride;

var /* 00000008 */ BioMaterialOverride m_pMaterialParameters;

var(AppearanceInstance) const Name CreatureSpeedOverride;

var /* 00000008 */ Bio_Appr_Character_Settings m_oSettings;

struct native BioPawnLabelledHeadGearBool
{
    var() const EBioPawnHeadGearComponent m_eComponent;

    var() bool m_bIsVisible;

}

struct native BioPawnHeadGearVisibility
{
    var() bool m_bOverride;

    var() BioPawnLabelledHeadGearBool m_a[3];

}

native function SetHeadGearVisiblePreference(bool B);

native function ExtractResources(BioPawn Pawn, Bio_Appr_Character Appearance);

native function bool UpdateAppearance(optional bool bForceUpdate);

native function GetCreatureSpeeds(out CreatureSpeeds SpeedsRecord);

native function float GetDefaultCollisionHeight();

native function float GetDefaultCollisionRadius();

native function float GetDefaultCollisionCrouchHeight();

native function float GetDefaultCollisionReadyHeight();

defaultproperties
{
    m_oSettings=Bio_Appr_Character_Settings'oSettings'
    CreatureSpeedOverride=Default
    m_pMaterialParameters=BioMaterialOverride's_pDefaultMaterialParameters'
    m_bHeadGearVisiblePreference=true
    m_oCreatureSpeedsTable=Bio2DA'MovementTables_CreatureSpeeds'
    // child object oSettings of type Bio_Appr_Character_Settings
    // child object s_pDefaultMaterialParameters of type BioMaterialOverride
}
