﻿class BioLevelUpSystem extends BioBaseComponent
    native;

enum EBioLevelUp2DA
{
    LEVEL_UP_2DA_LEVEL_UP,
    LEVEL_UP_2DA_RANK,
    LEVEL_UP_2DA_CHALLENGE_SCALING,
    LEVEL_UP_2DA_EXPERIENCE,
};

var transient bool m_bDefault2DAsLoaded;

var Bio2DA m_aLevelUp2DA[4];

var Name m_aLevelUp2DANames[4];

var Name m_nmLevelUpPackageName;

native static function bool LevelUpPawn(BioPawn Pawn, int newLevel);

native static function int PointsForHenchLevelUp(int oldLevel, int newLevel);

native static function bool ExperienceNeededForLevel(int Level, out int experience);

static function bool AttemptLevelUp(BioPlayerSquad Squad)
{
    local int NewPlayerLevel;
    local int PlayerLevel;
    local int XPForNextLevel;
    local int idx;
    local float CurrentXP;
    local SFXPawn_Player Pawn;
    local BioPawn Member;
    idx = 0;
    while (idx < Squad.GetSquadSize())
    {
        Pawn = SFXPawn_Player(Squad.GetMember(idx));
        if (Pawn != None && Pawn.IsHumanControlled())
        {
            CurrentXP = Pawn.TotalXP;
            PlayerLevel = Pawn.CharacterLevel;
            break;
        }
        idx++;
    }
    NewPlayerLevel = PlayerLevel;
    if (PlayerLevel >= 1 && ExperienceNeededForLevel(PlayerLevel + 1, XPForNextLevel))
    {
        while (CurrentXP >= XPForNextLevel)
        {
            ++NewPlayerLevel;
            if (ExperienceNeededForLevel(NewPlayerLevel + 1, XPForNextLevel) == false)
            {
                break;
            }
        }
        idx = 0;
        while (idx < Squad.GetSquadSize())
        {
            Member = BioPawn(Squad.GetMember(idx));
            if (Member != None && LevelUpPawn(Member, NewPlayerLevel))
            {
                Member.CharacterLevel = NewPlayerLevel;
            }
            idx++;
        }
        if (NewPlayerLevel > PlayerLevel)
        {
            Class'BioTelemetry'.SendEventInt('PLAYER_LEVEL_UP', NewPlayerLevel);
        }
        return NewPlayerLevel > PlayerLevel;
    }
    return false;
}

event AutoLevelUpPowers(BioPawn Pawn)
{
    local SFXPowerLevelUpHelper Helper;
    if (Pawn == None)
    {
        return;
    }
    Helper = new(self,Class'SFXPowerLevelUpHelper');
    if (Helper == None)
    {
        return;
    }
    Helper.Initialize(BioWorldInfo(Pawn.WorldInfo));
    Helper.SetPawn(Pawn);
    Helper.AutoLevelUp();
    Helper.ApplyChanges();
}

defaultproperties
{
    m_nmLevelUpPackageName=BIOG_2DA_LevelUp_X
    m_aLevelUp2DANames=LevelUp_LevelUp
    m_aLevelUp2DANames=LevelUp_Rank
    m_aLevelUp2DANames=LevelUp_ChallengeScalingVars
    m_aLevelUp2DANames=LevelUp_Experience
    m_aLevelUp2DA=Bio2DA'Default2DA'
    m_aLevelUp2DA=Bio2DA'Default2DA'
    m_aLevelUp2DA=Bio2DA'Default2DA'
    m_aLevelUp2DA=Bio2DA'Default2DA'
}
