﻿class BioMorphFaceFrontEnd extends BioMorphUtility
    hidecategories(Object,Advanced,Collision,Movement,Debug)
    config(UI)
    native;

enum EBioMorphFrontendSliderType
{
    BMFE_SLIDER_MORPH_SINGLE,
    BMFE_SLIDER_MORPH_DOUBLE,
    BMFE_SLIDER_MATERIAL,
};

struct native SliderModifierSliderData
{
    var array<BioMorphFaceFESliderBase> m_aoSliderData;

    var array<float> m_fRandWeights;

    var float m_fRandWeightsTotal;

}

struct native SliderModifier
{
    var String m_sName;

    var array<float> m_aRandMin;

    var array<float> m_aRandMax;

    var array<SliderModifierSliderData> m_aSliders;

}

struct native Slider
{
    var String m_sName;

    var int m_iIndex;

    var int m_iValue;

    var bool m_bNotched;

    var int m_iSteps;

    var int m_iStringRef;

    var int m_iDescriptionStringRef;

    var array<BioMorphFaceFESliderBase> m_aoSliderData;

    var array<float> m_fRandWeights;

    var float m_fRandWeightsTotal;

    var float m_fRandMin;

    var float m_fRandMax;

    var array<SliderModifier> m_aSliderModifiers;

}

struct native Category
{
    var String m_sCatName;

    var int m_iCatIndex;

    var int m_iStringRef;

    var int m_iDescriptionStringRef;

    var array<Slider> m_aoSliders;

}

struct native FaceData
{
    var AdditionalData m_pAdditionalParams;

    var array<Category> m_oCategories;

}

struct native BaseSliders
{
    var String m_sSliderName;

    var float m_fValue;

}

struct native BaseHeads
{
    var array<BaseSliders> m_fBaseHeadSettings;

}

var int m_iCurrentBaseHead;

var Slider m_pModifierData;

var array<BaseHeads> m_aBaseHeads;

var BaseHeads m_oBaseSettings;

var BioPawn m_oPawn;

var BioPawnBehavior m_oBehavior;

var String m_sPlayerName;

var config bool m_bDebugStrings;

var FaceData m_oFaceData;

var SkeletalMesh m_oOriginalMesh;

var MaterialInstanceConstant m_oOriginalMaterial;

var BioMorphFace m_oMorphFace;

var BioMorphFace m_oOriginalFace;

var /* 00000008 */ SkeletalMeshComponent m_oHairMeshComp;

var /* 00000008 */ SkeletalMeshComponent m_oHeadMeshComp;

native function Initialize(SFXMorphFaceFrontEndDataSource Data, BioPawn pThePlayer, bool bPlayerIsMale, optional bool bReset);

native function RandomizeAll();

native function RandomizeCategory(int nCategory, optional bool bUpdate);

native function ResetAll();

native function ResetCategory(int nCategory, optional bool bUpdate);

native function CalibrateToPawn(BioPawn pSrcPawn, optional bool bUpdate);

native function int GetNumberOfFeatureCategories();

native function int GetCategoryString(int categoryIndex);

native function int GetCategoryDescription(int categoryIndex);

native function int GetNumSlidersInCategory(int categoryIndex);

native function int GetSliderLabel(int categoryIndex, int sliderIndex);

native function int GetSliderDesc(int categoryIndex, int sliderIndex);

native function int GetSliderMin(int categoryIndex, int sliderIndex);

native function int GetSliderMax(int categoryIndex, int sliderIndex);

native function int GetSliderStep(int categoryIndex, int sliderIndex);

native function int GetSliderValue(int categoryIndex, int sliderIndex);

native function bool GetSliderNotched(int categoryIndex, int sliderIndex);

native function HandleSliderChange(int categoryIndex, int sliderIndex, int SliderValue, optional bool bUpdate);

native function CleanUp();

native function SetPlayerName(String sPlayerName);

native function SelectNextBaseHead();

native function SelectPreviousBaseHead();

defaultproperties
{
    m_iCurrentBaseHead=-1
}
