﻿class BioOp extends Object
    abstract;

enum EBioOp
{
    BIO_OP_NULL,
    BIO_OP_ADD,
    BIO_OP_MULTIPLY,
    BIO_OP_MULTIPLY_COMPLEMENT,
    BIO_OP_ASSIGN,
    BIO_OP_COUNT,
};

static function EvaluateFloat(out float fA, EBioOp eOp, out float fB, bool bInvertOp, optional float fU)
{
    switch (eOp)
    {
        case 1:
            if (bInvertOp)
            {
                fA -= fB;
            }
            else
            {
                fA += fB;
            }
            break;
        case 2:
            if (bInvertOp)
            {
                fA /= fB;
            }
            else
            {
                fA *= fB;
            }
            break;
        case 3:
            if (fU == 0)
            {
                fU = 1;
            }
            if (bInvertOp)
            {
                fA /= fU - fB;
            }
            else
            {
                fA *= fU - fB;
            }
            break;
        case 4:
            if (bInvertOp)
            {
                fB = fA;
            }
            else
            {
                fA = fB;
            }
            break;
        default:
            assert(false);
    }
}

static function EvaluateInt(out int nA, EBioOp eOp, int nB, bool bInvertOp, int nU)
{
    switch (eOp)
    {
        case 1:
            if (bInvertOp)
            {
                nA -= nB;
            }
            else
            {
                nA += nB;
            }
            break;
        case 2:
            if (bInvertOp)
            {
                nA /= nB;
            }
            else
            {
                nA *= nB;
            }
            break;
        case 3:
            if (nU == 0)
            {
                nU = 1;
            }
            if (bInvertOp)
            {
                nA /= nU - nB;
            }
            else
            {
                nA *= nU - nB;
            }
            break;
        case 4:
            if (bInvertOp)
            {
                nB = nA;
            }
            else
            {
                nA = nB;
            }
            break;
        default:
            assert(false);
    }
}

defaultproperties
{
}
