﻿class BioPawn extends Pawn
    hidecategories(Navigation)
    config(Game)
    native;

struct native RootMotionOverrideEntry
{
    var AnimNode Node;

    var ERootMotionMode RMMode;

    var ERootMotionRotationMode RMRMode;

}

enum ESFXRigidBodyMode
{
    SFXRigidBodyMode_Animated,
    SFXRigidBodyMode_Motorized,
    SFXRigidBodyMode_Full,
};

struct native AttackReservation
{
    var int nID;

    var int nTicketCost;

    var float fTimeUntilExpiry;

    var bool bUsingTicket;

}

struct native RigidBodyCallback
{
    var int nPriority;

    var delegate<RBCollisionCallback> RBCallback;

}

struct native AimAssistBox
{
    var() EAimNodes NodeType;

    var() float Width;

    var() float Height;

    var() float SoftMargin;

}

delegate RBCollisionCallback(Pawn oPawn, Actor oImpactActor, Vector vImpactDir);

enum EAimNodes
{
    AimNode_Cover,
    AimNode_Head,
    AimNode_LeftShoulder,
    AimNode_RightShoulder,
    AimNode_Chest,
    AimNode_Groin,
    AimNode_LeftKnee,
    AimNode_RightKnee,
};

var config float RadarFOV;

var config float RadarRange;

var transient float ScaleLimitTimeToGo;

var() array<AimAssistBox> AimAssistRegions;

var transient Actor m_aLastCollidedActor;

var transient float m_fInitialZVal;

var float MeshFloorConformTransSpeed;

var transient float MeshFloorConformTranslation;

var transient Vector MeshTranslationOffset;

var transient array<RigidBodyCallback> m_CollisionCallbacks;

var transient float LastMantleTime;

var transient Vector LastMantleLocation;

var transient float InterpZTranslation;

var transient int ConformTraceFrameCount;

var config int ConformTraceInterval;

var transient int m_nCurrentReservationID;

var transient array<AttackReservation> m_aReservations;

var transient int m_nAttackTickets;

var transient int m_nTargetTickets;

var config float m_fTicketExpiryTime;

var config int m_nMaxAttackTickets;

var config int m_nMaxTargetTickets;

var config float FallingStateEntranceTime;

var transient Object LastPhysicsSetter;

var int MaxBodyCount;

var transient float TimeOfDeath;

var() String AIBarkAnimName;

var() FaceFXAnimSet AIBarkAnimSet;

var(HitReactions) float fPlayerPawnPhysHRWeight;

var(HitReactions) float fPlayerPawnPhysHRModifier;

var(HitReactions) float fPhysHRAngularSPringStrength;

var(HitReactions) float fPhysHRLinearSpringStrength;

var(HitReactions) float fPhysHRMotorDampingStrength;

var(HitReactions) float fPhysHRMotorSpringStrength;

var(HitReactions) float fPhysicsImpactMassEffectScale;

var float fPhysicsImpactBlendTimeRemaining;

var(HitReactions) float fPhysicsImpactBlendOutTime;

var(HitReactions) float fPhysicsHitReactionImpulseScale;

var(HitReactions) array<Name> PhysicsImpactSpringList;

var(HitReactions) array<Name> PhysicsImpactBoneList;

var transient float ThreatRadiusSquared;

var /* 00000008 */ transient SFXPowerManager PowerManager;

var float m_fPhysicsForceIncurred;

var WwiseEvent DefaultFootStepEvent;

var float m_fLastFootStepTime;

var array<Object> m_aAdditionalResourcesToCook;

var transient int m_nHiddenRequestCount;

var config String m_sWrinkleMaterialIdentifier;

var config int m_nWrinkleHighestLOD;

var transient array<Name> m_afnCinematicLevels;

var transient array<AnimSet> m_aOriginalAnimSets;

var transient AnimTree m_pOriginalAnimTree;

var /* 00000008 */ transient AudioComponent m_pFacialAudioComp;

var(SoundSet) FaceFXAnimSet m_pOverrideSndSetFaceFXPkg;

var WwiseEventPairObject m_oWwiseRollingStartMoving;

var WwiseEventPairObject m_oWwiseRollingIdle;

var config float m_fMaxRelevancyDistance;

var transient int m_nTickCount;

var(Lighting) /* 00000008 */ LightEnvironmentComponent LightEnvironment;

var /* 00000008 */ LightEnvironmentComponent m_pLightEnvComponent;

var const transient config float m_fEnableCCDMultiplierThreshold;

var transient float m_fRBSleepEnergyThreshold;

var Vector m_vFinalRigidBodyPosition;

var transient float m_fBumpCheckTimer;

var transient Vector m_vBumpLastPosition;

var transient Vector m_vLastGoodNormal;

var transient Vector m_vLastGoodLocation;

var transient Rotator m_rLastGoodRotation;

var const transient int AnimationTransitionPending;

var const transient int AnimationTransitionCount;

var float LastCoverActionTime;

var float CurrentSlotPct;

var int RightSlotIdx;

var int LeftSlotIdx;

var int PreviousSlotIdx;

var int TargetSlotIdx;

var int CurrentSlotIdx;

var CoverLink CurrentLink;

var transient config float PortArmsWedgeRadius;

var transient config float PortArmsWedgeHeight;

var transient config float PortArmsNPCInterval;

var transient config float PortArmsPlayerInterval;

var transient float PortArmsTimer;

var const native MultiMap_Mirror m_mAnimsetRegistration;

var transient BioLookAt m_oLookAtData;

var config float m_fLookMultiplier;

var transient Vector m_vSafeTeleportLocation;

var /* 00000008 */ BioGestureAnimSetMgr m_pAnimSetMgr;

var transient array<RootMotionOverrideEntry> RootMotionOverrides;

var int m_nRootMotionEnabledCountDeprecated;

var float m_fCollisionReadyHeight;

var transient float m_fRunStopDistance;

var transient float m_fWalkStopDistance;

var float m_fWalkAnimPlaybackLen;

var float m_fWalkAnimPlaybackRate;

var float m_fWalkAnimPlaybackPos;

var float m_fRunAnimPlaybackLen;

var float m_fRunAnimPlaybackRate;

var float m_fRunAnimPlaybackPos;

var float m_fLookAtHoldTime;

var float m_fLookAtMaxAngle;

var float m_fLookAtMaxHoldTime;

var float m_fLookAtMinHoldTime;

var float m_fLookAtSpeed;

var Name m_nmRagdollRecoverDirSwapBone;

var Name m_nmRagdollRecoverBone;

var float m_fRagdollRecoverPhysBlendTime;

var transient float m_fLifeCrustCount;

var transient BioVisualEffect m_LifeCrust;

var transient int TalentPoints;

var() /* 00000008 */ array<SkeletalMeshComponent> m_aoAccessories;

var() /* 00000008 */ SkeletalMeshComponent m_oFacePlateMesh;

var() /* 00000008 */ SkeletalMeshComponent m_oVisorMesh;

var() /* 00000008 */ SkeletalMeshComponent m_oHeadGearMesh;

var() /* 00000008 */ SkeletalMeshComponent m_oHairMesh;

var() BioMorphFace MorphHead;

var() /* 00000008 */ SkeletalMeshComponent HeadMesh;

var int m_nTalkedToCount;

var() transient Vector KilledByHitLocation;

var() transient class<DamageType> KilledByDamageType;

var() transient Controller KilledBy;

var() transient float LastAnimatedReactionTime;

var() transient int DeathHitBoneIdx;

var transient float fMoveMag;

var float StormTurnSpeed;

var float StormSpeed;

var float CrouchGroundSpeed;

var float CoverCrouchGroundSpeed;

var float CoverGroundSpeed;

var float DeathCrawlSpeed;

var float CombatGroundSpeed;

var float CombatWalkSpeed;

var float TurnSpeed;

var float WalkSpeed;

var BioEventDispatcher m_oEventDispatcher;

var transient Weapon WeaponOnDeck;

var transient Weapon WeaponFromLastGameState;

var array<MaterialInstance> HeadMaterialInstances;

var array<MaterialInstance> BodyMaterialInstances;

var(Save) const Guid MyGuid;

var(Optimization) float FootstepCullDistance;

var BioPawnBehavior m_oBehavior;

var transient int CharacterLevel;

var transient ESFXRigidBodyMode RigidBodyMode;

var transient EActionState ActionState;

var transient BioBaseSquad Squad;

var transient BioPawnType PawnType;

var Name m_nmAIBehaviour;

var transient NavigationPoint PreRagdollAnchor;

var transient bool m_bRagdollEnteredPendingBodyFallSound;

var transient bool bIsCrawling;

var transient bool m_bDeathPowerUsed;

var transient bool bIsDead;

var transient bool bScalingToZero;

var transient bool m_bPreviewBegun;

var transient bool m_bMovingIsPlaying;

var transient bool m_bIdleIsPlaying;

var transient bool m_bRollingNotMoving;

var transient bool m_bBumpLastMoving;

var transient bool m_bLastGoodInitalized;

var transient bool bPlayingPortArmsAnim;

var transient bool bInPortArms;

var transient bool bCanUsePortArms;

var transient bool bPortArmsEnabled;

var transient bool m_bNoWrinkleMapData;

var transient bool m_bLookAtNotice;

var transient bool m_bSafeTeleportQueued;

var transient bool m_bTurnInPlaceRequested;

var transient bool bRootMotionOverriden;

var() transient bool bPlayDeathAnimation;

var transient bool bIsSniping;

var transient bool bHasShields;

var transient bool bIgnoreSelectionMaxRange;

var transient bool bIsStealthed;

var transient bool bScalePowers;

var(AI) float fSleepPerceptionDistance;

var bool bDisableMeshTranslationChanges;

var bool bAimBackDisabledTransitions;

var() bool bDisableVocEvents;

var(HitReactions) bool bEnableHitReactionBoneSprings;

var(AI) bool m_bPlayCustomActivationAnim;

var bool m_bAllowedToLeavePlaypen;

var() bool m_bClassificationOverriden;

var bool m_bDroneLanded;

var bool m_bRollingSoundUsed;

var(Behavior) bool m_bAlwaysTick;

var bool bIgnoreDuringCoverSelection;

var bool bIsInStationaryCover;

var bool bWasInCover;

var(Debug) config bool bWeaponDebug_DamageRadius;

var(Debug) config bool bWeaponDebug_Accuracy;

var() bool m_bDisableLookAtNotice;

var() bool m_bAutoLookAtPlayer;

var bool m_bInConversation;

var bool m_bRagDollEnabled;

var bool m_bHideWithCameraCollision;

var bool m_bUseBoneCameraHookOffset;

var bool m_bUseWallSlidingSpeedAdj;

var bool m_bEnableStopRootMotion;

var bool m_bEnableStartRootMotion;

var bool m_bEnableLookAtTargeting;

var() bool m_bCanCleanupCorpse;

var bool m_bInvertRagdollRecoverDirSwapBoneAxis;

var bool m_bRecoverDirSwap;

var bool m_bInvertRagdollRecoverBoneAxis;

var bool m_bOldUpdateSkelWhenNotRendered;

var const bool bOverrideBodyMats;

var const bool bOverrideHeadMat;

var(Save) bool bSaveMe;

var(Optimization) bool bCollidesAfterDeath;

var(Optimization) bool bKillOnRagdoll;

var(Optimization) bool bSpawnPHATInstance;

var(Optimization) bool bCanPlayPhysicsHitReactions;

var(Optimization) bool bCanPlayAnimatedReactions;

var(Optimization) bool bIconicAppearance;

var bool bFullyInitialized;

var bool bShouldSpawnWeapons;

var(AI) bool bSleeping;

var(AI) float BioticResistance;

var(AI) float TechResistance;

var() ECoverType LastCoverType;

var() EBioPawnClassification m_eClassification;

var EPhysics m_eUseRollingInPhysicsMode;

var ECoverAction CoverAction;

var ECoverType CoverType;

var ECoverDirection CoverDirection;

var ECoverDirection CurrentSlotDirection;

var EAxis m_eRagdollRecoverDirSwapBoneAxis;

var EAxis m_eRagdollRecoverBoneAxis;

var(AI) eAIBehaviour m_eAIBehaviour;

var(AI) SFXLoadoutData Loadout;

var transient class<BioFaction> OldFactionClass;

var(AI) class<BioFaction> FactionClass;

var(AI) class<BioAiController> AIController;

var() transient array<AnimNodeSlot> BodyStanceNodes;

var() array<Name> AttachSlots;

var const Name LeftHandSocketName;

var const Name RightHandSocketName;

var() array<ReactionPart> ReactionBones;

var() array<Name> AimNodes;

struct native ReactionPart
{
    var() Name BodyPart;

    var() array<Name> BoneNames;

}

enum EActionState
{
    ActionState_Explore,
    ActionState_Combat,
};

enum eAIBehaviour
{
    AIB_None,
};

enum EWalkingSpeedMode
{
    eWalkingSpeedMode_ExploreRun,
    eWalkingSpeedMode_ExploreWalk,
    eWalkingSpeedMode_ExploreStorming,
    eWalkingSpeedMode_ExploreCrouched,
    eWalkingSpeedMode_CombatRun,
    eWalkingSpeedMode_CombatWalk,
    eWalkingSpeedMode_CombatStorming,
    eWalkingSpeedMode_CombatCrouched,
    eWalkingSpeedMode_CombatSniping,
    eWalkingSpeedMode_CombatZoomed,
    eWalkingSpeedMode_CoverMove,
    eWalkingSpeedMode_CoverCrouched,
    eWalkingSpeedMode_Crawling,
};

enum EBodyStance
{
    BS_FullBody,
};

struct native BodyStance
{
    var() EBodyStance StanceID;

    var() Name AnimName;

}

native function ValidateRagdoll();

native function WeldPhysicsAssetInstance();

native function UnWeldPhysicsAssetInstance();

native function SFXCompositeSkeletalMesh MergeMeshes(SkeletalMesh BaseMesh, array<SkeletalMesh> AdditionalMeshes, SkeletalMeshComponent HeadMeshComponent);

native function RefreshMaterialInstances();

native function ClearMaterialInstances();

event UpdateAppearance()
{
    ClearMaterialInstances();
    RefreshMaterialInstances();
}

native final function bool GetAimNodeLocation(EAimNodes AimNode, out Vector AimLocation, optional bool bLogError);

native function HardResetActionAndAnimationState();

native function HACKResetRootMotion();

native final function bool IsInAnimatedTransition();

native final function BeginAnimatedTransition();

native final function EndAnimatedTransition();

native final function bool IsAnimatedTransitionPending();

native final function SetAnimatedTransitionPending();

native final function bool IsInCover();

native final function bool IsInCoverLeaning();

native final function bool CanDoCoverAction(ECoverAction CovAction, optional bool bPrecise, optional bool bTestCamera);

native final function bool DoesCoverStateAllowImmediateFire();

native final function CalculateCoverLocationDelta(out Vector Delta);

native final simulated function bool FitCollision();

native final function bool CanUseAnchor(NavigationPoint Nav);

native final function SetMeshTranslationOffset(Vector NewOffset, bool bForce);

native final function UpdateFloorConform(float DeltaSeconds);

native final function PerformStepsSmoothing(const out Vector OldLocation, float DeltaSeconds);

function bool InCombat()
{
    local BioAiController AI;
    local SFXGame GameInfo;
    AI = BioAiController(Controller);
    if (AI != None)
    {
        return AI.HasAnyEnemies();
    }
    GameInfo = SFXGame(WorldInfo.Game);
    if (GameInfo != None)
    {
        return GameInfo.bInCombat || GameInfo.bForceCombat;
    }
    return false;
}

native final function bool CanExplore();

native final function bool CanCombat();

function PlayerCoverAcquired(CovPosInfo CovInfo)
{
    local BioPlayerController PC;
    SetCoverType(GetCoverTypeFor(CovInfo));
    SetCoverAction(0);
    CurrentSlotDirection = 0;
    SetCovPosInfo(CovInfo);
    CurrentLink.Claim(Controller, CurrentSlotIdx);
    PC = BioPlayerController(Controller);
    if (PC != None)
    {
        PC.OnEnteredCover();
        PC.CoverLog("enter cover", GetFuncName());
        PC.HintSystem.HintEvent('EnterCover');
    }
}

simulated function SetCovPosInfo(CovPosInfo CovInfo)
{
    SetCoverInfo(CovInfo.Link, CovInfo.LtToRtPct < 0,5 ? CovInfo.LtSlotIdx : CovInfo.RtSlotIdx, CovInfo.LtSlotIdx, CovInfo.RtSlotIdx, CovInfo.LtToRtPct);
}

simulated function SetCoverInfo(CoverLink Link, int SlotIdx, int LeftIdx, int RightIdx, float SlotPct)
{
    CurrentLink = Link;
    CurrentSlotIdx = SlotIdx;
    LeftSlotIdx = LeftIdx;
    RightSlotIdx = RightIdx;
    CurrentSlotPct = SlotPct;
    SetCoverType(FindCoverType());
}

final function ECoverType FindCoverType()
{
    local ECoverType LeftType;
    local ECoverType RightType;
    if (CurrentLink.Slots.Length > 1)
    {
        if (LeftSlotIdx < 0 || RightSlotIdx < 0 || LeftSlotIdx >= CurrentLink.Slots.Length || RightSlotIdx >= CurrentLink.Slots.Length)
        {
            ScriptTrace();
        }
        LeftType = CurrentLink.Slots[LeftSlotIdx].CoverType;
        RightType = CurrentLink.Slots[RightSlotIdx].CoverType;
        if (CurrentSlotPct <= 0,1)
        {
            return LeftType;
        }
        else
        {
            if (CurrentSlotPct >= 0,9)
            {
                return RightType;
            }
            else
            {
                if (LeftType > RightType)
                {
                    return LeftType;
                }
                else
                {
                    return RightType;
                }
            }
        }
    }
    return CurrentLink.Slots[0].CoverType;
}

final simulated function ECoverType GetCoverTypeFor(CovPosInfo Cover)
{
    local ECoverType LeftType;
    local ECoverType RightType;
    if (Cover.Link == None)
    {
        return 0;
    }
    if (Cover.Link.Slots.Length > 1)
    {
        if (Cover.LtToRtPct == 0)
        {
            return Cover.Link.Slots[Cover.LtSlotIdx].CoverType;
        }
        else
        {
            LeftType = Cover.Link.Slots[Cover.LtSlotIdx].CoverType;
            RightType = Cover.Link.Slots[Cover.RtSlotIdx].CoverType;
            return LeftType > RightType ? LeftType : RightType;
        }
    }
    return Cover.Link.Slots[0].CoverType;
}

final event LeaveCover()
{
    local BioPlayerController ControllerPlayer;
    local BioAiController ControllerAI;
    ControllerPlayer = BioPlayerController(Controller);
    if (IsInCover() || ControllerPlayer != None && ControllerPlayer.IsInState('PlayerInAimBack'))
    {
        CurrentLink.UnClaim(Controller, CurrentSlotIdx, true);
        PreviousSlotIdx = CurrentSlotIdx;
        CurrentSlotPct = -1;
        CurrentLink = None;
        CurrentSlotIdx = -1;
        LeftSlotIdx = -1;
        RightSlotIdx = -1;
        CoverType = 0;
        CoverAction = 0;
        CoverDirection = 0;
        if (IsHumanControlled())
        {
            SetAnchor(None);
        }
        if (ControllerPlayer != None)
        {
            ControllerPlayer.OnExitedCover();
            ControllerPlayer.CoverLog("leave cover", GetFuncName());
            ControllerPlayer.HintSystem.HintEvent('LeaveCover');
        }
        else
        {
            ControllerAI = BioAiController(Controller);
            if (ControllerAI != None)
            {
                ControllerAI.bForceDesiredRotation = false;
            }
        }
    }
}

final simulated function SetCoverType(ECoverType NewCoverType)
{
    if (NewCoverType != CoverType)
    {
        if (BioPlayerController(Controller) != None)
        {
            BioPlayerController(Controller).CoverLog("newCoverType:" @ NewCoverType, GetFuncName());
        }
        CoverType = NewCoverType;
    }
}

final event SetCoverAction(ECoverAction NewCoverAction)
{
    if (NewCoverAction != CoverAction)
    {
        if (IsHumanControlled())
        {
            BioPlayerController(Controller).CoverLog("NewCoverAction:" @ NewCoverAction, GetFuncName());
        }
        CoverAction = NewCoverAction;
        LastCoverActionTime = WorldInfo.TimeSeconds;
    }
}

final simulated function bool IsLeaning(ECoverAction Action)
{
    return Action == 4 || Action == 3 || Action == 7;
}

final simulated function bool IsPeeking(ECoverAction Action)
{
    return Action == 10 || Action == 9 || Action == 11;
}

final simulated function bool IsPoppingUp(ECoverAction Action)
{
    return Action == 7;
}

final function SetCoverDirection(ECoverDirection NewCoverDirection)
{
    if (CoverDirection != NewCoverDirection)
    {
        if (IsHumanControlled())
        {
            BioPlayerController(Controller).CoverLog("NewCD:" @ NewCoverDirection, GetFuncName());
        }
        CoverDirection = NewCoverDirection;
    }
}

final function int GetSlotIdxByPct()
{
    if (CurrentSlotPct < 0,5)
    {
        return LeftSlotIdx;
    }
    return RightSlotIdx;
}

simulated event ReachedCoverSlot(int SlotIdx)
{
    local BioPlayerController PC;
    local BioAiController AI;
    local int OldSlotIdx;
    if (CurrentLink != None)
    {
        OldSlotIdx = CurrentSlotIdx;
        SetCoverType(CurrentLink.Slots[SlotIdx].CoverType);
        CurrentSlotIdx = SlotIdx;
        PC = BioPlayerController(Controller);
        if (PC != None)
        {
            PC.NotifyReachedCoverSlot(SlotIdx, OldSlotIdx);
        }
        else
        {
            AI = BioAiController(Controller);
            if (AI != None)
            {
                AI.NotifyReachedCoverSlot(SlotIdx);
            }
        }
    }
}

native final function bool IsOnACoverSlot();

native final function bool IsAtLeftEdgeSlot(optional float InLimit, optional bool bMustLean);

native final function bool IsAtRightEdgeSlot(optional float InLimit, optional bool bMustLean);

native final function RootMotionOverride(AnimNode Node, ERootMotionMode RMMode, ERootMotionRotationMode RMRMode);

native final function RootMotionRelease(AnimNode Node);

simulated event RootMotionModeChanged(SkeletalMeshComponent SkelComp)
{
    if (SkelComp.RootMotionMode == 0)
    {
        StopMovement(false);
    }
    Mesh.bRootMotionModeChangeNotify = false;
}

native simulated function Vector GetPawnViewLocation();

final simulated function bool IsPendingFire(byte InFiringMode)
{
    return InvManager != None && InvManager.PendingFire[InFiringMode] == 1;
}

simulated event Vector GetPhysicalFireStartLoc(Vector FireOffset)
{
    local Vector SocketLoc;
    local Vector X;
    local Vector Y;
    local Vector Z;
    local Rotator SocketRot;
    if (Weapon != None)
    {
        return Weapon.GetPhysicalFireStartLoc();
    }
    GetWeaponHandPosition(SocketLoc, SocketRot);
    GetAxes(SocketRot, X, Y, Z);
    return SocketLoc + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
}

simulated function bool GetWeaponHandPosition(out Vector HandLoc, out Rotator HandRot)
{
    return Mesh.GetSocketWorldLocationAndRotation(RightHandSocketName, HandLoc, HandRot);
}

final simulated function Vector GetPulledInMuzzleLocation(SFXWeapon SW, Vector AimDir)
{
    local float MuzzleDist;
    local Vector MuzzleLoc;
    local Vector PulledInMuzzleLoc;
    local Vector ExtraPullIn;
    local Vector HitLocation;
    local Vector HitNormal;
    local Actor HitActor;
    if (SFXWeapon_SniperRifle_Base(SW) != None)
    {
        MuzzleLoc = SkeletalMeshComponent(SW.Mesh).GetBoneLocation('b_LS_LensCap');
        MuzzleDist = VSize2D(MuzzleLoc - Location);
        HitActor = SW.GetTraceOwner().Trace(HitLocation, HitNormal, MuzzleLoc, MuzzleLoc - MuzzleDist * AimDir, false, vect(12,12,12), 1);
        return HitActor == None ? MuzzleLoc : HitLocation;
    }
    MuzzleLoc = GetPhysicalFireStartLoc(SW != None ? SW.FireOffset : vect(0,0,8));
    MuzzleDist = VSize2D(MuzzleLoc - Location);
    if (MuzzleDist > CylinderComponent.CollisionRadius)
    {
        PulledInMuzzleLoc = MuzzleLoc - MuzzleDist * AimDir;
        MuzzleDist = VSize2D(PulledInMuzzleLoc - Location);
        if (MuzzleDist < CylinderComponent.CollisionRadius)
        {
            MuzzleLoc = PulledInMuzzleLoc;
        }
        else
        {
            HitActor = SW.GetTraceOwner().Trace(HitLocation, HitNormal, PulledInMuzzleLoc, Location, false, 1);
            if (HitActor != None)
            {
                ExtraPullIn = Location - PulledInMuzzleLoc;
                ExtraPullIn.Z = 0;
                ExtraPullIn = 2 + MuzzleDist - CylinderComponent.CollisionRadius * Normal(ExtraPullIn);
            }
            MuzzleLoc = PulledInMuzzleLoc + ExtraPullIn;
        }
    }
    return MuzzleLoc;
}

final event Vector GetWeaponIdlePosition()
{
    local SFXWeapon SFXWeapon;
    SFXWeapon = SFXWeapon(Weapon);
    if (SFXWeapon != None)
    {
        return SFXWeapon.MuzzleIdlePosition;
    }
    else
    {
        return Location + vect(0,0,1) * BaseEyeHeight;
    }
}

simulated function Vector GetWeaponStartTraceLocation(optional Weapon CurrentWeapon)
{
    local SFXWeapon SW;
    local Vector POVLoc;
    local Rotator POVRot;
    local Vector AimDir;
    local Vector ProjectedForward;
    if (IsHumanControlled() == false)
    {
        return GetWeaponStartTraceLocation();
    }
    if (CurrentWeapon != None)
    {
        SW = SFXWeapon(CurrentWeapon);
    }
    if (SW == None)
    {
        SW = SFXWeapon(Weapon);
    }
    Controller.GetPlayerViewPoint(POVLoc, POVRot);
    if (SW == None)
    {
        return POVLoc;
    }
    AimDir = POVRot;
    ProjectedForward = AimDir * GetPhysicalFireStartLoc(SW.FireOffset) - POVLoc Dot AimDir;
    return POVLoc + ProjectedForward;
}

function AddWeaponAnimSets(SFXWeapon NewWeapon, SFXWeapon OldWeapon, optional bool bDrawOnly)
{
    local Bio_Appr_Character_Body BodyApp;
    local AnimSet Set;
    if (PawnType == None || PawnType.m_oAppearance == None || PawnType.m_oAppearance.Body == None)
    {
        return;
    }
    BodyApp = PawnType.m_oAppearance.Body;
    Mesh.bDisableWarningWhenAnimNotFound = true;
    if (bDrawOnly == false)
    {
        if (OldWeapon != None && OldWeapon != NewWeapon)
        {
            if (OldWeapon.AnimType >= 0 && OldWeapon.AnimType < BodyApp.WeaponAnimSpecs.Length)
            {
                foreach BodyApp.WeaponAnimSpecs[OldWeapon.AnimType].m_animSets(Set)
                {
                    RmvAnimSet(Set);
                }
                RmvAnimSet(BodyApp.WeaponAnimSpecs[OldWeapon.AnimType].m_drawAnimSet);
                jump 329;
            }
        }
        if (NewWeapon != None)
        {
            if (NewWeapon.AnimType >= 0 && NewWeapon.AnimType < BodyApp.WeaponAnimSpecs.Length)
            {
                foreach BodyApp.WeaponAnimSpecs[NewWeapon.AnimType].m_animSets(Set)
                {
                    AddAnimSet(Set);
                }
                jump 468;
            }
        }
    }
    if (NewWeapon != None)
    {
        AddAnimSet(BodyApp.WeaponAnimSpecs[NewWeapon.AnimType].m_drawAnimSet);
    }
    return;
}

final function AddAnimSet(AnimSet Set)
{
    if (Mesh != None)
    {
        if (Mesh.AnimSets.Find(Set) == -1)
        {
            Mesh.AnimSets[Mesh.AnimSets.Length] = Set;
        }
        else
        {
            Mesh.AnimSets.RemoveItem(Set);
            Mesh.AnimSets.AddItem(Set);
        }
        Mesh.bAnimSetUpdated = true;
    }
    if (m_oBehavior != None && m_oBehavior.m_bInMatinee)
    {
        if (m_oBehavior.m_aBackupAnimSets.Find(Set) == -1)
        {
            m_oBehavior.m_aBackupAnimSets[m_oBehavior.m_aBackupAnimSets.Length] = Set;
        }
    }
}

final function RmvAnimSet(AnimSet Set)
{
    local int AnimSetIndex;
    if (Mesh != None)
    {
        AnimSetIndex = Mesh.AnimSets.Find(Set);
        if (AnimSetIndex != -1)
        {
            Mesh.AnimSets.Remove(AnimSetIndex, 1);
            Mesh.bAnimSetUpdated = true;
        }
    }
    if (m_oBehavior != None && m_oBehavior.m_bInMatinee)
    {
        AnimSetIndex = m_oBehavior.m_aBackupAnimSets.Find(Set);
        if (AnimSetIndex != -1)
        {
            m_oBehavior.m_aBackupAnimSets.Remove(AnimSetIndex, 1);
        }
    }
}

function SwapDrawAnim()
{
    local SFXWeapon NewWeapon;
    NewWeapon = SFXWeapon(Weapon);
    if (NewWeapon != None && NewWeapon.IsInState('WeaponEquipping'))
    {
        NewWeapon.DetachWeapon();
        NewWeapon.AttachWeaponTo(Mesh, GetRightHandSocketName());
        AddWeaponAnimSets(NewWeapon, SFXWeapon(WeaponFromLastGameState), true);
    }
}

function FadeOutDrawAnim()
{
    local SFXWeapon ChkWeapon;
    ChkWeapon = SFXWeapon(Weapon);
    if (ChkWeapon != None)
    {
        ChkWeapon.EquipNearFinished();
        AddWeaponAnimSets(ChkWeapon, SFXWeapon(WeaponFromLastGameState));
    }
}

function FadeOutReloadAnim()
{
    local SFXWeapon ChkWeapon;
    ChkWeapon = SFXWeapon(Weapon);
    if (ChkWeapon != None)
    {
        ChkWeapon.ReloadNearFinished();
    }
}

function SwapHolsterAnim()
{
    local SFXWeapon ChkWeapon;
    ChkWeapon = SFXWeapon(Weapon);
    if (ChkWeapon != None && ChkWeapon.IsInState('WeaponPuttingDown'))
    {
        ChkWeapon.DetachWeapon();
        ChkWeapon.AttachWeaponTo(Mesh, AttachSlots[ChkWeapon.CharacterSlot]);
    }
}

function FadeOutHolsterAnim()
{
    local SFXWeapon ChkWeapon;
    ChkWeapon = SFXWeapon(Weapon);
    if (ChkWeapon != None && InvManager.PendingWeapon != None)
    {
        ChkWeapon.UnEquipFinished();
    }
}

function FadeOutPowerRelease()
{
    local BioActivePower Power;
    if (m_oBehavior != None)
    {
        Power = BioActivePower(m_oBehavior.m_oCurrentModalActive);
        if (Power != None)
        {
            Power.OnAnimReleaseEnd();
        }
    }
}

function ExpandWeapon()
{
    local SFXWeapon Wpn;
    Wpn = SFXWeapon(Weapon);
    if (Wpn != None && Wpn.IsInState('WeaponEquipping'))
    {
        Wpn.Expand();
    }
}

function CollapseWeapon()
{
    local SFXWeapon Wpn;
    Wpn = SFXWeapon(Weapon);
    if (Wpn != None && Wpn.IsInState('WeaponPuttingDown'))
    {
        Wpn.Collapse();
    }
}

event EAttachSlot GetCurrentWeaponCharacterSlot()
{
    if (SFXWeapon(Weapon) != None)
    {
        return SFXWeapon(Weapon).CharacterSlot;
    }
    return 5;
}

event SetWeaponFromSlot(EAttachSlot eSlot)
{
    if (SFXInventoryManager(InvManager) != None)
    {
        SFXInventoryManager(InvManager).SetWeaponFromSlot(eSlot);
    }
}

final simulated event Name GetRightHandSocketName()
{
    return RightHandSocketName;
}

final event bool SetWeaponImmediately(class<SFXWeapon> cWeapon)
{
    local SFXWeapon Wpn;
    local SFXWeapon WpnForSwitch;
    if (cWeapon != None)
    {
        foreach InvManager.InventoryActors(Class'SFXWeapon', Wpn)
        {
            if (ClassIsChildOf(Wpn.Class, cWeapon))
            {
                if (WpnForSwitch == None || Wpn.GetAIRating() > WpnForSwitch.GetAIRating())
                {
                    WpnForSwitch = Wpn;
                }
            }
        }
        if (WpnForSwitch == None)
        {
            return false;
        }
    }
    if (WpnForSwitch != None)
    {
        WpnForSwitch.DetachWeapon();
    }
    Wpn = SFXWeapon(Weapon);
    if (Wpn != None)
    {
        Wpn.bInstantExpansion = true;
        Wpn.Collapse();
        Wpn.GotoState('Inactive');
        Wpn.DetachWeapon();
        if (SFXInventoryManager(InvManager).GetWeaponInSlot(Wpn.AttachSlot, true) == None)
        {
            Wpn.AssignToSlot(Wpn.AttachSlot);
        }
        AddWeaponAnimSets(None, Wpn);
    }
    Weapon = WpnForSwitch;
    if (WpnForSwitch != None)
    {
        AddWeaponAnimSets(WpnForSwitch, None);
        WpnForSwitch.AttachWeaponTo(Mesh, RightHandSocketName);
        WpnForSwitch.bInstantExpansion = true;
        WpnForSwitch.Expand();
        WpnForSwitch.Instigator = InvManager.Instigator;
        WpnForSwitch.GotoState('Active');
    }
    if (m_oBehavior != None)
    {
        if (Weapon == None)
        {
            if (m_oBehavior.m_eCurrentActionState != 0)
            {
                ActionState = 0;
                m_oBehavior.m_ePreviousActionState = m_oBehavior.m_eCurrentActionState;
                m_oBehavior.m_eCurrentActionState = 0;
                Controller.BioOnPawnActionStateChanged();
            }
        }
        else
        {
            if (m_oBehavior.m_eCurrentActionState != 1)
            {
                ActionState = 1;
                m_oBehavior.m_ePreviousActionState = m_oBehavior.m_eCurrentActionState;
                m_oBehavior.m_eCurrentActionState = 1;
                Controller.BioOnPawnActionStateChanged();
            }
        }
    }
    return true;
}

event bool IsInBleedOut()
{
    return false;
}

function SFXLoadoutData GetPawnLoadout()
{
    local SFXLoadoutData oLoadout;
    oLoadout = Loadout != None ? Loadout : PawnType.Loadout;
    return oLoadout;
}

function AddDefaultInventory()
{
    local SFXLoadoutData ChkLoadout;
    ChkLoadout = GetPawnLoadout();
    GenerateInventoryFromLoadout(ChkLoadout);
    ScaleEquipment(GetScaledLevel(), ChkLoadout);
}

function GenerateInventoryFromLoadout(SFXLoadoutData oLoadout)
{
    local SFXShield_Base Shields;
    local class<SFXPower> PowerClass;
    local ShieldLoadout ShieldLoadout;
    if (oLoadout != None)
    {
        if (bShouldSpawnWeapons)
        {
            CreateWeapons(oLoadout);
        }
        foreach oLoadout.ShieldLoadouts(ShieldLoadout)
        {
            Shields = SFXShield_Base(CreateInventory(ShieldLoadout.Shields));
            if (Shields != None)
            {
                Shields.ShieldScale = oLoadout.ShieldScale;
                Shields.ShieldOffset = oLoadout.ShieldOffset;
                Shields.MaxShields.Level = Lerp(ShieldLoadout.ShieldLevelRange.X, ShieldLoadout.ShieldLevelRange.Y, GetScaledLevel() / SFXGame(WorldInfo.Game).gameconfig.100);
                if (ShieldLoadout.MaxShields.X != 0 || ShieldLoadout.MaxShields.Y != 0)
                {
                    Shields.MaxShields.X = ShieldLoadout.MaxShields.X;
                    Shields.MaxShields.Y = ShieldLoadout.MaxShields.Y;
                }
                Shields.ScaleShields();
                Shields.CurrentShields = Shields.MaxShields.Value;
                if (Shields.CurrentShields > 0)
                {
                    bHasShields = bHasShields || true;
                }
            }
        }
        PowerManager.MyPawn = self;
        foreach oLoadout.Powers(PowerClass)
        {
            PowerManager.AddPower(PowerClass);
        }
        StartFirstUsePowerDelay();
    }
}

function ScaleEquipment(int PlayerLevel, optional SFXLoadoutData oLoadout = None)
{
    local SFXLoadoutData ChkLoadout;
    local float MaxEnemyLevel;
    local float ScaleLevel;
    local int ArmorLevel;
    local int HealthLevel;
    local SFXArmor_Base ChkArmor;
    local SFXModule_Damage DmgModule;
    local SFXPower Power;
    MaxEnemyLevel = SFXGame(WorldInfo.Game).gameconfig.100;
    ScaleLevel = PlayerLevel;
    if (oLoadout != None)
    {
        ChkLoadout = oLoadout;
    }
    else
    {
        ChkLoadout = GetPawnLoadout();
    }
    if (ChkLoadout != None)
    {
        ArmorLevel = Lerp(ChkLoadout.ArmorLevelRange.X, ChkLoadout.ArmorLevelRange.Y, ScaleLevel / MaxEnemyLevel);
        HealthLevel = Lerp(ChkLoadout.HealthLevelRange.X, ChkLoadout.HealthLevelRange.Y, ScaleLevel / MaxEnemyLevel);
        TechResistance = ChkLoadout.TechResistance;
        BioticResistance = ChkLoadout.BioticResistance;
    }
    ScaleWeapons(ChkLoadout, ScaleLevel);
    foreach InvManager.InventoryActors(Class'SFXArmor_Base', ChkArmor)
    {
        ChkArmor.ArmorLevel = ArmorLevel;
    }
    DmgModule = GetModule(Class'SFXModule_Damage');
    if (DmgModule != None)
    {
        if (ChkLoadout != None)
        {
            DmgModule.MaxHealth.X = ChkLoadout.MaxHealth.X;
            DmgModule.MaxHealth.Y = ChkLoadout.MaxHealth.Y;
        }
        DmgModule.MaxHealth.Level = HealthLevel;
        Class'SFXGame'.ReCalculate(DmgModule.MaxHealth);
        DmgModule.CurrentHealth = DmgModule.MaxHealth.Value;
    }
    ScaleShields(DmgModule.CurrentHealth);
    if (bScalePowers)
    {
        foreach PowerManager.Powers(Power)
        {
            Power.Rank = Lerp(1, Power.MaxRank, ScaleLevel / MaxEnemyLevel);
        }
    }
}

function int GetScaledLevel()
{
    local int PlayerLevel;
    local BioPlayerController oController;
    local BioWorldInfo oWorldInfo;
    local SFXEngine oEngine;
    oEngine = None;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    if (oWorldInfo != None)
    {
        oController = oWorldInfo.GetLocalPlayerController();
    }
    if (oController != None)
    {
        oEngine = SFXEngine(oController.Player.Outer);
    }
    if (oEngine != None)
    {
        if (SFXGame(WorldInfo.Game).GetPlayerLevel(oEngine.CurrentUserID, PlayerLevel))
        {
            return PlayerLevel;
        }
    }
    return 1;
}

simulated function OnGiveInventory(SeqAct_GiveInventory inAction)
{
    local SFXLoadoutData ChkLoadout;
    local SFXShield_Base ChkShield;
    local ShieldLoadout ShieldLoadout;
    OnGiveInventory(inAction);
    ChkLoadout = GetPawnLoadout();
    if (ChkLoadout != None)
    {
        foreach InvManager.InventoryActors(Class'SFXShield_Base', ChkShield)
        {
            foreach ChkLoadout.ShieldLoadouts(ShieldLoadout)
            {
                if (ShieldLoadout.Shields == ChkShield.Class)
                {
                    ChkShield.ShieldScale = ChkLoadout.ShieldScale;
                    ChkShield.ShieldOffset = ChkLoadout.ShieldOffset;
                    ChkShield.MaxShields.Level = Lerp(ShieldLoadout.ShieldLevelRange.X, ShieldLoadout.ShieldLevelRange.Y, GetScaledLevel() / SFXGame(WorldInfo.Game).gameconfig.100);
                    if (ShieldLoadout.MaxShields.X != 0 || ShieldLoadout.MaxShields.Y != 0)
                    {
                        ChkShield.MaxShields.X = ShieldLoadout.MaxShields.X;
                        ChkShield.MaxShields.Y = ShieldLoadout.MaxShields.Y;
                    }
                }
            }
        }
        ScaleEquipment(GetScaledLevel(), ChkLoadout);
    }
}

function bool ReplaceWeapon(ELoadoutWeapons WeaponCategory, class<SFXWeapon> NewWeapon, bool bEquipWeapon)
{
    local SFXInventoryManager oInventory;
    local int GroupIdx;
    local int EntryIdx;
    local SFXWeapon W;
    local SFXWeapon ReplacementWeapon;
    local int WeaponCount;
    oInventory = SFXInventoryManager(InvManager);
    if (oInventory == None)
    {
        return false;
    }
    foreach oInventory.InventoryActors(Class'SFXWeapon', W)
    {
        WeaponCount++;
        Class'SFXPlayerSquadLoadoutData'.GetWeaponCategory(W.Class, GroupIdx, EntryIdx);
        if (GroupIdx == WeaponCategory)
        {
            if (W == Weapon)
            {
                bEquipWeapon = true;
            }
            oInventory.RemoveFromInventory(W);
            ReplacementWeapon = SFXWeapon(CreateInventory(NewWeapon));
            if (W.GetMaxSpareAmmo() > 0 && ReplacementWeapon.GetMaxSpareAmmo() > 0)
            {
                ReplacementWeapon.CurrentSpareAmmo = W.GetCurrentSpareAmmo() * ReplacementWeapon.GetMaxSpareAmmo() / W.GetMaxSpareAmmo();
            }
            else
            {
                ReplacementWeapon.CurrentSpareAmmo = 0;
            }
            ReplacementWeapon.AmmoUsedCount = W.AmmoUsedCount * ReplacementWeapon.GetMagazineSize() / W.GetMagazineSize();
            if (bEquipWeapon)
            {
                SetWeaponImmediately(NewWeapon);
            }
            W.Destroy();
            return true;
        }
    }
    if (WeaponCount < Class'SFXPlayerSquadLoadoutData'.Default.MaxWeapons)
    {
        ReplacementWeapon = SFXWeapon(CreateInventory(NewWeapon));
        if (bEquipWeapon)
        {
            oInventory.SetCurrentWeapon(ReplacementWeapon);
        }
        return true;
    }
    return false;
}

function bool CreateWeapon(class<SFXWeapon> WeaponClass, optional bool bEquipWeapon = false)
{
    local SFXPlayerSquadLoadoutData PlayerLoadout;
    local int GroupIdx;
    local int EntryIdx;
    PlayerLoadout = SFXPlayerSquadLoadoutData(Loadout);
    if (PlayerLoadout != None)
    {
        Class'SFXPlayerSquadLoadoutData'.GetWeaponCategory(WeaponClass, GroupIdx, EntryIdx);
        ReplaceWeapon(GroupIdx, WeaponClass, bEquipWeapon);
    }
    else
    {
        CreateInventory(WeaponClass);
    }
    return true;
}

function CreateWeapons(SFXLoadoutData ChkLoadout)
{
    local class<SFXWeapon> WeaponClass;
    foreach ChkLoadout.Weapons(WeaponClass)
    {
        CreateWeapon(WeaponClass);
    }
}

function ScaleWeapons(SFXLoadoutData ChkLoadout, int ScaleLevel)
{
    local SFXWeapon ChkWeapon;
    local int WeaponLevel;
    if (ChkLoadout != None)
    {
        WeaponLevel = Lerp(ChkLoadout.WeaponLevelRange.X, ChkLoadout.WeaponLevelRange.Y, ScaleLevel / SFXGame(WorldInfo.Game).gameconfig.100);
        foreach InvManager.InventoryActors(Class'SFXWeapon', ChkWeapon)
        {
            ChkWeapon.WeaponLevel = WeaponLevel;
        }
    }
}

function ScaleShields(float CurrentHealth)
{
    local SFXShield_Base ChkShield;
    local float BonusShields;
    BonusShields = 0;
    if (SFXGame(WorldInfo.Game) != None)
    {
        if (SFXPawn_Player(self) == None && SFXPawn_Henchman(self) == None)
        {
            BonusShields = SFXGame(WorldInfo.Game).Difficulty.Default.EnemyShieldBonus;
        }
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', ChkShield)
    {
        ChkShield.MaxShields.X += BonusShields;
        ChkShield.MaxShields.Y += BonusShields;
        ChkShield.ScaleShields();
        ChkShield.CurrentShields = ChkShield.MaxShields.Value;
        if (ChkShield.CurrentShields > 0)
        {
            bHasShields = true;
        }
    }
}

final function StartFirstUsePowerDelay()
{
    local SFXGame GameInfo;
    GameInfo = WorldInfo != None ? SFXGame(WorldInfo.Game) : None;
    if (GameInfo != None && GameInfo.InCombat())
    {
        if (PowerManager != None)
        {
            PowerManager.StartFirstTimeDelay();
        }
    }
}

native final function bool IsUsingPower();

native final function bool IsReloading(optional bool bCheckReloadRequest, optional bool bBlendOut);

native final function bool IsSwitchingWeapons(optional bool bBlendOut);

native final function bool IsPerformingCustomAction();

native final function bool IsPerformingBlockingAction();

final simulated function bool CanReload()
{
    if (IsPerformingBlockingAction())
    {
        return false;
    }
    return true;
}

final simulated function bool CanSwitchWeapons()
{
    if (IsPerformingBlockingAction())
    {
        return false;
    }
    return true;
}

final simulated event bool CanFireWeapon()
{
    if (IsPerformingBlockingAction())
    {
        return false;
    }
    if (BioPlayerController(Controller) != None && BioPlayerController(Controller).bStorming)
    {
        return false;
    }
    return true;
}

final simulated event bool IsWeaponFiring()
{
    if (Weapon != None && Weapon.IsInState('WeaponFiring'))
    {
        return true;
    }
    return false;
}

simulated function Tick(float DeltaTime)
{
    local bool bWeaponFiring;
    if (Controller == None)
    {
        return;
    }
    if (IsHumanControlled())
    {
        bWeaponFiring = IsPendingFire(0);
        if (bWeaponFiring == false && Controller.bFire == 1 && CanFireWeapon())
        {
            if (DoesCoverStateAllowImmediateFire() && !IsInAnimatedTransition())
            {
                StartFire(0);
                if (IsInvisible())
                {
                    BreakStealth();
                }
            }
        }
        else
        {
            if (bWeaponFiring && Controller.bFire == 0 || CanFireWeapon() == false)
            {
                StopFire(0);
            }
            else
            {
                if (DoesCoverStateAllowImmediateFire() == false && bWeaponFiring)
                {
                    StopFire(0);
                }
            }
        }
    }
    bIsSniping = false;
    if (BioPlayerController(Controller) != None && BioPlayerController(Controller).IsZoomed())
    {
        if (SFXWeapon(Weapon) != None && SFXWeapon(Weapon).bUseSniperCam)
        {
            bIsSniping = true;
        }
    }
    UpdateRagdollState(DeltaTime);
}

function UpdateRagdollState(float DeltaTime)
{
    if (Physics != 10)
    {
        m_fPhysicsForceIncurred -= PawnType.m_fPhysicsThresholdRegenerationRate * DeltaTime;
        if (m_fPhysicsForceIncurred < 0)
        {
            m_fPhysicsForceIncurred = 0;
        }
    }
}

function Falling()
{
    SetTimer(FallingStateEntranceTime, false, 'StartFall');
}

function StartFall()
{
    GotoState('FallingState');
}

function Landed(Vector HitNormal, Actor FloorActor)
{
    local Controller OldLastHitBy;
    OldLastHitBy = LastHitBy;
    ClearTimer('StartFall');
    TakeFallingDamage();
    LastHitBy = OldLastHitBy;
}

event bool ShouldPlayFallingAnim()
{
    return false;
}

event NotifyFallingAnimationComplete();

state FallingState
{
    event BeginState(Name PreviousStateName)
    {
        BeginState(PreviousStateName);
        if (BioPlayerController(Controller) != None)
        {
            BioPlayerController(Controller).PawnFalling();
        }
    }

    event bool ShouldPlayFallingAnim()
    {
        return true;
    }

    function Landed(Vector HitNormal, Actor FloorActor)
    {
        Global.Landed(HitNormal, FloorActor);
        GotoState('LandingState');
    }

    while (Physics == 2)
    {
        Sleep(0,1);
    }
    GotoState('LandingState');
    // invalid native function 205 ;
}

state LandingState
{
    event EndState(Name NextStateName)
    {
        EndState(NextStateName);
        if (BioPlayerController(Controller) != None)
        {
            BioPlayerController(Controller).PawnLanded();
        }
    }

    event bool ShouldPlayFallingAnim()
    {
        return true;
    }

    event NotifyFallingAnimationComplete()
    {
        GotoState(InitialState);
        StopMovement(true);
    }

    Sleep(2);
    GotoState(InitialState);
    jump 0;
    // unresolved reference 0 ;
}

function TakeDamage(float DamageAmount, Controller EventInstigator, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
{
    local int idx;
    local SeqEvent_TakeDamage dmgEvent;
    local BioPlayerController PC;
    if (Squad != None)
    {
        idx = 0;
        while (idx < Squad.GeneratedEvents.Length)
        {
            dmgEvent = SeqEvent_TakeDamage(Squad.GeneratedEvents[idx]);
            if (dmgEvent != None)
            {
                dmgEvent.HandleDamage(self, EventInstigator, DamageType, DamageAmount, HitLocation, DamageCauser);
            }
            idx++;
        }
    }
    if (IsHumanControlled())
    {
        PC = BioPlayerController(Controller);
        if (PC != None)
        {
            PC.HintSystem.HintEvent('Damaged', DamageType.Name);
        }
    }
    TakeDamage(DamageAmount, EventInstigator, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
}

function OnAttacked(Pawn oAttacker, Name WeaponName)
{
    local BioSeqEvt_OnAttacked Event;
    local int I;
    if (oAttacker != None)
    {
        I = 0;
        while (I < GeneratedEvents.Length)
        {
            Event = BioSeqEvt_OnAttacked(GeneratedEvents[I]);
            if (Event != None)
            {
                if (Event.CheckActivate(self, oAttacker))
                {
                    Event.SetNameVars("Weapon", WeaponName);
                    Event.SetObjectVars("Who", oAttacker);
                }
            }
            I++;
        }
        if (Squad != None)
        {
            I = 0;
            while (I < Squad.GeneratedEvents.Length)
            {
                Event = BioSeqEvt_OnAttacked(Squad.GeneratedEvents[I]);
                if (Event != None)
                {
                    if (Event.CheckActivate(self, oAttacker))
                    {
                        Event.SetNameVars("Weapon", WeaponName);
                        Event.SetObjectVars("Who", oAttacker);
                    }
                }
                I++;
            }
        }
    }
}

function OnCastAt(Pawn oAttacker, SFXPower Power)
{
    local BioSeqEvt_OnCastAt Event;
    local int I;
    local BioAiController oAIController;
    if (oAttacker != None)
    {
        I = 0;
        while (I < GeneratedEvents.Length)
        {
            Event = BioSeqEvt_OnCastAt(GeneratedEvents[I]);
            if (Event != None)
            {
                if (Event.CheckActivate(self, oAttacker))
                {
                    if (Power.BaseName != 'None')
                    {
                        Event.SetNameVars("Power", Power.BaseName);
                    }
                    else
                    {
                        Event.SetNameVars("Power", Power.PowerName);
                    }
                    Event.SetObjectVars("Who", oAttacker);
                    Event.SetObjectVars("AffectedPawn", self);
                    Event.SetIntVars("Category", Power.Discipline);
                }
            }
            I++;
        }
        if (Squad != None)
        {
            I = 0;
            while (I < Squad.GeneratedEvents.Length)
            {
                Event = BioSeqEvt_OnCastAt(Squad.GeneratedEvents[I]);
                if (Event != None)
                {
                    if (Event.CheckActivate(self, oAttacker))
                    {
                        if (Power.BaseName != 'None')
                        {
                            Event.SetNameVars("Power", Power.BaseName);
                        }
                        else
                        {
                            Event.SetNameVars("Power", Power.PowerName);
                        }
                        Event.SetObjectVars("Who", oAttacker);
                        Event.SetObjectVars("AffectedPawn", self);
                        Event.SetIntVars("Category", Power.Discipline);
                    }
                }
                I++;
            }
        }
    }
    oAIController = BioAiController(Controller);
    if (oAIController != None)
    {
        oAIController.NotifyCastAt(oAttacker, Power);
    }
}

native function SetVectorParameterValue(Name ParameterName, const out Color Value);

native function SetScalarParameterValue(Name ParameterName, float Value);

native function SetTextureParameterValue(Name ParameterName, Texture Value);

native final function ApplyMaterialParameters(BioMaterialOverride pMaterialParameters);

native final function UnapplyMaterialParameters(BioMaterialOverride pMaterialParameters);

native function bool IsInvisible();

native function bool InitRagdoll();

native function bool TermRagdoll();

native function bool CanRagdoll();

native final function bool IsWalking();

native final function EWalkingSpeedMode GetWalkingSpeedMode();

native final function StopMovement(optional bool bStopRotation);

native function SetDesiredRotation(Rotator rDesiredRotation, optional bool bForce);

native function GetRotationRate(out int nPitch, out int nYaw, out int nRoll);

native final function bool RequestTurnInPlace(Rotator rDesDir);

native final function bool GetAnimLengthAndPos(Name sAnimName, out float fAnimLength, out float fAnimPos);

native final function bool CanPlayAnimNode(Name sBlendName, int nFlags, out float fWeight);

native final function AnimNodePlayFinished(Name sBlendName);

native final function AnimNodeBlendComplete(Name sBlendName, int nChild);

native function SetEffectsMaterialType(Name EffectsMaterialType);

native function Name GetEffectsMaterialType(optional SkeletalMeshComponent Component);

native function SetFractionOfEffectsMaterialEnabled(float FractionEnabled);

native function float GetFractionOfEffectsMaterialEnabled();

native function bool ReadyMode(optional float fDelaySeconds);

native function bool ExploreMode(optional float fDelaySeconds);

native function SetAmbientLookAtTarget(Actor oTarget, optional int nRank);

native function SetLookAtTarget(Actor oTarget, optional ELookAtTransitionType a_eTransition, optional int nRank);

native function RequestHidden(const bool B);

native function bool SetDefaultFaceFXAsset();

native function bool PlayFaceFX(String AnimGroup, String AnimSeq);

native function SafeSetLocation(Vector vDest);

native final function CacheHeadGearVisibilityOverride();

native final function RestoreCachedHeadGearVisibilityOverride();

native final function SetHeadGearVisiblePreference(bool B);

native final function bool GetHeadGearVisiblePreference();

native final function bool IsHeadGearVisiblePreferenceRelevant();

native final function OverrideHeadGearVisibility(bool B);

native final function RequestVisorVisible(bool B);

native final function RequestFacePlateVisible(bool B);

native final function RequestHelmetVisible(bool B);

native function bool IsShowingVisor();

native function bool IsShowingFacePlate();

native function bool IsShowingHelmet();

native function DroneFinishedTakingOff();

native function DroneStartLanding();

native function SetClassification(EBioPawnClassification a_eClassification, optional bool a_bAsDefault);

native function EBioPawnClassification GetClassification();

native function EnsurePawnIsUpright();

event ForceHelmetVisibility(bool bHelmetVisible)
{
    SetHeadGearVisiblePreference(bHelmetVisible);
}

function PostBeginPlay()
{
    PawnType = BioPawnType(ActorType);
    if (m_oBehavior == None)
    {
        m_oBehavior = BioPawnBehavior(oBioComponent);
    }
    PostBeginPlay();
    m_oBehavior.PostBeginPlay();
    if (Squad == None)
    {
        Squad = m_oBehavior.Squad;
    }
    if (!bFullyInitialized)
    {
        bFullyInitialized = true;
        InitializeSpeeds();
        AddDefaultInventory();
        if (Squad != None)
        {
            Squad.AddMember(self, false);
        }
        if (PawnType.m_oAppearance != None && PawnType.m_oAppearance.LifetimeCrust != None)
        {
            m_LifeCrust = Class'BioVisualEffect'.CreateVFXOnMesh(PawnType.m_oAppearance.LifetimeCrust, self, 'None', false);
            if (m_LifeCrust != None)
            {
                m_LifeCrust.SetPaused(true);
            }
        }
        else
        {
            if (PawnType.EliteCrust != None)
            {
                m_LifeCrust = Class'BioVisualEffect'.CreateVFXOnMesh(PawnType.EliteCrust, self, 'None', false);
                if (m_LifeCrust != None)
                {
                    m_LifeCrust.SetPaused(true);
                }
            }
        }
        if (BioWorldInfo(WorldInfo).SelectableActors.Find(self) == -1)
        {
            BioWorldInfo(WorldInfo).SelectableActors.AddItem(self);
        }
        CreateSelection();
    }
}

function CreateSelection()
{
    local bool bTargetable;
    local bool bCombatTargetable;
    local SFXSelectionModule SelMod;
    if (m_oBehavior.m_bTargetableOverride == false)
    {
        if (ActorType != None)
        {
            bTargetable = PawnType.m_bTargetable;
        }
    }
    else
    {
        bTargetable = m_oBehavior.m_bTargetable;
    }
    if (m_oBehavior.m_bCombatTargetableOverride == false)
    {
        if (ActorType != None)
        {
            bCombatTargetable = PawnType.m_bCombatTargetable;
        }
    }
    else
    {
        bCombatTargetable = m_oBehavior.m_bCombatTargetable;
    }
    if (bTargetable || bCombatTargetable)
    {
        SelMod = GetModule(Class'SFXSelectionModule');
        if (SelMod == None)
        {
            SelMod = new(self,Class'SFXSelectionModule');
            Modules.AddItem(SelMod);
        }
        SelMod.m_bCombatTargetable = bCombatTargetable;
        SelMod.m_bTargetable = bTargetable;
    }
}

simulated function Destroyed()
{
    if (Squad != None)
    {
        Squad.RemoveMember(self);
    }
    ClearAnimNodes();
    if (m_LifeCrust != None)
    {
        m_LifeCrust.SetState(2);
    }
    Destroyed();
}

simulated function OnSetPhysics(SeqAct_SetPhysics Action)
{
    if (Action.newPhysics == 10)
    {
        InitRagdoll();
    }
    else
    {
        OnSetPhysics(Action);
    }
}

event SetShouldCrouch(bool bCrouch)
{
    ShouldCrouch(bCrouch);
}

native function PostInitAnimTree(SkeletalMeshComponent SkelComp);

native function MoveToRagdollRecoverStartPosition();

event OnEnterRagdoll()
{
    if (m_bEnableRagdollRecovery && !IsDead())
    {
        GotoState('InRagdoll');
    }
}

event ForceEndRagdoll();

event NotifyRagdollRecoverAnimationComplete();

state InRagdoll
{
    event BeginState(Name PreviousStateName)
    {
        BeginState(PreviousStateName);
        LastPhysicsSetter = None;
        if (m_bInConversation && BioWorldInfo(WorldInfo) != None)
        {
        }
        SendKismetRagdollEvent(true);
        if (bKillOnRagdoll)
        {
            Died(None, Class'SFXDamageType_Suicide', Location);
        }
    }

    event EndState(Name NextStateName)
    {
        EndState(NextStateName);
        if (NextStateName != 'Dying' && NextStateName != 'Downed')
        {
            if (Physics == 10)
            {
                TermRagdoll();
            }
            Mesh.PhysicsWeight = 0;
            SendKismetRagdollEvent(false);
        }
    }

    function PlayHit(float Damage, Controller InstigatedBy, Vector HitLocation, class<DamageType> DamageType, Vector Momentum, TraceHitInfo HitInfo)
    {
        PlayHit(Damage, InstigatedBy, HitLocation, DamageType, Momentum, HitInfo);
        Mesh.AddImpulse(Momentum, HitLocation, HitInfo.BoneName);
    }

    function SendKismetRagdollEvent(bool bInit)
    {
        local int idx;
        local BioSeqEvt_PawnPhysicsChange physicsEvent;
        local array<int> outputList;
        idx = 0;
        while (idx < GeneratedEvents.Length)
        {
            physicsEvent = BioSeqEvt_PawnPhysicsChange(GeneratedEvents[idx]);
            if (physicsEvent != None)
            {
                if (bInit)
                {
                    outputList.AddItem(0);
                }
                else
                {
                    outputList.AddItem(1);
                }
                physicsEvent.CheckActivate(self, self, false, outputList);
            }
            idx++;
        }
    }

    event ForceEndRagdoll()
    {
        GotoState('Auto');
    }

    PushState('WaitForRagdollRecovery');
    PushState('RagdollRecovery');
    GotoState('Auto');
    jump 0;
    // unresolved reference 0 ;
}

state WaitForRagdollRecovery
{
    function bool ReadyToRecover()
    {
        return m_oBehavior.m_nRemainInRagdoll <= 0;
    }

    event ForceEndRagdoll()
    {
        GotoState('Auto');
    }

    Sleep(1);
    while (!ReadyToRecover())
    {
        Sleep(0,1);
    }
    PopState();
    // invalid native function 205 ;
}

state RagdollRecovery
{
    function EndState(Name NextState)
    {
        EndState(NextState);
        if (Physics == 10 && NextState != 'Dying' && NextState != 'Downed')
        {
            TermRagdoll();
        }
    }

    function PoppedState()
    {
        PoppedState();
        if (Physics == 10)
        {
            TermRagdoll();
        }
    }

    event NotifyRagdollRecoverAnimationComplete()
    {
        PopState();
    }

    function UpdateRagdollState(float DeltaTime);

    event ForceEndRagdoll()
    {
        GotoState('Auto');
    }

    ValidateRagdoll();
    MoveToRagdollRecoverStartPosition();
    Sleep(0,1);
    TermRagdoll();
    Sleep(3);
    PopState();
    // invalid native function 205 ;
}

final function Vector CalculateOffsetHook(Vector Hook, Name Bone)
{
    local Vector V;
    V = GetCameraHook(Bone);
    V += QuatRotateVector(QuatFromRotator(Rotation), Hook);
    return V;
}

final function Vector GetCameraHook(Name HookName)
{
    local Vector V;
    local int BoneIdx;
    if (HookName == 'CoverSlot')
    {
        if (CurrentLink != None)
        {
            V = CurrentLink.GetSlotLocation(CurrentSlotIdx);
        }
    }
    else
    {
        if (HookName != 'None')
        {
            BoneIdx = Mesh.MatchRefBone(HookName);
            if (BoneIdx == -1)
            {
                return V;
            }
            V = Mesh.GetBoneLocation(HookName);
        }
        else
        {
            V = Location;
            V.Z -= CylinderComponent.CollisionHeight;
        }
    }
    return V;
}

event Vector GetDefaultHookOffset()
{
    local Vector vPawnPos;
    vPawnPos.X = m_oBehavior.CAMHOOK_NORMAL_FRONTBACK;
    vPawnPos.Y = m_oBehavior.CAMHOOK_NORMAL_RIGHTLEFT;
    vPawnPos.Z = m_oBehavior.CAMHOOK_NORMAL_UPDOWN;
    return vPawnPos;
}

event Vector GetPlayerPawnConversationCloseupCameraHook()
{
    local Vector vPawnPos;
    vPawnPos = CalculateOffsetHook(GetDefaultHookOffset(), 'Camera');
    vPawnPos.Z += 15;
    return vPawnPos;
}

simulated event EndCrouch(float HeightAdjust)
{
    local Vector V;
    EndCrouch(HeightAdjust);
    V = Mesh.Translation;
    V.Z -= HeightAdjust;
    Mesh.SetTranslation(V);
}

simulated event StartCrouch(float HeightAdjust)
{
    local Vector V;
    StartCrouch(HeightAdjust);
    V = Mesh.Translation;
    V.Z += HeightAdjust;
    Mesh.SetTranslation(V);
}

event Touch(Actor Other, PrimitiveComponent OtherComp, Vector HitLocation, Vector HitNormal)
{
    Touch(Other, OtherComp, HitLocation, HitNormal);
}

event RanInto(Actor Other)
{
    if (Physics == 10 && Other.Physics != 10)
    {
        if (BioPawn(Other) != None && VSize(Velocity) > 2 && BioPlayerSquad(BioPawn(Other).m_oBehavior.Squad) == None)
        {
        }
    }
}

native function RegisterCustomAnimset(Name nmSetGroupName, AnimSet oAnim);

native function ClearRegisteredCustomAnimsets(Name nmSetGroupName);

native function ClearUnregisteredAnimsets();

simulated function OnToggle(SeqAct_Toggle Action)
{
    local AnimNodeSequence SeqNode;
    SeqNode = AnimNodeSequence(Mesh.FindAnimNode('MatineeAnim'));
    if (SeqNode != None)
    {
        if (Action.InputLinks[0].bHasImpulse)
        {
            if (!SeqNode.bPlaying)
            {
                SeqNode.PlayAnim(SeqNode.bLooping, SeqNode.Rate, 0);
            }
        }
        else
        {
            if (Action.InputLinks[1].bHasImpulse)
            {
                if (SeqNode.bPlaying)
                {
                    SeqNode.StopAnim();
                }
            }
            else
            {
                if (Action.InputLinks[2].bHasImpulse)
                {
                    if (SeqNode.bPlaying)
                    {
                        SeqNode.StopAnim();
                    }
                    else
                    {
                        SeqNode.PlayAnim(SeqNode.bLooping, SeqNode.Rate, 0);
                    }
                }
            }
        }
    }
}

event BeginAnimControl(array<AnimSet> InAnimSets)
{
    local AnimNodeSequence SeqNode;
    local SkeletalMeshComponent MeshComponent;
    SeqNode = AnimNodeSequence(Mesh.FindAnimNode('MatineeAnim'));
    if (m_oBehavior != None)
    {
        StopMovement(true);
        TerminateCurrentCustomAction();
        EnsurePawnIsUpright();
        m_oBehavior.HardResetActionAndAnimationState();
        m_oBehavior.m_aBackupAnimSets = Mesh.AnimSets;
        m_oBehavior.m_bInMatinee = true;
    }
    if (SeqNode != None)
    {
        Mesh.AnimSets = InAnimSets;
        SeqNode.SetAnim('None');
    }
    if (Mesh != None)
    {
        m_bOldUpdateSkelWhenNotRendered = Mesh.bUpdateSkelWhenNotRendered;
        Mesh.bUpdateSkelWhenNotRendered = true;
        foreach ComponentList(Class'SkeletalMeshComponent', MeshComponent)
        {
            MeshComponent.bUpdateSkelWhenNotRendered = true;
        }
    }
}

event SetAnimPosition(Name SlotName, int ChannelIndex, Name InAnimSeqName, float InPosition, bool bFireNotifies, bool bLooping)
{
    local AnimNodeSequence SeqNode;
    SeqNode = AnimNodeSequence(Mesh.FindAnimNode('MatineeAnim'));
    if (SeqNode != None)
    {
        if (SeqNode.AnimSeqName != InAnimSeqName)
        {
            SeqNode.SetAnim(InAnimSeqName);
        }
        SeqNode.bLooping = bLooping;
        SeqNode.SetPosition(InPosition, bFireNotifies);
    }
}

event FinishAnimControl()
{
    local SkeletalMeshComponent MeshComponent;
    if (m_oBehavior != None)
    {
        if (m_oBehavior.m_bInMatinee)
        {
            m_oBehavior.m_bInMatinee = false;
            Mesh.AnimSets = m_oBehavior.m_aBackupAnimSets;
            m_oBehavior.HardResetActionAndAnimationState();
        }
    }
    if (Mesh != None)
    {
        Mesh.bUpdateSkelWhenNotRendered = m_bOldUpdateSkelWhenNotRendered;
        foreach ComponentList(Class'SkeletalMeshComponent', MeshComponent)
        {
            MeshComponent.bUpdateSkelWhenNotRendered = m_bOldUpdateSkelWhenNotRendered;
        }
    }
}

function bool DoReachedWaypointEvent(BioPathPoint oPoint)
{
    local int I;
    local bool bPause;
    bPause = false;
    I = 0;
    while (I < GeneratedEvents.Length)
    {
        if (ClassIsChildOf(GeneratedEvents[I].Class, Class'BioSeqEvt_Pawn_WaypointReached'))
        {
            if (BioSeqEvt_Pawn_WaypointReached(GeneratedEvents[I]) != None && BioSeqEvt_Pawn_WaypointReached(GeneratedEvents[I]).m_oPathPointTrigger == None || BioSeqEvt_Pawn_WaypointReached(GeneratedEvents[I]).m_oPathPointTrigger == oPoint)
            {
                bPause = GeneratedEvents[I].CheckActivate(self, self);
                if (bPause)
                {
                    GeneratedEvents[I].SetObjectVars("Waypoint", oPoint);
                }
            }
        }
        I++;
    }
    return bPause;
}

native function bool IsHostile(Pawn Other);

native function bool IsFriendly(Pawn Other);

native final function EBioFactionTypes GetFaction(optional Pawn Other);

function ReleasePower()
{
    if (m_oBehavior != None && m_oBehavior.m_oCurrentModalActive != None)
    {
        if (BioActivePower(m_oBehavior.m_oCurrentModalActive) != None)
        {
            BioActivePower(m_oBehavior.m_oCurrentModalActive).AnimationReadyForPowerRelease();
        }
    }
}

function SetScale(float fScale)
{
    Mesh.SetScale(fScale);
}

native event setHeadFaceFX();

event PlayFootStepSound(int FootDown)
{
    local Vector HitLocation;
    local Vector HitNormal;
    local TraceHitInfo HitInfo;
    local Vector TraceStart;
    local Vector TraceEnd;
    local Actor TraceActor;
    local float Loudness;
    local PlayerController P;
    local bool bFootstepRelevant;
    local float MaxSpeed;
    bFootstepRelevant = false;
    foreach LocalPlayerControllers(Class'PlayerController', P)
    {
        if (CheckMaxEffectDistance(P, Location, FootstepCullDistance))
        {
            bFootstepRelevant = true;
            break;
        }
    }
    if (!bFootstepRelevant)
    {
        return;
    }
    if (TimeSince(m_fLastFootStepTime) < 0,2)
    {
        return;
    }
    m_fLastFootStepTime = WorldInfo.TimeSeconds;
    TraceStart = Location;
    TraceEnd = Location - vect(0,0,1) * GetCollisionHeight() * 2;
    TraceActor = Trace(HitLocation, HitNormal, TraceEnd, TraceStart, HitInfo);
    PlayStepSound(FootDown, HitInfo);
    if (TraceActor != None)
    {
        MaxSpeed = GetMaxSpeed();
        if (MaxSpeed > 0)
        {
            Loudness = VSize(Velocity) / MaxSpeed;
        }
        MakeNoise(Loudness * Loudness * Loudness, 'NoiseType_Footstep');
        PlayStepEffect(FootDown, HitInfo, Loudness);
    }
}

final function PlayStepSound(int FootDown, TraceHitInfo HitInfo)
{
    local WwiseEvent FootStepEvent;
    local PhysicalMaterial ParentPhysMaterial;
    if (HitInfo.PhysMaterial != None)
    {
        FootStepEvent = GetFootStepSound(HitInfo.PhysMaterial, FootDown);
        ParentPhysMaterial = HitInfo.PhysMaterial.Parent;
    }
    else
    {
        if (HitInfo.Material != None)
        {
            FootStepEvent = GetFootStepSound(HitInfo.Material.PhysMaterial, FootDown);
            if (HitInfo.Material.PhysMaterial != None)
            {
                ParentPhysMaterial = HitInfo.Material.PhysMaterial.Parent;
            }
        }
    }
    while (FootStepEvent == None && ParentPhysMaterial != None)
    {
        FootStepEvent = GetFootStepSound(ParentPhysMaterial, FootDown);
        ParentPhysMaterial = ParentPhysMaterial.Parent;
    }
    if (FootStepEvent != None)
    {
        PlaySound(FootStepEvent);
    }
    else
    {
        PlaySound(DefaultFootStepEvent);
    }
}

final function WwiseEvent GetFootStepSound(PhysicalMaterial PhysMat, int FootDown)
{
    if (PhysMat == None || PhysMat.PhysicalMaterialProperty == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialFootSteps == None)
    {
        return None;
    }
    return GetSpecificFootStepSound(SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialFootSteps, FootDown);
}

function WwiseEvent GetSpecificFootStepSound(SFXPhysicalMaterialFootSteps FootStepSounds, int FootDown)
{
    local WwiseEvent retSound;
    local bool isRunning;
    if (VSize(Velocity) > WalkSpeed * 1,15)
    {
        isRunning = true;
    }
    if (PawnType != None)
    {
        switch (PawnType.CharacterType);
        case 1;
        if (!isRunning) jump 121;
        retSound = bIsFemale ? FootStepSounds.HLRunningSound : FootStepSounds.RunningSound;
        jump 166;
        retSound = bIsFemale ? FootStepSounds.HLWalkingSound : FootStepSounds.WalkingSound;
        jump 672;
        case 3;
        case 5;
        if (!isRunning) jump 211;
        retSound = FootStepSounds.HLRunningSound;
        jump 231;
        retSound = FootStepSounds.HLWalkingSound;
        jump 672;
        case 4;
        if (!isRunning) jump 271;
        retSound = FootStepSounds.HHRunningSound;
        jump 291;
        retSound = FootStepSounds.HHWalkingSound;
        jump 672;
        case 16;
        case 15;
        if (!isRunning) jump 336;
        retSound = FootStepSounds.HuskRunningSound;
        jump 356;
        retSound = FootStepSounds.HuskWalkingSound;
        jump 672;
        case 18;
        if (!isRunning) jump 396;
        retSound = FootStepSounds.CollectorRunningSound;
        jump 416;
        retSound = FootStepSounds.CollectorWalkingSound;
        jump 672;
        case 12;
        case 10;
        if (!isRunning) jump 461;
        retSound = FootStepSounds.RMRunningSound;
        jump 481;
        retSound = FootStepSounds.RMWalkingSound;
        jump 672;
        case 8;
        if (!isRunning) jump 521;
        retSound = FootStepSounds.RLRunningSound;
        jump 541;
        retSound = FootStepSounds.RLWalkingSound;
        jump 672;
        case 13;
        case 9;
        case 14;
        if (!isRunning) jump 591;
        retSound = FootStepSounds.RHRunningSound;
        jump 611;
        retSound = FootStepSounds.RHWalkingSound;
        jump 672;
        default;
        if (!isRunning) jump 649;
        retSound = FootStepSounds.OtherRunningSound;
        jump 669;
        retSound = FootStepSounds.OtherWalkingSound;
        jump 672;
    }
    if (retSound == None)
    {
        retSound = isRunning ? FootStepSounds.OtherRunningSound : FootStepSounds.OtherWalkingSound;
    }
    return retSound;
}

function PlayStepEffect(int FootDown, TraceHitInfo HitInfo, float Loudness)
{
    local ParticleSystem FootStep;
    local PhysicalMaterial ParentPhysMaterial;
    local SFXObjectPool Pool;
    local ParticleSystemComponent FootStepPSC;
    local Vector BoneLocation;
    if (HitInfo.PhysMaterial != None)
    {
        FootStep = GetFootStepEffect(HitInfo.PhysMaterial, FootDown);
        ParentPhysMaterial = HitInfo.PhysMaterial.Parent;
    }
    else
    {
        if (HitInfo.Material != None)
        {
            FootStep = GetFootStepEffect(HitInfo.Material.PhysMaterial, FootDown);
            if (HitInfo.Material.PhysMaterial != None)
            {
                ParentPhysMaterial = HitInfo.Material.PhysMaterial.Parent;
            }
        }
    }
    while (FootStep == None && ParentPhysMaterial != None)
    {
        FootStep = GetFootStepEffect(ParentPhysMaterial, FootDown);
        ParentPhysMaterial = ParentPhysMaterial.Parent;
    }
    if (FootStep != None)
    {
        Pool = SFXGame(WorldInfo.Game).ObjectPool;
        if (Pool != None)
        {
            if (FootDown == 1)
            {
                BoneLocation = Mesh.GetBoneLocation('RightToe', 0);
            }
            else
            {
                BoneLocation = Mesh.GetBoneLocation('LeftToe', 0);
            }
            if (IsZero(BoneLocation) == false)
            {
                FootStepPSC = Pool.GetImpactParticleSystemComponent(FootStep);
                if (FootStepPSC != None)
                {
                    Pool.AttachParticleSystemComponent(FootStepPSC, None, None, 'None', BoneLocation, Rotation, true);
                    FootStepPSC.SetActive(true);
                }
            }
        }
    }
}

final simulated function ParticleSystem GetFootStepEffect(PhysicalMaterial PhysMat, int FootDown)
{
    if (PhysMat == None || PhysMat.PhysicalMaterialProperty == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialFootSteps == None)
    {
        return None;
    }
    return GetSpecificFootStepEffect(SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialFootSteps, FootDown);
}

simulated function ParticleSystem GetSpecificFootStepEffect(SFXPhysicalMaterialFootSteps FootStepMat, int FootDown)
{
    if (VSize(Velocity) > WalkSpeed * 1,15)
    {
        return FootStepMat.FootstepRun;
    }
    return FootStepMat.FootstepWalk;
}

simulated function OnTeleport(SeqAct_Teleport Action)
{
    local array<Object> objVars;
    local int idx;
    local Actor destActor;
    local BioPlayerController oPlayerController;
    local BioWorldInfo oBioWorldInfo;
    oPlayerController = BioPlayerController(Controller);
    if (oPlayerController != None)
    {
        oBioWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
        if (oBioWorldInfo != None)
        {
            oBioWorldInfo.m_bHasPlayerTeleported = true;
            oBioWorldInfo.m_fPlayerTeleportTimeSeconds = oBioWorldInfo.TimeSeconds;
        }
        oPlayerController.OnTeleportCameraSync(Action);
    }
    LeaveCover();
    OnTeleport(Action);
    Action.GetObjectVars(objVars, "Destination");
    destActor = None;
    idx = 0;
    while (idx < objVars.Length && destActor == None)
    {
        destActor = Actor(objVars[idx]);
        if (destActor != None)
        {
            break;
        }
        idx++;
    }
    if (destActor != None && Action.bUpdateRotation)
    {
        Controller.Focus = None;
        Controller.FocalPoint = Location + vect(100,0,0) >> destActor.Rotation;
    }
}

function ReleasePowersCamera()
{
    local BioPlayerController oCont;
    oCont = BioPlayerController(Controller);
    if (oCont != None)
    {
        oCont.RecoverForPlayerPawnActionState();
    }
}

function gibbedBy(Actor Other);

event OnDeathAnimationFinished()
{
    InitRagdoll();
}

function bool HasGameEffect(Name GEName)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    Manager = GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class.Name == GEName)
            {
                return true;
            }
        }
    }
    return false;
}

function SFXGameEffect GetGameEffect(Name GEName)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    Manager = GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class.Name == GEName)
            {
                return oEffect;
            }
        }
    }
    return None;
}

event bool Died(Controller Killer, class<DamageType> DamageType, Vector HitLocation)
{
    local SFXModule_Damage DmgModule;
    local class<SFXDamageType> SFXDamageType;
    local SFXAI_Core AI;
    local bool bPermanentDeath;
    local SFXPower Power;
    local BioPowerScript PowerScript;
    SFXDamageType = Class<SFXDamageType>(DamageType);
    SFXPRI(Killer.PlayerReplicationInfo).ScoreFinesseKill(self, SFXDamageType);
    DmgModule = GetModule(Class'SFXModule_Damage');
    PlayDeathVocalization(Killer != None ? BioPawn(Killer.Pawn) : None);
    AI = SFXAI_Core(Controller);
    bPermanentDeath = false;
    if (!SFXGame(WorldInfo.Game).PreventPermanentDeath(self))
    {
        if (SFXDamageType.Default.bImmediateDeath || IsInState('Downed') || SFXDamageType.Default.DeathEffect != None && CanPlayDeathEffect(None) || m_oBehavior.m_bCanUseDeathCapabilities == false || HasDeathPower() == false && AI == None || !AI.IsPlayingDeathReaction())
        {
            bPermanentDeath = true;
        }
    }
    if (!bPermanentDeath)
    {
        if (AI != None && BioPlayerSquad(Squad) == None)
        {
            AI.EnableAI(false, 16);
        }
        KilledBy = Killer;
        KilledByDamageType = DamageType;
        KilledByHitLocation = HitLocation;
        GotoState('Downed');
        return false;
    }
    if (AI != None)
    {
        AI.NotifyDeathBlow();
        AI.EndCustomAction();
    }
    m_bEnableRagdollRecovery = false;
    Squad.Died(self, Killer);
    MakeNoise(1, 'NoiseType_Death');
    FadeLifeCrust();
    KillAttachedVFX();
    Controller.ClearTimer('UpdateAllEnemyInfo');
    if (DmgModule != None)
    {
        DmgModule.CurrentHealth = Min(0, DmgModule.CurrentHealth);
    }
    if (PowerManager != None)
    {
        foreach PowerManager.Powers(Power)
        {
            PowerScript = Power.GetPowerScript();
            if (PowerScript != None)
            {
                PowerScript.OnOwnerDied();
            }
        }
    }
    Died(Killer, DamageType, HitLocation);
    bIsDead = true;
    ResetSnapshotNode();
    return true;
}

function ResetSnapshotNode()
{
    local BioAnimNodeFrame SnapshotNode;
    if (Mesh != None && Mesh.Animations != None)
    {
        foreach Mesh.AllAnimNodes(Class'BioAnimNodeFrame', SnapshotNode)
        {
            SnapshotNode.CaptureAnimFrame();
        }
    }
}

function PlayDeathVocalization(BioPawn Killer)
{
    local BioPawnType ThePawnType;
    ThePawnType = BioPawnType(ActorType);
    if (ThePawnType != None && ThePawnType.ChallengeType > 2)
    {
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(22, self, Killer);
    }
    else
    {
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(21, self, Killer);
    }
    if (Killer != None && SFXAI_Henchman(Killer.Controller) != None)
    {
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(15, Killer, self);
    }
}

simulated function PlayDying(class<DamageType> DamageType, Vector HitLoc)
{
    local class<SFXDamageType> SFXDamageType;
    SFXDamageType = Class<SFXDamageType>(DamageType);
    if (m_oBehavior.Squad != None)
    {
        m_oBehavior.Squad.RemoveDyingMember(self);
    }
    ScaleLimitTimeToGo = 1;
    GotoState('Dying');
    InitRagdoll();
    Mesh.AddImpulse(TearOffMomentum, HitLoc, 'root');
    bReplicateMovement = false;
    bTearOff = true;
    Velocity += TearOffMomentum;
    bPlayedDeath = true;
    if (bCollidesAfterDeath == false)
    {
        Mesh.SetRBChannel(7);
        Mesh.SetRBCollidesWithChannel(2, false);
    }
    PlayDeathEffect(SFXDamageType);
    TimeOfDeath = WorldInfo.TimeSeconds;
    ManageRagdolls();
}

function PlayDeathEffect(class<SFXDamageType> SFXDamageType)
{
    local BioVFXTemplate DeathEffect;
    local BioVisualEffect VFXInstance;
    local SFXGameEffect Effect;
    local SFXModule_GameEffectManager GEM;
    local SFXGameEffect_DeathEffect DeathGE;
    local bool bGameEffectDeath;
    local int HighestGEPriority;
    local WwiseEvent DeathGESound;
    DeathEffect = SFXDamageType.Default.DeathEffect;
    GEM = GetModule(Class'SFXModule_GameEffectManager');
    foreach GEM.GameEffects(Effect)
    {
        DeathGE = SFXGameEffect_DeathEffect(Effect);
        if (DeathGE != None)
        {
            if (CanPlayDeathEffect(DeathGE) == false)
            {
                continue;
            }
            if (DeathGE.Priority < HighestGEPriority)
            {
                continue;
            }
            HighestGEPriority = DeathGE.Priority;
            DeathEffect = DeathGE.DeathEffect;
            bGameEffectDeath = true;
            DeathGESound = DeathGE.DeathSoundEffect;
        }
    }
    if (!bGameEffectDeath && !CanPlayDeathEffect(None))
    {
        return;
    }
    if (bGameEffectDeath && DeathGESound != None)
    {
        PlaySound(DeathGESound);
    }
    if (DeathEffect != None)
    {
        VFXInstance = CreateDeathEffect(DeathEffect, true, true);
        if (VFXInstance != None)
        {
            VFXInstance.SetVectorParameter('BlastDirection', Normal(TearOffMomentum));
        }
    }
}

function bool CanPlayDeathEffect(SFXGameEffect GE)
{
    if (HasDeathPower())
    {
        if (m_oBehavior != None && m_oBehavior.m_bCanUseDeathCapabilities || m_bDeathPowerUsed)
        {
            return false;
        }
    }
    return true;
}

state Dying
{
    function OnEnterRagdoll();

    event Timer()
    {
        if (m_bCanCleanupCorpse)
        {
            Timer();
        }
    }

    event TakeDamage(float Damage, Controller EventInstigator, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
    {
        Global.TakeDamage(Damage, EventInstigator, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
    }

    simulated function Tick(float DeltaTime)
    {
        if (bScalingToZero)
        {
            SetDrawScale(DrawScale - DeltaTime);
            if (DrawScale < 0,4)
            {
                Mesh.SetRBChannel(1);
                Mesh.SetRBCollidesWithChannel(1, false);
                Mesh.SetRBCollidesWithChannel(0, false);
                Mesh.SetRBCollidesWithChannel(2, false);
                if (DrawScale < 0,02)
                {
                    bScalingToZero = false;
                    if (bDeleteMe == false)
                    {
                        Destroy();
                    }
                }
            }
        }
    }

}

function bool HasDeathPower()
{
    local int Index;
    local SFXPower Power;
    if (PowerManager != None)
    {
        Index = 0;
        while (Index < PowerManager.Powers.Length)
        {
            Power = PowerManager.Powers[Index];
            if (Power != None && Power.CapabilityType == 9)
            {
                return true;
            }
            Index++;
        }
    }
    return false;
}

state Downed
{
    function BreathTimer();

    function FellOutOfWorld(class<DamageType> dmgType);

    function TakeDamage(float DamageAmount, Controller EventInstigator, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser);

    function bool Died(Controller Killer, class<DamageType> DamageType, Vector HitLocation);

    function OnEnterRagdoll();

    function bool CastDeathPower()
    {
        local SFXAI_Core AI;
        local Name PowerName;
        local int Index;
        local SFXPower Power;
        local float CooldownRemaining;
        local BioActivePower Active;
        AI = SFXAI_Core(Controller);
        if (AI != None)
        {
            AI.ChooseDeathPower(PowerName);
        }
        else
        {
            if (PowerManager != None)
            {
                Index = 0;
                while (Index < PowerManager.Powers.Length)
                {
                    Power = PowerManager.Powers[Index];
                    if (Power != None && Power.CapabilityType == 9)
                    {
                        PowerName = Power.PowerName;
                        break;
                    }
                    Index++;
                }
            }
        }
        if (m_oBehavior.SetCurrentPower(PowerName, CooldownRemaining))
        {
            Active = BioActivePower(m_oBehavior.AcquireActive(Class'BioActivePower'));
            if (Active != None)
            {
                return true;
            }
        }
        return false;
    }

    function bool IsPlayingReaction()
    {
        local SFXAI_Core AI;
        AI = SFXAI_Core(Controller);
        if (AI != None && AI.IsPlayingReaction())
        {
            return true;
        }
        return false;
    }

    event ForceEndRagdoll()
    {
        local bool bGotoAutoState;
        bGotoAutoState = true;
        if (!SFXGame(WorldInfo.Game).PreventPermanentDeath(self))
        {
            if (GetCurrentHealth() <= 0)
            {
                Global.Died(KilledBy, KilledByDamageType, KilledByHitLocation);
                bGotoAutoState = false;
            }
        }
        if (Physics == 10)
        {
            TermRagdoll();
        }
        if (bGotoAutoState)
        {
            GotoState('Auto');
        }
    }

    while (IsPlayingReaction())
    {
        Sleep(0,1);
    }
    if (m_oBehavior.m_bCanUseDeathCapabilities && HasDeathPower())
    {
        if (m_oBehavior.m_oCurrentModalActive != None)
        {
            m_oBehavior.m_oCurrentModalActive.EndActive();
        }
        while (CastDeathPower() == false)
        {
            Sleep(0,1);
        }
        while (m_oBehavior.m_oCurrentModalActive != None)
        {
            Sleep(0,1);
        }
        m_bDeathPowerUsed = true;
        m_oBehavior.m_bCanUseDeathCapabilities = false;
    }
    if (Physics != 10)
    {
        InitRagdoll();
    }
    if (SFXAI_Core(Controller) != None)
    {
        if (SFXAI_Core(Controller).UpdateDeathState() == false)
        {
            if (Physics == 10)
            {
                GotoState('InRagdoll');
            }
            else
            {
                GotoState('Auto');
            }
        }
        SFXAI_Core(Controller).NotifyDeathBlow();
        SFXAI_Core(Controller).EndCustomAction();
    }
    bIsDead = true;
    ResetSnapshotNode();
    while (SFXGame(WorldInfo.Game).PreventPermanentDeath(self))
    {
        Sleep(1);
    }
    Global.Died(KilledBy, KilledByDamageType, KilledByHitLocation);
    jump 0;
    // unresolved reference 0 ;
}

state BioPawn
{
    function UpdateCombatMode()
    {
        if (ActionState != 1 && GetClassification() == 4 && m_oBehavior != None)
        {
            m_oBehavior.SetActionState(1);
        }
    }

    UpdateCombatMode();
    jump 0;
    // unresolved reference 0 ;
}

event SetRichPresence()
{
    local OnlineSubsystem OnlineSub;
    local array<LocalizedStringSetting> aContexts;
    local LocalizedStringSetting Context;
    local array<SettingsProperty> aProperties;
    local SettingsProperty Property;
    local BioPlayerController PC;
    local LocalPlayer LocPlayer;
    local int nPresenceMode;
    local int nIndex;
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSub != None && NotEqual_InterfaceInterface(OnlineSub.PlayerInterface, OnlinePlayerInterface(None)))
    {
        PC = BioPlayerController(Controller);
        if (PC != None)
        {
            LocPlayer = LocalPlayer(PC.Player);
            if (LocPlayer != None)
            {
                if (PC.GetScaleFormManager().GetPanelByTag('MainMenu') != None || PC.GetScaleFormManager().GetPanelByTag('Splash') != None)
                {
                    nPresenceMode = 1;
                }
                else
                {
                    nPresenceMode = 0;
                    Context.Id = 1;
                    Context.ValueIndex = GetXLASTClassContextID();
                    Context.AdvertisementType = 1;
                    aContexts.AddItem(Context);
                    Context.Id = 2;
                    if (PC.ProfileSettings != None)
                    {
                        Context.ValueIndex = PC.ProfileSettings.GetDifficultyConfigOption();
                    }
                    else
                    {
                        Context.ValueIndex = 1;
                    }
                    aContexts.AddItem(Context);
                    Property.PropertyId = 268435458;
                    Class'Settings'.SetSettingsDataInt(Property.Data, CharacterLevel);
                    Property.AdvertisementType = 1;
                    aProperties.AddItem(Property);
                }
                OnlineSub.PlayerInterface.SetOnlineStatus(LocPlayer.ControllerId, nPresenceMode, aContexts, aProperties);
                aContexts.Length = 0;
                aProperties.Length = 0;
                nIndex = 0;
                while (nIndex < 4)
                {
                    if (nIndex != LocPlayer.ControllerId)
                    {
                        OnlineSub.PlayerInterface.SetOnlineStatus(nIndex, 1, aContexts, aProperties);
                    }
                    ++nIndex;
                }
            }
        }
    }
}

function int GetXLASTClassContextID()
{
    local int nValue;
    if (SFXPawn_PlayerSoldier(self) != None)
    {
        nValue = 0;
    }
    else
    {
        if (SFXPawn_PlayerEngineer(self) != None)
        {
            nValue = 1;
        }
        else
        {
            if (SFXPawn_PlayerAdept(self) != None)
            {
                nValue = 2;
            }
            else
            {
                if (SFXPawn_PlayerInfiltrator(self) != None)
                {
                    nValue = 3;
                }
                else
                {
                    if (SFXPawn_PlayerSentinel(self) != None)
                    {
                        nValue = 4;
                    }
                    else
                    {
                        if (SFXPawn_PlayerVanguard(self) != None)
                        {
                            nValue = 5;
                        }
                    }
                }
            }
        }
    }
    return nValue;
}

native function FadeLifeCrust();

native function KillAttachedVFX();

event bool IsShieldBoosted()
{
    local SFXShield_Base Shield;
    if (InvManager == None)
    {
        return false;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', Shield)
    {
        if (Shield.BoostedShieldMax > 0)
        {
            return true;
        }
    }
    return false;
}

function SFXShield_Base GetShields()
{
    local SFXShield_Base Shield;
    if (InvManager == None)
    {
        return None;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', Shield)
    {
        return Shield;
    }
    return None;
}

final event float GetCurrentHealth()
{
    local SFXModule_Damage DmgModule;
    DmgModule = GetModule(Class'SFXModule_Damage');
    if (DmgModule != None)
    {
        return DmgModule.CurrentHealth;
    }
    return 0;
}

final event float GetMaxHealth()
{
    local SFXModule_Damage DmgModule;
    DmgModule = GetModule(Class'SFXModule_Damage');
    if (DmgModule != None)
    {
        return DmgModule.MaxHealth.Value;
    }
    return 0;
}

event float GetHealthPct()
{
    local SFXModule_Damage DmgMod;
    DmgMod = GetModule(Class'SFXModule_Damage');
    if (DmgMod == None)
    {
        return 1;
    }
    if (DmgMod.MaxHealth.Value == 0)
    {
        return 1;
    }
    return DmgMod.CurrentHealth / DmgMod.MaxHealth.Value;
}

final event float GetCurrentShields()
{
    local SFXShield_Base ShieldObj;
    local float Shields;
    if (InvManager == None)
    {
        return 0;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', ShieldObj)
    {
        Shields += ShieldObj.CurrentShields;
    }
    return Shields;
}

final event float GetMaxShields()
{
    local SFXShield_Base ShieldObj;
    local float MaxShields;
    if (InvManager == None)
    {
        return 0;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', ShieldObj)
    {
        MaxShields += ShieldObj.MaxShields.Value;
    }
    return MaxShields;
}

event float GetShieldPct()
{
    if (GetMaxShields() <= 0)
    {
        return 0;
    }
    return GetCurrentShields() / GetMaxShields();
}

final function float GetShieldRegenDelay()
{
    local SFXShield_Base ShieldObj;
    if (InvManager == None)
    {
        return 0;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', ShieldObj)
    {
        return ShieldObj.GetShieldRegenDelay();
    }
    return 0;
}

final function float GetShieldRechargeTime()
{
    local SFXShield_Base ShieldObj;
    if (InvManager == None)
    {
        return 0;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', ShieldObj)
    {
        return ShieldObj.GetShieldRechargeTime();
    }
    return 0;
}

event bool IsArmorFortified()
{
    local SFXArmor_Base Armor;
    if (InvManager == None)
    {
        return false;
    }
    Armor = SFXArmor_Base(InvManager.FindInventoryType(Class'SFXArmor_Base', true));
    if (Armor != None)
    {
        return Armor.bShowFortifyOnGUI || SFXArmor_Heavy(Armor) != None;
    }
    return false;
}

event RecoverFromBleedout()
{
    if (GetModule(Class'SFXModule_DamagePlayer') != None)
    {
        GetModule(Class'SFXModule_DamagePlayer').RecoverFromBleedout();
    }
}

event bool GetInBleedout()
{
    if (GetModule(Class'SFXModule_DamagePlayer') != None)
    {
        GetModule(Class'SFXModule_DamagePlayer').bIsBleedingOut;
    }
    return false;
}

event float GetRegenRate()
{
    local SFXModule_GameEffectManager GEModule;
    GEModule = GetModule(Class'SFXModule_GameEffectManager');
    if (GEModule != None)
    {
        return GEModule.GetEffectValue(Class'SFXGameEffect_Regeneration');
    }
    return 0;
}

event bool Resurrect(float PercentOfHealthRegained, bool bIsInstantaneous)
{
    local SFXModule_Damage DmgMod;
    DmgMod = GetModule(Class'SFXModule_Damage');
    if (DmgMod == None)
    {
        return false;
    }
    if (IsDead() == false)
    {
        return false;
    }
    DmgMod.CurrentHealth = DmgMod.MaxHealth.Value * PercentOfHealthRegained;
    DmgMod.bIsDead = false;
    bIsDead = false;
    if (bIsInstantaneous)
    {
        ForceEndRagdoll();
    }
    else
    {
        if (Physics != 10)
        {
            InitRagdoll();
        }
        if (Physics == 10)
        {
            GotoState('InRagdoll');
        }
        else
        {
            GotoState('Auto');
        }
    }
    return true;
}

function SpawnDefaultController()
{
    local class<BioAiController> AIControllerClass;
    if (Controller != None)
    {
        return;
    }
    AIControllerClass = AIController;
    if (AIControllerClass == None)
    {
        if (PawnType != None)
        {
            AIControllerClass = PawnType.AIController;
        }
    }
    Controller = Spawn(AIControllerClass);
    if (Controller == None)
    {
        AIControllerClass = Class'SFXAI_None';
        Controller = Spawn(AIControllerClass);
    }
    if (Controller != None)
    {
        Controller.Possess(self, false);
        BioAiController(Controller).Initialize();
        return;
    }
}

final function MakeVulnerable();

native final static function bool IsCombatActionState(EActionStateVariable eActionStateVar);

static function class<BioBaseSaveObject> GetSaveObjectClass()
{
    return Class'BioPawnSaveObject';
}

event OnPowerCooldownFinished(Name nmPower)
{
    local int idx;
    local BioSeqEvt_PowerCooldownFinished pcdEvent;
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        pcdEvent = BioSeqEvt_PowerCooldownFinished(GeneratedEvents[idx]);
        if (pcdEvent != None)
        {
            pcdEvent.SetNameVars("PowerName", nmPower);
            pcdEvent.CheckActivate(self, self);
        }
        idx++;
    }
}

event OnPowerEffectDurationComplete(Name nmPower)
{
    local int idx;
    local BioSeqEvt_PowerEffectDurationComplete pedEvent;
    local SFXAI_Core SFXAI;
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        pedEvent = BioSeqEvt_PowerEffectDurationComplete(GeneratedEvents[idx]);
        if (pedEvent != None)
        {
            pedEvent.SetNameVars("PowerName", nmPower);
            pedEvent.CheckActivate(self, self);
        }
        idx++;
    }
    SFXAI = SFXAI_Core(Controller);
    if (SFXAI != None)
    {
        SFXAI.NotifyPowerFinished(nmPower);
    }
}

event OnPowerCast(SFXPower Power)
{
    local int idx;
    local SFXSeqEvt_CastPower oCastEvent;
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        oCastEvent = SFXSeqEvt_CastPower(GeneratedEvents[idx]);
        if (oCastEvent != None)
        {
            oCastEvent.SetNameVars("Power", Power.PowerName);
            oCastEvent.SetObjectVars("Who", self);
            oCastEvent.SetIntVars("Category", Power.Discipline);
            oCastEvent.CheckActivate(self, self);
        }
        idx++;
    }
}

event OnPowerOrdered(Name nmPower, Actor oTargetActor)
{
    local int idx;
    local SFXSeqEvt_OrderedPower oOrderEvent;
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        oOrderEvent = SFXSeqEvt_OrderedPower(GeneratedEvents[idx]);
        if (oOrderEvent != None)
        {
            oOrderEvent.SetNameVars("Power", nmPower);
            oOrderEvent.SetObjectVars("Target", oTargetActor);
            oOrderEvent.CheckActivate(self, self);
        }
        idx++;
    }
}

event NotifyLimbDetached(EBioPartGroup ePartGroup)
{
    local int idx;
    local BioSeqEvt_NotifyLimbDetached detachEvent;
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        detachEvent = BioSeqEvt_NotifyLimbDetached(GeneratedEvents[idx]);
        if (detachEvent != None)
        {
            detachEvent.SetIntVars("WhichLimb", ePartGroup);
            detachEvent.CheckActivate(self, self);
        }
        idx++;
    }
}

native function InitializeSpeeds();

function OnOrbitalGame(BioSeqAct_OrbitalGame Action);

function CacheAnimNodes()
{
    local AnimNodeSlot SlotNode;
    ClearAnimNodes();
    if (Mesh != None && Mesh.Animations != None)
    {
        foreach Mesh.AllAnimNodes(Class'AnimNodeSlot', SlotNode)
        {
            if (SlotNode.NodeName == 'None')
            {
                continue;
            }
            switch (SlotNode.NodeName)
            {
                case 'Custom_FullBody':
                    BodyStanceNodes[0] = SlotNode;
                    break;
                default:
                    break;
            }
        }
    }
}

event RecacheAnimNodes()
{
    CacheAnimNodes();
}

function ClearAnimNodes()
{
    BodyStanceNodes.Length = 0;
}

event OnAnimEnd(AnimNodeSequence SeqNode, float PlayedTime, float ExcessTime)
{
    local int I;
    OnAnimEnd(SeqNode, PlayedTime, ExcessTime);
    I = 0;
    while (I < BodyStanceNodes.Length)
    {
        if (BodyStanceNodes[I] != None)
        {
            if (SeqNode == BodyStanceNodes[I].GetCustomAnimNodeSeq())
            {
                BodyStanceAnimEndNotification(SeqNode, PlayedTime, ExcessTime);
                return;
            }
        }
        I++;
    }
}

native final function float PawnPlayCustomAnim(AnimNodeSlot Slot, Name AnimName, float Rate, optional float BlendInTime, optional float BlendOutTime, optional bool bLooping, optional bool bOverride, optional float StartTime);

final function float PlayBodyStance(BodyStance Stance, float Rate, optional float BlendInTime, optional float BlendOutTime, optional bool bLooping, optional bool bOverride = true, optional bool bKeepRBASettings, optional float StartTime)
{
    local float Duration;
    local bool bAnimPlayFail;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        Duration = PawnPlayCustomAnim(BodyStanceNodes[Stance.StanceID], Stance.AnimName, Rate, BlendInTime, BlendOutTime, bLooping, bOverride, StartTime);
        if (Duration == 0)
        {
            bAnimPlayFail = true;
        }
        if (!bKeepRBASettings)
        {
            BodyStanceNodes[Stance.StanceID].SetRootBoneAxisOption(0, 0, 0);
        }
        BodyStanceNodes[Stance.StanceID].Children[BodyStanceNodes[Stance.StanceID].CustomChildIndex].bMirrorSkeleton = false;
    }
    else
    {
        bAnimPlayFail = true;
    }
    if (bAnimPlayFail == true)
    {
        TerminateCurrentCustomAction();
    }
    return Duration;
}

final function PlayBodyStanceByDuration(BodyStance Stance, float Duration, optional float BlendInTime, optional float BlendOutTime, optional bool bLooping, optional bool bOverride = true)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        BodyStanceNodes[Stance.StanceID].PlayCustomAnimByDuration(Stance.AnimName, Duration, BlendInTime, BlendOutTime, bLooping, bOverride);
        BodyStanceNodes[Stance.StanceID].SetRootBoneAxisOption(0, 0, 0);
        BodyStanceNodes[Stance.StanceID].Children[BodyStanceNodes[Stance.StanceID].CustomChildIndex].bMirrorSkeleton = false;
    }
}

final function bool IsPlayingBodyStance(BodyStance Stance)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        if (BodyStanceNodes[Stance.StanceID].GetPlayedAnimation() == Stance.AnimName)
        {
            return true;
        }
    }
    return false;
}

final function StopBodyStance(BodyStance Stance, optional float BlendOutTime)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        if (BodyStanceNodes[Stance.StanceID].bIsPlayingCustomAnim && BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq().AnimSeqName == Stance.AnimName)
        {
            BodyStanceNodes[Stance.StanceID].StopCustomAnim(BlendOutTime);
            BodyStanceNodes[Stance.StanceID].SetActorAnimEndNotification(false);
        }
    }
}

final function StopAllBodyStances(float BlendOutTime)
{
    local int I;
    I = 0;
    while (I < BodyStanceNodes.Length)
    {
        if (BodyStanceNodes[I] != None)
        {
            BodyStanceNodes[I].StopCustomAnim(BlendOutTime);
            BodyStanceNodes[I].SetActorAnimEndNotification(false);
        }
        I++;
    }
}

final function SetBodyStance(BodyStance Stance)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        BodyStanceNodes[Stance.StanceID].SetCustomAnim(Stance.AnimName);
    }
}

final function BS_SetPosition(BodyStance Stance, float Position)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.SetPosition(Position, false);
        }
    }
}

final function float BS_GetTimeLeft(BodyStance Stance)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            return SeqNode.GetTimeLeft();
        }
    }
    return 0;
}

final function float BS_GetPlayRate(BodyStance Stance)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            return SeqNode.GetGlobalPlayRate();
        }
    }
    return 1;
}

final function BS_SetPlayRate(BodyStance Stance, float NewRate)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.Rate = NewRate;
        }
    }
}

final function BS_AccelerateBlend(BodyStance Stance, float BlendAmount)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        BodyStanceNodes[Stance.StanceID].AccelerateBlend(BlendAmount);
    }
}

final function BS_PauseAnim(BodyStance Stance)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.bPlaying = false;
        }
    }
}

final function BS_UnpauseAnim(BodyStance Stance)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.bPlaying = true;
        }
    }
}

final function ScaleBodyStancePlayRate(BodyStance Stance, float RateScale)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.Rate *= RateScale;
        }
    }
}

final function SetBodyStanceRootBoneAxisOption(BodyStance Stance, optional ERootBoneAxis AxisX = 0, optional ERootBoneAxis AxisY = 0, optional ERootBoneAxis AxisZ = 0)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        BodyStanceNodes[Stance.StanceID].SetRootBoneAxisOption(AxisX, AxisY, AxisZ);
    }
}

final function SetBodyStanceAnimEndNotification(BodyStance Stance, bool bNewStatus)
{
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        BodyStanceNodes[Stance.StanceID].SetActorAnimEndNotification(bNewStatus);
    }
}

final function SetBodyStanceAnimLooping(BodyStance Stance, bool bNewLooping)
{
    local AnimNodeSequence SeqNode;
    if (Stance.StanceID < BodyStanceNodes.Length && BodyStanceNodes[Stance.StanceID] != None)
    {
        SeqNode = BodyStanceNodes[Stance.StanceID].GetCustomAnimNodeSeq();
        if (SeqNode != None)
        {
            SeqNode.bLooping = bNewLooping;
        }
    }
}

function BodyStanceAnimEndNotification(AnimNodeSequence SeqNode, float PlayedTime, float ExcessTime)
{
    local BioCustomAction pAction;
    GetCurrentCustomAction(pAction);
    if (pAction != None)
    {
        pAction.BodyStanceAnimEndNotification(SeqNode, PlayedTime, ExcessTime);
    }
}

final function AnimNotify(AnimNodeSequence SeqNode, BioAnimNotify_CustomAction NotifyObject)
{
    local BioCustomAction pAction;
    GetCurrentCustomAction(pAction);
    if (pAction != None)
    {
        pAction.AnimNotify(SeqNode, NotifyObject);
    }
}

native function bool GetCurrentCustomAction(out BioCustomAction pAction);

event TerminateCurrentCustomAction()
{
    if (SFXPlayerController(Controller) != None)
    {
        SFXPlayerController(Controller).EndCustomAction();
    }
    else
    {
        if (SFXAI_Core(Controller) != None)
        {
            SFXAI_Core(Controller).EndCustomAction();
        }
    }
}

function bool ControllerContainsCustomActionClass(class<BioCustomAction> CustomActionClass)
{
    local BioPlayerController PlayerCont;
    local SFXAI_Core AICont;
    local class<BioCustomAction> CurrentAction;
    PlayerCont = BioPlayerController(Controller);
    if (PlayerCont != None)
    {
        foreach PlayerCont.CustomActionClasses(CurrentAction)
        {
            if (CurrentAction == CustomActionClass)
            {
                return true;
            }
        }
    }
    else
    {
        AICont = SFXAI_Core(Controller);
        if (AICont != None)
        {
            foreach AICont.CustomActionClasses(CurrentAction)
            {
                if (CurrentAction == CustomActionClass)
                {
                    return true;
                }
            }
        }
    }
    return false;
}

event bool ControllerContainsMantleCustomAction()
{
    return ControllerContainsCustomActionClass(Class'BioCustomAction_CoverMantle');
}

event bool ControllerContainsClimbUpCustomAction()
{
    return ControllerContainsCustomActionClass(Class'BioCustomAction_CoverClimb');
}

event bool ControllerCanDoSpecialMove()
{
    local SFXAI_Core AICont;
    AICont = SFXAI_Core(Controller);
    if (AICont != None)
    {
        return AICont.m_bSpecialMoveAllowed;
    }
    return true;
}

function bool SpecialMoveTo(NavigationPoint Start, NavigationPoint End, Actor Next)
{
    local SFXAI_Core AICont;
    local bool CustomActionSuccess;
    local CoverSlotMarker oStartMarker;
    local CoverSlotMarker oEndMarker;
    local MantleMarker oMantleMarker;
    local BioPawn oPawn;
    if (Start == None || End == None)
    {
        return false;
    }
    AICont = SFXAI_Core(Controller);
    if (CanMantleBetween(Start, End) == true)
    {
        oStartMarker = CoverSlotMarker(Start);
        oEndMarker = CoverSlotMarker(End);
        oMantleMarker = MantleMarker(End);
        foreach OverlappingActors(Class'BioPawn', oPawn, CylinderComponent.CollisionRadius, End.Location)
        {
            if (oPawn != self && oPawn.Physics != 10)
            {
                AICont.MoveTarget = None;
                return false;
            }
        }
        if (oStartMarker != None && oEndMarker != None && oEndMarker.OwningSlot.Link != None)
        {
            if (oEndMarker.OwningSlot.Link.IsValidClaim(AICont, oEndMarker.OwningSlot.SlotIdx, false, false))
            {
                CustomActionSuccess = SpecialMoveTo_Mantle(Start, End);
            }
            else
            {
                AICont.MoveTarget = None;
                return false;
            }
        }
        else
        {
            if (oMantleMarker != None)
            {
                CustomActionSuccess = SpecialMoveTo_ClimbUp(Start, End);
            }
        }
    }
    return CustomActionSuccess;
}

function bool SpecialMoveTo_Mantle(NavigationPoint Start, NavigationPoint End)
{
    local SFXAI_Core Control;
    Control = SFXAI_Core(Controller);
    if (Control != None)
    {
        SetAnchor(Start);
        Control.StartCustomAction(10);
        Control.MoveTarget = End;
        LastMantleTime = WorldInfo.TimeSeconds;
        LastMantleLocation = Start.Location;
        return true;
    }
    return false;
}

function bool SpecialMoveTo_ClimbUp(NavigationPoint Start, NavigationPoint End)
{
    local SFXAI_Core Control;
    Control = SFXAI_Core(Controller);
    if (Control != None)
    {
        SetAnchor(Start);
        Control.StartCustomAction(9);
        Control.MoveTarget = End;
        LastMantleTime = WorldInfo.TimeSeconds;
        LastMantleLocation = Start.Location;
        return true;
    }
    return false;
}

function bool CanMantleBetween(NavigationPoint first, NavigationPoint Second)
{
    local ReachSpec CurrentPath;
    CurrentPath = first.GetReachSpecTo(Second);
    if (CurrentPath != None && CurrentPath.IsA('MantleReachSpec'))
    {
        return true;
    }
    return false;
}

native function SetCrouchStateInstantly(bool bDoCrouch);

event bool IsReturningToPlaypen()
{
    local SFXAI_Core oAI;
    oAI = SFXAI_Core(Controller);
    if (oAI != None)
    {
        return oAI.IsReturningToPlaypen();
    }
    return false;
}

function bool CanHavePhysicsImpulse()
{
    if (IsDead())
    {
        return true;
    }
    return !bPlayDeathAnimation && m_oBehavior.GetCanBePhysicsImpacted() && m_bEnableRagdollRecovery;
}

event bool AddRagdollImpulse(Vector Impulse, Controller InstigatedBy, optional Vector HitLocation, optional bool bIgnorePhysicsThreshold, optional Name HitBone, optional bool bVelChange)
{
    if (HitBone == 'None')
    {
        HitBone = PawnType.m_oAppearance.m_nmPhysicsImpactBone;
    }
    if (IsDead())
    {
        if (Physics != 10)
        {
            InitRagdoll();
        }
        Mesh.AddImpulse(Impulse, HitLocation, HitBone, bVelChange);
        return true;
    }
    if (Physics == 10)
    {
        Mesh.AddImpulse(Impulse, HitLocation, HitBone, bVelChange);
        return true;
    }
    if (PlayAnimatedReaction(5, InstigatedBy, true, HitLocation, Normal(Impulse)))
    {
        Mesh.AddImpulse(Impulse, HitLocation, HitBone, bVelChange);
        return true;
    }
    return false;
}

function PlayShieldHit(float Damage, Controller InstigatedBy, Vector HitLocation, class<DamageType> DamageType, Vector Momentum, TraceHitInfo HitInfo)
{
    local class<SFXDamageType> DamageClass;
    local HitReaction Reaction;
    DamageClass = Class<SFXDamageType>(DamageType);
    if (CanPlayAnimatedReaction(Damage, InstigatedBy, HitLocation, DamageClass, Momentum, HitInfo, Reaction))
    {
        PlayAnimatedReaction(Reaction.AnimatedReaction, InstigatedBy, true, HitLocation, Normal(Location - InstigatedBy.Pawn.Location), HitInfo, Reaction.bDeathReaction);
    }
}

function PlayHit(float Damage, Controller InstigatedBy, Vector HitLocation, class<DamageType> DamageType, Vector Momentum, TraceHitInfo HitInfo)
{
    local SFXModule_Damage DmgModule;
    local SFXWeapon oWeapon;
    local class<SFXDamageType> DamageClass;
    local float HealthPct;
    local HitReaction Reaction;
    local float fDamageVocProbMod;
    PlayHit(Damage, InstigatedBy, HitLocation, DamageType, Momentum, HitInfo);
    DamageClass = Class<SFXDamageType>(DamageType);
    DmgModule = GetModule(Class'SFXModule_Damage');
    if (DmgModule == None || DamageClass == None || InstigatedBy == None)
    {
        return;
    }
    HealthPct = DmgModule.CurrentHealth / DmgModule.MaxHealth.Value;
    if (CanPlayAnimatedReaction(Damage, InstigatedBy, HitLocation, DamageClass, Momentum, HitInfo, Reaction))
    {
        PlayAnimatedReaction(Reaction.AnimatedReaction, InstigatedBy, true, HitLocation, Normal(Location - InstigatedBy.Pawn.Location), HitInfo, Reaction.bDeathReaction);
    }
    oWeapon = SFXWeapon(InstigatedBy.Pawn.Weapon);
    if (oWeapon != None && oWeapon.__GetDamageVocProbabilityMod__Delegate != None)
    {
        fDamageVocProbMod = oWeapon.GetDamageVocProbabilityMod();
    }
    else
    {
        fDamageVocProbMod = 1;
    }
    if (HealthPct > 0,5)
    {
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(114, BioPawn(InstigatedBy.Pawn), self, 1, fDamageVocProbMod);
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(24, self, BioPawn(InstigatedBy.Pawn), 0, fDamageVocProbMod);
    }
    else
    {
        if (HealthPct > 0,2)
        {
            SFXGame(WorldInfo.Game).TriggerVocalizationEvent(111, BioPawn(InstigatedBy.Pawn), self, 1, fDamageVocProbMod);
            SFXGame(WorldInfo.Game).TriggerVocalizationEvent(25, self, BioPawn(InstigatedBy.Pawn), 0, fDamageVocProbMod);
        }
        else
        {
            if (HealthPct > 0)
            {
                SFXGame(WorldInfo.Game).TriggerVocalizationEvent(26, self, BioPawn(InstigatedBy.Pawn), 0, fDamageVocProbMod);
            }
        }
    }
    SFXGame(WorldInfo.Game).TriggerVocalizationEvent(104, BioPawn(InstigatedBy.Pawn), self, 1, fDamageVocProbMod);
    if (bHasShields == false || DamageClass.Default.bIgnoreShields)
    {
        if (Physics == 10)
        {
            Mesh.AddImpulse(Momentum, HitLocation, HitInfo.BoneName, false);
            return;
        }
        if (DmgModule.CurrentHealth <= 0)
        {
            return;
        }
        if (bCanPlayPhysicsHitReactions && DamageClass.Default.bCausesPhysicsImpact)
        {
            DoPhysicsBodyImpact(HitLocation, Momentum, DamageType, HitInfo);
            return;
        }
    }
}

native final function bool CanPlayAnimatedReaction(float Damage, Controller InstigatedBy, Vector HitLocation, class<SFXDamageType> DamageType, Vector Momentum, TraceHitInfo HitInfo, out HitReaction out_Reaction);

function bool PlayAnimatedReaction(EAICustomAction CustomAction, Controller InstigatedBy, optional bool bPlayImpact, optional Vector HitLocation, optional Vector HitNormal, optional out TraceHitInfo HitInfo, optional bool bDeathReaction)
{
    local SFXAI_Core AI;
    local SFXCustomAction_DamageReaction Action;
    local BioCustomAction CurrentAction;
    AI = SFXAI_Core(Controller);
    if (Physics != 10 && AI != None && AI.CanDoCustomAction(CustomAction))
    {
        if (AI.IsDoingACustomAction())
        {
            if (CustomAction >= AI.CurrentCustomAction)
            {
                if (CustomAction != 5 || AI.CurrentCustomAction != 5)
                {
                    return false;
                }
            }
            if (AI.GetCurrentCustomAction(CurrentAction) && CurrentAction != None)
            {
                CurrentAction.StopCustomAction();
                AI.PopState();
            }
        }
        AI.StartCustomAction(CustomAction, bDeathReaction ? 2 : 1);
        LastAnimatedReactionTime = WorldInfo.TimeSeconds;
        Action = SFXCustomAction_DamageReaction(AI.CustomActions[CustomAction]);
        Action.Init(HitLocation, HitNormal, HitInfo, bPlayImpact, InstigatedBy);
        return true;
    }
    return false;
}

event bool TryStagger(Vector vDirection, Controller InstigatedBy, optional bool bTest = false)
{
    local SFXAI_Core Cont;
    local TraceHitInfo HitInfo;
    local EAICustomAction Action;
    Cont = SFXAI_Core(Controller);
    HitInfo.BoneName = AimNodes[4];
    if (Cont != None)
    {
        if (Cont.CanDoCustomAction(47))
        {
            Action = 47;
        }
        else
        {
            if (Cont.CanDoCustomAction(30))
            {
                Action = 30;
            }
            else
            {
                return false;
            }
        }
        if (bTest || PlayAnimatedReaction(Action, InstigatedBy, true, Location, Normal(vDirection), HitInfo))
        {
            return true;
        }
    }
    return false;
}

final simulated function DoPhysicsBodyImpact(Vector HitLocation, Vector Momentum, class<DamageType> DamageType, TraceHitInfo HitInfo)
{
    local Vector vImpulse;
    local bool bAlreadyHit;
    local float fTotalMass;
    local float fImpulseScale;
    if (bCanPlayPhysicsHitReactions == false || Mesh == None || Mesh.bNotUpdatingKinematicDueToDistance || Physics == 10)
    {
        return;
    }
    if (bPlayedDeath || IsInState('Dying'))
    {
        return;
    }
    if (Base != None && Base.Physics == 7)
    {
        return;
    }
    if (IsZero(Momentum) != false || DamageType == None || DamageType.Default.KDamageImpulse == 0)
    {
        return;
    }
    if (HitInfo.BoneName == 'None')
    {
        CheckHitInfo(HitInfo, Mesh, Normal(Momentum), HitLocation);
        if (HitInfo.BoneName == 'None')
        {
            return;
        }
    }
    vImpulse = DamageType.Default.KDamageImpulse * Momentum;
    fImpulseScale = 1;
    if (Mesh.PhysicsAssetInstance != None)
    {
        fTotalMass = Mesh.PhysicsAssetInstance.GetTotalMassBelowBone(HitInfo.BoneName, Mesh.PhysicsAsset, Mesh.SkeletalMesh);
        fImpulseScale = 1 + fTotalMass - 1 * fPhysicsImpactMassEffectScale;
    }
    vImpulse *= fImpulseScale;
    if (IsZero(vImpulse))
    {
        return;
    }
    bAlreadyHit = fPhysicsImpactBlendTimeRemaining / fPhysicsImpactBlendOutTime > 0;
    fImpulseScale = bAlreadyHit ? 0,75 * 0,25 + FRand() : 1;
    vImpulse = fPhysicsHitReactionImpulseScale * fImpulseScale * vImpulse;
    if (IsHumanControlled())
    {
        vImpulse *= fPlayerPawnPhysHRModifier;
    }
    if (StartPhysicsBodyImpact(HitInfo.BoneName, Class<SFXDamageType>(DamageType)))
    {
        Mesh.AddImpulse(vImpulse, HitLocation, HitInfo.BoneName);
    }
}

final simulated function bool StartPhysicsBodyImpact(Name nmHitBoneName, class<SFXDamageType> SFXDamageType)
{
    local bool bFoundBone;
    local int nBone;
    if (Mesh == None || Mesh.PhysicsAsset == None || Mesh.PhysicsAssetInstance == None)
    {
        return false;
    }
    nBone = 0;
    while (nBone < PhysicsImpactBoneList.Length)
    {
        if (PhysicsImpactBoneList[nBone] == nmHitBoneName)
        {
            bFoundBone = true;
            break;
        }
        ++nBone;
    }
    if (bFoundBone == false)
    {
        return false;
    }
    SetRigidBodyMode(1);
    return true;
}

final simulated event OnDoneBlendingPhysicsReaction()
{
    if (Physics == 10)
    {
        return;
    }
    SetRigidBodyMode(0);
}

native function GetAdjustedMoveDirection(const out Vector Dest, Actor MoveTarget, out Vector Direction);

native final private function float CalculateDesiredGroundConformHeight(const out Vector vNewLocation);

native function ForceGroundConform();

event float GetWeaponRange(EWeaponRange RangeType)
{
    local SFXWeapon oWeapon;
    oWeapon = SFXWeapon(Weapon);
    if (oWeapon != None)
    {
        switch (RangeType);
        case 1;
        return oWeapon.Range_Melee;
        jump 129;
        case 2;
        return oWeapon.Range_Short;
        jump 129;
        case 3;
        return oWeapon.Range_Medium;
        jump 129;
        case 4;
        return oWeapon.Range_Long;
        jump 129;
        default;
    }
    return -1;
}

function bool IsWithinWeaponRange(Actor TargetActor, EWeaponRange RangeType)
{
    local float fWeaponRange;
    if (TargetActor == None)
    {
        return false;
    }
    fWeaponRange = GetWeaponRange(RangeType);
    if (fWeaponRange > 0)
    {
        if (VSize(TargetActor.Location - Location) < fWeaponRange)
        {
            return true;
        }
    }
    return false;
}

final function BreakStealth()
{
    local SFXModule_GameEffectManager Manager;
    Manager = GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        Manager.RemoveEffectsByCategory('BreakableStealth');
    }
}

native function BioVisualEffect CreateDeathEffect(BioVFXTemplate vfxTemplate, bool bIsCrustEffect, bool bIsTargetDeletedOnDeathEffectCompletion);

native function PlayFOVO(WwiseEvent Sound);

native function SetRigidBodyMode(ESFXRigidBodyMode NewMode);

function OutputState()
{
}

state Broken
{
    while (true)
    {
        Sleep(1);
        appScreenDebugMessage("Physics change broke pawn.");
    }
    // invalid native function 205 ;
}

event bool EnsurePhysics(EPhysics NewMode)
{
    if (NewMode == 10 && RigidBodyMode != 2)
    {
        OutputState();
        ScriptTrace();
        GotoState('Broken');
        return false;
    }
    if (NewMode != 10 && IsInState('WaitForRagdollRecovery'))
    {
        OutputState();
        ScriptTrace();
        GotoState('Broken');
        return false;
    }
    if (Physics == 10 && !IsInState('InRagdoll') || IsInState('RagdollRecovery'))
    {
        OutputState();
        ScriptTrace();
        GotoState('Broken');
        return false;
    }
    if (Physics == 2 && !CollisionComponent.bAttached)
    {
        OutputState();
        ScriptTrace();
        GotoState('Broken');
        return false;
    }
    return true;
}

native function AddTalentPoints(int nPoints);

native function RemoveTalentPoints(int nPoints);

event CopyPawnAppearance(BioPawn pSrcPawn);

native function float GetTimeSinceLastRender();

function bool AcquireTargetTicket(int nCost)
{
    m_nTargetTickets += nCost;
    return m_nTargetTickets <= GetMaxTargetTickets();
}

function ReleaseTargetTicket(int nCost)
{
    m_nTargetTickets -= nCost;
    if (m_nTargetTickets < 0)
    {
        m_nTargetTickets = 0;
    }
}

function PlayFireCharging();

event int GetMaxAttackTickets()
{
    local int Tickets;
    Tickets = m_nMaxAttackTickets;
    if (PlayerReplicationInfo != None)
    {
        Tickets = SFXPRI(PlayerReplicationInfo).CurrentMaxAttackTickets;
        if (!IsInCover() && !IsInCoverLeaning())
        {
            Tickets += 2;
        }
    }
    return Tickets;
}

event int GetMaxTargetTickets()
{
    local int Tickets;
    Tickets = m_nMaxTargetTickets;
    if (PlayerReplicationInfo != None)
    {
        Tickets = SFXPRI(PlayerReplicationInfo).CurrentMaxTargetTickets;
        if (!IsInCover() && !IsInCoverLeaning())
        {
            Tickets += 2;
        }
    }
    return Tickets;
}

native function int AcquireAttackTicket(int nCost);

native function ReleaseAttackTicket(int nID, bool bKillTicket);

native function bool HasValidAttackTicket(int nID);

native function SetTicketDuration(int nID, float fDuration);

function PathConstraint CreatePathConstraint(class<PathConstraint> ConstraintClass)
{
    return SFXGame(WorldInfo.Game).ObjectPool.GetPathConstraintFromCache(ConstraintClass, self);
}

function PathGoalEvaluator CreatePathGoalEvaluator(class<PathGoalEvaluator> GoalEvalClass)
{
    return SFXGame(WorldInfo.Game).ObjectPool.GetPathGoalEvaluatorFromCache(GoalEvalClass, self);
}

function RegisterRBCallback(delegate<RBCollisionCallback> RBCallback, optional bool bDisablePhysicsDamage = false, optional int nPriority = 5)
{
    local int nInsertIndex;
    nInsertIndex = 0;
    while (nInsertIndex < m_CollisionCallbacks.Length)
    {
        if (nPriority > m_CollisionCallbacks[nInsertIndex].nPriority)
        {
            break;
        }
        nInsertIndex++;
    }
    m_CollisionCallbacks.Insert(nInsertIndex, 1);
    m_CollisionCallbacks[nInsertIndex].nPriority = nPriority;
    m_CollisionCallbacks[nInsertIndex].RBCallback = RBCallback;
    if (m_oBehavior != None)
    {
        m_oBehavior.m_bPhysicsDamageIgnored = bDisablePhysicsDamage;
    }
}

event ClearRBCallbacks()
{
    m_CollisionCallbacks.Length = 0;
}

event RigidBodyCollision(PrimitiveComponent HitComponent, PrimitiveComponent OtherComponent, const out CollisionImpactData RigidCollisionData, int ContactIndex)
{
    local int idx;
    local delegate<RBCollisionCallback> RBCallback;
    local float fContactMag;
    if (m_CollisionCallbacks.Length > 0)
    {
        if (HitComponent.Owner != OtherComponent.Owner)
        {
            fContactMag = VSize(RigidCollisionData.ContactInfos[0].ContactVelocity[ContactIndex]);
            if (fContactMag > HitComponent.ScriptRigidBodyCollisionThreshold)
            {
                idx = 0;
                while (idx < m_CollisionCallbacks.Length)
                {
                    RBCallback = m_CollisionCallbacks[idx].RBCallback;
                    RBCallback.RBCollisionCallback(self, OtherComponent.Owner, RigidCollisionData.ContactInfos[0].ContactVelocity[ContactIndex]);
                    idx++;
                }
                ClearRBCallbacks();
            }
        }
    }
}

function TossWeapon(Weapon Weap, optional Vector ForceVelocity)
{
    local Vector POVLoc;
    local Vector TossVel;
    local Rotator POVRot;
    local Vector X;
    local Vector Y;
    local Vector Z;
    GetActorEyesViewPoint(POVLoc, POVRot);
    if (ForceVelocity != vect(0,0,0))
    {
        TossVel = ForceVelocity;
    }
    else
    {
        TossVel = POVRot;
        TossVel = TossVel * Velocity Dot TossVel + 500 + vect(0,0,200);
    }
    GetAxes(Rotation, X, Y, Z);
    Weap.DropFrom(Location + 0,8 * CylinderComponent.CollisionRadius * X - 0,5 * CylinderComponent.CollisionRadius * Y, TossVel);
}

function GenerateRegenVocalization()
{
    if (!bIsDead)
    {
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(71, self, None);
    }
}

function CollectorPossess();

native final function WwiseAudioComponent GetCurrentVOAudio();

native final function bool FindBumpAdjust(const out Vector vHitNormal, Actor oHitActor);

event Texture2D GetGUIIcon(optional bool bGetDeadIcon = false)
{
    return None;
}

event SFXDoComponentAction(ActorComponent pComponent)
{
    if (WwiseAudioComponent(pComponent) != None)
    {
        SetRTPCHelmetIsEnabled(WwiseAudioComponent(pComponent));
    }
}

event SetRTPCHelmetIsEnabled(WwiseAudioComponent WwiseComponent)
{
    if (WwiseComponent != None)
    {
        if (m_oFacePlateMesh != None && m_oFacePlateMesh.bAttached)
        {
            WwiseComponent.SetWwiseRTPC("Helmet", 1);
        }
        else
        {
            WwiseComponent.SetWwiseRTPC("Helmet", 0);
        }
    }
}

function bool StopVocalization()
{
    local WwiseAudioComponent CurrentVO;
    CurrentVO = GetCurrentVOAudio();
    if (CurrentVO != None)
    {
        if (CurrentVO.IsPlaying())
        {
            CurrentVO.PostGlobalEvent('Stop');
            return true;
        }
    }
    return false;
}

final function ManageRagdolls()
{
    local float OldestTimeOfDeath;
    local BioPawn P;
    local BioPawn OldestDeadPawn;
    local int NumDeadPawns;
    foreach WorldInfo.AllPawns(Class'BioPawn', P)
    {
        if (P != self && !P.bDeleteMe && !P.bScalingToZero && !P.bHidden && !P.Mesh.HiddenGame && P.bIsDead && P.Physics == 10 && P.m_bCanCleanupCorpse)
        {
            NumDeadPawns++;
            if (OldestTimeOfDeath == 0 || P.TimeOfDeath < OldestTimeOfDeath)
            {
                OldestTimeOfDeath = P.TimeOfDeath;
                OldestDeadPawn = P;
            }
        }
    }
    if (NumDeadPawns >= MaxBodyCount && OldestDeadPawn != None)
    {
        OldestDeadPawn.bScalingToZero = true;
    }
}

function OnPowersLoaded();

function OnSquadMemberAdded(Pawn Pawn)
{
    local SFXPower Power;
    local BioPowerScript PowerScript;
    if (PowerManager != None)
    {
        foreach PowerManager.Powers(Power)
        {
            PowerScript = Power.GetPowerScript();
            if (PowerScript != None)
            {
                PowerScript.OnSquadMemberAdded(Pawn);
            }
        }
    }
}

function bool CanBeBioticCharged()
{
    return true;
}

defaultproperties
{
    AimNodes(0)=FAKE_Cover
    AimNodes(1)=Head
    AimNodes(2)=LeftShoulder
    AimNodes(3)=RightShoulder
    AimNodes(4)=Chest1
    AimNodes(5)=root
    AimNodes(6)=LeftKnee
    AimNodes(7)=RightKnee
    ReactionBones=System.Byte[]
    RightHandSocketName=Socket_01
    AttachSlots(0)=Socket_05
    AttachSlots(1)=Socket_06
    AttachSlots(2)=Socket_03
    AttachSlots(3)=Socket_04
    AttachSlots(4)=Socket_07
    bShouldSpawnWeapons=true
    bCanPlayAnimatedReactions=true
    bCanPlayPhysicsHitReactions=true
    bSpawnPHATInstance=true
    m_bCanCleanupCorpse=true
    m_bUseBoneCameraHookOffset=true
    m_bHideWithCameraCollision=true
    m_bRagDollEnabled=true
    m_bAutoLookAtPlayer=true
    bEnableHitReactionBoneSprings=true
    fSleepPerceptionDistance=800
    bScalePowers=true
    bPortArmsEnabled=true
    bCanUsePortArms=true
    CharacterLevel=1
    FootstepCullDistance=1500
    HeadMesh=SkeletalMeshComponent'HeadMesh0'
    m_fLookAtSpeed=2,5
    m_fLookAtMinHoldTime=0,5
    m_fLookAtMaxHoldTime=2
    m_fLookAtMaxAngle=90
    m_fRunAnimPlaybackRate=1
    m_fRunAnimPlaybackLen=1
    m_fWalkAnimPlaybackRate=1
    m_fWalkAnimPlaybackLen=1
    m_fCollisionReadyHeight=50
    m_pAnimSetMgr=BioGestureAnimSetMgr'oAnimSetMgr'
    m_fLookMultiplier=8
    PortArmsPlayerInterval=0,1
    PortArmsNPCInterval=0,5
    PortArmsWedgeHeight=5
    PortArmsWedgeRadius=5
    m_fRBSleepEnergyThreshold=5
    m_fEnableCCDMultiplierThreshold=10
    LightEnvironment=BioDynamicLightEnvironmentComponent'BioLightEnvComponent0'
    m_fMaxRelevancyDistance=1E+08
    m_sWrinkleMaterialIdentifier="_face"
    DefaultFootStepEvent=WwiseEvent'Play_foot_humanoid_medium_metal_run'
    PowerManager=SFXPowerManager'PowerMgr'
    PhysicsImpactBoneList(0)=Chest
    PhysicsImpactBoneList(1)=Chest1
    PhysicsImpactBoneList(2)=LeftCollar
    PhysicsImpactBoneList(3)=LeftShoulder
    PhysicsImpactBoneList(4)=LeftElbow
    PhysicsImpactBoneList(5)=LeftWrist
    PhysicsImpactBoneList(6)=RightCollar
    PhysicsImpactBoneList(7)=RightShoulder
    PhysicsImpactBoneList(8)=RightElbow
    PhysicsImpactBoneList(9)=RightWrist
    PhysicsImpactBoneList(10)=Sphere 0
    PhysicsImpactBoneList(11)=Sphyl 0
    PhysicsImpactBoneList(12)=Head
    PhysicsImpactBoneList(13)=Neck
    PhysicsImpactBoneList(14)=Box 0
    PhysicsImpactBoneList(15)=Box 1
    PhysicsImpactSpringList(0)=LeftWrist
    PhysicsImpactSpringList(1)=RightWrist
    fPhysicsHitReactionImpulseScale=1,2
    fPhysicsImpactBlendOutTime=0,45
    fPhysicsImpactMassEffectScale=0,9
    fPhysHRMotorSpringStrength=1500
    fPhysHRLinearSpringStrength=5
    fPhysHRAngularSPringStrength=5
    fPlayerPawnPhysHRModifier=0,75
    fPlayerPawnPhysHRWeight=0,25
    AIBarkAnimSet=FaceFXAnimSet'SFX_HumanMale_FaceFX_AnimSet'
    AIBarkAnimName="Bark1"
    MaxBodyCount=3
    FallingStateEntranceTime=0,5
    m_nMaxTargetTickets=5
    m_nMaxAttackTickets=3
    m_fTicketExpiryTime=5
    ConformTraceInterval=10
    MeshFloorConformTransSpeed=10
    AimAssistRegions=System.Byte[]
    RadarRange=4000
    RadarFOV=45
    MaxStepHeight=40
    bCanCrouch=true
    bJumpCapable=false
    bCanJump=false
    bAvoidLedges=true
    bStopAtLedges=true
    bCanMantle=true
    bModifyReachSpecCost=true
    m_bSuppressPhysicsRoll=true
    PathSearchType=System.Byte[]
    DesiredSpeed=0
    HearingThreshold=1500
    SightRadius=3000
    PeripheralVision=-0,7
    AirControl=0,35
    BaseEyeHeight=80
    EyeHeight=75
    Mesh=None
    CylinderComponent=None
    ViewPitchMin=-14563
    ViewPitchMax=14563
    InventoryManagerClass=None
    Components=None
    // child object HeadMesh0 of type SkeletalMeshComponent
    // child object CollisionCylinder of type CylinderComponent
    // child object BioLightEnvComponent0 of type BioDynamicLightEnvironmentComponent
    // child object BioPawnSkeletalMeshComponent of type SkeletalMeshComponent
    // child object oAnimSetMgr of type BioGestureAnimSetMgr
    // child object PowerMgr of type SFXPowerManager
    // child object DmgMod0 of type SFXModule_Damage
    // child object GEMod0 of type SFXModule_GameEffectManager
    // child object RadarModule of type SFXModule_Radar
    // child object GPModule of type SFXGamePropertiesModule
    // child object Behavior of type BioPawnBehavior
}
