﻿class BioPawnBehavior extends BioEpicPawnBehavior
    hidecategories(Object)
    config(Game)
    native
    editinlinenew;

enum EBioAnimCombatState
{
    eBioAnimCombat_NoState,
    eBioAnimCombat_FireAuto,
    eBioAnimCombat_FireAutoStop,
    eBioAnimCombat_FireManual,
    eBioAnimCombat_ThrowGrenade,
    eBioAnimCombat_DoneFireManual,
};

enum EBioAnimStartState
{
    eBioAnimStart_NoState,
    eBioAnimStart_StartingMove,
    eBioAnimStart_FinishStartMove,
    eBioAnimStart_DoneStartMove,
    eBioAnimStart_RotationUnlocked,
    eBioAnimStart_PlayingMove,
};

enum EBioAnimStopState
{
    eBioAnimStop_NoState,
    eBioAnimStop_StopLeftMove,
    eBioAnimStop_StopRightMove,
    eBioAnimStop_FinishLeftMove,
    eBioAnimStop_FinishRightMove,
    eBioAnimStop_InterruptLeftMove,
    eBioAnimStop_InterruptRightMove,
    eBioAnimStop_DoneFinishLeftMove,
    eBioAnimStop_DoneFinishRightMove,
    eBioAnimStop_DoneIntLeftMove,
    eBioAnimStop_DoneIntRightMove,
};

enum EBioAnimTurnDirState
{
    eBioAnimTurn_NoTurn,
    eBioAnimTurn_ReqStartLeft,
    eBioAnimTurn_ReqStartRight,
    eBioAnimTurn_AckStartLeft,
    eBioAnimTurn_AckStartRight,
    eBioAnimTurn_ProcessLeft,
    eBioAnimTurn_ProcessRight,
};

enum EBioAnimGetUpState
{
    eBioAnimGetUp_Idle,
    eBioAnimGetUp_Start,
    eBioAnimGetUp_Processing,
};

var config float m_fVehicleExpScaleFactor;

var const config float m_fDeathCapabilityActivationTime;

var int m_nRemainInRagdoll;

var transient int m_nXP_Cache;

var transient int m_nXP_Level_Cache;

var Bio2DA m_oExperience2DA;

var Name m_nmDebugKey;

var float CAMHOOK_TACSEL_RIGHTLEFT;

var float CAMHOOK_TACSEL_FRONTBACK;

var float CAMHOOK_TACSEL_UPDOWN;

var float CAMHOOK_SNIPER_RIGHTLEFT;

var float CAMHOOK_SNIPER_FRONTBACK;

var float CAMHOOK_SNIPER_UPDOWN;

var float CAMHOOK_COMBAT_RIGHTLEFT;

var float CAMHOOK_COMBAT_FRONTBACK;

var float CAMHOOK_COMBAT_UPDOWN;

var float CAMHOOK_COLL_RIGHTLEFT;

var float CAMHOOK_COLL_FRONTBACK;

var float CAMHOOK_COLL_UPDOWN;

var float CAMHOOK_NORMAL_UPDOWN;

var float CAMHOOK_NORMAL_RIGHTLEFT;

var float CAMHOOK_NORMAL_FRONTBACK;

var transient int STAT_AbortedMoveTowards;

var transient int STAT_Teleports;

var transient int STAT_ERRORS;

var transient int STAT_Samples;

var transient array<int> STAT_GroundSpeed;

var transient array<Name> STAT_FollowState;

var transient array<float> STAT_PathFindModeTime;

var transient array<int> STAT_PathFindMode;

var transient array<float> STAT_AITime;

var transient array<float> STAT_boost;

var transient array<float> STAT_dist;

var transient float STAT_Dist_track;

var transient float STAT_boost_track;

var int PathFind_LastMovment_Mode;

var transient float m_fMoveStopDSDecelRate;

var transient float m_fSkidDSDecelRate;

var transient Rotator m_rSkidTargetRotation;

var transient Rotator m_rSkidStartRotation;

var transient Rotator m_rLastStopRotation;

var transient float m_fCurrentInclineMoveMod;

var transient float m_fDesiredMaxSpeed;

var(Designer) float PawnMoveStopTimerThreshold;

var(Designer) float PawnMoveStartTimerThreshold;

var transient Actor m_oMeshAdjLastBase;

var transient float m_fMeshAdjLastDistFound;

var transient float m_fMeshAdjTimeTillCheck;

var config float m_fMeshAdjFarCheckDistance;

var config float m_fMeshAdjFarCheckFrequency;

var config float m_fMeshAdjCheckFrequency;

var float m_fManualMeshAdj;

var float m_fMeshAdjRate;

var float m_fPawnStopDecelTime;

var float m_fSkidTurnThresh;

var float m_fInclineDownMod;

var float m_fInclineUpMod;

var transient array<AnimSet> m_aBackupAnimSets;

var transient bool m_bArmorOverridden;

var transient bool m_bDoneSpeedInterpolation;

var transient bool m_bDoneYawInterpolation;

var transient bool m_bInMatinee;

var float m_fCurPhysSettleDownTime;

var transient float m_fAnimMoveStartSpeedSnapshot;

var transient float m_fAnimMoveSpeedSnapshot;

var transient float m_fMoveStopElapsedTime;

var transient float m_fMoveStartElapsedTime;

var transient float m_fAnimStartTime;

var float m_fTurningAngle;

var transient Vector m_vFixedRotation;

var EBioAnimGetUpState m_eGetUpState;

var EBioAnimTurnDirState m_eTurningDirection;

var bool m_bCanUseDeathCapabilities;

var(Designer) bool m_bIsFeigningDeath;

var(Physics) bool m_bCanBePhysicsImpactedOverride;

var(Physics) bool m_bCanBePhysicsImpacted;

var bool m_bUseManualMeshAdj;

var bool m_bMeshAdjOn;

var bool m_bAllowStopAnimInCombat;

var bool m_bAllowSkidAnimInCombat;

var bool m_bAllowStartAnimInCombat;

var bool m_bEnableStopAnim;

var bool m_bEnableSkidAnim;

var bool m_bEnableStartAnim;

var bool m_bReadyForCombat;

var(AI) bool m_bPowerUsePercentOverride;

var(AI) float m_fPowerUsePercent;

var transient EBioAnimStopState m_eAnimStopState;

var transient EBioAnimSkidTurnState m_eAnimSkidState;

var transient EBioAnimStartState m_eAnimStartState;

var transient EBioAnimCombatState m_eCombatState;

var transient Weapon SecondaryWeapon;

var /* 00000008 */ BioTalentContainer m_Talents;

const BIO_PAWN_ANIM_RUN_RIGHT_FOOT_START = 0.25f;
const BIO_PAWN_ANIM_RUN_RIGHT_FOOT_END = 0.75f;
const BIO_PAWN_ANIM_WALK_START_SPEED = 0.05f;
native final private function InitializeActionFramework();

native final private function bool FindFirstValidPrimaryFloatAttribute(Bio2DA table, int nRankedLevel, Name ColumnName, out float fValue);

native final private function FindFirstValidSecondaryAttribute(Bio2DA table, int nRankedLevel, Name ColumnName, EBioAttrModType modType, BioGameProperty oGameProperty);

native function TickBehavior(float DeltaTime);

native function HardResetActionAndAnimationState();

native function SoftResetMovementAndAnimationState();

function PostBeginPlay()
{
    PostBeginPlay();
    m_fMeshAdjTimeTillCheck = m_fMeshAdjCheckFrequency;
    m_fMeshAdjLastDistFound = 0;
    InitializeActionFramework();
    m_fDesiredMaxSpeed = 0;
    m_bDoneYawInterpolation = false;
    m_bDoneSpeedInterpolation = false;
    m_fCurrentInclineMoveMod = 0;
    m_eAnimStartState = 0;
    m_eAnimSkidState = 0;
    m_eAnimStopState = 0;
    m_fMoveStartElapsedTime = 0;
    m_fAnimMoveSpeedSnapshot = 0;
    m_fAnimMoveStartSpeedSnapshot = 0;
    m_fMoveStopElapsedTime = 0;
    m_bInMatinee = false;
    m_PawnAttributes.EnsureInitialized();
    if (m_bIsFeigningDeath)
    {
        FeignDeath(true, true);
    }
}

native function bool IsArmorOverridden();

native function ForceArmorOverride(bool B);

event int ComputeLevel()
{
    return 0;
}

function AmplifyDamage(out float Damage)
{
    Damage *= Class'BioAttributes'.GetCurrentFloatValue(BioAttributesPawn(m_PawnAttributes).m_DamageDurationMult);
}

event bool HasKey(Name Key)
{
    return m_nmDebugKey == Key;
}

function int GetBackground_Childhood()
{
    if (SFXPawn_Player(Owner) != None)
    {
        return SFXPawn_Player(Owner).Origin;
    }
    return 0;
}

function SetBackground_Childhood(int nValue)
{
    if (SFXPawn_Player(Owner) != None)
    {
        SFXPawn_Player(Owner).Origin = nValue;
    }
}

function int GetBackground_Notoritey()
{
    if (SFXPawn_Player(Owner) != None)
    {
        return SFXPawn_Player(Owner).Notoriety;
    }
    return 0;
}

function SetBackground_Notoritey(int nValue)
{
    if (SFXPawn_Player(Owner) != None)
    {
        SFXPawn_Player(Owner).Notoriety = nValue;
    }
}

function int GetMarshalRank()
{
    return 0;
}

function int GetTalkToCount()
{
    if (BioPlayerController(BioPawn(Owner).Controller) != None)
    {
    }
    return BioPawn(Owner).m_nTalkedToCount;
}

function SetTalkToCount(int nValue)
{
    if (BioPlayerController(BioPawn(Owner).Controller) != None)
    {
    }
    BioPawn(Owner).m_nTalkedToCount = nValue;
}

function AdvanceTalkToCount(int nAmt)
{
    if (BioPlayerController(BioPawn(Owner).Controller) != None)
    {
    }
    BioPawn(Owner).m_nTalkedToCount += nAmt;
}

function EBioAttributePawnGender GetGender()
{
    if (BioPawn(Owner).bIsFemale)
    {
        return 1;
    }
    return 0;
}

function int GetCredits()
{
    return GetInventoryResource(0);
}

function AdjustCredits(int nAmt)
{
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Owner.WorldInfo);
    if (oWorldInfo != None)
    {
        AdjustInventoryResource(0, nAmt, true);
    }
}

event int GetMediGel()
{
    return GetInventoryResource(1);
}

event AdjustMediGel(int nAmt)
{
    AdjustInventoryResource(1, nAmt, true);
}

function int GetClass()
{
    return 0;
}

function bool GetBioticAmpEquipped()
{
    return false;
}

function bool InPlayerParty()
{
    return BioPawn(Owner).InPlayerParty();
}

native function ProcessMeshAdj(float fDeltaTime);

function int GetIntimidateSkill(optional SFXPowerLevelUpHelper LevelUpHelper = None)
{
    local BioWorldInfo WorldInfo;
    local SFXGame Game;
    local float fIntimidateSkill;
    local BioPawn MyPawn;
    local SFXPower_PassivePower Power;
    local SFXPower_PassivePower BestPower;
    local int nBestPowerRank;
    local int nPowerRank;
    local int nIndex;
    WorldInfo = Owner != None ? BioWorldInfo(Owner.WorldInfo) : None;
    if (WorldInfo != None)
    {
        Game = SFXGame(WorldInfo.Game);
        if (Game != None)
        {
            fIntimidateSkill = Game.GetRenegadePoints();
        }
    }
    MyPawn = BioPawn(Owner);
    if (MyPawn != None && MyPawn.PowerManager != None)
    {
        nIndex = 0;
        while (nIndex < MyPawn.PowerManager.Powers.Length)
        {
            Power = SFXPower_PassivePower(MyPawn.PowerManager.Powers[nIndex]);
            if (Power != None)
            {
                nPowerRank = Power.Rank;
                if (LevelUpHelper != None)
                {
                    nPowerRank = LevelUpHelper.GetCurrentRankByPower(Power);
                }
                if (BestPower == None || nPowerRank > nBestPowerRank)
                {
                    BestPower = Power;
                    nBestPowerRank = nPowerRank;
                }
            }
            nIndex++;
        }
    }
    if (BestPower != None)
    {
        BestPower.ModifyIntimidateSkill(fIntimidateSkill, nBestPowerRank);
    }
    return fIntimidateSkill;
}

function int GetCharmSkill(optional SFXPowerLevelUpHelper LevelUpHelper = None)
{
    local BioWorldInfo WorldInfo;
    local SFXGame Game;
    local float fCharmSkill;
    local BioPawn MyPawn;
    local SFXPower_PassivePower Power;
    local SFXPower_PassivePower BestPower;
    local int nBestPowerRank;
    local int nPowerRank;
    local int nIndex;
    WorldInfo = Owner != None ? BioWorldInfo(Owner.WorldInfo) : None;
    if (WorldInfo != None)
    {
        Game = SFXGame(WorldInfo.Game);
        if (Game != None)
        {
            fCharmSkill = Game.GetParagonPoints();
        }
    }
    MyPawn = BioPawn(Owner);
    if (MyPawn != None && MyPawn.PowerManager != None)
    {
        nIndex = 0;
        while (nIndex < MyPawn.PowerManager.Powers.Length)
        {
            Power = SFXPower_PassivePower(MyPawn.PowerManager.Powers[nIndex]);
            if (Power != None)
            {
                nPowerRank = Power.Rank;
                if (LevelUpHelper != None)
                {
                    nPowerRank = LevelUpHelper.GetCurrentRankByPower(Power);
                }
                if (BestPower == None || nPowerRank > nBestPowerRank)
                {
                    BestPower = Power;
                    nBestPowerRank = nPowerRank;
                }
            }
            nIndex++;
        }
    }
    if (BestPower != None)
    {
        BestPower.ModifyCharmSkill(fCharmSkill, nBestPowerRank);
    }
    return fCharmSkill;
}

static function class<BioBaseSaveObject> GetSaveObjectClass()
{
    return Class'BioPawnBehaviorSaveObject';
}

event FeignDeath(bool B, optional bool bForceState)
{
    if (m_bIsFeigningDeath == B && bForceState == false)
    {
        return;
    }
    if (B == true)
    {
        if (Pawn(Owner).InitRagdoll() == true)
        {
            m_bIsFeigningDeath = true;
            IncrementRagdollCount();
        }
    }
    else
    {
        m_bIsFeigningDeath = false;
        DecrementRagdollCount();
    }
}

function FeignDeathKismet(bool B)
{
    FeignDeath(B);
}

function IncrementRagdollCount()
{
    ++m_nRemainInRagdoll;
}

function DecrementRagdollCount()
{
    if (m_nRemainInRagdoll > 0)
    {
        --m_nRemainInRagdoll;
    }
}

function float GetDeathCapabilityActivationTime()
{
    return m_fDeathCapabilityActivationTime;
}

native function EActionStateVariable SetActionState(EActionStateVariable eState, optional float fDelay);

native function bool GetCanBePhysicsImpacted();

function float GetPowerUsePercent()
{
    if (m_bPowerUsePercentOverride)
    {
        return m_fPowerUsePercent;
    }
    return BioPawnType(Owner.ActorType).m_fPowerUsePercent;
}

function bool HasPowersOfType(EBioCapMode eDiscipline)
{
    local int nPowerIndex;
    local BioPower oPower;
    nPowerIndex = 0;
    while (nPowerIndex < m_powers.Length)
    {
        oPower = m_powers[nPowerIndex];
        if (oPower != None && oPower.GetDiscipline() == eDiscipline && oPower.IsEnabled() == true)
        {
            return true;
        }
        nPowerIndex++;
    }
    return false;
}

event TEMP_DrawWeapon()
{
    local BioPawn P;
    P = BioPawn(Owner);
    if (P != None)
    {
        SFXInventoryManager(P.InvManager).SetWeaponBySelected();
    }
}

event TEMP_HolsterWeapon()
{
    local BioPawn P;
    P = BioPawn(Owner);
    if (P != None)
    {
        SFXInventoryManager(P.InvManager).SetCurrentWeapon(None);
    }
}

function ???<StringRefProperty> GetActorTypeGameName()
{
    if (BioActorType(Owner.ActorType) != None)
    {
        return BioActorType(Owner.ActorType).ActorGameNameStrRef;
    }
}

defaultproperties
{
    m_Talents=BioTalentContainer'TalentContainer'
    m_fPowerUsePercent=1
    m_bCanBePhysicsImpacted=true
    m_bCanUseDeathCapabilities=true
    m_fMeshAdjCheckFrequency=0,15
    m_fMeshAdjFarCheckFrequency=1
    m_fMeshAdjFarCheckDistance=2000
    PawnMoveStartTimerThreshold=0,03
    PawnMoveStopTimerThreshold=0,1
    CAMHOOK_NORMAL_UPDOWN=98
    CAMHOOK_COLL_UPDOWN=83
    CAMHOOK_COLL_FRONTBACK=10
    CAMHOOK_COMBAT_UPDOWN=79
    CAMHOOK_COMBAT_FRONTBACK=22
    CAMHOOK_COMBAT_RIGHTLEFT=47
    CAMHOOK_SNIPER_UPDOWN=83
    CAMHOOK_SNIPER_FRONTBACK=10
    CAMHOOK_SNIPER_RIGHTLEFT=35
    CAMHOOK_TACSEL_UPDOWN=79
    m_oExperience2DA=Bio2DANumberedRows'LevelUp_Experience'
    m_fDeathCapabilityActivationTime=2
    m_fVehicleExpScaleFactor=0,4
    m_eCurrentActionState=BIO_ACTION_STATE_EXPLORE
    m_bDoCameraBehaviorTransition=true
    m_attributesClass=class'BioAttributesPawn'
    m_PawnAttributes=BioAttributesPawn'AttributesPawn'
    m_nCurrentPowerIndex=-1
    ActorGameName="BioPawn"
    m_oAppearanceType=BioInterface_Appearance_Pawn'PawnApperInterface'
    m_cameraShakeInterface=BioPawnCameraShakeInterface'cameraShakeInterface'
    m_aTargetTipDefaults=System.Byte[]
    // child object TalentContainer of type BioTalentContainer
    // child object AttributesPawn of type BioAttributesPawn
    // child object PawnApperInterface of type BioInterface_Appearance_Pawn
    // child object cameraShakeInterface of type BioPawnCameraShakeInterface
}
