﻿class BioPhysicsSounds extends Object
    config(Game)
    native;

struct native BioPhysicsSoundsInfo
{
    var int nPriority;

    var /* 00000008 */ AudioComponent oAudioComp;

    var float fLastTimePlayed;

}

var transient array<BioPhysicsSoundsInfo> m_aAudioTracks;

var config bool m_bEnableLogging;

var config float m_fMinSpeedToPlay;

var config float m_fMinTimeBetweenSoundByActor;

var config float m_fMaxSpeed;

var config float m_fMaxMass;

event PlaySoundOnPhysMatAt(GameInfo Game, PhysicalMaterial PhysMat, PhysicalMaterial PhysMatSweetener, Vector pos, array<String> RTPCNames, array<float> RTPCValues)
{
    local WwiseEvent PhysicsWwiseEvent;
    local SFXGame SFXGameObj;
    local int SweetenerRTPCValue;
    PhysicsWwiseEvent = GetWwiseEvent(PhysMat);
    if (PhysicsWwiseEvent != None)
    {
        if (PhysMatSweetener != None)
        {
            SweetenerRTPCValue = GetPhysMatWwiseType(PhysMatSweetener);
            if (SweetenerRTPCValue != -1)
            {
                RTPCNames.AddItem("Physics_Physmat_Type");
                RTPCValues.AddItem(SweetenerRTPCValue);
            }
        }
        SFXGameObj = SFXGame(Game);
        SFXGameObj.PlayTransientSound(PhysicsWwiseEvent, pos, RTPCNames, RTPCValues);
    }
}

function WwiseEvent GetWwiseEvent(PhysicalMaterial PhysMat)
{
    local WwiseEvent PhysMatWwiseEvent;
    local SFXPhysicalMaterialPhysics PhysMatPhysics;
    while (PhysMatWwiseEvent == None && PhysMat != None)
    {
        if (PhysMat.PhysicalMaterialProperty != None && SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) != None && SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialPhysics != None)
        {
            PhysMatPhysics = SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialPhysics;
            PhysMatWwiseEvent = PhysMatPhysics.Sound;
        }
        PhysMat = PhysMat.Parent;
    }
    return PhysMatWwiseEvent;
}

function int GetPhysMatWwiseType(PhysicalMaterial PhysMat)
{
    local int PhysMatWwiseType;
    local SFXPhysicalMaterialPhysics PhysMatPhysics;
    PhysMatWwiseType = -1;
    while (PhysMatWwiseType == -1 && PhysMat != None)
    {
        if (PhysMat.PhysicalMaterialProperty != None && SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) != None && SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialPhysics != None)
        {
            PhysMatPhysics = SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialPhysics;
            PhysMatWwiseType = PhysMatPhysics.WwiseType;
        }
        PhysMat = PhysMat.Parent;
    }
    return PhysMatWwiseType;
}

native function bool CanPlay(PrimitiveComponent oComp0, PrimitiveComponent oComp1, const out CollisionImpactData RigidCollisionData);

native function bool IsTooSoonToPlay(PrimitiveComponent oComp);

native function bool IsSameCollidedActor(PrimitiveComponent oComp, Actor OtherActor);

native function bool IsTooSlowToPlay(PrimitiveComponent oComp);

native function UpdateLastTimePlayed(PrimitiveComponent oComp);

native function UpdateLastCollidedActor(PrimitiveComponent oComp, Actor OtherActor);

native function float GetMassSpecifier(PrimitiveComponent oComp);

native function float GetSpeedSpecifier(PrimitiveComponent oComp, float fSpeedToUse);

defaultproperties
{
    m_fMaxMass=100
    m_fMaxSpeed=500
}
