﻿class BioPlayerController extends BioBasePlayerController
    hidecategories(Navigation)
    config(Game)
    native;

const DefaultNoSaveReason = 168056;
const DefaultInCombatReason = 168057;
const DefaultNotLoggedInReason = 297457;
const DefaultNoValidStorageReason = 343733;
const DefaultInVehicleReason = 343734;
enum ETutorialHooks
{
    TUT_Reload,
    TUT_Melee,
    TUT_Zoom,
    TUT_QuickCast,
    TUT_WeaponSwitch,
    TUT_Storm,
    TUT_OrderHenchmen,
    TUT_WheelHidden,
    TUT_AreaMapHidden,
};

struct native BioRadarData
{
    var int nIndex;

    var float fPassTime;

    var EBioRadarType eRadarType;

    var Vector vPosition;

    var int nSize;

    var bool bPlayerLockedOn;

    var int nRelativeZ;

}

struct native BioDamageIndicatorData
{
    var float fCoolDownTime;

}

struct native PostProcessInfo
{
    var ETVType Preset;

    var float Shadows;

    var float MidTones;

    var float HighLights;

    var float Desaturation;

}

struct native PlayerOrder
{
    var Name nmPower;

    var Actor oTarget;

    var Vector vTarget;

    var SFXWeapon oSwitchWeapon;

    var Vector vOriginalCameraLocation;

    var Rotator rOriginalCameraRotation;

}

const SFX_HOTKEY_SLOT_COUNT = 8;
struct native SFXHotKeyDefinition
{
    var Name nmPawn;

    var int nPowerID;

}

struct native BioPPSettingsCallbackData
{
    var Pointer fpCallback;

    var Pointer pData;

}

struct native CameraRotationLog
{
    var Name Trace[10];

    var Rotator PrevRot;

    var Rotator PostRot;

}

var transient array<CameraRotationLog> RotLog;

var transient int RotLogCursor;

var array<StaticKeyBind> m_aFlyCamConsoleBinds;

var array<StaticKeyBind> m_aFlyCamPCBinds;

var transient config float m_fAttackOrderCloseDistance;

var transient config float m_fAttackOrderCloseAngle;

var transient config float m_fAttackOrderFarAngle;

var transient array<BioPPSettingsCallbackData> m_aPPCallbacks;

var int lstHotKeyEvents[12];

var int lstHotKeyPawns[12];

var SFXHotKeyDefinition m_aHotKeyDefines[8];

var transient PlayerOrder m_currentOrder;

var transient SFXGameModeManager GameModeManager2;

// m_srVehicleExitAButtonMsg: StringRefProperty[44]
// m_srVehicleExitFailureMsg: StringRefProperty[44]
var transient array<PostProcessInfo> PostProcessPresets;

var native Map_Mirror m_DamageIndicatorDataMap;

var transient array<Pawn> m_aoDamageCausers;

var() float m_fDamageIndicatorDisplayTime;

var /* 00000004 */ byte bMine;

var /* 00000004 */ byte bAlternateCamera;

var /* 00000004 */ byte bJump;

var /* 00000004 */ byte bBoost;

var config int m_nNavAssistMaxNodeLimit;

var transient Vector m_vNavAssistPoint;

var transient Vector AimDirection;

var transient array<BioRadarMapBoundaries> m_aoMapBoundaryObjects;

var transient array<Actor> m_aoPotentialRadarObjects;

var transient array<int> m_anDestroyedPawnIndexesToRecover;

var transient int m_nMaxRadarIndex;

var transient array<int> m_anRecoveredRadarIndexes;

var transient BioRadarMapBoundaries m_oRadarMapBoundary;

var Vector m_vLocationRadarArrowPointsTo;

var native Map_Mirror m_RadarDataMap;

var float m_fLastRadarFOV;

var float m_fRadarFOV;

var float m_fRadarRange;

var float m_fLastRadarRange;

var float m_fLastRadarPassTime;

var config float m_fRelativeZDownLimit;

var config float m_fRelativeZUpLimit;

var config float m_fMaxZDifference;

var transient array<BioPawn> m_AchievementTargets;

var /* 00000008 */ BioPlayerSelection m_oPlayerSelection;

var config float m_fMoveToDropDistance;

var transient config float m_fLeaveConvPitch;

var() /* 00000008 */ BioHintSystemBase HintSystem;

// InsufficentSpaceAcknowledgedText: StringRefProperty[44]
// InsufficentSpaceText: StringRefProperty[44]
// RestartGame: StringRefProperty[44]
// StorageDeviceRemovedText: StringRefProperty[44]
// ConfirmSignOutText: StringRefProperty[44]
// ProfileSignOutText: StringRefProperty[44]
// ProfileChangedText: StringRefProperty[44]
// KismetNoSaveReason: StringRefProperty[44]
var() WwiseEvent StormEndWwiseEvent;

var() WwiseEvent StormPeakWwiseEvent_F;

var() WwiseEvent StormStartWwiseEvent_F;

var() WwiseEvent StormPeakWwiseEvent_M;

var() WwiseEvent StormStartWwiseEvent_M;

var() String StormRTPCName;

var transient config float StormCooldownTime;

var transient float CurrentStormStamina;

var transient int NextEnemyToCheckLOS;

var array<LocalEnemy> EnemyList;

var() config float RotationSensitivityHigh;

var() config float RotationSensitivityMedium;

var() config float RotationSensitivityLow;

var float RemappedJoyUp;

var float RemappedJoyRight;

var config float m_fClimbMantleDistanceThreshold;

var config float m_fClimbMantleFaceAngleThreshold;

var(Cover) config float StormCoverUpdateDelay;

var(Cover) config float StormMaxCoverEnterDist;

var(Cover) config float StormCoverFOV;

var(Cover) config float StormAcquireCoverFOV;

var(Cover) config float CoverUpdateDelay;

var(Cover) config float CoverSnapScale;

var(Cover) config float CoverFOV;

var(Cover) config float AcquireCoverFOV;

var(Cover) config float MaxCoverEnterDist;

var transient float CoverBreakTimer;

var(Cover) config float CoverBreakTimeThreshold;

var transient float CoverTransitionCountHold;

var(Cover) config float CoverTransitionTime;

var /* 00000004 */ transient byte bWantsToStorm;

var transient ECoverAction m_CoverBreakCoverAction;

var transient float m_fCoverExitTimer;

var config float m_fCoverBreakForwardAccelDelay;

var config float m_fCoverBreakAccelTime;

var config Vector m_vCoverBreakAccel;

var transient bool m_bPermanentWalk;

var transient bool m_bRadarIsJammed;

var transient bool m_bDEBUGFlyDownPressed;

var transient bool m_bDEBUGFlyUpPressed;

var transient bool m_bIsStoppedForConv;

var transient bool bStormCoolingDown;

var transient bool bTiredStorming;

var transient bool bStorming;

var transient bool bPreferLeanOverPopup;

var transient bool m_bDoCoverExitAccel;

var transient bool bBreakFromCover;

var(Cover) config float DeadZoneThreshold;

var config float MoveStickRunThreshold;

var config float MoveStickWalkThreshold;

var config float MoveStickIdleThreshold;

var config bool bEnableRotLog;

var bool m_bRadarArrow;

var() bool bKismetNoSave;

var() bool bProfileSettingsUpdated;

var config bool m_bCanMantleOutsideOfCover;

var(Cover) config bool CoverRespectsRotation;

var(Cover) config bool m_bEnableStormToCover;

var(Cover) config bool bDebugCover;

var bool m_bDisableSquadCommandExit;

var transient BioCameraZoom ZoomData;

var SFXProfileSettings ProfileSettings;

var(CustomActions) transient array<BioCustomAction> CustomActions;

var array<class<BioCustomAction> > CustomActionClasses;

var /* 00000008 */ SFXModule_AimAssist AimAssist;

struct native LocalEnemy
{
    var Pawn Enemy;

    var bool bVisible;

    var bool bSeen;

    var bool bHasLOS;

}

native function bool SetRotation(Rotator NewRotation);

native exec function DumpWhipLog(optional int Index);

simulated protected function RegisterCustomPlayerDataStores()
{
    local LocalPlayer LP;
    if (ProfileSettings != None)
    {
        UnregisterPlayerDataStores();
    }
    LP = LocalPlayer(Player);
    RegisterCustomPlayerDataStores();
}

simulated function UnregisterPlayerDataStores()
{
    ProfileSettings = None;
    UnregisterPlayerDataStores();
}

native function DrawCircle(Vector vLocation, Vector vNormal, float fRadius, Color CircleColor);

native function DrawSelectionReticle(Vector vLocation);

native function RecoverCameraPostCinematic();

native function RecoverCameraForPawnActionState();

native function RecoverSelectionForPawnActionState();

native function RecoverForPlayerPawnActionState();

native function DisableDOF();

native function UpdateBinkAudioVolume();

function Destroyed()
{
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(GetScaleFormManager());
    if (GuiMan != None)
    {
        GuiMan.Player = None;
    }
}

native final function PlayerSquadSetActionState(byte eState);

native final function bool QuickCommandFollowPlayer(optional int nSquadIndex);

native final function bool QuickCommandAttackTarget(optional int nSquadIndex);

native final function bool QuickCommandMoveTo(int nSquadIndex);

native final function bool ShouldLockOnTarget(Actor pTarget);

native final function SquadOrderUsePower(Name nmPower, Pawn pPawn, optional int nQueue, optional bool bShowIndicator, optional Actor pDesiredTarget);

native final function SquadOrderEquipWeapon(byte nWeapon, Pawn pPawn);

native final function SFXNav_GoalPoint GetBestGoalPoint();

native final function ResetGoalPriorities(SFXNav_GoalPoint oGoal);

native function BioOnPawnActionStateChanged();

event OnActionStateChanged();

native function bool GetCameraRelativeRotation(out Vector vDirection);

native final function ComputeMovementStickAngle(out float mag, out float AngleStick, out Rotator RotWorld);

native final function int LerpMovementStickAngle(int RotDesired, int RotBase, float RotationSpeed, float DeltaSeconds);

native function float ScoreZoomSnapTarget(Pawn TestPawn, float MaxDistance, const out Vector CamLoc, const out Rotator CamRot, out Vector AimLocation);

native final function Pawn GetAimAssistTarget(float MaxDistance, const out Vector CamLoc, const out Rotator CamRot, out Vector TargetLoc, out float Margin);

native final function Pawn GetZoomSnapTarget(float MinDistance, float MaxDistance, out Vector AimLocation);

event bool GetZoomSnapWeaponInfo(Weapon Weapon, int idx, out EAimNodes AimNode, out float OuterSnapAngle, out float InnerSnapAngle, out float OffsetMag)
{
    local SFXWeapon ChkWeapon;
    ChkWeapon = SFXWeapon(Weapon);
    if (ChkWeapon != None && idx < ChkWeapon.ZoomSnapList.Length)
    {
        AimNode = ChkWeapon.ZoomSnapList[idx].AimNode;
        OuterSnapAngle = ChkWeapon.ZoomSnapList[idx].OuterSnapAngle;
        InnerSnapAngle = ChkWeapon.ZoomSnapList[idx].InnerSnapAngle;
        OffsetMag = ChkWeapon.ZoomSnapList[idx].SnapOffsetMag;
        return true;
    }
    return false;
}

event ActivateMelee()
{
    local BioPlayerInput Input;
    local SFXWeapon SW;
    Input = BioPlayerInput(PlayerInput);
    if (Pawn != None)
    {
        SW = SFXWeapon(Pawn.Weapon);
        if (Input != None)
        {
            Input.ActivatePower(SW.MeleePowerName);
        }
    }
}

function SetInputDisabled(bool bVal)
{
    local BioPlayerInput oInput;
    oInput = BioPlayerInput(PlayerInput);
    if (oInput != None)
    {
        oInput.SetInputDisabled(bVal);
    }
}

function bool GetInputDisabled()
{
    local BioPlayerInput oInput;
    oInput = BioPlayerInput(PlayerInput);
    if (oInput != None)
    {
        return oInput.GetInputDisabled();
    }
    else
    {
        return true;
    }
}

native final function OnEnteredCover();

native final function OnExitedCover();

native final function DOFEffect FindUberDOFEffect();

native function bool UpdateMoveToIndicator(Pawn pSquadPawn, Vector vMoveToPosition);

simulated event PostBeginPlay()
{
    PostBeginPlay();
    InitializeGammaCorrectionSettings();
    GameModeManager2 = new(self,Class'SFXGameModeManager');
    GameModeManager2.Initialize();
    if (!Class'SFXGameConfig'.Default.bAimAssistEnabled)
    {
        Modules.RemoveItem(AimAssist);
        AimAssist = None;
    }
    m_oPlayerSelection.m_eCurrentSelectionMode = 1;
}

native function RefreshRadarData();

native function bool IsCombatTargetable(Actor A);

native function bool IsExploreTargetable(Actor A);

native function bool CanStorm();

event ApplyTacticalOrders()
{
    local BioPawn PlayerPawn;
    local BioPlayerInput Input;
    PlayerPawn = BioPawn(Pawn);
    if (PlayerPawn == None || PlayerPawn.m_oBehavior == None)
    {
        return;
    }
    if (PlayerPawn.IsInAnimatedTransition())
    {
        SetTimer(0,25, false, 'ApplyTacticalOrders');
        return;
    }
    else
    {
        if (IsTimerActive('ApplyTacticalOrders'))
        {
            ClearTimer('ApplyTacticalOrders');
        }
    }
    if (PlayerPawn.m_oBehavior.m_eCurrentActionState == 0)
    {
        PlayerPawn.m_oBehavior.SetActionState(1);
        return;
    }
    if (!IsPlayerPerformingBlockingAction())
    {
        if (m_currentOrder.nmPower != 'None')
        {
            Input = BioPlayerInput(PlayerInput);
            if (Input != None)
            {
                Input.ActivatePower(m_currentOrder.nmPower, m_currentOrder.oTarget, m_currentOrder.vTarget, m_currentOrder.vOriginalCameraLocation, m_currentOrder.rOriginalCameraRotation);
            }
        }
        else
        {
            if (m_currentOrder.oSwitchWeapon != None)
            {
                SwitchWeapon(m_currentOrder.oSwitchWeapon);
            }
        }
        ClearPlayerOrder();
    }
}

function PawnDied(Pawn inPawn)
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(inPawn);
    if (BioPawn != None && BioPawn.IsInCover())
    {
        BioPawn.CurrentLink.UnClaim(self, -1, true);
    }
    PawnDied(inPawn);
}

function PawnFalling()
{
    GotoState('PlayerFalling');
}

function PawnLanded()
{
    GotoState('PlayerWalking');
}

state PlayerFalling
{
    function PlayerMove(float DeltaTime);

}

state PlayerWalking
{
    function PlayerMoveCombatOrExplore(BioPawn PawnAsBioPawn, float DeltaTime, float MoveMag, float MoveAngle, Rotator MoveRot, Rotator CameraRotation, bool bIsCrouched, bool bIsInCombat, bool bIsStorming, bool bIsFreeCam)
    {
        local float MoveMagIdle;
        local float MoveAngleIdle;
        local float MoveWalkModifierBlendTime;
        local Rotator MoveFacing;
        local Vector MoveDir;
        local float MoveAccMag;
        local float MoveWalkModifier;
        local float MoveWalkModifierAlpha;
        local Vector AimDir;
        local float MaxSpeed;
        local Rotator CameraRotation2D;
        local Rotator MoveRot2D;
        MoveMagIdle = 0,01;
        MoveAngleIdle = 3,141593 / 4;
        MoveWalkModifierBlendTime = 0,5;
        CameraRotation2D.Yaw = CameraRotation.Yaw;
        CameraRotation2D.Pitch = 0;
        CameraRotation2D.Roll = 0;
        MoveRot2D.Yaw = MoveRot.Yaw;
        MoveRot2D.Pitch = 0;
        MoveRot2D.Roll = 0;
        MaxSpeed = PawnAsBioPawn.GetMaxSpeed();
        if (bIsCrouched && !bIsInCombat)
        {
            if (MoveMag > MoveMagIdle || Abs(MoveAngle) > MoveAngleIdle)
            {
                PawnAsBioPawn.ShouldCrouch(false);
            }
        }
        MoveWalkModifier = 1;
        if (MaxSpeed > 0 && MoveMag > MoveMagIdle)
        {
            MoveAccMag = PawnAsBioPawn.AccelRate;
            if (!bIsCrouched && !bIsStorming && !PawnAsBioPawn.IsInCover())
            {
                if (!PawnAsBioPawn.bIsWalking)
                {
                    if (MoveMag >= MoveStickRunThreshold)
                    {
                        MoveWalkModifier = 1;
                    }
                    else
                    {
                        if (MoveMag >= MoveStickWalkThreshold)
                        {
                            if (bIsInCombat)
                            {
                                MoveWalkModifier = PawnAsBioPawn.CombatWalkSpeed / PawnAsBioPawn.CombatGroundSpeed;
                            }
                            else
                            {
                                MoveWalkModifier = PawnAsBioPawn.WalkSpeed / PawnAsBioPawn.GroundSpeed;
                            }
                        }
                        else
                        {
                            if (bIsInCombat)
                            {
                                MoveWalkModifier = MoveMag / MoveStickWalkThreshold * PawnAsBioPawn.CombatWalkSpeed / PawnAsBioPawn.CombatGroundSpeed;
                            }
                            else
                            {
                                MoveWalkModifier = MoveMag / MoveStickWalkThreshold * PawnAsBioPawn.WalkSpeed / PawnAsBioPawn.GroundSpeed;
                            }
                        }
                    }
                }
            }
            if (bIsStorming)
            {
                MoveFacing.Pitch = PawnAsBioPawn.Rotation.Pitch;
                MoveFacing.Yaw = LerpMovementStickAngle(MoveRot2D.Yaw, PawnAsBioPawn.Rotation.Yaw, PawnAsBioPawn.StormTurnSpeed, DeltaTime);
                MoveFacing.Roll = PawnAsBioPawn.Rotation.Roll;
            }
            else
            {
                if (bIsInCombat)
                {
                    if (bIsFreeCam)
                    {
                        MoveFacing = MoveRot2D;
                    }
                    else
                    {
                        MoveFacing = CameraRotation2D;
                    }
                }
                else
                {
                    if (bIsCrouched)
                    {
                        MoveFacing = PawnAsBioPawn.Rotation;
                    }
                    else
                    {
                        MoveFacing = MoveRot2D;
                    }
                }
            }
            if (bIsStorming)
            {
                MoveDir = MoveFacing;
            }
            else
            {
                if (bIsInCombat)
                {
                    MoveDir = MoveRot2D;
                }
                else
                {
                    MoveDir = MoveFacing;
                }
            }
        }
        else
        {
            MoveAccMag = 0;
            MoveDir = vect(1,0,0);
            MoveWalkModifier = 0;
            if (bIsInCombat)
            {
                if (bIsFreeCam)
                {
                    MoveFacing = PawnAsBioPawn.Rotation;
                }
                else
                {
                    MoveFacing = CameraRotation2D;
                }
            }
            else
            {
                MoveFacing = PawnAsBioPawn.Rotation;
            }
        }
        if (!bIsInCombat && MoveWalkModifier < PawnAsBioPawn.fMoveMag)
        {
            MoveWalkModifierAlpha = DeltaTime / MoveWalkModifierBlendTime;
            if (MoveWalkModifierAlpha > 1)
            {
                MoveWalkModifierAlpha = 1;
            }
            MoveWalkModifier = PawnAsBioPawn.fMoveMag + MoveWalkModifierAlpha * MoveWalkModifier - PawnAsBioPawn.fMoveMag;
        }
        if (bIsInCombat && !bIsStorming && !bIsFreeCam)
        {
            AimDir = CameraRotation;
        }
        else
        {
            AimDir = MoveFacing;
        }
        if (PawnAsBioPawn.IsInCover())
        {
            MoveFacing = PawnAsBioPawn.CurrentLink.GetSlotRotation(PawnAsBioPawn.CurrentSlotIdx);
            if (!PawnAsBioPawn.IsInCoverLeaning())
            {
                AimDir = MoveFacing;
            }
        }
        if (IsMoveInputIgnored() == false)
        {
            PawnAsBioPawn.fMoveMag = MoveWalkModifier;
            PawnAsBioPawn.Acceleration = MoveDir * MoveAccMag;
        }
        else
        {
            PawnAsBioPawn.fMoveMag = 1;
            PawnAsBioPawn.Acceleration *= 0;
        }
        if (IsLookInputIgnored() == false)
        {
            PawnAsBioPawn.DesiredRotation = MoveFacing;
            AimDirection = AimDir;
        }
        if (PawnAsBioPawn.GetModule(Class'SFXModule_Locomotion') != None)
        {
            PawnAsBioPawn.GetModule(Class'SFXModule_Locomotion').SetDesiredRotation(PawnAsBioPawn.DesiredRotation);
            PawnAsBioPawn.GetModule(Class'SFXModule_Locomotion').SetAcceleration(PawnAsBioPawn.Acceleration);
        }
    }

    function UpdateRotation(float DeltaTime)
    {
        local Rotator DeltaRot;
        local Rotator ViewRotation;
        ViewRotation = Rotation;
        DesiredRotation = ViewRotation;
        DeltaRot.Yaw = PlayerInput.aTurn;
        DeltaRot.Pitch = PlayerInput.aLookUp;
        ProcessViewRotation(DeltaTime, ViewRotation, DeltaRot);
        SetRotation(ViewRotation);
        ViewShake(DeltaTime);
    }

    function PlayerMove(float DeltaTime)
    {
        local BioPawn PawnAsBioPawn;
        local BioPawnBehavior PawnBehav;
        local SFXPlayerCamera CamMan;
        local BioCameraBehaviorFree CamBehavFree;
        local BioCameraBehaviorGalaxy CamBehavGalaxy;
        local bool BlockMovement;
        local float MoveStickMag;
        local float MoveStickAngle;
        local Rotator MoveStickRot;
        PawnAsBioPawn = BioPawn(Pawn);
        PawnBehav = BioPawnBehavior(Pawn.oBioComponent);
        CamMan = SFXPlayerCamera(PlayerCamera);
        CamBehavGalaxy = BioCameraBehaviorGalaxy(CamMan.CurrentCameraMode);
        CamBehavFree = BioCameraBehaviorFree(CamMan.CurrentCameraMode);
        if (CamBehavGalaxy != None || CamBehavFree != None && !CamBehavFree.m_bCameraLocked || Pawn.IsInState('RagdollRecovery') || GameModeManager2.IsActive(2) || GameModeManager2.IsActive(1) || GameModeManager2.IsActive(3))
        {
            BlockMovement = true;
        }
        else
        {
            BlockMovement = false;
        }
        ComputeMovementStickAngle(MoveStickMag, MoveStickAngle, MoveStickRot);
        UpdateRotation(DeltaTime);
        if (!BlockMovement && Pawn.Physics == 1)
        {
            PlayerMoveCombatOrExplore(PawnAsBioPawn, DeltaTime, MoveStickMag, MoveStickAngle, MoveStickRot, self.Rotation, PawnAsBioPawn.bIsCrouched, PawnBehav.m_eCurrentActionState == 1, self.bStorming, CamMan.bFreeCamActive);
        }
        else
        {
            if (Pawn.Physics == 1 || Pawn.Physics == 7 || Pawn.Physics == 0)
            {
                PawnAsBioPawn.StopMovement(true);
            }
        }
    }

}

state PlayerDriving
{
    function BeginState(Name PreviousStateName)
    {
        Pawn.Weapon.GotoState('Active');
        GameModeManager2.EnableMode(4);
    }

    function EndState(Name NextStateName)
    {
        GameModeManager2.DisableMode(4);
    }

    net netserver function ServerUse();

    function UpdateRotation(float DeltaTime)
    {
        local Rotator DeltaRot;
        local Rotator ViewRotation;
        ViewRotation = Rotation;
        DesiredRotation = ViewRotation;
        DeltaRot.Yaw = PlayerInput.aTurn;
        DeltaRot.Pitch = PlayerInput.aLookUp;
        ProcessViewRotation(DeltaTime, ViewRotation, DeltaRot);
        SetRotation(ViewRotation);
        ViewShake(DeltaTime);
    }

    function bool NotifyBump(Actor Other, Vector HitNormal)
    {
        SFXVehicleHover(Pawn).NotifyBump(Other, HitNormal);
        return NotifyBump(Other, HitNormal);
    }

}

state PlayerExitingCover
{
    function BeginState(Name PreviousStateName)
    {
        CoverLog("PreviousStateName:" @ PreviousStateName, GetFuncName());
        BeginState(PreviousStateName);
        m_fCoverExitTimer = m_fCoverBreakAccelTime;
    }

    function EndState(Name NextStateName)
    {
        CoverLog("NextStateName:" @ NextStateName, GetFuncName());
        EndState(NextStateName);
        m_CoverBreakCoverAction = 0;
        m_bDoCoverExitAccel = false;
    }

    function PlayerMove(float DeltaTime)
    {
        local Vector vPeekExitAccelValue;
        local Vector vExitPushOffAccelValue;
        local float MoveStickMag;
        local float MoveStickAngle;
        local Rotator MoveStickRot;
        PlayerMove(DeltaTime);
        m_fCoverExitTimer -= DeltaTime;
        if (m_fCoverExitTimer < 0)
        {
            GotoState('PlayerWalking');
        }
        ComputeMovementStickAngle(MoveStickMag, MoveStickAngle, MoveStickRot);
        if (MoveStickMag > 0 && !m_bDoCoverExitAccel)
        {
            if (m_CoverBreakCoverAction == 10 || m_CoverBreakCoverAction == 9)
            {
                vPeekExitAccelValue.Y = m_vCoverBreakAccel.Y;
                if (m_CoverBreakCoverAction == 9)
                {
                    vPeekExitAccelValue.Y = -vPeekExitAccelValue.Y;
                }
                if (m_fCoverExitTimer < m_fCoverBreakAccelTime - m_fCoverBreakForwardAccelDelay)
                {
                    vPeekExitAccelValue.X = m_vCoverBreakAccel.X;
                }
                vPeekExitAccelValue = QuatRotateVector(QuatFromRotator(Pawn.Rotation), vPeekExitAccelValue);
                Pawn.Acceleration += vPeekExitAccelValue;
            }
        }
        else
        {
            if (m_bDoCoverExitAccel)
            {
                vExitPushOffAccelValue = QuatRotateVector(QuatFromRotator(MoveStickRot), vect(1000,0,0));
                Pawn.Acceleration += vExitPushOffAccelValue;
            }
        }
    }

}

native function DetermineLeanDirection(BioPawn BioPawn, out CoverSlot CurrentSlot, out ECoverAction out_PawnCA, out ECoverDirection out_PawnCD);

function bool IsCameraAlignedWithCoverSlot(optional float fThreshold = 0)
{
    local BioPawn BioPawn;
    local Vector vSlotDir;
    local Vector vCamDir;
    BioPawn = BioPawn(Pawn);
    if (BioPawn.CurrentLink != None)
    {
        vSlotDir = BioPawn.CurrentLink.GetSlotRotation(BioPawn.CurrentSlotIdx);
        vCamDir = PlayerCamera.CameraCache.POV.Rotation;
        if (vCamDir Dot vSlotDir >= fThreshold)
        {
            return true;
        }
    }
    return false;
}

function BreakFromCover();

function EnableTransitions()
{
    BioPawn(Pawn).bAimBackDisabledTransitions = false;
}

state PlayerInAimBack
{
    function BeginState(Name PreviousState)
    {
        local BioPawn BioPawn;
        BeginState(PreviousState);
        BioPawn = BioPawn(Pawn);
        BioPawn.LastCoverType = BioPawn.CoverType;
        BioPawn.CoverType = 0;
        BioPawn.bAimBackDisabledTransitions = true;
        ClearTimer('EnableTransitions');
        if (BioPawn.LastCoverType == 2 && IsZoomed() == false || BioPawn.CoverAction == 3 || BioPawn.CoverAction == 4)
        {
            BioPawn.ShouldCrouch(true);
        }
    }

    function EndState(Name NextState)
    {
        local BioPawn BioPawn;
        EndState(NextState);
        BioPawn = BioPawn(Pawn);
        SetTimer(0,5, false, 'EnableTransitions');
        if (NextState == 'PlayerInCover')
        {
            BioPawn.CoverType = BioPawn.LastCoverType;
        }
        else
        {
            BioPawn.LastCoverType = 0;
            BioPawn.LeaveCover();
            BioPawn.CurrentLink.UnClaim(self, -1, true);
        }
    }

    function PlayerMove(float DeltaTime)
    {
        local BioPawn BioPawn;
        local float CamDot;
        local Rotator YawRotation;
        local Vector CamCross;
        BioPawn = BioPawn(Pawn);
        if (BioPawn.CurrentLink == None)
        {
            GotoState('PlayerWalking');
            return;
        }
        YawRotation.Yaw = Rotation.Yaw;
        CamDot = YawRotation Dot BioPawn.CurrentLink.GetSlotRotation(BioPawn.CurrentSlotIdx);
        if (BioPawn.LastCoverType == 1 && CamDot > 0,5 || BioPawn.LastCoverType == 2 && CamDot > 0,1)
        {
            BioPawn.m_oBehavior.m_eTurningDirection = 0;
            if (BioPawn.LastCoverType == 2)
            {
            }
            GotoState('PlayerInCover');
            return;
        }
        CamCross = BioPawn.CurrentLink.GetSlotRotation(BioPawn.CurrentSlotIdx) Cross Rotation;
        if (CamCross.Z < 0)
        {
            BioPawn.CoverDirection = 1;
        }
        else
        {
            BioPawn.CoverDirection = 2;
        }
        if (!IsMoveInputIgnored() && BioWorldInfo(WorldInfo).bPlayersOnly == false)
        {
            if (Abs(PlayerInput.RawJoyUp) > DeadZoneThreshold || Abs(PlayerInput.RawJoyRight) > DeadZoneThreshold)
            {
                GotoState('PlayerWalking');
                return;
            }
        }
        if (BioPawn.LastCoverType == 2 && BioPlayerInput(PlayerInput).bWantsToZoom == 0)
        {
            BioPawn.CoverAction = 0;
            BioPawn.ShouldCrouch(true);
        }
        PlayerMove(DeltaTime);
    }

}

state PlayerInCover
{
    function BreakFromCover()
    {
        bBreakFromCover = true;
    }

    event PlayerTick(float DeltaTime)
    {
        Global.PlayerTick(DeltaTime);
    }

    function bool IsInCoverState()
    {
        return true;
    }

    function BeginState(Name PreviousStateName)
    {
        local BioPawn pPawn;
        local MassEffectGuiManager oGuiMgr;
        BeginState(PreviousStateName);
        CoverLog("PreviousStateName:" @ PreviousStateName, GetFuncName());
        CoverTransitionCountHold = 0;
        CoverBreakTimer = 0;
        pPawn = BioPawn(Pawn);
        if (pPawn != None && pPawn.CoverType == 2)
        {
            pPawn.ShouldCrouch(true);
        }
        if (PreviousStateName != 'PlayerInAimBack')
        {
            bPreferLeanOverPopup = true;
            if (pPawn.IsAtLeftEdgeSlot())
            {
                pPawn.CoverAction = 9;
            }
            else
            {
                if (pPawn.IsAtRightEdgeSlot())
                {
                    pPawn.CoverAction = 10;
                }
            }
        }
        oGuiMgr = MassEffectGuiManager(GetScaleFormManager());
        if (oGuiMgr != None)
        {
            oGuiMgr.HideCoverWidget();
        }
        if (PreviousStateName != 'PlayerInAimBack')
        {
            bBreakFromCover = false;
        }
    }

    function EndState(Name NextStateName)
    {
        local BioPawn BioPawn;
        EndState(NextStateName);
        if (NextStateName != 'PlayerInAimBack')
        {
            CoverLog("NextStateName:" @ NextStateName, GetFuncName());
            BioPawn = BioPawn(Pawn);
            if (BioPawn != None && BioPawn.IsInCover())
            {
                BioPawn.LeaveCover();
            }
        }
    }

    function PlayerMove(float DeltaTime)
    {
        local BioPawn BioPawn;
        local int PawnBreakCover;
        local Rotator YawRotation;
        local float CamDot;
        local ECoverAction PawnCoverAction;
        local ECoverDirection PawnCoverDirection;
        local ECoverDirection PawnMoveCoverDirection;
        BioPawn = BioPawn(Pawn);
        if (BioPawn != None && BioPawn.IsInCover())
        {
            if (!bBreakFromCover)
            {
                if (Abs(RemappedJoyUp) > Abs(RemappedJoyRight) && RemappedJoyUp < -DeadZoneThreshold && PawnCoverAction != 4 && PawnCoverAction != 3 && !IsMoveInputIgnored() && BioWorldInfo(WorldInfo).bPlayersOnly == false)
                {
                    CoverBreakTimer += DeltaTime;
                    if (CoverBreakTimer >= CoverBreakTimeThreshold)
                    {
                        PawnCoverAction = GetPawnCoverAction();
                        PawnCoverDirection = GetCoverDirection();
                        PawnMoveCoverDirection = BioPawn.CurrentSlotDirection;
                        UpdatePlayerPosture(DeltaTime, PawnBreakCover, PawnCoverAction, PawnCoverDirection, PawnMoveCoverDirection);
                        if (IsCameraAlignedWithCoverSlot())
                        {
                            m_bDoCoverExitAccel = true;
                        }
                        bBreakFromCover = true;
                        SFXWeapon(BioPawn.Weapon).CancelReload();
                    }
                }
                else
                {
                    CoverBreakTimer = 0;
                }
            }
            if (bBreakFromCover && !BioPawn.IsInAnimatedTransition())
            {
                m_CoverBreakCoverAction = BioPawn.CoverAction;
                BioPawn.LeaveCover();
                BioPawn.SetAnimatedTransitionPending();
                GotoState('PlayerExitingCover');
            }
            else
            {
                if (BioPawn.IsSwitchingWeapons() || BioPawn.IsReloading() || BioPawn.IsUsingPower())
                {
                    BioPawn.CurrentSlotDirection = 0;
                }
                else
                {
                    if (!IsMoveInputIgnored() && BioWorldInfo(WorldInfo).bPlayersOnly == false)
                    {
                        PawnCoverAction = GetPawnCoverAction();
                        PawnCoverDirection = GetCoverDirection();
                        PawnMoveCoverDirection = BioPawn.CurrentSlotDirection;
                        YawRotation.Yaw = Rotation.Yaw;
                        CamDot = YawRotation Dot BioPawn.CurrentLink.GetSlotRotation(BioPawn.CurrentSlotIdx);
                        if (BioPawn.CoverType == 1 && CamDot < 0,4 || BioPawn.CoverType == 2 && CamDot < 0)
                        {
                            GotoState('PlayerInAimBack');
                            return;
                        }
                        UpdatePlayerPosture(DeltaTime, PawnBreakCover, PawnCoverAction, PawnCoverDirection, PawnMoveCoverDirection);
                        if (!BioPawn.IsInAnimatedTransition())
                        {
                            if (BioPawn.CoverAction != PawnCoverAction || BioPawn.CoverDirection != PawnCoverDirection)
                            {
                                BioPawn.SetCoverAction(PawnCoverAction);
                                BioPawn.SetCoverDirection(PawnCoverDirection);
                                BioPawn.SetAnimatedTransitionPending();
                                switch (PawnCoverAction);
                                case 3;
                                case 4;
                                bPreferLeanOverPopup = true;
                                jump 1040;
                                case 7;
                                case 11;
                                bPreferLeanOverPopup = false;
                                jump 1040;
                                default;
                                jump 1040;
                            }
                        }
                        BioPawn.CurrentSlotDirection = PawnMoveCoverDirection;
                    }
                }
            }
            if (!bBreakFromCover)
            {
                if (BioPawn.CoverAction == 7)
                {
                    BioPawn.ShouldCrouch(false);
                }
                else
                {
                    if (BioPawn.CoverAction == 3 || BioPawn.CoverAction == 4)
                    {
                        BioPawn.ShouldCrouch(BioPawn.bIsCrouched);
                    }
                    else
                    {
                        if (BioPawn.CoverType == 2)
                        {
                            BioPawn.ShouldCrouch(true);
                        }
                    }
                }
            }
        }
        else
        {
            GotoState('PlayerWalking');
        }
        PlayerMove(DeltaTime);
        return;
    }

    function bool DetermineCanMoveInCoverDirection(BioPawn BioPawn, ECoverDirection DesiredDirection)
    {
        local bool bCanMove;
        local bool bIsAtSlot;
        local bool bIsStationary;
        local int SlotIdx;
        local CoverSlot CurrentSlot;
        bIsAtSlot = BioPawn.CurrentSlotPct < 0,1 || BioPawn.CurrentSlotPct > 0,9;
        bIsStationary = BioPawn.bIsInStationaryCover;
        SlotIdx = BioPawn.GetSlotIdxByPct();
        CurrentSlot = BioPawn.CurrentLink.Slots[SlotIdx];
        if (!bIsAtSlot || !bIsStationary)
        {
            bCanMove = true;
        }
        else
        {
            if (DesiredDirection == 2 && BioPawn.IsAtRightEdgeSlot() || DesiredDirection == 1 && BioPawn.IsAtLeftEdgeSlot())
            {
                bCanMove = false;
            }
            else
            {
                if (DesiredDirection == 2 && !CurrentSlot.bLeanRight || DesiredDirection == 1 && !CurrentSlot.bLeanLeft)
                {
                    bCanMove = true;
                }
                else
                {
                    if (CoverTransitionCountHold >= CoverTransitionTime)
                    {
                        bCanMove = true;
                    }
                    else
                    {
                        bCanMove = false;
                    }
                }
            }
        }
        return bCanMove;
    }

    function UpdatePlayerPosture(float DeltaTime, out int out_BreakFromCover, out ECoverAction out_PawnCA, out ECoverDirection out_PawnCD, out ECoverDirection out_PawnMoveCD)
    {
        local BioPawn BioPawn;
        local int SlotIdx;
        local CoverSlot CurrentSlot;
        local bool bIsAtSlot;
        local bool bJoyUpDominant;
        local bool bJoyRightDominant;
        local bool bJoyIsLeft;
        local bool bJoyIsRight;
        local ECoverDirection PreviousPawnCD;
        local ECoverAction PreviousPawnCA;
        local bool bCanMoveRight;
        local bool bCanMoveLeft;
        BioPawn = BioPawn(Pawn);
        SlotIdx = BioPawn.GetSlotIdxByPct();
        CurrentSlot = BioPawn.CurrentLink.Slots[SlotIdx];
        bIsAtSlot = BioPawn.IsOnACoverSlot();
        bJoyUpDominant = Abs(RemappedJoyUp) > Abs(RemappedJoyRight);
        bJoyRightDominant = Abs(RemappedJoyRight) > Abs(RemappedJoyUp);
        if (bJoyRightDominant && Abs(RemappedJoyRight) > DeadZoneThreshold)
        {
            bJoyIsLeft = RemappedJoyRight < -DeadZoneThreshold;
            bJoyIsRight = RemappedJoyRight > DeadZoneThreshold;
            bPreferLeanOverPopup = true;
        }
        else
        {
            bJoyIsLeft = false;
            bJoyIsRight = false;
        }
        out_BreakFromCover = 0;
        if (bJoyUpDominant)
        {
            if (RemappedJoyUp < -DeadZoneThreshold)
            {
                if (out_PawnCA != 4 && out_PawnCA != 3)
                {
                    out_BreakFromCover = 1;
                }
            }
        }
        if (out_BreakFromCover == 0)
        {
            PreviousPawnCD = out_PawnCD;
            PreviousPawnCA = out_PawnCA;
            DetermineLeanDirection(BioPawn, CurrentSlot, out_PawnCA, out_PawnCD);
            if (out_PawnCA != 7 && out_PawnCA != 0)
            {
                out_PawnMoveCD = 0;
            }
            else
            {
                if (out_PawnCA != PreviousPawnCA)
                {
                    out_PawnMoveCD = 0;
                }
                else
                {
                    if (out_PawnCA != 7 && out_PawnCD != PreviousPawnCD)
                    {
                        out_PawnMoveCD = 0;
                    }
                    else
                    {
                        CoverTransitionCountHold += DeltaTime;
                        bCanMoveRight = DetermineCanMoveInCoverDirection(BioPawn, 2);
                        bCanMoveLeft = DetermineCanMoveInCoverDirection(BioPawn, 1);
                        if (bJoyIsRight && out_PawnCD == 2 && bCanMoveRight)
                        {
                            out_PawnMoveCD = 2;
                        }
                        else
                        {
                            if (bJoyIsLeft && out_PawnCD == 1 && bCanMoveLeft)
                            {
                                out_PawnMoveCD = 1;
                            }
                            else
                            {
                                out_PawnMoveCD = 0;
                            }
                        }
                    }
                }
            }
            if (BioPawn.bIsInStationaryCover)
            {
                if (!bIsAtSlot)
                {
                    SetIsInStationaryCover(false);
                }
                else
                {
                    if (out_PawnMoveCD != 0)
                    {
                        SetIsInStationaryCover(false);
                    }
                }
                jump 726;
            }
            jump 729;
        }
        return;
    }

}

function bool IsInCoverState()
{
    return false;
}

function CoverLog(String msg, coerce String Function)
{
}

final function LeaveCover()
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        BioPawn.LeaveCover();
        GotoState('PlayerWalking');
    }
}

final function SetCoverDirection(ECoverDirection NewCoverDirection)
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        BioPawn.SetCoverDirection(NewCoverDirection);
    }
}

final function ECoverDirection GetCoverDirection()
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        return BioPawn.CoverDirection;
    }
    return 0;
}

final function SetPawnCoverAction(ECoverAction NewCoverAction)
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        BioPawn.SetCoverAction(NewCoverAction);
    }
}

final function ECoverAction GetPawnCoverAction()
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        return BioPawn.CoverAction;
    }
    return 0;
}

final function SetPawnCoverType(ECoverType NewCoverType)
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        BioPawn.SetCoverType(NewCoverType);
    }
}

final function ECoverType GetPawnCoverType()
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        return BioPawn.CoverType;
    }
    return 0;
}

final function SetIsInStationaryCover(bool bIsInStationaryCover)
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None && bIsInStationaryCover != BioPawn.bIsInStationaryCover)
    {
        BioPawn.bIsInStationaryCover = bIsInStationaryCover;
    }
}

function NotifyReachedCoverSlot(int SlotIdx, int OldSlotIdx)
{
    local BioPawn BioPawn;
    local CoverLink Link;
    local CoverSlot Slot;
    BioPawn = BioPawn(Pawn);
    Link = BioPawn.CurrentLink;
    if (Link != None)
    {
        CoverLog("Slot:" @ SlotIdx, GetFuncName() @ "Cur" @ BioPawn.CurrentSlotIdx @ "L" @ BioPawn.LeftSlotIdx @ "R" @ BioPawn.RightSlotIdx);
        if (OldSlotIdx >= 0)
        {
            Link.UnClaim(self, OldSlotIdx, false);
        }
        Link.Claim(self, SlotIdx);
        Slot = Link.Slots[SlotIdx];
        if (Slot.CoverType == 2)
        {
            BioPawn.ShouldCrouch(true);
        }
        if (Slot.CoverType == 1)
        {
            BioPawn.StopFire(0);
            BioPawn.ShouldCrouch(false);
        }
        Pawn.SetAnchor(Link.Slots[SlotIdx].SlotMarker);
        if (Link.IsStationarySlot(SlotIdx))
        {
            if (Link.IsEdgeSlot(SlotIdx) == false)
            {
                CoverTransitionCountHold = 0;
            }
            SetIsInStationaryCover(true);
        }
    }
}

simulated function NotifyCoverDisabled(CoverLink Link, int SlotIdx)
{
    local BioPawn MyPawn;
    MyPawn = BioPawn(Pawn);
    if (MyPawn != None)
    {
        MyPawn.LeaveCover();
        MyPawn.PlayAnimatedReaction(52, self);
    }
}

final exec function bool TryAcquireCover()
{
    local BioPawn BioPawn;
    local CovPosInfo FoundCover;
    local bool bFindCoverPassed;
    local BioRemoteLogger GLogger;
    if (CoverRespectsRotation == true)
    {
        bFindCoverPassed = FindPlayerCover(FoundCover, true);
    }
    else
    {
        bFindCoverPassed = FindPlayerCover(FoundCover) || FindPlayerCover(FoundCover, true);
    }
    if (bFindCoverPassed == false)
    {
        return false;
    }
    BioPawn = BioPawn(Pawn);
    if (BioPawn.m_oBehavior.m_eCurrentActionState == 0)
    {
        BioPawn.m_oBehavior.SetActionState(1);
        return true;
    }
    SFXWeapon(BioPawn.Weapon).CancelReload();
    if (BioPawn.IsInAnimatedTransition())
    {
        return false;
    }
    if (CanPerformEnterCover() == false)
    {
        return false;
    }
    AcquireCover(FoundCover);
    GLogger = Class'BioRemoteLogger'.GetLogger();
    if (GLogger != None)
    {
        GLogger.SendPlayerEvent(37, GLogger.ShortName(BioPawn.CurrentLink), "", "", "", 1, 0, 0, 0);
    }
    return true;
}

native final function bool FindPlayerCover(out CovPosInfo out_CovPosInfo, optional bool bUseRotation);

native final function FillCoverPosInfo(CoverLink Link, int SlotIdx, Vector SourceLoc, Vector Direction, float MaxDistance, out CovPosInfo out_CovPosInfo);

native final function bool ValidatePotentialCover(Vector SourceLoc, Vector Direction, bool OnlyIfBetter, out float OutMinDotFOV, out float OutMaxDistanceSquared, out CovPosInfo OutCovPosInfo);

native final function bool CanPerformEnterCover();

native final function bool CanPerformClimb(CovPosInfo CoverInfo);

native final function bool CanPerformMantle(CovPosInfo CoverInfo);

function AcquireCover(CovPosInfo CovInfo)
{
    local BioPawn BioPawn;
    if (!IsLocalPlayerController())
    {
        ScriptTrace();
        return;
    }
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None && BioPawn.IsPerformingBlockingAction() == false)
    {
        BioPawn.PlayerCoverAcquired(CovInfo);
        if (CovInfo.LtToRtPct == 0 || CovInfo.LtToRtPct == 1)
        {
            NotifyReachedCoverSlot(BioPawn.CurrentSlotIdx, -1);
        }
        if (BioPawn.CanDoCoverAction(3))
        {
            BioPawn.SetCoverDirection(1);
        }
        else
        {
            BioPawn.SetCoverDirection(2);
        }
        BioPawn.SetAnimatedTransitionPending();
        GotoState('PlayerInCover');
    }
}

event bool GetCurrentCustomAction(out BioCustomAction Action);

event bool CanDoCustomAction(EAICustomAction CAction);

final function bool IsUsingPower()
{
    local BioPawnBehavior Behavior;
    Behavior = BioPawnBehavior(Pawn.oBioComponent);
    if (Behavior != None && BioActivePower(Behavior.m_oCurrentModalActive) != None)
    {
        return true;
    }
    return false;
}

native final function UpdateEnemyList();

native final function UpdateCover();

function Rotator GetAdjustedAimFor(Weapon W, Vector StartFireLoc)
{
    if (AimAssist != None)
    {
        return AimAssist.GetAdjustedAimFor(W, StartFireLoc);
    }
    else
    {
        return Pawn != None ? Pawn.GetBaseAimRotation() : Rotation;
    }
}

exec function ToggleFlyCam()
{
    SFXPlayerCamera(PlayerCamera).bFreeCamActive = !SFXPlayerCamera(PlayerCamera).bFreeCamActive;
}

exec function ToggleSlowFlyCam()
{
    local SFXPlayerCamera TheCamera;
    TheCamera = SFXPlayerCamera(PlayerCamera);
    if (TheCamera != None)
    {
        TheCamera.bFreeCamActive = !TheCamera.bFreeCamActive;
        TheCamera.m_bIgnoreSlowMo = !TheCamera.bFreeCamActive;
    }
}

exec function ToggleFlyCamControl()
{
    local SFXPlayerCamera man;
    local BioCameraBehaviorFree oFreeBehav;
    man = SFXPlayerCamera(PlayerCamera);
    oFreeBehav = BioCameraBehaviorFree(man.CurrentCameraMode);
    if (oFreeBehav != None)
    {
        oFreeBehav.m_bCameraLocked = !oFreeBehav.m_bCameraLocked;
    }
}

state PlayerFlying
{
    function PlayerMove(float DeltaTime)
    {
        local Vector vNewAccel;
        local BioPawnBehavior oPawnBehav;
        local Rotator rCamRotation;
        local Rotator rNewRotation;
        local Rotator rNewDirection;
        local float fMoveTheta;
        local float fMoveMag;
        local float fWalkMag;
        local bool bSetRotate;
        local BioPlayerInput Input;
        Input = BioPlayerInput(PlayerInput);
        bSetRotate = false;
        oPawnBehav = BioPawnBehavior(Pawn.oBioComponent);
        vNewAccel = vect(0,0,0);
        fWalkMag = BioPawn(Pawn).WalkSpeed / BioPawn(Pawn).GroundSpeed;
        fMoveMag = Sqrt(Input.Outer.RemappedJoyRight * Input.Outer.RemappedJoyRight + Input.Outer.RemappedJoyUp * Input.Outer.RemappedJoyUp);
        if (fMoveMag > 0)
        {
            fMoveMag = FClamp(fMoveMag, fWalkMag, 1);
        }
        fMoveTheta = Atan(PlayerInput.aStrafe, PlayerInput.aForward);
        rCamRotation = PlayerCamera.CameraCache.POV.Rotation;
        rCamRotation.Pitch = 0;
        if (fMoveMag > 0)
        {
            if (!Class'BioPawn'.IsCombatActionState(oPawnBehav.m_eCurrentActionState))
            {
                rNewRotation = rCamRotation;
                rNewRotation.Yaw = rNewRotation.Yaw & 65535 + fMoveTheta * 57,29578 * 182,0444;
                vNewAccel = vect(1,0,0) >> Pawn.Rotation * Pawn.AccelRate * fMoveMag;
                bSetRotate = true;
            }
            else
            {
                rNewDirection = rCamRotation;
                rNewDirection.Yaw = rNewDirection.Yaw + fMoveTheta * 57,29578 * 182,0444;
                vNewAccel = vect(1,0,0) >> rNewDirection * Pawn.AccelRate * fMoveMag;
            }
        }
        if (bSetRotate)
        {
            BioPawn(Pawn).SetDesiredRotation(rNewRotation);
        }
        if (m_bDEBUGFlyUpPressed)
        {
            vNewAccel = vNewAccel + vect(0,0,1) * Pawn.AccelRate;
            fMoveMag = 1;
        }
        else
        {
            if (m_bDEBUGFlyDownPressed)
            {
                vNewAccel = vNewAccel + vect(0,0,-1) * Pawn.AccelRate;
                fMoveMag = 1;
            }
        }
        if (VSize(vNewAccel) < 1)
        {
            vNewAccel = vect(0,0,0);
        }
        BioPawn(Pawn).SetDesiredSpeed(fMoveMag);
        BioPawn(Pawn).fMoveMag = fMoveMag;
        if (Role < 3)
        {
            ReplicateMove(DeltaTime, vNewAccel, 0, rot(0,0,0));
        }
        else
        {
            ProcessMove(DeltaTime, vNewAccel, 0, rot(0,0,0));
        }
    }

}

function Possess(Pawn aPawn, bool bVehicleTransition)
{
    local BioTriggerStream V;
    local BioPlayerSquad PlayerSquad;
    local BioPawn oBioPawn;
    local BioWorldInfo oBioWorldInfo;
    Possess(aPawn, bVehicleTransition);
    foreach AllActors(Class'BioTriggerStream', V)
    {
        if (V.Encompasses(aPawn))
        {
            V.Touch(aPawn, None, aPawn.RelativeLocation, aPawn.RelativeLocation);
        }
    }
    if (aPawn != None)
    {
        oBioPawn = BioPawn(aPawn);
        oBioWorldInfo = BioWorldInfo(WorldInfo);
        if (oBioWorldInfo != None && oBioPawn != None)
        {
            PlayerSquad = SFXGame(WorldInfo.Game).PlayerSquad;
            if (oBioWorldInfo.m_playerSquad == None)
            {
                oBioWorldInfo.m_playerSquad = PlayerSquad;
            }
            PlayerSquad.AddMember(oBioPawn);
            if (oBioPawn != PlayerSquad.m_playerPawn)
            {
                if (PlayerSquad.m_InitialPlayerPawn == None)
                {
                    PlayerSquad.m_InitialPlayerPawn = PlayerSquad.m_playerPawn;
                }
                else
                {
                    if (PlayerSquad.m_playerPawn != PlayerSquad.m_InitialPlayerPawn)
                    {
                        PlayerSquad.RemoveMember(PlayerSquad.m_playerPawn);
                    }
                }
                PlayerSquad.m_playerPawn = oBioPawn;
            }
        }
    }
    SFXPlayerCamera(PlayerCamera).OnPossess(aPawn);
}

event UnPossess()
{
    UnPossess();
    if (SFXPlayerCamera(PlayerCamera) != None)
    {
        SFXPlayerCamera(PlayerCamera).OnUnPossess();
    }
}

final function GrantXP(float XP, optional bool bSkipNotify = false)
{
    local float XPGained;
    local int MaxExperience;
    local SFXPRI PRI;
    local SFXPawn_Player PlayerPawn;
    PRI = SFXPRI(PlayerReplicationInfo);
    PRI.bCalculatedChallenge = false;
    PlayerPawn = SFXPawn_Player(Pawn);
    if (PlayerPawn != None)
    {
        MaxExperience = SFXGame(WorldInfo.Game).gameconfig.MaxPlayerExperience;
        XPGained = XP;
        if (PlayerPawn.TotalXP + XPGained > MaxExperience)
        {
            XPGained = MaxExperience - PlayerPawn.TotalXP;
        }
        PlayerPawn.TotalXP += XPGained;
        if (XPGained > 0 && !bSkipNotify)
        {
            BioHintSystem(HintSystem).AddNotification_XP(XPGained);
        }
        if (Class'BioLevelUpSystem'.AttemptLevelUp(BioPlayerSquad(PlayerPawn.Squad)))
        {
            if (!bSkipNotify)
            {
                BioHintSystem(HintSystem).AddNotification_LevelUp(PlayerPawn.CharacterLevel);
            }
            if (PlayerPawn.CharacterLevel >= ProfileSettings.GetAchievementRequirement(43))
            {
                UnlockAchievement(43);
            }
        }
    }
}

static function class<BioBaseSaveObject> GetSaveObjectClass()
{
    return Class'BioPlayerControllerSaveObject';
}

native function SetPostProcessValues(ETVType Preset);

native function InitializeGammaCorrectionSettings();

event SpawnPlayerCamera()
{
    SpawnPlayerCamera();
    if (LocalPlayer(Player) != None)
    {
        BioWorldInfo(WorldInfo).SetRenderStateOfPlayerToDefault(0);
    }
}

function OnTeleportCameraSync(SeqAct_Teleport Action)
{
    local array<Object> objVars;
    local int idx;
    local Actor destActor;
    local int nYawDiff;
    if (Action.bUpdateRotation == true)
    {
        Action.GetObjectVars(objVars, "Destination");
        destActor = None;
        idx = 0;
        while (idx < objVars.Length && destActor == None)
        {
            destActor = Actor(objVars[idx]);
            if (destActor != None)
            {
                break;
            }
            idx++;
        }
        nYawDiff = destActor.Rotation.Yaw - Pawn.Rotation.Yaw;
        PlayerCamera.CameraCache.POV.Rotation.Yaw += nYawDiff;
    }
}

function ResetStormCooldown()
{
    bStormCoolingDown = false;
}

event ProxyOnControllerChanged(int ControllerId, bool bIsConnected)
{
    OnControllerChanged(ControllerId, bIsConnected);
}

event bool GetHenchmanAttackOrderPower(Pawn oHenchman, Actor oTarget, out Name nmPowerName)
{
    local SFXPawn_Henchman oPawn;
    local SFXAI_Henchman oController;
    local SFXPower oPower;
    local int nRequiresAttackTicket;
    local Vector AttackOrigin;
    oPawn = SFXPawn_Henchman(oHenchman);
    if (oPawn == None || oPawn.PowerManager == None)
    {
        return false;
    }
    if (oPawn.GetAttackOrderPower(oPower))
    {
        if (oPower != None && oPower.IsTargetInRange(oTarget))
        {
            if (oPawn.PowerManager.GetSharedCooldownRemaining() == 0)
            {
                nmPowerName = oPower.PowerName;
                return true;
            }
        }
    }
    oController = SFXAI_Henchman(oPawn.Controller);
    if (oController == None)
    {
        return false;
    }
    return oController.ChooseAttackPowerHelper(oTarget, true, nmPowerName, nRequiresAttackTicket, AttackOrigin);
}

event HenchmanOrderUsePower(Pawn oHenchman, Actor oTargetActor, Vector vTargetLocation, Name nmPower, int nQueue)
{
    GiveHenchmanOrder(oHenchman, 1, oTargetActor, vTargetLocation, nmPower, None, nQueue);
}

event HenchmanOrderAttackTarget(Pawn oHenchman, Actor oTargetActor)
{
    GiveHenchmanOrder(oHenchman, 3, oTargetActor, vect(0,0,0));
    if (oTargetActor != None)
    {
        Class'BioTelemetry'.SendEventName('SQUAD_ATTACK', oTargetActor.Tag);
    }
}

event HenchmanOrderFollow(Pawn oHenchman)
{
    GiveHenchmanOrder(oHenchman, 4, None, vect(0,0,0));
}

event HenchmanOrderHoldPosition(Pawn oHenchman, Vector vLocation)
{
    GenerateTutorialEvent(6);
    GiveHenchmanOrder(oHenchman, 5, None, vLocation);
    Class'BioTelemetry'.SendEvent('SQUAD_HOLD_POSITION');
}

function GiveHenchmanOrder(Pawn oHenchman, HenchmanOrderType eOrder, Actor oTargetActor, Vector vTargetLocation, optional Name nmPower, optional SFXWeapon oWpn, optional int nQueue)
{
    local SFXAI_Henchman oController;
    if (oHenchman != None)
    {
        oController = SFXAI_Henchman(oHenchman.Controller);
        if (oController != None)
        {
            oController.AddOrder(eOrder, oTargetActor, vTargetLocation, nmPower, oWpn, nQueue);
        }
    }
}

function OrderWeaponSwitch(Pawn oOrderedPawn, SFXWeapon Wpn)
{
    local SFXAI_Henchman oController;
    if (oOrderedPawn != None)
    {
        oController = SFXAI_Henchman(oOrderedPawn.Controller);
        if (oController != None)
        {
            GiveHenchmanOrder(oOrderedPawn, 2, None, vect(0,0,0), 'None', Wpn);
            if (Wpn != None && Wpn.Class != None)
            {
                Class'BioTelemetry'.SendEventName('SQUAD_SWAP_WEAPON', Wpn.Class.Name);
            }
        }
        else
        {
            if (oOrderedPawn == Pawn)
            {
                m_currentOrder.oSwitchWeapon = Wpn;
                SFXPawn_Player(oOrderedPawn).OutOfAmmoTimestamp = 0;
            }
        }
    }
}

function bool CanQueueOrder()
{
    if (m_currentOrder.nmPower == 'None' && m_currentOrder.oSwitchWeapon == None)
    {
        return true;
    }
    return false;
}

function bool CanStartImmediateOrder()
{
    if (!IsPlayerPerformingBlockingAction())
    {
        if (m_currentOrder.nmPower == 'None' && m_currentOrder.oSwitchWeapon == None)
        {
            return true;
        }
    }
    return false;
}

event SwitchWeapon(SFXWeapon oWpn)
{
    local SFXInventoryManager oInventory;
    local BioPawn PlayerPawn;
    PlayerPawn = BioPawn(Pawn);
    if (PlayerPawn != None)
    {
        oInventory = SFXInventoryManager(PlayerPawn.InvManager);
        if (oInventory != None)
        {
            oInventory.SetWeaponIfAvailable(oWpn);
        }
        if (PlayerPawn.IsInCoverLeaning())
        {
            PlayerPawn.CoverAction = 0;
        }
    }
}

native function ClearPlayerOrder();

native function bool CanRunQueuedOrder();

event CancelLastOrderedPower(Pawn oOrderedPawn, Name nmPower)
{
    local SFXAI_Henchman oController;
    if (oOrderedPawn != None)
    {
        oController = SFXAI_Henchman(oOrderedPawn.Controller);
        if (oController != None)
        {
            oController.CancelOrder(1, nmPower);
        }
        else
        {
            if (oOrderedPawn == Pawn)
            {
                ClearPlayerOrder();
            }
        }
    }
}

event bool IsPlayerPerformingBlockingAction()
{
    local BioPawn oPawn;
    oPawn = BioPawn(Pawn);
    if (oPawn != None)
    {
        return oPawn.IsPerformingBlockingAction();
    }
    return false;
}

native final function bool IsZoomed();

event SetZoomed(bool bZoomState)
{
    local SFXWeapon Weapon;
    Weapon = SFXWeapon(Pawn.Weapon);
    if (Weapon != None)
    {
        Weapon.SetZoomed(bZoomState);
    }
}

function bool IsReloading()
{
    local BioPawn BioPawn;
    BioPawn = BioPawn(Pawn);
    if (BioPawn != None)
    {
        return BioPawn.IsReloading(true);
    }
    return false;
}

function CameraShake(float Duration, Vector newRotAmplitude, Vector newRotFrequency, Vector newLocAmplitude, Vector newLocFrequency, float newFOVAmplitude, float newFOVFrequency)
{
    local ScreenShakeStruct Shake;
    Shake.TimeDuration = Duration;
    Shake.FOVAmplitude = newFOVAmplitude;
    Shake.FOVFrequency = newFOVFrequency;
    Shake.RotAmplitude = newRotAmplitude;
    Shake.RotFrequency = newRotFrequency;
    Shake.LocAmplitude = newLocAmplitude;
    Shake.LocFrequency = newLocFrequency;
    SFXPlayerCamera(PlayerCamera).AddScreenShake(Shake);
}

static function PlayLocationBasedCameraShake(Vector ImpactLocation, ScreenShakeStruct CameraShake, optional float MinShakeDistance = 3000, optional float MinShakeMultiplier = 0)
{
    local BioPlayerController pController;
    local float fPlayerDistanceToImpact;
    local float fCameraShakeMult;
    local ScreenShakeStruct ModifiedCameraShake;
    pController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    if (pController != None && pController.PlayerCamera != None)
    {
        fPlayerDistanceToImpact = VSize(pController.Pawn.Location - ImpactLocation);
        fCameraShakeMult = 1 - FClamp(fPlayerDistanceToImpact / MinShakeDistance, 0, 1 - FClamp(MinShakeMultiplier, 0, 1));
        ModifiedCameraShake = CameraShake;
        ModifiedCameraShake.FOVAmplitude *= fCameraShakeMult;
        ModifiedCameraShake.RotAmplitude.X *= fCameraShakeMult;
        ModifiedCameraShake.RotAmplitude.Y *= fCameraShakeMult;
        ModifiedCameraShake.RotAmplitude.Z *= fCameraShakeMult;
        ModifiedCameraShake.LocAmplitude.X *= fCameraShakeMult;
        ModifiedCameraShake.LocAmplitude.Y *= fCameraShakeMult;
        ModifiedCameraShake.LocAmplitude.Z *= fCameraShakeMult;
        SFXPlayerCamera(pController.PlayerCamera).AddScreenShake(ModifiedCameraShake);
    }
}

static function PlayLocationBasedForceFeedback(Vector ImpactLocation, ForceFeedbackWaveform ForceFeedback, optional float MinShakeDistance = 3000, optional float MinShakeMultiplier = 0)
{
    local BioPlayerController pController;
    local float fPlayerDistanceToImpact;
    local float fForceFeedbackMult;
    local ForceFeedbackWaveform ModifiedForceFeedback;
    local WaveformSample Sample;
    pController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    if (pController != None)
    {
        fPlayerDistanceToImpact = VSize(pController.Pawn.Location - ImpactLocation);
        fForceFeedbackMult = 1 - FClamp(fPlayerDistanceToImpact / MinShakeDistance, 0, 1 - FClamp(MinShakeMultiplier, 0, 1));
        ModifiedForceFeedback = new(None,Class'ForceFeedbackWaveform');
        ForceFeedback;
        foreach ForceFeedback.Samples(Sample)
        {
            Sample.LeftAmplitude *= fForceFeedbackMult;
            Sample.RightAmplitude *= fForceFeedbackMult;
            ModifiedForceFeedback.Samples.AddItem(Sample);
        }
        pController.ClientPlayForceFeedbackWaveform(ModifiedForceFeedback);
    }
}

native final function float GetAcquireCoverFOV();

native final function float GetCoverFOV();

native final function float GetMaxCoverEnterDist();

function CheckStormToCover()
{
    if (bStorming != false && m_bEnableStormToCover != false)
    {
        TryAcquireCover();
    }
}

function DebugDraw_CoverCheck(BioHUD HUD)
{
    local float fMaxDistance;
    local Vector vDir;
    local Vector vLoc;
    local float fFov;
    local float fAngle;
    local Color clrCone;
    fMaxDistance = GetMaxCoverEnterDist();
    if (IsZero(vLoc) == true)
    {
        vDir = Pawn.Rotation;
        vDir.Z = 0;
        vDir = Normal(vDir);
    }
    else
    {
        vDir = Pawn.Acceleration;
        vDir.Z = 0;
        vDir = Normal(vDir);
    }
    vLoc = Pawn.Location;
    fFov = 1 - FClamp(GetAcquireCoverFOV(), 0, 1);
    Pawn.FlushPersistentDebugLines();
    clrCone.R = 0;
    clrCone.G = 255;
    clrCone.B = 0;
    fAngle = Acos(fFov);
    Pawn.DrawDebugCylinder(vLoc, vLoc, fMaxDistance, 32, 255, 0, 0, true);
    Pawn.DrawDebugCylinder(vLoc, vLoc, fMaxDistance + 512, 32, 255, 0, 0, true);
    Pawn.DrawDebugCone(vLoc, vDir, fMaxDistance, fAngle, 0, 16, clrCone, true);
}

native function QueueDamageIndicator(Pawn oPawn);

function GenerateTutorialEvent(ETutorialHooks eTutHook)
{
    local SFXGame oGame;
    local int idx;
    local array<SequenceObject> Events;
    local SFXSeqEvt_Tutorial tutorialEvent;
    oGame = SFXGame(Class'Engine'.GetCurrentWorldInfo().Game);
    if (oGame != None && oGame.bGenerateTutorialEvents)
    {
        if (WorldInfo.GetGameSequence() != None)
        {
            switch (eTutHook)
            {
                case 0:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialReload', true, Events);
                    break;
                case 1:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialMelee', true, Events);
                    break;
                case 2:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialZoom', true, Events);
                    break;
                case 3:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialQuickCast', true, Events);
                    break;
                case 4:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialWeaponSwitch', true, Events);
                    break;
                case 5:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialStorm', true, Events);
                    break;
                case 6:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialOrderHenchman', true, Events);
                    break;
                case 7:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialWheelHidden', true, Events);
                    break;
                case 8:
                    WorldInfo.GetGameSequence().FindSeqObjectsByClass(Class'SFXSeqEvt_TutorialAreaMapHidden', true, Events);
                    break;
            }
            idx = 0;
            while (idx < Events.Length)
            {
                tutorialEvent = SFXSeqEvt_Tutorial(Events[idx]);
                if (tutorialEvent != None)
                {
                    tutorialEvent.CheckActivate(self, self);
                }
                idx++;
            }
        }
    }
}

function SetCinematicMode(bool bInCinematicMode, bool bHidePlayer, bool bAffectsHUD, bool bAffectsMovement, bool bAffectsTurning, bool bAffectsButtons)
{
    local int Cnt;
    local BioPawn pPawn;
    local SFXAI_NativeBase pAI;
    local BioWorldInfo pBWI;
    SetCinematicMode(bInCinematicMode, bHidePlayer, bAffectsHUD, bAffectsMovement, bAffectsTurning, bAffectsButtons);
    pBWI = BioWorldInfo(WorldInfo);
    if (bInCinematicMode && GameModeManager2.IsActive(6) == false)
    {
        GameModeManager2.EnableMode(6);
        if (BioPawn(Pawn) != None)
        {
            BioPawn(Pawn).RecoverFromBleedout();
        }
        Cnt = 0;
        while (Cnt < pBWI.m_playerSquad.GetSquadSize())
        {
            pPawn = BioPawn(pBWI.m_playerSquad.GetMember(Cnt));
            if (pPawn != None)
            {
                pPawn.TerminateCurrentCustomAction();
                pPawn.EnsurePawnIsUpright();
                pPawn.SetWeaponImmediately(None);
                pAI = SFXAI_NativeBase(pPawn.Controller);
                if (pAI != None)
                {
                    pAI.EnableAI(false, 2);
                }
                pPawn.m_oBehavior.SetActionState(0);
            }
            Cnt++;
        }
    }
    else
    {
        if (bInCinematicMode == false && GameModeManager2.IsActive(6))
        {
            GameModeManager2.DisableMode(6);
            DisableDOF();
            Cnt = 0;
            while (Cnt < pBWI.m_playerSquad.GetSquadSize())
            {
                pPawn = BioPawn(pBWI.m_playerSquad.GetMember(Cnt));
                if (pPawn != None)
                {
                    pAI = SFXAI_NativeBase(pPawn.Controller);
                    if (pAI != None)
                    {
                        pAI.EnableAI(true, 2);
                    }
                }
                Cnt++;
            }
        }
    }
}

function float GetSensitivityScaling()
{
    local SFXPRI PRI;
    local float Multiplier;
    Multiplier = RotationSensitivityMedium;
    PRI = SFXPRI(PlayerReplicationInfo);
    if (PRI != None)
    {
        switch (PRI.ControllerSensitivityConfig);
        case 1;
        Multiplier = RotationSensitivityLow;
        jump 114;
        case 2;
        Multiplier = RotationSensitivityHigh;
        jump 114;
        case 0;
        default;
        Multiplier = RotationSensitivityMedium;
        jump 114;
    }
    return Multiplier;
}

function PreClientTravel()
{
    if (!Class'WorldInfo'.IsMenuLevel())
    {
        SaveProfile();
    }
    PreClientTravel();
}

function SetDeviceID(int nID)
{
    local SFXEngine Engine;
    if (ProfileSettings != None)
    {
        ProfileSettings.SetCurrentDeviceID(nID, self);
    }
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        Engine.UpdateCurrentDevice(nID);
    }
}

event bool CanSave(out String Reason)
{
    local byte PlayerID;
    local SFXGame GameInfo;
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Class'WorldInfo'.IsConsoleBuild())
    {
        if (OnlineSub != None)
        {
            PlayerInterface = OnlineSub.PlayerInterface;
            if (NotEqual_InterfaceInterface(PlayerInterface, OnlinePlayerInterface(None)))
            {
                PlayerID = LocalPlayer(Player).ControllerId;
                if (PlayerInterface.GetLoginStatus(PlayerID) == 0)
                {
                    Reason = Class'SFXGame'.GetSimpleString(// unknown bytecode 4F ;
                }
            }
        }
    }
}

exec function QuickSave()
{
    local SFXEngine Engine;
    local String Reason;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None && CanSave(Reason))
    {
        Engine.bCanWriteSaveToStorage = true;
        Engine.PendingSaveGameAction = 9;
        Engine.PendingSaveGameLocation = Pawn != None ? Pawn.Location : Location;
        Engine.PendingSaveGameIndex = -1;
        Engine.LastSaveGameAction = Engine.PendingSaveGameAction;
        Engine.LastSaveGameLocation = Engine.PendingSaveGameLocation;
        Engine.LastSaveGameIndex = -1;
        Engine.LastDeleteGameIndex = -1;
    }
}

exec function QuickLoad()
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None && Engine.PendingSaveGameAction == 0)
    {
        Engine.PendingSaveGameAction = 4;
    }
}

function bool SaveGame(int SaveIndex)
{
    local SFXEngine Engine;
    local Name nmStreamingChunk;
    local BioSFHandler_MessageBox oInsufficientSpaceMsgBox;
    local BioMessageBoxOptionalParams stParams;
    local bool retval;
    retval = true;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            if (Engine.IsCurrentDeviceValid(1048576))
            {
                Engine.bCanWriteSaveToStorage = true;
                Helper_SaveGame(SaveIndex);
            }
            else
            {
                if (Engine.IsCurrentDeviceValid())
                {
                    oInsufficientSpaceMsgBox = MassEffectGuiManager(GetScaleFormManager()).CreateMessageBox();
                    stParams.srAText = InsufficentSpaceAcknowledgedText;
                    stParams.srBText = // unknown bytecode 4F ;
                }
            }
        }
    }
}

final private function Helper_SaveGame(int SaveIndex)
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        Engine.PendingSaveGameAction = 5;
        Engine.PendingSaveGameLocation = Pawn != None ? Pawn.Location : Location;
        Engine.PendingSaveGameIndex = SaveIndex;
        Engine.LastSaveGameAction = Engine.PendingSaveGameAction;
        Engine.LastSaveGameLocation = Engine.PendingSaveGameLocation;
        Engine.LastSaveGameIndex = Engine.PendingSaveGameIndex;
        Engine.LastDeleteGameIndex = -1;
    }
}

function LoadGame(bool bChapterSave, bool bAutoSave, bool bQuickSave, String CareerName, int LoadIndex)
{
    local SFXEngine Engine;
    local Name nmStreamingChunk;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            if (Engine.IsCurrentDeviceValid())
            {
                Helper_LoadGame(bChapterSave, bAutoSave, bQuickSave, CareerName, LoadIndex);
            }
        }
        else
        {
            Helper_LoadGame(bChapterSave, bAutoSave, bQuickSave, CareerName, LoadIndex);
        }
        BioWorldInfo(WorldInfo).GetCurrentStreamingChunkName(nmStreamingChunk);
        Class'BioTelemetry'.SendEventName('LOAD_GAME', nmStreamingChunk);
    }
}

final private function Helper_LoadGame(bool bChapterSave, bool bAutoSave, bool bQuickSave, String CareerName, int LoadIndex)
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (CareerName != "")
        {
            Engine.CareerNameOverride = CareerName;
        }
        if (bChapterSave)
        {
            Engine.PendingSaveGameAction = 3;
        }
        else
        {
            if (bAutoSave)
            {
                Engine.PendingSaveGameAction = 2;
            }
            else
            {
                if (bQuickSave)
                {
                    Engine.PendingSaveGameAction = 10;
                }
                else
                {
                    Engine.PendingSaveGameAction = 1;
                }
            }
        }
        Engine.PendingSaveGameIndex = LoadIndex;
    }
}

function DeleteGame(bool bAutoSave, int DeleteIndex, String CareerName)
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            if (Engine.IsCurrentDeviceValid())
            {
                Helper_DeleteGame(bAutoSave, DeleteIndex, CareerName);
            }
        }
        else
        {
            Helper_DeleteGame(bAutoSave, DeleteIndex, CareerName);
        }
    }
}

final private function Helper_DeleteGame(bool bAutoSave, int DeleteIndex, String CareerName)
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (CareerName != "")
        {
            Engine.CareerNameOverride = CareerName;
        }
        if (bAutoSave)
        {
            Engine.PendingSaveGameAction = 12;
        }
        else
        {
            Engine.PendingSaveGameAction = 11;
        }
        Engine.PendingDeleteGameIndex = DeleteIndex;
    }
}

function bool OverwriteGame(int DeleteIndex, int SaveIndex)
{
    local SFXEngine Engine;
    local BioSFHandler_MessageBox oInsufficientSpaceMsgBox;
    local BioMessageBoxOptionalParams stParams;
    local bool retval;
    retval = true;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            if (Engine.IsCurrentDeviceValid(1048576))
            {
                Engine.bCanWriteSaveToStorage = true;
                Helper_OverwriteGame(DeleteIndex, SaveIndex);
            }
            else
            {
                if (Engine.IsCurrentDeviceValid())
                {
                    oInsufficientSpaceMsgBox = MassEffectGuiManager(GetScaleFormManager()).CreateMessageBox();
                    stParams.srAText = InsufficentSpaceAcknowledgedText;
                    stParams.srBText = // unknown bytecode 4F ;
                }
            }
        }
    }
}

final private function Helper_OverwriteGame(int DeleteIndex, int SaveIndex)
{
    local SFXEngine Engine;
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        Engine.PendingSaveGameAction = 6;
        Engine.PendingSaveGameIndex = SaveIndex;
        Engine.PendingSaveGameLocation = Pawn != None ? Pawn.Location : Location;
        Engine.PendingDeleteGameIndex = DeleteIndex;
        Engine.LastSaveGameAction = Engine.PendingSaveGameAction;
        Engine.LastSaveGameLocation = Engine.PendingSaveGameLocation;
        Engine.LastSaveGameIndex = Engine.PendingSaveGameIndex;
        Engine.LastDeleteGameIndex = Engine.PendingDeleteGameIndex;
    }
}

event SaveProfile()
{
    local LocalPlayer LP;
    local int ControllerId;
    local BioPawn MyBP;
    LP = LocalPlayer(Player);
    if (LP != None)
    {
        if (OnlineSub != None)
        {
            PlayerInt = OnlineSub.PlayerInterface;
            if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)))
            {
                ControllerId = LP.ControllerId;
                if (ControllerId != -1 && Class'UIInteraction'.IsLoggedIn(ControllerId))
                {
                    PlayerInt.WriteProfileSettings(ControllerId, ProfileSettings);
                }
            }
        }
    }
    UpdateLocalProfileSettingsCache();
    MyBP = BioPawn(Pawn);
    if (MyBP != None)
    {
        MyBP.SetRichPresence();
    }
}

function RegisterOnlineDelegates()
{
    local LocalPlayer LocPlayer;
    local MassEffectGuiManager GuiMan;
    RegisterOnlineDelegates();
    LocPlayer = LocalPlayer(Player);
    if (LocPlayer != None && OnlineSub != None)
    {
        PlayerInterface = OnlineSub.PlayerInterface;
        if (NotEqual_InterfaceInterface(PlayerInterface, OnlinePlayerInterface(None)))
        {
            PlayerInterface.AddLoginChangeDelegate(NotifyLoginChange, 255);
            PlayerInterface.AddReadProfileSettingsCompleteDelegate(LocPlayer.ControllerId, NotifyProfileReadComplete);
        }
        OnlineSub.SystemInterface.AddStorageDeviceChangeDelegate(StorageDeviceChanged);
        GuiMan = MassEffectGuiManager(GetScaleFormManager());
        if (GuiMan != None)
        {
            GuiMan.Player = self;
        }
    }
}

function ClearOnlineDelegates()
{
    local LocalPlayer LocPlayer;
    ClearOnlineDelegates();
    LocPlayer = LocalPlayer(Player);
    if (LocPlayer != None && OnlineSub != None)
    {
        PlayerInterface = OnlineSub.PlayerInterface;
        if (NotEqual_InterfaceInterface(PlayerInterface, OnlinePlayerInterface(None)))
        {
            PlayerInterface.ClearLoginChangeDelegate(NotifyLoginChange, 255);
            PlayerInterface.ClearReadProfileSettingsCompleteDelegate(LocPlayer.ControllerId, NotifyProfileReadComplete);
        }
    }
}

function NotifyLoginChange()
{
    local WorldInfo oWorld;
    oWorld = Class'Engine'.GetCurrentWorldInfo();
    if (BioWorldInfo(oWorld) != None && BioWorldInfo(oWorld).m_playerSquad != None && BioWorldInfo(oWorld).m_playerSquad.m_playerPawn != None)
    {
        BioWorldInfo(oWorld).m_playerSquad.m_playerPawn.SetRichPresence();
    }
    CheckThatGameCanContinue();
}

function Callback_PlayerLoggedOut(bool bAPressed, int Context)
{
    SFXEngine(Player.Outer).ReLaunchExecutable();
}

native function bool DownloadableContentWasRemoved();

function StorageDeviceChanged()
{
    CheckThatGameCanContinue();
}

event CheckThatGameCanContinue()
{
    local SFXEngine Engine;
    local BioMessageBoxOptionalParams stParams;
    local bool bSplashScreen;
    local bool bSaveDeviceRemoved;
    local LocalPlayer LocPlayer;
    local UniqueNetId NewPlayerID;
    local UniqueNetId ZeroId;
    LocPlayer = LocalPlayer(Player);
    if (LocPlayer != None && OnlineSub != None && NotEqual_InterfaceInterface(OnlineSub.PlayerInterface, OnlinePlayerInterface(None)))
    {
        OnlineSub.PlayerInterface.GetUniquePlayerId(LocPlayer.ControllerId, NewPlayerID);
    }
    Engine = SFXEngine(Player.Outer);
    if (Engine != None)
    {
        bSplashScreen = MassEffectGuiManager(GetScaleFormManager()).IsInSplashScreen();
        if (!bSplashScreen)
        {
            bSaveDeviceRemoved = Len(Engine.CurrentCareerName) > 0 && !Engine.FindCurrentSaveDevice();
            if (NewPlayerID != Engine.m_oInitialPlayerID)
            {
                if (Engine.m_oInitialPlayerID == ZeroId)
                {
                    NewErrorString = ProfileSignOutText;
                }
                else
                {
                    NewErrorString = ProfileChangedText;
                }
            }
            else
            {
                if (bSaveDeviceRemoved || DownloadableContentWasRemoved())
                {
                    NewErrorString = StorageDeviceRemovedText;
                }
            }
        }
        else
        {
            NewErrorString = // unknown bytecode 4F ;
        }
    }
}

function NotifyProfileReadComplete(byte LocalUserNum, bool bWasSuccessful)
{
    UpdateProfileData();
    InitializeGammaCorrectionSettings();
}

function UpdateProfileData()
{
    local SFXEngine Engine;
    local int ControllerId;
    local array<AchievementDetails> Achievements;
    if (OnlineSub != None)
    {
        ControllerId = LocalPlayer(Player).ControllerId;
        PlayerInterface = OnlineSub.PlayerInterface;
        if (NotEqual_InterfaceInterface(PlayerInterface, OnlinePlayerInterface(None)))
        {
            ProfileSettings = SFXProfileSettings(OnlinePlayerData.ProfileProvider.Profile);
            if (ProfileSettings != None)
            {
                Engine = SFXEngine(Player.Outer);
                if (Engine != None)
                {
                    Engine.CacheProfileData(ProfileSettings);
                }
            }
            bProfileSettingsUpdated = true;
            PlayerIntEx = OnlineSub.PlayerInterfaceEx;
            if (NotEqual_InterfaceInterface(PlayerIntEx, OnlinePlayerInterfaceEx(None)) && PlayerInterface.GetLoginStatus(ControllerId) != 0)
            {
                PlayerIntEx.GetAchievements(ControllerId, Achievements);
                if (Achievements.Length == 0)
                {
                    PlayerIntEx.AddReadAchievementsCompleteDelegate(ControllerId, NotifyReadAchievementsComplete);
                    if (PlayerIntEx.ReadAchievements(ControllerId) == false)
                    {
                        PlayerIntEx.ClearReadAchievementsCompleteDelegate(ControllerId, NotifyReadAchievementsComplete);
                    }
                }
                else
                {
                    ProfileSettings.UpdateAchievements(Achievements, self);
                }
            }
        }
    }
}

function NotifyReadAchievementsComplete(int TitleId)
{
    local int ControllerId;
    local array<AchievementDetails> AchievementsList;
    if (OnlineSub != None)
    {
        ControllerId = LocalPlayer(Player).ControllerId;
        PlayerIntEx = OnlineSub.PlayerInterfaceEx;
        if (NotEqual_InterfaceInterface(PlayerIntEx, OnlinePlayerInterfaceEx(None)))
        {
            PlayerIntEx.ClearReadAchievementsCompleteDelegate(ControllerId, NotifyReadAchievementsComplete);
            if (ProfileSettings != None)
            {
                PlayerIntEx.GetAchievements(ControllerId, AchievementsList);
                ProfileSettings.UpdateAchievements(AchievementsList, self);
            }
        }
    }
}

event UnlockAchievement(EAchievementID AchievementId)
{
    local LocalPlayer LP;
    local AchievementData AD;
    local int PlatformAchievementId;
    local GrinderAchievement GrinderData;
    if (ProfileSettings.HasCompletedAchievement(AchievementId) == true)
    {
        return;
    }
    ProfileSettings.GetAchievementData(AchievementId, AD);
    if (OnlineSub != None && NotEqual_InterfaceInterface(OnlineSub.PlayerInterfaceEx, OnlinePlayerInterfaceEx(None)))
    {
        PlatformAchievementId = AchievementId;
        if (Class'WorldInfo'.IsConsoleBuild(1))
        {
            if (AD.XboxAchievementID > 0)
            {
                PlatformAchievementId = AD.XboxAchievementID;
            }
        }
        LP = LocalPlayer(Player);
        if (OnlineSub.PlayerInterfaceEx.UnlockAchievement(LP.ControllerId, PlatformAchievementId) == false)
        {
        }
    }
    else
    {
        if (Class'WorldInfo'.IsConsoleBuild() == false)
        {
            ProfileSettings.GetGrinderAchievement(AchievementId, GrinderData);
            HintSystem.AddNotification_AchievementUnlocked(AD, GrinderData);
        }
    }
    if (ProfileSettings != None)
    {
        ProfileSettings.SetAchievementCompleted(AchievementId, self);
    }
    Class'BioTelemetry'.SendEventInt('ACHIEVEMENT_AWARDED', AchievementId);
}

event UpdateAchievementProgression(EAchievementID AchievementId, optional BioPawn oTarget)
{
    if (ProfileSettings != None)
    {
        if (oTarget == None || m_AchievementTargets.Find(oTarget) < 0)
        {
            ProfileSettings.GrinderAchievementIncrement(AchievementId, self);
            if (oTarget != None)
            {
                m_AchievementTargets.AddItem(oTarget);
            }
        }
    }
}

final function UpdateHeavyWeaponKill(class<SFXDamageType> DamageType)
{
    if (ProfileSettings != None && DamageType.Default.HeavyWeaponId > 0)
    {
        ProfileSettings.UpdateHeavyWeaponKill(DamageType.Default.HeavyWeaponId, self);
    }
}

function bool HasCompletedAchievement(EAchievementID AchievementId)
{
    if (ProfileSettings != None)
    {
        return ProfileSettings.HasCompletedAchievement(AchievementId);
    }
}

native function EnableMotionBlur(bool bEnable);

native function EnableFilmgrain(bool bEnable);

function bool CanRestartPlayer()
{
    return CanRestartPlayer();
}

event UpdateLocalProfileSettingsCache()
{
    local SFXPRI PRI;
    local SFXGame Game;
    local int PlayerIndex;
    local LocalPlayer LP;
    LP = LocalPlayer(Player);
    if (LP != None)
    {
        PlayerIndex = Class'UIInteraction'.GetPlayerIndex(LP.ControllerId);
    }
    PRI = SFXPRI(PlayerReplicationInfo);
    if (PRI != None && ProfileSettings != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            PRI.bControllerVibrationAllowed = ProfileSettings.GetControllerVibrationOption();
        }
        else
        {
            PRI.bControllerVibrationAllowed = false;
        }
        PlayerInput.bInvertMouse = ProfileSettings.GetInvertYOption();
        PRI.ControllerSensitivityConfig = ProfileSettings.GetControllerSensitivityValue();
        PRI.TriggerConfig = ProfileSettings.GetTriggerConfigOption();
        PRI.StickConfig = ProfileSettings.GetStickConfigOption();
        UpdateInputConfiguration();
        SetShowSubtitles(ProfileSettings.GetSubtitleConfigOption());
        PRI.AimAssistConfig = ProfileSettings.GetAimAssistValue();
        Game = SFXGame(WorldInfo.Game);
        if (Game != None)
        {
            switch (ProfileSettings.GetDifficultyConfigOption());
            case 0;
            Game.Difficulty = Class'SFXDifficulty_Level1';
            jump 614;
            case 2;
            Game.Difficulty = Class'SFXDifficulty_Level3';
            jump 614;
            case 3;
            Game.Difficulty = Class'SFXDifficulty_Level4';
            jump 614;
            case 4;
            Game.Difficulty = Class'SFXDifficulty_Level5';
            jump 614;
            case 5;
            Game.Difficulty = Class'SFXDifficulty_Level6';
            jump 614;
            case 1;
            default;
            Game.Difficulty = Class'SFXDifficulty_Level2';
            jump 614;
        }
        PRI.DifficultyOption = ProfileSettings.GetDifficultyConfigOption();
        PRI.AutoLevelUp = ProfileSettings.GetAutoLevelConfigOption();
        PRI.bSquadUsesPowers = ProfileSettings.GetSquadPowerConfigOption();
        PRI.bAutoSave = ProfileSettings.GetAutoSaveConfigOption();
        PRI.bAutoLogin = ProfileSettings.GetAutoLoginConfigOption();
        Class'WwiseAudioComponent'.SetGlobalRTPCFromScript("Music_Volume", ProfileSettings.GetMusicVolume() * 0,01);
        Class'WwiseAudioComponent'.SetGlobalRTPCFromScript("FX_Volume", ProfileSettings.GetFXVolume() * 0,01);
        Class'WwiseAudioComponent'.SetGlobalRTPCFromScript("Dialog_Volume", ProfileSettings.GetDialogVolume() * 0,01);
        UpdateBinkAudioVolume();
        if (Class'WorldInfo'.IsConsoleBuild())
        {
            EnableMotionBlur(ProfileSettings.GetMotionBlurConfigOption());
            EnableFilmgrain(ProfileSettings.GetFilmgrainConfigOption());
        }
        if (LP != None)
        {
            LP.BioRecalculatePostProcessEffects();
        }
        bProfileSettingsUpdated = false;
    }
    return;
}

native function SavePCInputConfiguration(SFXProfileSettings Profile);

native function LoadPCInputConfiguration();

function UpdateInputConfiguration()
{
    local SFXPRI PRI;
    PRI = SFXPRI(PlayerReplicationInfo);
    if (PRI != None)
    {
        if (Class'WorldInfo'.IsConsoleBuild() || WorldInfo.bUseConsoleInput)
        {
            GameModeManager2.Console_UpdateStickBindings(PRI.StickConfig);
            GameModeManager2.Console_UpdateTriggerBindings(PRI.TriggerConfig);
        }
        else
        {
            LoadPCInputConfiguration();
        }
    }
}

function bool IsLookInputIgnored()
{
    if (SFXPlayerCamera(PlayerCamera).bFreeCamActive)
    {
        return false;
    }
    return IsLookInputIgnored();
}

function PostControllerIdChange()
{
    local SFXEngine Engine;
    local LocalPlayer LP;
    LP = LocalPlayer(Player);
    Engine = SFXEngine(Player.Outer);
    if (Engine != None && LP != None)
    {
        Engine.CurrentUserID = LP.ControllerId;
    }
    PostControllerIdChange();
}

function HandleWalking()
{
    if (Pawn != None && m_bPermanentWalk)
    {
        Pawn.SetWalking(true);
    }
    else
    {
        HandleWalking();
    }
}

function ELoginStatus GetLoginStatus()
{
    local LocalPlayer LP;
    LP = LocalPlayer(Player);
    if (OnlineSub != None && NotEqual_InterfaceInterface(OnlineSub.PlayerInterface, OnlinePlayerInterface(None)) && LP != None)
    {
        return OnlineSub.PlayerInterface.GetLoginStatus(LP.ControllerId);
    }
    else
    {
        return 0;
    }
}

native function BioPawn GetBioPawn();

native function float GetRadarRange();

native function float GetRadarFOV();

defaultproperties
{
    AimAssist=SFXModule_AimAssist'AimAssist'
    m_bEnableStormToCover=true
    CoverRespectsRotation=true
    MoveStickIdleThreshold=0,001
    MoveStickWalkThreshold=0,65
    MoveStickRunThreshold=0,7
    DeadZoneThreshold=0,1
    m_vCoverBreakAccel=(X=8000,Y=5000,Z=0)
    m_fCoverBreakAccelTime=0,6
    m_fCoverBreakForwardAccelDelay=0,4
    CoverBreakTimeThreshold=0,08
    MaxCoverEnterDist=250
    AcquireCoverFOV=0,02
    CoverFOV=0,7
    CoverSnapScale=1,5
    CoverUpdateDelay=0,333
    StormAcquireCoverFOV=0,025
    StormCoverFOV=0,11
    StormMaxCoverEnterDist=250
    StormCoverUpdateDelay=0,15
    m_fClimbMantleFaceAngleThreshold=0,7
    m_fClimbMantleDistanceThreshold=50
    RotationSensitivityLow=0,6
    RotationSensitivityMedium=0,75
    RotationSensitivityHigh=1
    StormCooldownTime=0,3
    StormRTPCName="Storm"
    StormStartWwiseEvent_M=WwiseEvent'Play_player_male_storm_standard'
    StormPeakWwiseEvent_M=WwiseEvent'Play_player_male_storm_recover'
    StormStartWwiseEvent_F=WwiseEvent'Play_player_female_storm_standard'
    StormPeakWwiseEvent_F=WwiseEvent'Play_player_female_storm_recover'
    StormEndWwiseEvent=WwiseEvent'Stop_player_storm_recover'
    ProfileChangedText=System.Byte[]
    ProfileSignOutText=System.Byte[]
    ConfirmSignOutText=System.Byte[]
    StorageDeviceRemovedText=System.Byte[]
    RestartGame=System.Byte[]
    InsufficentSpaceText=System.Byte[]
    InsufficentSpaceAcknowledgedText=System.Byte[]
    HintSystem=BioHintSystem'HintSys0'
    m_fLeaveConvPitch=-20
    m_fMoveToDropDistance=4000
    m_oPlayerSelection=BioPlayerSelection'oSelection'
    m_fMaxZDifference=2000
    m_fRelativeZUpLimit=200
    m_fRelativeZDownLimit=100
    m_fLastRadarRange=-1
    m_fRadarRange=-1
    m_fRadarFOV=-1
    m_fLastRadarFOV=-1
    AimDirection=(X=1,Y=0,Z=0)
    m_nNavAssistMaxNodeLimit=4
    m_fDamageIndicatorDisplayTime=1
    PostProcessPresets=System.Byte[]
    m_srVehicleExitFailureMsg=System.Byte[]
    m_srVehicleExitAButtonMsg=System.Byte[]
    m_fAttackOrderFarAngle=5
    m_fAttackOrderCloseAngle=14
    m_fAttackOrderCloseDistance=500
    m_aFlyCamPCBinds=System.Byte[]
    m_aFlyCamConsoleBinds=System.Byte[]
    CameraClass=None
    CheatClass=None
    CylinderComponent=None
    Components=None
    // child object CollisionCylinder of type CylinderComponent
    // child object AimAssist of type SFXModule_AimAssist
    // child object HintSys0 of type BioHintSystem
    // child object oSelection of type BioPlayerSelection
}
