﻿class BioPlayerSelection extends Object
    within BioPlayerController
    config(Game)
    native;

enum EGeneralSelectionMode
{
    BIO_SELECTION_MODE_INACTIVE,
    BIO_SELECTION_MODE_NORMAL,
    BIO_SELECTION_MODE_SPECTATOR,
};

var config float SelectionCloseAngle;

var config float SelectionCloseRange;

var config float SelectionFarAngle;

var config float SelectionFarRange;

var /* 00000008 */ LensFlareComponent SelectionFlareComp;

var transient bool m_bCurrentSelectionObstructed;

var transient bool m_bCurrentSelectionIsCombatTarget;

var Actor m_oLastSelectionTarget;

var Actor m_oCurrentSelectionTarget;

var EGeneralSelectionMode m_ePreviousSelectionMode;

var EGeneralSelectionMode m_eCurrentSelectionMode;

var array<Actor> m_lSelectionsInRange;

native final private function FindCurrentSelectionTarget();

native final function UpdateSelection();

function bool IsSelectable(Actor oTarget)
{
    if (oTarget == None)
    {
        return false;
    }
    if (m_eCurrentSelectionMode == 2)
    {
        return true;
    }
    return Outer.IsCombatTargetable(oTarget) || Outer.IsExploreTargetable(oTarget);
}

native final function SetSelectionIconMaterialParam(Name Param, int Value);

defaultproperties
{
    SelectionFlareComp=SFXSelectionLensFlareComponent'SelectionFlare0'
    SelectionFarRange=3200
    SelectionFarAngle=10
    SelectionCloseRange=1500
    SelectionCloseAngle=30
    // child object SelectionFlare0 of type SFXSelectionLensFlareComponent
}
