﻿class BioPower extends BioAttributes
    hidecategories(Object,BioBaseComponent,BioCoreBaseObject,Debug)
    native;

enum EBioPowerResource
{
    BIO_POWER_RESOURCE_VFX_PLAYER_CRUST,
    BIO_POWER_RESOURCE_VFX_PLAYER_MATERIAL,
    BIO_POWER_RESOURCE_VFX_TARGET_CRUST,
    BIO_POWER_RESOURCE_VFX_TARGET_MATERIAL,
    BIO_POWER_RESOURCE_VFX_FRAMEBUFFER,
    BIO_POWER_RESOURCE_VFX_TRAVELLING,
    BIO_POWER_RESOURCE_VFX_IMPACT,
    BIO_POWER_RESOURCE_VFX_WORLD_IMPACT,
    BIO_POWER_RESOURCE_VFX_RELEASE,
    BIO_POWER_RESOURCE_VFX_CASTING_BEAM,
    BIO_POWER_RESOURCE_CASTING,
    BIO_POWER_RESOURCE_RELEASE,
};

enum EBioPowerType
{
    BIO_POWER_TYPE_UNKNOWN,
    BIO_POWER_TYPE_CYLINDER,
    BIO_POWER_TYPE_TARGET,
    BIO_POWER_TYPE_PARTY,
    BIO_POWER_TYPE_IMPACT_VOLUME,
    BIO_POWER_TYPE_MELEE,
};

var transient int m_nSuppressedCount;

var float m_fCooldownRemaining;

var float m_fTotalCooldownTime;

var String m_sRTPCName;

var transient bool m_bDisableAnimation;

var transient bool m_bDisableDamageAndEffects;

var transient bool m_bDisableVFX;

var transient bool m_bFakePower;

var SFXPower NewPower;

var() Controller Instigator;

var() BioPowerScript Script;

var Name m_nmPower;

native function float GetCastingTime();

native function float GetReleaseAnimRate();

native function float GetCooldownTime();

native function float GetGlobalCooldown();

native function float GetProjectileSpeed();

native function float GetProjectileRadius();

native function float GetMinimumRange();

native function float GetMaximumRange();

native function float GetImpactRadius();

native function float GetEffectDuration();

native function float GetVFXIntensity();

native function float GetConeHalfAngle();

native function bool GetBlockedByObjects();

native function bool GetStopOnFirstHit();

native function EBioCapabilityTypes GetCapabilityType();

native function EBioCapMode GetDiscipline();

native function InitializePower(Name nmPower);

native final function CreatePowerScript();

native function bool CreateVisualEffect(EBioPowerResource eResource, out BioVisualEffect pEffect);

native function EndVisualEffect(EBioPowerResource eResource, optional bool bAllowVFXToFinish);

native function BioVFXTemplate GetVFXTemplate(EBioPowerResource eResource);

native function float GetVFXLifetime(EBioPowerResource eResource, float fCastingTimeRemaining);

native function DoImpactVFX(EBioPowerResource ImpactType, Actor oActor, Vector vLocation, Vector vHitNormal, float fCastingTimeRemaining, optional Name BoneName);

native function bool GetAnimSet(out AnimSet oAnimSet);

native function bool GetProjectileAttachPoint(Pawn pPawn, out Vector vAttachPoint);

native function EBioPowerType GetType();

native function bool IsEnabled();

native function int SuppressPower(bool bSuppress);

native function bool IsSuppressed();

native function float GetCooldownRemaining();

native function SetCooldownRemaining(float fCooldownRemaining);

native function float GetTotalCooldownTime();

native function SetTotalCooldownTime(float fTotalCooldown);

native function Tick(float fDeltaTime);

native function bool CanCasterMoveDuringPower();

native function bool IsActive();

native function bool CancelPower();

native function float GetReleaseNoise();

native function float GetImpactNoise();

native function int GetPowerIcon();

native function bool GetDisplayName(out String sDisplayName);

native function bool GetImpactText();

native function bool GetDescription(out String sDescription);

native function bool ShouldDisplayInHUD();

event float GetDifficultyCooldownMultiplier()
{
    return SFXGame(Owner.WorldInfo.Game).Difficulty.GetCooldownMultiplier(Owner);
}

defaultproperties
{
    m_sRTPCName="Power_Rank"
}
