﻿class BioProjectile extends Projectile
    hidecategories(Navigation)
    native;

var /* 00000008 */ BioProjectilePhysicsCollisionContext m_oPhysicsCollisionContext;

var bool m_bEnablePhysicsTouch;

struct native BioProjectilePhysicsCollisionContext
{
    var Actor m_oActor;

    var Vector m_vHitLocation;

    var Vector m_vHitNormal;

}

native final private function bool IsValidTarget(Actor oActor);

simulated function Explode(Vector vHitLocation, Vector vHitNormal)
{
    local Actor pIgnoredActor_None;
    local Controller pInstigatorController;
    local bool bDoFullDamage_FALSE;
    pIgnoredActor_None = None;
    pInstigatorController = Instigator != None ? Instigator.Controller : None;
    bDoFullDamage_FALSE = false;
    HurtRadius(Damage, DamageRadius, Class'SFXDamageType_Explosion', MomentumTransfer, vHitLocation, pIgnoredActor_None, pInstigatorController, bDoFullDamage_FALSE);
    Destroy();
}

simulated function ProcessTouch(Actor oOther, Vector vHitLocation, Vector vHitNormal)
{
    local TraceHitInfo HitInfo;
    local Actor pDamageCausingActor_Owner;
    if (IsValidTarget(oOther))
    {
        if (DamageRadius > 0)
        {
            Explode(vHitLocation, vHitNormal);
        }
        else
        {
            pDamageCausingActor_Owner = Owner;
            oOther.TakeDamage(Damage, InstigatorController, vHitLocation, MomentumTransfer * Normal(Velocity), MyDamageType, HitInfo, pDamageCausingActor_Owner);
            Destroy();
        }
    }
}

event ProcessPhysicsTouch(Actor oOther, Vector vHitLocation, Vector vHitNormal)
{
    m_oPhysicsCollisionContext.m_oActor = oOther;
    m_oPhysicsCollisionContext.m_vHitLocation = vHitLocation;
    m_oPhysicsCollisionContext.m_vHitNormal = vHitNormal;
    GotoState('CollidedDueToPhysics');
}

state Standard
{
}

state CollidedDueToPhysics
{
Begin:
    ProcessTouch(m_oPhysicsCollisionContext.m_oActor, m_oPhysicsCollisionContext.m_vHitLocation, m_oPhysicsCollisionContext.m_vHitNormal);
    GotoState('Standard');
}

defaultproperties
{
    Speed=5000
    MaxSpeed=5000
    Damage=12,78
    DamageRadius=0
    CylinderComponent=None
    Components=None
    // child object CollisionCylinder of type CylinderComponent
    // child object SkelMeshComponent0 of type SkeletalMeshComponent
}
