﻿class BioSFHandler_Achievement extends BioSFHandler
    config(UI)
    transient;

// srEmpty: StringRefProperty[44]
var bool m_bFromMainMenu;

var int m_nShiftItemIndex;

var int m_nSelectedItemIndex;

const MaxIcons = 8;
const CloseAchievement = 1;
const Initialize = 2;
const NextItem = 3;
const PrevItem = 4;
const UpdateItemList = 5;
const DumpDebug = 6;
function SetFromMainMenu()
{
    m_bFromMainMenu = true;
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    switch (nCommand)
    {
        case 5:
            PopulateAchievementItemListEntry(0);
            break;
        case 1:
            if (m_bFromMainMenu)
            {
                MassEffectGuiManager(oPanel.oParentManager).ShowMainMenu(6);
                oPanel.oParentManager.RemovePanel(oPanel, true);
            }
            else
            {
                MassEffectGuiManager(oPanel.oParentManager).HideAchievementGui();
            }
            break;
        case 2:
            Init();
            PopulateAchievementItemList();
            break;
        case 6:
            break;
    }
}

final function Init()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 0;
    stParam.nVar = ScreenLayout;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("initialize", lstParams);
}

final function PopulateAchievementItemList()
{
    local BioPlayerController PC;
    local SFXProfileSettings Profile;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local int idx;
    PC = BioPlayerController(GetPlayerController());
    if (PC != None)
    {
        Profile = PC.ProfileSettings;
    }
    if (Profile != None)
    {
        stParam.Type = 0;
        stParam.nVar = Profile.StaticAchievementData.Length;
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("createList", lstParams);
        idx = 0;
        while (idx < Profile.StaticAchievementData.Length)
        {
            PopulateAchievementItemListEntry(idx);
            idx++;
        }
    }
}

final function PopulateAchievementItemListEntry(int nDisplayIndex)
{
    local BioPlayerController PC;
    local SFXProfileSettings Profile;
    local AchievementData Achievement;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local bool bEarned;
    PC = BioPlayerController(GetPlayerController());
    if (PC != None)
    {
        Profile = PC.ProfileSettings;
    }
    if (Profile != None)
    {
        Achievement = Profile.StaticAchievementData[nDisplayIndex];
        stParam.Type = 0;
        stParam.nVar = nDisplayIndex;
        lstParams.AddItem(stParam);
        stParam.Type = 2;
        stParam.sVar = Achievement.Icon;
        lstParams.AddItem(stParam);
        bEarned = Profile.HasCompletedAchievement(Achievement.AchievementId);
        stParam.Type = 3;
        stParam.bVar = bEarned;
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = Achievement.Title;
        lstParams.AddItem(stParam);
        ClearCustomTokens();
        SetCustomToken(0, Profile.GetAchievementRequirement(Achievement.AchievementId));
        stParam.Type = 2;
        stParam.sVar = Class'SFXGame'.GetSimpleString(bEarned ? Achievement.Complete : Achievement.Incomplete, true);
        ClearCustomTokens();
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = Profile.GetAchievementStatus(Achievement.AchievementId);
        lstParams.AddItem(stParam);
        stParam.nVar = Profile.GetAchievementRequirement(Achievement.AchievementId);
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("contentHold.PopulateAchievementItem", lstParams);
    }
}

defaultproperties
{
    nHandlerID=18
}
