﻿class BioSFHandler_BrowserWheel extends BioSFHandler
    config(UI)
    transient
    native;

const PickSegment = 1;
const CloseMenu = 2;
const BWInitialized = 3;
const GotoMainMenu = 4;
const ConfirmMainMenu = 5;
const PExitGame = 6;
const ConfirmExit = 7;
const srExitConfirm = 176289;
const srMainMenuConfirm = 176290;
const srConfirm = 153362;
const srCancel = 153363;
var /* 00000008 */ SFXPowerLevelUpHelper m_Helper;

var config array<BWPageStruct> lstPages;

var float fLastRadius;

var Vector vInput;

struct native BWPageStruct
{
    var Name Tag;

// srLabel: StringRefProperty[44]
    var BioSFHandler oHandler;

    var MEBrowserWheelSubPages Type;

}

final event ShowSelectedPanel(int nPanel, optional BioSFManager oManager)
{
    local MassEffectGuiManager oGuiMan;
    local BioSFPanel oNewPanel;
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    if (oManager == None)
    {
        oGuiMan = MassEffectGuiManager(oPanel.oParentManager);
    }
    else
    {
        oGuiMan = MassEffectGuiManager(oManager);
    }
    if (lstPages.Length - 1 >= nPanel)
    {
        switch (lstPages[nPanel].Type)
        {
            case 7:
                oMsgBox = oGuiMan.CreateMessageBox();
                oMsgBox.SetInputDelegate(MainMenuConfirm);
                stParams.srAText = // unknown bytecode 4F ;
        }
    }
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    switch (nCommand)
    {
        case 1:
            oPanel.oParentManager.AddEventCooldown(9, 0,5);
            oPanel.oParentManager.AddEventCooldown(10, 0,5);
            oPanel.oParentManager.AddEventCooldown(11, 0,5);
            oPanel.oParentManager.AddEventCooldown(8, 0,5);
            ShowSelectedPanel(lstArguments[0]);
            break;
        case 2:
            MassEffectGuiManager(oPanel.oParentManager).HideBrowserWheel();
            break;
        case 3:
            InitializeBrowser();
            break;
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 2:
            vInput.X = fValue;
            break;
        case 3:
            vInput.Y = fValue;
            break;
        case 15:
            BioPlayerController(MassEffectGuiManager(oPanel.oParentManager).Player).ConsoleCommand("StartIngamePropertyEditor 1");
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function Update(float fDeltaT)
{
    local Rotator R;
    local float fRadius;
    local ASParams stParam;
    local array<ASParams> lstParams;
    if (Abs(vInput.X) > 0,25 || Abs(vInput.Y) > 0,25)
    {
        fRadius = Square(vInput.X) + Square(vInput.Y);
        if (fRadius >= fLastRadius || fRadius > 0,9)
        {
            R = vInput;
            stParam.Type = 0;
            stParam.nVar = R.Yaw * 0,005493164;
            if (stParam.nVar < 0)
            {
                stParam.nVar += 360;
            }
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("setArrowPosition", lstParams);
        }
        fLastRadius = fRadius;
    }
    else
    {
        fLastRadius = 0;
    }
}

final function DetermineSquadUpdateStatus()
{
    local int I;
    local int nSquadSize;
    local bool bAlert;
    local BioPawn oPawn;
    local BioPlayerSquad oSquad;
    local BioWorldInfo oBWI;
    oBWI = BioWorldInfo(oWorldInfo);
    oSquad = oBWI.m_playerSquad;
    if (oSquad == None || oSquad.IsFieldingInitialPlayerPawn() == false)
    {
        oBWI.m_lstBrowserAlerts[2] = 2;
        return;
    }
    bAlert = false;
    nSquadSize = oSquad.GetSquadSize();
    I = 0;
    while (I < nSquadSize)
    {
        oPawn = BioPawn(oSquad.GetMember(I));
        if (oPawn != None)
        {
            m_Helper.SetPawn(oPawn);
            if (m_Helper.CanMakePurchase())
            {
                bAlert = true;
                break;
            }
        }
        I++;
    }
    oBWI.m_lstBrowserAlerts[2] = bAlert ? 1 : 0;
}

native final function DetermineJournalCodexUpdateStatus();

final function InitializeBrowser()
{
    local BioWorldInfo oBWI;
    local BioPlayerController PC;
    local int I;
    local String sReason;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local SubPageState oSubPageState;
    local bool bAbleToSave;
    local bool bAbleToLoad;
    local int nIndex;
    local BioBrowserStates StateWithOverride;
    oBWI = BioWorldInfo(oWorldInfo);
    m_Helper.Initialize(oBWI);
    PC = BioPlayerController(oPanel.oParentManager.GetPlayerController());
    bAbleToSave = PC != None ? PC.CanSave(sReason) : false;
    if (bAbleToSave == false)
    {
        oBWI.m_lstBrowserAlerts[1] = 2;
    }
    else
    {
        oBWI.m_lstBrowserAlerts[1] = 0;
    }
    bAbleToLoad = true;
    if (Class'WorldInfo'.IsConsoleBuild(0) && PC != None)
    {
        bAbleToLoad = PC.GetLoginStatus() != 0;
    }
    if (bAbleToLoad)
    {
        oBWI.m_lstBrowserAlerts[3] = 0;
    }
    else
    {
        oBWI.m_lstBrowserAlerts[3] = 2;
    }
    DetermineSquadUpdateStatus();
    DetermineJournalCodexUpdateStatus();
    if (MassEffectGuiManager(oPanel.oParentManager).GetAreaMapData() == None)
    {
        oBWI.m_lstBrowserAlerts[0] = 2;
    }
    else
    {
        oBWI.m_lstBrowserAlerts[0] = 0;
    }
    stParam.Type = 0;
    stParam.nVar = MassEffectGuiManager(oPanel.oParentManager).m_eLastBrowserWheelSubPage;
    lstParams.AddItem(stParam);
    I = 0;
    while (I < lstPages.Length)
    {
        stParam.Type = 2;
        stParam.sVar = lstPages[I].srLabel;
        lstParams.AddItem(stParam);
        StateWithOverride = oBWI.m_lstBrowserAlerts[lstPages[I].Type];
        nIndex = 0;
        while (nIndex < oBWI.SubPageStateOverrides.Length)
        {
            oSubPageState = oBWI.SubPageStateOverrides[nIndex];
            if (oSubPageState.Page == 0)
            {
            }
            else
            {
                if (oSubPageState.Page == lstPages[I].Type)
                {
                    if (oSubPageState.Page != 1 || bAbleToSave == true)
                    {
                        StateWithOverride = oSubPageState.State;
                    }
                    else
                    {
                        jump 820;
                    }
                }
            }
            nIndex++;
        }
        stParam.Type = 0;
        stParam.nVar = StateWithOverride;
        lstParams.AddItem(stParam);
        I++;
    }
    oPanel.InvokeMethodArgs("initBrowser", lstParams);
    SetResourceValues();
    return;
}

function SetResourceValues()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local PlayerController PC;
    local BioPawn oPlayerPawn;
    local SFXInventoryManager oInventory;
    local SFXHeavyWeapon oWeap;
    PC = BioWorldInfo(oWorldInfo).GetLocalPlayerController();
    if (PC != None)
    {
        oPlayerPawn = BioPawn(PC.Pawn);
    }
    if (oPlayerPawn == None)
    {
        return;
    }
    oInventory = SFXInventoryManager(oPlayerPawn.InvManager);
    if (oInventory == None)
    {
        return;
    }
    stParam.nVar = oInventory.GetResource(0);
    lstParams.AddItem(stParam);
    stParam.nVar = oInventory.GetResource(1);
    lstParams.AddItem(stParam);
    stParam.nVar = 0;
    foreach oPlayerPawn.InvManager.InventoryActors(Class'SFXHeavyWeapon', oWeap)
    {
        stParam.nVar = oWeap.GetCurrentTotalAmmo();
        break;
    }
    lstParams.AddItem(stParam);
    stParam.nVar = oInventory.GetResource(6);
    lstParams.AddItem(stParam);
    stParam.nVar = oInventory.GetResource(5);
    lstParams.AddItem(stParam);
    stParam.nVar = oInventory.GetResource(7);
    lstParams.AddItem(stParam);
    stParam.nVar = oInventory.GetResource(4);
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("SetResourceCounts", lstParams);
}

function MainMenuConfirm(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        MassEffectGuiManager(oPanel.oParentManager).ClearAll();
        MassEffectGuiManager(oPanel.oParentManager).HackReloadMainMenu();
    }
}

function ExitGame();

function OnPanelAdded()
{
    oPanel.bUseThumbstickAsDPad = false;
}

function OnPanelRemoved()
{
    OnPanelRemoved();
    fLastRadius = 0;
}

defaultproperties
{
    lstPages=System.Byte[]
    m_Helper=SFXPowerLevelUpHelper'oHelper'
    nHandlerID=21
    // child object oHelper of type SFXPowerLevelUpHelper
}
