﻿class BioSFHandler_DesignerUI extends BioSFHandler
    transient
    native;

enum BioDUIElements
{
    BIO_DUI_PassiveTimer,
    BIO_DUI_PassiveCounter,
    BIO_DUI_PassiveText,
    BIO_DUI_PassiveBar,
    BIO_DUI_PassiveBarMarker1,
    BIO_DUI_PassiveBarMarker2,
    BIO_DUI_ModalBar,
    BIO_DUI_ModalBarMarker1,
    BIO_DUI_ModalBarMarker2,
    BIO_DUI_ModalCounter,
    BIO_DUI_ModalTimer,
    BIO_DUI_ModalText,
    BIO_DUI_ModalBackground,
    BIO_DUI_ButtonA,
    BIO_DUI_ButtonAText,
    BIO_DUI_ButtonB,
    BIO_DUI_ButtonBText,
    BIO_DUI_ButtonX,
    BIO_DUI_ButtonXText,
    BIO_DUI_ButtonY,
    BIO_DUI_ButtonYText,
    BIO_DUI_ModalBackground2,
};

struct native BioDUITimerDetails
{
    var float fCurTime;

    var float fEndTime;

    var float fIntervalTime;

    var float fNextInterval;

    var bool bIncrementing;

    var bool bIntervalTriggered;

    var bool bCompleted;

    var bool bRunning;

    var bool bActive;

    var bool bFirstUpdate;

}

struct native BioDUIPulseDetails
{
    var BioDUIElements nElement;

    var float fHalfCycleTime;

    var float fMinAlpha;

    var float fCurCycle;

}

struct native BioDUIElementStatus
{
    var bool bVisible;

    var bool bFading;

}

var int m_nLayout;

var int nElementVisibleCount;

var BioDUIElementStatus lstElementStatus[22];

var array<BioDUIPulseDetails> lstPulsingElements;

var BioDUITimerDetails stPassiveTimer;

var BioDUITimerDetails stModalTimer;

var bool m_bCanInvoke;

native function ClearAll(bool bModal);

native function bool IsActive(bool bModal);

native function SetElementVisible(BioDUIElements nElement, bool bVisible, optional float fFadeTime);

native function SetElementColor(BioDUIElements nElement, const out Color stColor);

native function SetElementAlpha(BioDUIElements nElement, float fAlpha);

native function int SetupElementPulse(BioDUIElements nElement, float fMinAlpha, float fCycleTime);

native function ClearElementPulse(BioDUIElements nElement);

native function SetTextStringRef(BioDUIElements nElement);

native function SetElementText(BioDUIElements nElement, const out String sText);

native function SetCounterValue(bool bModalCounter, int nValue);

native function SetBarMarkerPoints(bool bModalBar, int nMarker1, int nMarker2);

native function SetBarFillPercent(bool bModalBar, int nPercent);

native function SetBarFillDirection(bool bModalBar, bool bLeftToRight);

native function SetQuasarLayout(bool bShow);

native function bool IsQuasarLayout();

native function SetTimerDetails(bool bModalTimer, float fStartTime, float fEndTime, float fInterval);

native function float GetTimerValue(bool bModalTimer);

native function ExIntInitialize();

function OnPanelAdded()
{
    oPanel.IsVisible = nElementVisibleCount > 0;
    oPanel.SetExternalInterface(self);
    oPanel.SetInputDisabled(true);
}

defaultproperties
{
    m_nLayout=1
    bSetGameMode=false
}
