﻿class BioSFHandler_MessageBox extends BioSFHandler
    transient
    native;

enum BioMessageBoxIconSets
{
    ICONSET_None,
    ICONSET_Manufacturer,
    ICONSET_Combat,
    ICONSET_Plot,
    ICONSET_ItemProperties,
};

enum SFXHintPosition
{
    SFXHINTPOS_Top,
    SFXHINTPOS_Middle,
    SFXHINTPOS_Bottom,
};

enum SFXXBoxHintIcon
{
    XBICON_None,
    XBICON_XBOX_A,
    XBICON_XBOX_B,
    XBICON_XBOX_Y,
    XBICON_XBOX_X,
    XBICON_XBOX_Right_Thumb,
    XBICON_XBOX_Right_Thumb_Pressed,
    XBICON_XBOX_Right_Thumb_Released,
    XBICON_XBOX_Left_Thumb,
    XBICON_XBOX_Left_Thumb_Pressed,
    XBICON_XBOX_Left_Thumb_Released,
    XBICON_XBOX_Right_Thumb_Up,
    XBICON_XBOX_Right_Thumb_UpRight,
    XBICON_XBOX_Right_Thumb_Right,
    XBICON_XBOX_Right_Thumb_DownRight,
    XBICON_XBOX_Right_Thumb_Down,
    XBICON_XBOX_Right_Thumb_DownLeft,
    XBICON_XBOX_Right_Thumb_Left,
    XBICON_XBOX_Right_Thumb_UpLeft,
    XBICON_XBOX_Left_Thumb_Up,
    XBICON_XBOX_Left_Thumb_UpRight,
    XBICON_XBOX_Left_Thumb_Right,
    XBICON_XBOX_Left_Thumb_DownRight,
    XBICON_XBOX_Left_Thumb_Down,
    XBICON_XBOX_Left_Thumb_DownLeft,
    XBICON_XBOX_Left_Thumb_Left,
    XBICON_XBOX_Left_Thumb_UpLeft,
    XBICON_XBOX_DPad,
    XBICON_XBOX_DPad_Up,
    XBICON_XBOX_DPad_Right,
    XBICON_XBOX_DPad_Down,
    XBICON_XBOX_DPad_Left,
    XBICON_XBOX_Start,
    XBICON_XBOX_Back,
    XBICON_XBOX_Right_Shoulder,
    XBICON_XBOX_Right_Trigger,
    XBICON_XBOX_Left_Shoulder,
    XBICON_XBOX_Left_Trigger,
};

enum SFXPS3HintIcon
{
    PS3ICON_None,
};

enum SFXPCHintIcon
{
    PCICON_None,
};

enum SFXGenericHintIcon
{
    HINTICON_None,
};

enum SFX_MB_Skin
{
    SFX_MB_Skin_User,
    SFX_MB_Skin_Shepard,
};

enum SFX_MB_TextAlign
{
    SFX_MB_Centered,
    SFX_MB_Left,
    SFX_MB_Right,
};

struct native BioMessageBoxOptionalParams
{
// srAText: StringRefProperty[44]
// srBText: StringRefProperty[44]
    var bool bNoFade;

    var BioMessageBoxIconSets nIconSet;

    var int nIconIndex;

    var bool bModal;

    var bool bForcePlayersOnly;

    var SFX_MB_Skin m_SkinType;

    var SFX_MB_TextAlign m_TextAlign;

}

var transient float m_fRScrollValue;

var transient int m_nHiddenDepth;

var transient bool m_bCached;

var transient bool m_bInitialPlayersOnly;

var transient bool m_bForcePlayersOnly;

var transient bool m_bIsModal;

var transient bool bShowMouse;

var BioSFManager m_oBackupSFMgr;

var bool bHandleInput;

var int nInputCallbackContext;

delegate InputCallback(bool bAPressed, int nContext);

delegate UpdateCallback(float fDeltaT, BioSFHandler_MessageBox oMsgBox);

delegate UpdateCallbackEx(float fDeltaT, Object oMsgBox);

native final function SetInputDelegate(delegate<InputCallback> pDelegate, optional int nContext);

native final function SetUpdateDelegate(delegate<UpdateCallback> pDelegate);

native final function DisplayMessageBox(const out BioMessageBoxOptionalParams stParams);

native final function DisplayMessageBoxEx(String sMessage, const out BioMessageBoxOptionalParams stParams);

native final function DisplayQuickMessageBox(const out BioMessageBoxOptionalParams stParams);

native final function DisplayQuickMessageBoxEx(String sMessage, const out BioMessageBoxOptionalParams stParams);

native final function HideMessageBox(optional bool bRemove, optional bool bSkipFade);

function DisplayHintMessage(int nIcon, SFXHintPosition ePosition)
{
    local array<ASParams> aParams;
    aParams.Length = 3;
    aParams[0].Type = 2;
    aParams[0].sVar = "" $ srMessage;
    aParams[1].Type = 0;
    aParams[1].nVar = ePosition;
    aParams[2].Type = 0;
    aParams[2].nVar = ScreenLayout;
    oPanel.InvokeMethodArgs("ShowHintMessage", aParams);
    bShowMouse = false;
}

function OnPanelAdded()
{
    oPanel.SetInputDisabled(true);
    oPanel.UpdateAspectRatio(true);
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 5:
            if (Abs(fValue) > 0,25)
            {
                m_fRScrollValue = -fValue;
            }
            else
            {
                m_fRScrollValue = 0;
            }
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

defaultproperties
{
    bShowMouse=true
    nHandlerID=24
    bSetGameMode=false
}
