﻿class BioSFHandler_PCNewCharacter extends BioSFHandler_NewCharacter
    config(GuiResources)
    transient
    native;

const CONST_SetCustomName = 19;
const CONST_CopyCode = 22;
const CONST_PasteCode = 23;
var float fLookAtLimit;

var float fLookAtThreshold;

var float fLookAtThresholdAhead;

var float fScrollValueMouse;

var bool bHeadLookEnabled;

native function ClipboardCopy(String sString);

native function String ClipboardPaste();

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    local String szName;
    switch (nCommand)
    {
        case 19:
            if (lstArguments.Length < 1)
            {
                szName = "";
            }
            else
            {
                szName = lstArguments[0];
            }
            if (m_bMaleSelected)
            {
                m_sMaleName = szName;
            }
            else
            {
                m_sFemaleName = szName;
            }
            SetCustomName(m_sMaleName, m_sFemaleName);
            break;
        case 22:
            ClipboardCopy(m_sCode);
            break;
        case 23:
            ApplyNewCode(ClipboardPaste());
            SetSliderPositions();
            UpdateCode();
            break;
    }
    HandleEvent(nCommand, lstArguments);
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    switch (Event)
    {
        case 47:
            bHeadLookEnabled = true;
            fLookAtUpDownValue = 0;
            fLookAtLeftRightValue = 0;
            stParam.Type = 3;
            stParam.bVar = true;
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("DissableMouseEvents", lstParams);
            SetMouseShown(false);
            break;
        case 49:
            bHeadLookEnabled = false;
            fLookAtUpDownValue = 0;
            fLookAtLeftRightValue = 0;
            stParam.Type = 3;
            stParam.bVar = false;
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("DissableMouseEvents", lstParams);
            SetMouseShown(true);
            break;
        case 7:
            if (bHeadLookEnabled)
            {
                HandleLookAtUpDownMouse(fValue);
            }
            break;
        case 6:
            if (bHeadLookEnabled)
            {
                HandleLookAtLeftRightMouse(fValue);
            }
            break;
    }
    HandleInputEvent(Event, fValue);
}

function HandleLookAtUpDownMouse(float fValue)
{
    if (!bZoomedInOnFace)
    {
        return;
    }
    fLookAtUpDownValue += fValue;
    fLookAtUpDownValue = FClamp(fLookAtUpDownValue, -fLookAtLimit, fLookAtLimit);
}

function HandleLookAtLeftRightMouse(float fValue)
{
    if (!bZoomedInOnFace)
    {
        return;
    }
    fLookAtLeftRightValue += fValue;
    fLookAtLeftRightValue = FClamp(fLookAtLeftRightValue, -fLookAtLimit, fLookAtLimit);
}

function HandleLookAtUpDown(float fValue);

function HandleLookAtLeftRight(float fValue);

event Update(float fDeltaT)
{
    if (!bHeadLookEnabled)
    {
        SetMouseShown(true);
    }
    Update(fDeltaT);
}

function UpdateLookAtTarget()
{
    local float LookThreshold;
    if (bZoomedInOnFace)
    {
        if (CurrentLookAtTarget == 0)
        {
            LookThreshold = fLookAtThresholdAhead;
        }
        else
        {
            LookThreshold = fLookAtThreshold;
        }
        if (Abs(fLookAtUpDownValue) > Abs(fLookAtLeftRightValue))
        {
            if (fLookAtUpDownValue < -LookThreshold)
            {
                NextLookAtTarget = CurrentLookAtTarget == 3 ? 0 : 4;
            }
            else
            {
                if (fLookAtUpDownValue > LookThreshold)
                {
                    NextLookAtTarget = CurrentLookAtTarget == 4 ? 0 : 3;
                }
            }
        }
        else
        {
            if (fLookAtLeftRightValue < -LookThreshold)
            {
                NextLookAtTarget = CurrentLookAtTarget == 2 ? 0 : 1;
            }
            else
            {
                if (fLookAtLeftRightValue > LookThreshold)
                {
                    NextLookAtTarget = CurrentLookAtTarget == 1 ? 0 : 2;
                }
            }
        }
    }
    UpdateLookAtTarget();
}

defaultproperties
{
    fLookAtThresholdAhead=110
    fLookAtThreshold=40
    fLookAtLimit=200
    ScreenLayout=System.Byte[]
}
