﻿class BioSeqAct_AOECauseDamage extends SequenceAction
    hidecategories(Object);

var Actor InstigatorController;

var() float MomentumScale;

var() bool bForceCinematicDamage;

var() bool bDamageFalloff;

var() class<SFXDamageType> DamageType;

var() float DamageRadius;

var() float DamageAmount;

var() /* 00000008 */ BioDamageType m_pDamage;

function Activated()
{
    local Controller Instigator;
    local BioWorldInfo WorldInfo;
    local Object ChkObject;
    local Actor ChkTarget;
    local Actor DamageActor;
    local Vector ToDamageActor;
    local float Distance;
    Instigator = Controller(InstigatorController);
    if (Pawn(InstigatorController) != None)
    {
        Instigator = Pawn(InstigatorController).Controller;
    }
    WorldInfo = BioWorldInfo(GetWorldInfo());
    WorldInfo.m_bForceCinematicDamage = bForceCinematicDamage;
    foreach Targets(ChkObject)
    {
        ChkTarget = Actor(ChkObject);
        if (Controller(ChkObject) != None)
        {
            ChkTarget = Controller(ChkObject).Pawn;
        }
        if (ChkTarget != None)
        {
            foreach ChkTarget.CollidingActors(Class'Actor', DamageActor, DamageRadius, true)
            {
                ToDamageActor = DamageActor.Location - ChkTarget.Location;
                Distance = VSize(ToDamageActor);
                ToDamageActor = Normal(ToDamageActor);
                if (bDamageFalloff)
                {
                    DamageAmount *= 1 - Distance / DamageRadius;
                    ToDamageActor *= 1 - Distance / DamageRadius;
                }
                DamageActor.TakeDamage(DamageAmount, Instigator, ChkTarget.Location, ToDamageActor * MomentumScale, DamageType);
            }
        }
    }
    WorldInfo.m_bForceCinematicDamage = false;
}

defaultproperties
{
    DamageRadius=200
    MomentumScale=500
    bCallHandler=false
    VariableLinks=None
}
