﻿class BioSeqAct_AdjustCostForDiscount extends SequenceAction
    hidecategories(Object);

var() Name nmLevel;

var() ETreasureType TreasureType;

var() bool bDiscount;

var() int nDiscountedPrice;

var() int nState;

var() int nPrice;

function Activated()
{
    local SFXInventoryManager oInv;
    local int CashAmount;
    local BioWorldInfo oWorldInfo;
    local SFXPlotTreasure oTreasure;
    local STreasure stTreasure;
    Activated();
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oTreasure = oWorldInfo.m_oTreasure;
    if (nmLevel == 'None')
    {
        nmLevel = oTreasure.CurrentLevel();
    }
    stTreasure = oTreasure.TREASURE(nState);
    nDiscountedPrice = 0;
    if (stTreasure.nmTreasure != 'None')
    {
        nDiscountedPrice = oTreasure.Price(nState, bDiscount);
        switch (TreasureType);
        case 2;
        nDiscountedPrice = stTreasure.Resource == 0 ? nDiscountedPrice : 0;
        jump 454;
        case 3;
        nDiscountedPrice = stTreasure.Resource == 4 ? nDiscountedPrice : 0;
        jump 454;
        case 5;
        nDiscountedPrice = stTreasure.Resource == 5 ? nDiscountedPrice : 0;
        jump 454;
        case 4;
        nDiscountedPrice = stTreasure.Resource == 6 ? nDiscountedPrice : 0;
        jump 454;
        case 6;
        nDiscountedPrice = stTreasure.Resource == 7 ? nDiscountedPrice : 0;
        jump 454;
        default;
        nDiscountedPrice = 0;
    }
    else
    {
        nDiscountedPrice = nPrice;
        if (bDiscount)
        {
            nDiscountedPrice = nPrice / Class'SFXPlotTreasure'.Default.fFullPriceMultiplier;
        }
    }
    oInv = SFXInventoryManager(SFXPawn(BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController().Pawn).InvManager);
    switch (TreasureType)
    {
        case 2:
            CashAmount = oInv.GetResource(0);
            break;
        case 3:
            CashAmount = oInv.GetResource(4);
            break;
        case 4:
            CashAmount = oInv.GetResource(6);
            break;
        case 6:
            CashAmount = oInv.GetResource(7);
            break;
        case 5:
            CashAmount = oInv.GetResource(5);
            break;
    }
    OutputLinks[0].bHasImpulse = CashAmount >= nDiscountedPrice;
    OutputLinks[1].bHasImpulse = !OutputLinks[0].bHasImpulse;
    return;
}

defaultproperties
{
    TreasureType=CREDITS_TREASURE
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
