﻿class BioSeqAct_AwardTreasure extends SequenceAction
    hidecategories(Object)
    native;

var Texture2D oImageResource;

var() bool bDiscount;

var() int nState;

function Activated()
{
    local BioWorldInfo oWorldInfo;
    local SFXPlotTreasure oTreasure;
    local bool bAwardedLoot;
    Activated();
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oTreasure = oWorldInfo.m_oTreasure;
    bAwardedLoot = oTreasure.AwardTreasure(nState, bDiscount);
    OutputLinks[0].bHasImpulse = bAwardedLoot;
    OutputLinks[1].bHasImpulse = !OutputLinks[0].bHasImpulse;
}

event String GetTreasureImageResourcePath()
{
    local String sImageResource;
    local int nTreasureId;
    if (VariableLinks.Length < 1)
    {
        return "";
    }
    nTreasureId = SeqVar_Int(VariableLinks[0].LinkedVariables[0]).IntValue;
    if (Class'BioWorldInfo'.Default.m_oTreasure != None)
    {
        sImageResource = Class'SFXPlotTreasure'.GetTreasureImageResourcePath(nTreasureId);
    }
    return sImageResource;
}

defaultproperties
{
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
