﻿class BioSeqAct_GetShieldPercentage extends SequenceAction
    hidecategories(Object);

enum EShieldType
{
    EShieldType_All,
    EShieldType_Energy,
    EShieldType_Barrier,
    EShieldType_Armour,
};

var float m_fShieldCurrent;

var float m_fShieldMax;

var float m_fShieldPct;

var() EShieldType eType;

var() Actor m_oPawn;

function Activated()
{
    local Pawn ChkPawn;
    local SFXShield_Base Shield;
    local SFXShield_Energy EnergyShield;
    local SFXShield_Biotic BarrierShield;
    local SFXShield_Armour ArmourShield;
    m_fShieldPct = 0;
    m_fShieldMax = 0;
    m_fShieldCurrent = 0;
    ChkPawn = Pawn(m_oPawn);
    if (ChkPawn == None)
    {
        ChkPawn = Controller(m_oPawn).Pawn;
    }
    if (BioPawn(ChkPawn) == None)
    {
        return;
    }
    if (eType == 0)
    {
        foreach ChkPawn.InvManager.InventoryActors(Class'SFXShield_Base', Shield)
        {
            m_fShieldCurrent += Shield.CurrentShields;
            m_fShieldMax += Shield.MaxShields.Value;
        }
        m_fShieldPct = m_fShieldMax > 0 ? m_fShieldCurrent / m_fShieldMax : 0;
    }
    else
    {
        if (eType == 1)
        {
            foreach ChkPawn.InvManager.InventoryActors(Class'SFXShield_Energy', EnergyShield)
            {
                m_fShieldCurrent += EnergyShield.CurrentShields;
                m_fShieldMax += EnergyShield.MaxShields.Value;
            }
            m_fShieldPct = m_fShieldMax > 0 ? m_fShieldCurrent / m_fShieldMax : 0;
        }
        else
        {
            if (eType == 2)
            {
                foreach ChkPawn.InvManager.InventoryActors(Class'SFXShield_Biotic', BarrierShield)
                {
                    m_fShieldCurrent += BarrierShield.CurrentShields;
                    m_fShieldMax += BarrierShield.MaxShields.Value;
                }
                m_fShieldPct = m_fShieldMax > 0 ? m_fShieldCurrent / m_fShieldMax : 0;
            }
            else
            {
                if (eType == 3)
                {
                    foreach ChkPawn.InvManager.InventoryActors(Class'SFXShield_Armour', ArmourShield)
                    {
                        m_fShieldCurrent += ArmourShield.CurrentShields;
                        m_fShieldMax += ArmourShield.MaxShields.Value;
                    }
                    m_fShieldPct = m_fShieldMax > 0 ? m_fShieldCurrent / m_fShieldMax : 0;
                }
            }
        }
    }
}

defaultproperties
{
    bCallHandler=false
    VariableLinks=None
}
