﻿class BioSeqAct_OrbitalGame extends SeqAct_Latent
    hidecategories(Object);

var InterpActor ReticleBlinker;

var InterpActor ScanBeam;

var array<InterpActor> RingReticleSpinners;

var array<InterpActor> ScanIndicatorArray;

var InterpActor ScanIndicator;

var MaterialInstanceConstant ScanReticleMaterial;

var MaterialInstanceConstant ReticleMaterial;

var InterpActor RingReticle;

var transient BioPlanet CurrentPlanet;

var(Config) Rotator ReticleRotMinClamp;

var(Config) Rotator ReticleRotMaxClamp;

var(Config) Rotator ReticleRotStart;

var(Audio) WwiseBaseSoundObject AnomalyStaticStop;

var(Audio) WwiseBaseSoundObject AnomalyStaticStart;

var(Audio) array<WwiseBaseSoundObject> ProbeLaunchedVO;

var(Audio) array<WwiseBaseSoundObject> AnomalyDetectedVO;

var(Audio) String LandingSiteIndicator_RTPCName;

var(Audio) WwiseBaseSoundObject LandingSiteIndicator;

var(Audio) WwiseBaseSoundObject ProbeLaunchSound_NoProbes;

var(Audio) WwiseBaseSoundObject MineralRecoverySound_Large;

var(Audio) WwiseBaseSoundObject MineralRecoverySound_Medium;

var(Audio) WwiseBaseSoundObject MineralRecoverySound_Small;

var(Audio) WwiseBaseSoundObject MineralRecoverySound_None;

var(Audio) WwiseBaseSoundObject ProbeImpactSound;

var(Audio) array<String> MineralRTPCNames;

var(Audio) array<WwiseBaseSoundObject> MineralStopEvents;

var(Audio) array<WwiseBaseSoundObject> MineralStartEvents;

var(ParticleSystems) ParticleSystem ProbeLocationMarker;

var(ParticleSystems) ParticleSystem ProbeImpact;

var(ParticleSystems) ParticleSystem ScanBlip;

var(ParticleSystems) ParticleSystem ScanDirection;

var(ParticleSystems) ParticleSystem ScanWipe;

var ParticleSystem LandReticleIndicator;

var(ParticleSystems) ParticleSystem LaunchReticle;

var(ParticleSystems) ParticleSystem ScanReticle;

var(ParticleSystems) ParticleSystem Reticle;

var(ParticleSystems) ParticleSystem LandingSiteMarker;

var(Actors) Emitter ProbeTrail;

var(Actors) InterpActor ScanSphere;

var(Actors) InterpActor Ring;

var(Actors) InterpActor Probe;

var(Actors) InterpActor Clouds;

var(Actors) InterpActor Planet;

event Activated()
{
    local BioCameraBehaviorGalaxy GalaxyCam;
    local int nCluster;
    local int nSystem;
    local int nPlanet;
    local BioPlayerController PC;
    local SFXGameModeOrbital GameMode;
    GalaxyCam = GetGalaxyCamera();
    nCluster = GalaxyCam.m_nActiveWorld / 10000;
    nSystem = GalaxyCam.m_nActiveWorld / 100 % 100;
    nPlanet = GalaxyCam.m_nActiveWorld % 10;
    CurrentPlanet = GalaxyCam.m_pGalaxyMap.Clusters[nCluster].Systems[nSystem].Planets[nPlanet];
    PC = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    if (PC != None)
    {
        PC.GameModeManager2.EnableMode(10);
        GameMode = SFXGameModeOrbital(PC.GameModeManager2.HACK_GetOrbitalMode());
        if (GameMode != None)
        {
            GameMode.ReticleRotMinClamp = ReticleRotMinClamp;
            GameMode.ReticleRotMaxClamp = ReticleRotMaxClamp;
            GameMode.ReticleRot = ReticleRotStart;
            if (CurrentPlanet != None)
            {
                CurrentPlanet.LoadPlanetData(Planet, GameMode.TemporaryComponents);
            }
        }
    }
}

event bool Update(float DeltaTime)
{
    local BioPlayerController PC;
    local SFXGameModeOrbital GameMode;
    PC = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    if (PC != None)
    {
        GameMode = SFXGameModeOrbital(PC.GameModeManager2.HACK_GetOrbitalMode());
        if (GameMode != None && PC.GameModeManager2.IsActive(10))
        {
            GameMode.Update(DeltaTime);
        }
        else
        {
            bCancelled = true;
        }
    }
    if (bAborted)
    {
        bAborted = false;
        return true;
    }
    return false;
}

function EndAction()
{
    OutputLinks[0].bHasImpulse = true;
    bAborted = true;
}

function SignalProbeLaunch()
{
    OutputLinks[1].bHasImpulse = true;
}

function SignalProbeImpact()
{
    OutputLinks[2].bHasImpulse = true;
}

function BioCameraBehaviorGalaxy GetGalaxyCamera()
{
    return BioCameraBehaviorGalaxy(BioWorldInfo(GetWorldInfo()).GetLocalPlayerController().GameModeManager2.HACK_GetCameraMode(9));
}

defaultproperties
{
    ReticleRotStart=(Pitch=0,Yaw=32768,Roll=0)
    ReticleRotMaxClamp=(Pitch=6000,Yaw=38000,Roll=0)
    ReticleRotMinClamp=(Pitch=-6000,Yaw=24576,Roll=0)
    bManualHandleOutputs=true
    InputLinks=None
}
