﻿class BioSeqAct_SelectWeapon extends SequenceAction
    hidecategories(Object);

enum EBioSeqActSelectWeaponLinks
{
    EBioSeqActSelectWeaponLinks_Success,
    EBioSeqActSelectWeaponLinks_Failure,
};

var() class<SFXWeapon> cWeapon;

var() BioPawn oPawn;

function Activated()
{
    local SFXWeapon Wpn;
    local SFXWeapon WpnForSwitch;
    local BioWorldInfo BWI;
    local BioPlayerController PC;
    OutputLinks[0].bHasImpulse = false;
    OutputLinks[1].bHasImpulse = false;
    if (oPawn == None || cWeapon == None || SFXWeapon(oPawn.Weapon) == None)
    {
        OutputLinks[1].bHasImpulse = true;
        return;
    }
    foreach oPawn.InvManager.InventoryActors(Class'SFXWeapon', Wpn)
    {
        if (ClassIsChildOf(Wpn.Class, cWeapon))
        {
            if (WpnForSwitch == None || Wpn.GetAIRating() > WpnForSwitch.GetAIRating())
            {
                WpnForSwitch = Wpn;
            }
        }
    }
    if (WpnForSwitch == None)
    {
        OutputLinks[1].bHasImpulse = true;
        return;
    }
    if (BioPlayerController(oPawn.Controller) != None)
    {
        BioPlayerController(oPawn.Controller).OrderWeaponSwitch(oPawn, WpnForSwitch);
    }
    else
    {
        if (SFXAI_Henchman(oPawn.Controller) != None)
        {
            BWI = BioWorldInfo(GetWorldInfo());
            if (BWI == None)
            {
                OutputLinks[1].bHasImpulse = true;
                return;
            }
            PC = BWI.GetLocalPlayerController();
            if (PC == None)
            {
                OutputLinks[1].bHasImpulse = true;
                return;
            }
            PC.OrderWeaponSwitch(oPawn, WpnForSwitch);
        }
        else
        {
            if (SFXAI_Core(oPawn.Controller) != None)
            {
                SFXAI_Core(oPawn.Controller).SwitchWeapon(WpnForSwitch);
            }
            else
            {
                OutputLinks[1].bHasImpulse = true;
                return;
            }
        }
    }
    OutputLinks[0].bHasImpulse = true;
}

defaultproperties
{
    bManualHandleOutputs=true
    OutputLinks=None
}
