﻿class BioSeqAct_SetExploreCameraRotation extends SequenceAction
    hidecategories(Object);

var() bool bForceInstant;

var() Actor oTarget;

event bool IsCameraExploreMode(SFXCameraMode pCameraMode)
{
    return SFXCameraMode_Explore(pCameraMode) != None;
}

function Activated()
{
    local BioWorldInfo BWI;
    local PlayerController PC;
    if (oTarget == None)
    {
        OutputLinks[1].bHasImpulse = true;
        return;
    }
    BWI = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    PC = BWI.GetLocalPlayerController();
    if (PC == None || PC.PlayerCamera == None)
    {
        OutputLinks[1].bHasImpulse = true;
        return;
    }
    if (SFXPlayerCamera(PC.PlayerCamera) == None || SFXPlayerCamera(PC.PlayerCamera).CurrentCameraMode == None)
    {
        OutputLinks[1].bHasImpulse = true;
        return;
    }
    SFXPlayerCamera(PC.PlayerCamera).CurrentCameraMode.AimAtPoint(oTarget.Location);
    PC.SetRotation(SFXPlayerCamera(PC.PlayerCamera).CurrentCameraMode.m_pov.Rotation);
    OutputLinks[0].bHasImpulse = true;
}

defaultproperties
{
    bManualHandleOutputs=true
    OutputLinks=None
}
