﻿class BioSeqAct_SetPowerCooldown extends SequenceAction
    hidecategories(Object);

var() float m_fCooldownTimeRemaining;

var() Name m_nmPower;

var() Pawn m_oPawn;

function Activated()
{
    local float fTotalCooldownTime;
    local BioPawnBehavior Behavior;
    local BioPower Power;
    OutputLinks[0].bHasImpulse = false;
    OutputLinks[1].bHasImpulse = false;
    Behavior = BioPawn(m_oPawn).m_oBehavior;
    foreach Behavior.m_powers(Power)
    {
        if (Power.m_nmPower == m_nmPower)
        {
            if (Power.GetCooldownRemaining() > 0)
            {
                fTotalCooldownTime = Power.GetTotalCooldownTime();
            }
            else
            {
                fTotalCooldownTime = Power.GetCooldownTime();
            }
            Power.SetTotalCooldownTime(FMax(fTotalCooldownTime, m_fCooldownTimeRemaining));
            Power.SetCooldownRemaining(m_fCooldownTimeRemaining);
            OutputLinks[0].bHasImpulse = true;
        }
    }
    OutputLinks[1].bHasImpulse = !OutputLinks[0].bHasImpulse;
}

defaultproperties
{
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
