﻿class BioSeqAct_WalkWaypointSet extends BioSequenceLatentStateAction
    hidecategories(Object)
    native;

var int nCompletionReason;

var transient bool m_bDone;

var(Optional) int m_nNextWaypoint;

var(Optional) float m_fMoveTolerance;

var() eWalkWaypointsTypes m_eWalkType;

var(Optional) bool m_bSkipPathNodes;

var(Optional) bool m_bCountingUp;

var() bool m_bWalking;

var() bool m_bStartAtNearestPoint;

var BioWaypointSet m_oWaypointSet;

var() Route m_oRoute;

enum EWalkWaypointSetOutputPins
{
    WWS_Success,
    WWS_Failed,
};

function Activated()
{
    local int nNearestWaypoint;
    local int I;
    local SFXAI_Ambient oAI;
    local BioPawn oBP;
    m_bDone = false;
    if (m_oRoute != None)
    {
        nNearestWaypoint = m_nNextWaypoint;
        if (m_oRoute.NavList.Length <= 0)
        {
            m_bDone = true;
            OutputLinks[1].bHasImpulse = true;
            return;
        }
        if (m_bStartAtNearestPoint)
        {
            nNearestWaypoint = -1;
        }
        I = 0;
        while (I < Targets.Length)
        {
            oBP = BioPawn(Targets[I]);
            oAI = SFXAI_Ambient(oBP.Controller);
            if (oAI != None)
            {
                oAI.MoveOnScriptedRoute(m_oRoute, nNearestWaypoint, m_bWalking, m_eWalkType, m_bSkipPathNodes);
            }
            I++;
        }
    }
    else
    {
        m_bDone = true;
        OutputLinks[1].bHasImpulse = true;
    }
}

defaultproperties
{
    m_bSkipPathNodes=true
    OutputLinks=None
}
