﻿class BioSeqEvt_TakeDamage extends SequenceEvent
    hidecategories(Object);

var float CurrentMitigatedDamage;

var float CurrentDamage;

var() array<class<DamageType> > IgnoreDamageTypes;

var() array<class<DamageType> > DamageTypes;

var() float DamageThreshold;

var() float MinDamageAmount;

final function bool IsValidDamageType(class<DamageType> inDamageType)
{
    local bool bValid;
    bValid = true;
    if (DamageTypes.Length > 0)
    {
        bValid = DamageTypes.Find(inDamageType) != -1;
    }
    if (bValid && IgnoreDamageTypes.Length > 0)
    {
        bValid = IgnoreDamageTypes.Find(inDamageType) == -1;
    }
    return bValid;
}

final function HandleDamage(Actor InOriginator, Actor InInstigator, class<DamageType> inDamageType, float inAmount, float inMitigatedAmount)
{
    if (InOriginator != None && bEnabled && inAmount >= MinDamageAmount && IsValidDamageType(inDamageType) && PassesWhoTriggers(InInstigator))
    {
        CurrentDamage += inAmount;
        CurrentMitigatedDamage += inMitigatedAmount;
        if (CurrentDamage > DamageThreshold)
        {
            if (CheckActivate(InOriginator, InInstigator, false))
            {
                SetFloatVars("Damage Taken", CurrentDamage);
                SetFloatVars("Mitigated Damage Taken", CurrentMitigatedDamage);
                SetObjectVars("Who Took Damage", InOriginator);
                CurrentDamage = 0;
                CurrentMitigatedDamage = 0;
            }
        }
    }
}

defaultproperties
{
    VariableLinks=None
}
