﻿class BioSpectatorModeAnim extends BioSpectatorMode;

function InitializeOptions(BioWorldInfo WorldInfo)
{
    local int I;
    local Actor Target;
    local AnimSet Set;
    local Bio_Appr_Character Appearance;
    InitializeOptions(WorldInfo);
    Target = WorldInfo.GetLocalPlayerController().PlayerCamera.ViewTarget.Target;
    if (BioPawn(Target) != None)
    {
        Appearance = BioPawnType(BioPawn(Target).ActorType).m_oAppearance;
        m_options.Length = 0;
        I = 0;
        while (I < Appearance.Body.AnimSets.Length)
        {
            Set = Appearance.Body.AnimSets[I];
            m_options[m_options.Length] = Set;
            I++;
        }
    }
}

function ActivateOption(BioWorldInfo WorldInfo)
{
    local Actor Target;
    local AnimNodeSequence AnimSeq;
    local AnimTree AnimTree;
    local AnimSet Set;
    local Bio_Appr_Character Appearance;
    local int I;
    local int J;
    ActivateOption(WorldInfo);
    Target = WorldInfo.GetLocalPlayerController().PlayerCamera.ViewTarget.Target;
    if (BioPawn(Target) != None)
    {
        if (m_nCurrentLevel == 0)
        {
            Appearance = BioPawnType(BioPawn(Target).ActorType).m_oAppearance;
            I = 0;
            while (I < Appearance.Body.AnimSets.Length)
            {
                Set = Appearance.Body.AnimSets[I];
                if (Set != None)
                {
                    if (m_options[m_nSelectedOption] == Set)
                    {
                        BioPawn(Target).Mesh.AnimSets.Length = 0;
                        BioPawn(Target).Mesh.AnimSets[0] = Set;
                        m_subOptions.Length = 0;
                        J = 0;
                        while (J < Set.Sequences.Length)
                        {
                            m_subOptions[m_subOptions.Length] = Set.Sequences[J].SequenceName;
                            J++;
                        }
                        break;
                    }
                }
                I++;
            }
            m_nSelectedSubOption = 0;
            m_nCurrentLevel = 1;
        }
        else
        {
            J = 0;
            while (J < BioPawn(Target).Mesh.AnimSets[0].Sequences.Length)
            {
                if (BioPawn(Target).Mesh.AnimSets[0].Sequences[J].SequenceName == m_subOptions[m_nSelectedSubOption])
                {
                    AnimTree = new(self,Class'AnimTree');
                    AnimSeq = new(self,Class'AnimNodeSequence');
                    AnimSeq.SetAnim(BioPawn(Target).Mesh.AnimSets[0].Sequences[J].SequenceName);
                    AnimSeq.NodeName = 'ModelViewer';
                    AnimTree.Children[0].Name = 'ModelViewer';
                    AnimTree.Children[0].Anim = AnimSeq;
                    AnimTree.Children[0].Weight = 1;
                    if (BioPawn(Target).Mesh.Animations != None)
                    {
                        AnimNodeSequence(BioPawn(Target).Mesh.Animations.FindAnimNode('ModelViewer')).StopAnim();
                    }
                    BioPawn(Target).Mesh.SetAnimTreeTemplate(AnimTree);
                    if (BioPawn(Target).Mesh.Animations != None)
                    {
                        AnimNodeSequence(BioPawn(Target).Mesh.Animations.FindAnimNode('ModelViewer')).PlayAnim(true, 1);
                    }
                }
                J++;
            }
        }
    }
}

defaultproperties
{
}
