﻿class BioTalentContainer extends BioBaseComponent
    config(Game)
    native;

struct native BioTalentSpecification
{
    var /* 00000008 */ BioTalent m_Talent;

    var /* 00000008 */ array<int> m_PrereqTalentIDArray;

    var /* 00000008 */ array<int> m_PrereqTalentRankArray;

    var int m_MaxRank;

    var int m_LevelOffset;

    var int m_LevelsPerRank;

    var int m_OriginalRank;

    var int m_VisualOrder;

// m_LocalizedName: StringRefProperty[44]
// m_LocalizedDesc: StringRefProperty[44]
// m_StringForUnlockReferences: StringRefProperty[44]
// m_BlurbForUnlockReferences: StringRefProperty[44]
    var int m_CostTemplateID;

}

struct native BioTalentStaticData
{
// m_TalentName: StringRefProperty[44]
// m_TalentDesc: StringRefProperty[44]
    var int m_MaxRank;

    var String m_sUnlockDetails;

}

struct native BioTalentDynamicData
{
    var bool m_IsUnlocked;

    var int m_CurrentRank;

    var int m_AvailableRank;

    var int m_MaxRank;

    var array<int> m_RankIconArray;

    var array<???> m_RankNameArray;

    var array<???> m_RankDescArray;

    var array<???> m_RankUnlockBlurbArray;

}

struct native BioTalentDebugData
{
    var int m_ID;

    var int m_Rank;

// m_Name: StringRefProperty[44]
}

var int m_TalentPointsSpent;

var bool m_bUpdateRequired;

var bool m_IsLevelUpInProgress;

var /* 00000008 */ BioPawn m_Target;

var /* 00000008 */ array<BioTalent> m_SimpleTalentArray;

var /* 00000008 */ array<BioTalentSpecification> m_TalentSpecArray;

var const config int m_EVOLVE_RANK;

// srRequiredUnlockRequirement: StringRefProperty[44]
// srSingularUnlockRequirement: StringRefProperty[44]
// srPluralUnlockRequirement: StringRefProperty[44]
var const config int m_UNLOCKED_RANK_ICON;

var const config int m_LOCKED_RANK_ICON;

var const config int m_PASSIVE_RANK_ICON;

native final function SetTarget(BioPawn Target);

native final function AddTalent(BioTalent Talent, int MaxRank, int LevelOffset, int LevelsPerRank, int VisualOrder);

native final function bool AddBonusTalents(int bonusIdentifier);

native final function bool AddSpecialization(int bonusIdentification, int ReplaceTalentID);

native final function AddSimpleTalent(BioTalent Talent);

native final function BioTalent RemoveTalent(int Id);

native final function bool IncreaseTalentMaxRank(int Id, int MaxRank);

native final function bool IncreaseTalentMaxRankByIncrement(int Id, int MaxRankIncrement);

native final function ScaleTalentToRank(int Id, int Rank);

native final function ScaleTalentByIncrement(int Id, int rankIncrement);

native final function AddPrerequisiteTalent(int TalentID, int prereqID, int prereqRank);

native final function bool UpdateRequired();

native final function bool InitializeLevelUp();

native final function bool ApplyLevelUp();

native final function bool ClearLevelUp();

native final function bool GetNumLevelUpTalents(out int numTalents);

native final function bool GetNumLevelUpPoints(out int numPoints, out int pointsSpent);

native final function bool GetStaticLevelUpTalentData(out array<BioTalentStaticData> dataArray);

native final function bool GetDynamicLevelUpTalentData(int talentIndex, out BioTalentDynamicData Data);

native final function bool GetTalentLevelUpIndex(int TalentID, out int talentIndex);

native final function bool GetTalentLevelUpRank(int talentIndex, out int talentRank);

native final function bool IncrementLevelUpRank(int talentIndex);

native final function bool DecrementLevelUpRank(int talentIndex);

native final function bool CanIncrementLevelUpRank(int talentIndex, out int incrementCost);

native final function bool CanDecrementLevelUpRank(int talentIndex);

native final function bool CanEvolveTalent(int talentIndex, out int TalentID);

native final function bool GetTalentDebugData(out array<BioTalentDebugData> dataArray, out int simpleTalentStartIndex);

native final function bool GetTalentRank(int TalentID, out int talentRank);

native final function GetTalentSaveData(out array<BioSimpleTalentSave> simpleTalents, out array<BioComplexTalentSave> complexTalents);

native final function ReloadTalentContainer(BioPawnBehavior targetBehavior, out array<BioSimpleTalentSave> simpleTalents, out array<BioComplexTalentSave> complexTalents);

defaultproperties
{
    m_LOCKED_RANK_ICON=28
    m_UNLOCKED_RANK_ICON=29
    srPluralUnlockRequirement=System.Byte[]
    srSingularUnlockRequirement=System.Byte[]
    srRequiredUnlockRequirement=System.Byte[]
    m_EVOLVE_RANK=12
}
