﻿class BioUIWorld extends Object
    config(UI)
    native;

const UIWORLD_FLAG_HideHeadGear = 1;
const UIWORLD_FLAG_HideScar = 2;
const UIWORLD_FLAG_DisableCollision = 4;
const UIWORLD_FLAG_SpawnHidden = 8;
var PostProcessChain m_PostProcessChain;

var PostProcessSettings m_CurrentPostProcessSettings;

var BioSFHandler_NewCharacter m_oNCHandler;

var transient BioVisualEffect m_pTechToolEffect;

var transient BioVisualEffect m_pHalfBioticEffect;

var transient BioVisualEffect m_pFullBioticEffect;

var transient BioVFXTemplate m_pTechToolEffectTemplate;

var transient BioVFXTemplate m_pHalfBioticEffectTemplate;

var transient BioVFXTemplate m_pFullBioticEffectTemplate;

var const native transient array<Actor> m_aoInitialActors;

var const transient array<AppliedVFXPair> m_AppliedVFX;

// m_mSpawnedPawnMap: MapProperty[52]
var const native transient Pointer m_pCriticalSection;

var const native transient array<Pointer> m_aCommandQueue;

var native transient CameraActor m_pCameraActor;

var native transient Pointer m_pWorld;

var transient bool m_bLoaded;

var() config BioConvLightingData m_CustomLightingData;

var() config bool m_bEnabled;

var() config Name m_fnCameraActorName;

var() config String m_sMapFile;

struct native AppliedVFXPair
{
    var() BioPawn Target;

    var() BioVisualEffect Effect;

}

native function TriggerEvent(Name a_fnEventName, Actor a_pCaller);

native function SpawnPawn(BioPawn a_pOriginalPawn, Name a_fnSpawnLocation, Name a_fnSpawnVariable, optional AnimSet InAnimSet, optional Name a_fnRemoteEvent, optional int a_Flags);

native function DestroyPawn(BioPawn a_pOriginalPawn);

native function UpdateAppearance(BioPawn a_pOriginalPawn, optional AnimSet a_AnimSet, optional int a_Flags);

native final function UpdateHeadGearVisibility(BioPawn pOriginalPawn);

native function SetObjectVariable(Name a_fnVariableName, Object a_pValue);

native function SetNameVariable(Name a_fnVariableName, Name a_nmValue);

native function SetBoolVariable(Name a_fnVariableName, bool a_bValue);

native function ResetActors();

native function SwapPawn(BioPawn a_pSourcePawn, Name a_fnSourceVarName, BioPawn a_pOtherPawn, Name a_fnOtherVarName);

native function MovePawn(BioPawn a_pOriginalPawn, Name a_fnNewLocation);

native function AttachBioticsAndTech(BioPawn a_pSourcePawn, Name a_fnClassName);

native function PrimeTextures(BioPawn a_pSourcePawn);

native function AttachOmnitool(BioPawn a_pSourcePawn, bool a_fnClassName);

native function ApplyVFXTemplate(BioPawn SourcePawn, BioVFXTemplate Template);

native function ClearVFX(BioPawn SourcePawn);

native function SetAnimSet(BioPawn SourcePawn, AnimSet AnimSet);

native function HidePawn(BioPawn a_pOriginalPawn, optional bool bHidden);

native function FlushPendingCommands();

native function BioPawn GetSpawnedPawn(BioPawn a_pOriginalPawn);

native function RotatePawn(BioPawn a_pOriginalPawn, Rotator a_newRot);

event ClearScarFromPawn(BioPawn PawnToClear)
{
    local SFXPawn_Player PlayerPawn;
    PlayerPawn = SFXPawn_Player(PawnToClear);
    if (PlayerPawn != None)
    {
        PlayerPawn.bOverrideHideScars = true;
        PlayerPawn.UpdateParameters();
    }
    else
    {
        if (PawnToClear.HeadMesh != None)
        {
            Class'SFXPawn_Player'.ApplyScarParameters(Class'SFXPawn_Player'.Default.Scars, 5, PawnToClear);
        }
    }
}

defaultproperties
{
    m_sMapFile="BIOG_UIWorld"
    m_fnCameraActorName=CameraActor
    m_bEnabled=true
    m_PostProcessChain=PostProcessChain'UIWorld_PostProcess'
}
