﻿class BioVFXTemplate extends Object
    hidecategories(Object)
    config(Game)
    native;

enum EBioVFXCost
{
    EBioVFXCost,
    EBioVFXCost,
    EBioVFXCost,
    EBioVFXCost,
    EBioVFXCost,
};

var() /* 00000008 */ BioCameraShake m_cameraShake;

var(VFXDecal) /* 00000008 */ array<BioDecalComponent> Decals;

var(VFXDecal) float fPercentageOfDirection;

var(VFXMaterial) array<BioCurveDrivenParameter> aInstanceParameters;

var(VFXMaterial) Name m_nmEffectsMaterial;

var(VFXFrameBuffer) RawDistributionFloat m_rawIntensityVsDistanceDistribution;

var(VFXFrameBuffer) float m_fMaxRange;

var transient BioVisualEffect oInstancedSharedFrameBufferEffect;

var transient BioVFXTemplate oSharedFramebufferEffect;

var transient int nNumActiveInstances;

var(VFXFrameBuffer) int nMaxInstancesAllowed;

var(VFXFrameBuffer) array<BioCurveDrivenParameter> aPostProcessParameters;

var(VFXFrameBuffer) PostProcessChain oFrameBufferEffect;

var(Performance) int m_nDefaultPoolMin;

var(Performance) int m_nDefaultPoolMax;

var(Performance) int m_nInstancePoolMax;

var(Performance) float m_fInstancePoolRechargePeriod;

var config float m_afCostTable[5];

var EEffectsMaterialType eCharacterMaterial;

var(Priority) EBioVFXCost eCost;

var(Priority) EBioVFXPriority ePriority;

var(VisualEffect) float fEffectMaterialTimeout;

var(VisualEffect) float fParticleTimeout;

var(VisualEffect) float fImpactRadius;

var(Audio) float m_fFadeOutTime;

var(Audio) float m_fFadeInTime;

var(Audio) array<WwiseBaseSoundObject> m_aSoundsForIntensityLevels;

var(Audio) WwiseBaseSoundObject oSoundCue;

var(VFXFrameBuffer) bool m_bUseIntensityCurve;

var bool bSharedBetweenInstances;

var(VFXFrameBuffer) bool bPlayerOnly;

var(Performance) bool m_bDisableBoolDecay;

var bool m_bIgnorePooling;

var(Performance) bool m_bInstancePoolEnabled;

var bool bIsInitialized;

var(VisualEffect) bool bAttachToNearestBone;

var(VisualEffect) bool bAllowParticlesToFinish;

var(VisualEffect) bool bIsImpactCrustEffect;

var(VisualEffect) bool bIsCrustEffect;

var(VisualEffect) bool bUseActorScale;

var(VisualEffect) bool bEnableCollision;

var(Audio) bool m_bFadeOnPause;

var(Audio) bool bCreateNewSoundEverySpawn;

var(VisualEffect) float fLifeTime;

var(VisualEffect) Prefab oPrefab;

event InitializeTemplate()
{
    bIsCrustEffect = bIsCrustEffect || m_nmEffectsMaterial != 'None' || bIsImpactCrustEffect;
    bIsInitialized = true;
}

defaultproperties
{
    fLifeTime=2
    bAllowParticlesToFinish=true
    m_bInstancePoolEnabled=true
    bSharedBetweenInstances=true
    fImpactRadius=20
    fParticleTimeout=3
    ePriority=BIO_VFX_PRIORITY_MEDIUM
    eCost=System.Byte[]
    m_afCostTable=1
    m_afCostTable=2
    m_afCostTable=3
    m_afCostTable=4
    m_afCostTable=5
    m_fInstancePoolRechargePeriod=0,3
    m_nInstancePoolMax=5
    m_nDefaultPoolMax=3
    m_nDefaultPoolMin=1
    nMaxInstancesAllowed=3
}
