﻿class BioWorldInfo extends WorldInfo
    hidecategories(Navigation,Movement,Collision,Actor,Advanced,Display,Events,Object,Attachment)
    config(Game)
    native;

struct native EffectsMaterialPriority
{
    var() Name EffectsMaterial;

    var() int Priority;

}

enum BioLocalVariableObjectType
{
    BIO_LVOT_PLAYER,
    BIO_LVOT_OWNER,
    BIO_LVOT_TARGET,
    BIO_LVOT_BYTAG,
    BIO_LVOT_SPEAKER,
};

enum EPlayerRenderStateSetting
{
    PRSS_NEARCLIP,
};

enum JournalSortMethods
{
    JSM_Newest,
    JSM_Name,
    JSM_Oldest,
};

enum MEBrowserWheelSubPages
{
    MBW_SP_Map,
    MBW_SP_Save,
    MBW_SP_CharacterRecord,
    MBW_SP_Load,
    MBW_SP_Journal,
    MBW_SP_DataPad,
    MBW_SP_Options,
    MBW_SP_ReturnToMainMenu,
    MBW_SP_ExitGame,
};

var() array<Object> m_AutoPersistentObjects;

var() config array<EffectsMaterialPriority> EffectsMaterialPriorities;

var const transient WwiseEnvironmentVolume HighestPriorityAudioEnvVolume;

var transient array<SubPageState> SubPageStateOverrides;

var transient config int m_nDesignerEnableDifficultyChecksPlotFlag;

var transient int bForceFullGarbageCollection;

var WwiseEventPairObject m_pEndGameMusicEvent;

var /* 00000008 */ AudioComponent m_pEndGameMusic;

var /* 00000008 */ BioPowerManager m_oPowerManager;

var const config float m_fGameOverPauseTime;

var /* 00000008 */ BioSkillGame m_SkillGame;

var BioSkillGame_Handler SkillGameHandler;

var() const /* 00000008 */ BioUIWorld m_UIWorld;

var() array<int> m_pScannedPlanets;

var() array<int> m_pScannedSystems;

var() array<int> m_pScannedClusters;

var() Vector m_vDestination;

var() String m_sDestinationAreaMap;

var() array<String> m_lstCinematicsSeen;

var config array<String> ConditionalClasses;

var /* 00000008 */ transient BioPhysicsSounds m_PhysicsSound;

var WorldEnvironmentEffect m_PendingEnvironmentEffect;

var WorldEnvironmentEffect m_ActiveEnvironmentEffect;

var const native transient BoughtVFXListEnds m_aBoughtEffects[5];

// m_BoughtVFXMap: MapProperty[52]
var transient array<VFXListNode> m_BoughtVFXList;

var float m_fUsedVFXBudget;

var config float m_fMaxVFXBudget;

var(VFXPool) array<VFXTemplatePoolSizeSpec> m_VFXTemplatePoolSizeOverride;

var transient float m_fPlayerTeleportTimeSeconds;

// m_mVFXPool: MapProperty[52]
var BioInGamePropertyEditor m_oPropertyEditor;

var() array<WorldStreamingState> m_WorldStreamingStates;

var() array<PlotStreamingSet> PlotStreaming;

var array<Actor> RadarActors;

var array<Actor> SelectableActors;

var transient BioBaseSquad m_oPlayerSquad;

// m_srProfileNotSignedInWarningMsg: StringRefProperty[44]
// m_OverrideTip: StringRefProperty[44]
var int m_nCurrentTipID;

var transient config array<Name> m_aCullFXConvList;

var transient config float m_fLookAtNoticeSpeed;

var transient config float m_fLookAtNoticeDuration;

var transient config float m_fLookAtNoticeInitialDelay;

var transient config float m_fLookAtNoticeMaxRange;

var transient config array<float> m_fLookAtDelays;

var transient config float m_fNoSkipBuffer;

var config float m_fIdleCameraSpeed;

var config float m_fConversationInterruptDistance;

var transient String m_sCinematicSkipEvent;

var() bool m_bAllowBrowserWheel;

var config bool m_bPartyMembersImmuneToExternalForce;

var config bool m_bDebugCameras;

var bool m_bBreakHideHudOnConversation;

var bool m_bFlushSFHud;

var() bool m_bInvokesHintMessages;

var() GFxMovieInfo m_oParentAreaMap;

var() GFxMovieInfo m_oAreaMap;

var() String m_sFriendlyName;

var BioSubtitles m_Subtitles;

var /* 00000008 */ transient SFXPlotTreasure m_oTreasure;

var /* 00000008 */ BioPlotTreasure m_oPlotTreasureMgr;

var BioPlayerController LocalPlayerController;

var /* 00000008 */ transient BioEventNotifier EventNotifier;

var transient BioConversation m_pConvCondCheckOverride;

var transient BioSeqAct_FaceOnlyVO m_pCurrentFaceOnlyVO;

var transient BioConversation m_oCurrentConversation;

var transient int m_nCodexLastSelectedSecondary;

var transient int m_nCodexLastSelectedPrimary;

var transient int m_nJournalLastSelectedAssignment;

var transient int m_nJournalLastSelectedMission;

var transient BioBrowserStates m_lstBrowserAlerts[9];

var transient JournalSortMethods m_nJournalSortMethod;

var transient BioDiscoveredCodexMap m_oDiscoveredCodex;

var transient BioQuestProgressionMap m_oQuestProgress;

var transient BioGlobalVariableTable m_oGlobalVariables;

var BioTimerList TimerList;

var config int nMemoryBudgetDLC;

var transient bool bKismetShowHUD;

var transient bool m_bGameWasPaused;

var transient bool m_bHasPlayerTeleported;

var transient bool m_bWaitingForStreamingLoadVisibleComplete;

var transient bool m_bWaitingForStreamingLoadIdle;

var transient bool m_bForceCinematicDamage;

var transient bool m_bDisableCinematicSkip;

var transient bool m_bCinematicSkip;

var transient bool m_bCodexShowingPrimary;

var transient bool m_bJournalShowingMissions;

var transient bool bStreamingLevelsResorted;

var transient BioSaveGame CurrentGame;

var transient BioPlayerSquad m_playerSquad;

enum BioBrowserStates
{
    BBS_NORMAL,
    BBS_ALERT,
    BBS_DISABLED,
};

struct native PlotStreamingElement
{
    var() Name ChunkName;

    var() int Conditional;

    var() bool bFallback;

}

struct native PlotStreamingSet
{
    var() Name VirtualChunkName;

    var() array<PlotStreamingElement> Elements;

}

struct native WorldStreamingState
{
    var() Name Name;

    var() bool Enabled;

}

struct native WorldEnvironmentEffect
{
    var transient BioVisualEffect m_Effect;

    var Vector m_vOffset;

    var float m_fBlendDuration;

    var float m_fBlendTime;

    var float m_fDesiredIntensity;

    var float m_fCurrentIntensity;

    var Controller m_TargetController;

    var bool m_bAttachToCamera;

}

struct native VFXTemplatePoolSizeSpec
{
    var() BioVFXTemplate Template;

    var() int MaxPoolSize;

    var() int MinPoolSize;

}

struct native VFXListNode
{
    var BioVisualEffect Effect;

    var int NextNode;

    var int PrevNode;

    var bool ValidNode;

}

struct native BoughtVFXListEnds
{
    var int HeadIndex;

    var int TailIndex;

}

struct native SubPageState
{
    var int nPadding;

    var() MEBrowserWheelSubPages Page;

    var() BioBrowserStates State;

}

native function SetStreamingState(String StateName, bool bValue);

native function bool TriggerCinematicSkippedEvent();

native function OnNewGameStartRequest(Name RemoteEvent);

final event RequestStartNewGame(optional bool bFemale, optional Name RemoteEvent)
{
    local BioPlayerController BPC;
    local MassEffectGuiManager MEGM;
    if (RemoteEvent == 'None')
    {
        RemoteEvent = 're_StartNewGame';
    }
    BPC = GetLocalPlayerController();
    if (BPC == None)
    {
        return;
    }
    MEGM = MassEffectGuiManager(BPC.GetScaleFormManager());
    if (MEGM == None)
    {
        return;
    }
    CurrentGame.bStartedGame = false;
    CurrentGame.DefaultPlayer.bIsFemale = bFemale;
    OnNewGameStartRequest(RemoteEvent);
    MEGM.ClearAll();
    MEGM.StopGuiMusic();
    MEGM.ShowBlackScreen(false);
}

native final function bool GetGuiInputPermission(byte nEvent);

event CauseEvent(Name EventName)
{
    if (GetLocalPlayerController() != None)
    {
        GetLocalPlayerController().CauseEvent(EventName);
    }
}

native function bool CheckConditional(int nConditional, optional int nParam);

native function ExecuteStateTransition(int nTransition, optional int nParam);

native function ExecuteConsequence(int nConsequence, optional int nParam);

native function int GetLocalIntegerVariable(BioLocalVariableObjectType eObjectType, Name GetFunctionName, optional Name sTag, optional int nParam);

native function float GetLocalFloatVariable(BioLocalVariableObjectType eObjectType, Name GetFunctionName, optional Name sTag, optional int nParam);

native function bool GetLocalBoolVariable(BioLocalVariableObjectType eObjectType, Name GetFunctionName, optional Name sTag, optional int nParam);

native final function MoveToArea(Name sAreaName, Name sNextAreaStartPoint);

native function String GetVersionString();

native function String GetEpicVersionString();

native function String GetDetailedVersionString();

native final private function OnGameLoaded();

native function BioVisualEffectPool GetVFXPool(BioVFXTemplate pEffect);

native function GetDefaultVFXPoolSize(BioVFXTemplate a_pEffect, out int a_rnMaxPoolSize, out int a_rnMinPoolSize);

native function OverrideVFXPoolSize(BioVFXTemplate a_pEffect, int a_nMaxPoolSize, int a_nMinPoolSize);

native function UpdateVFXStats(float fDeltaT);

native function UpdateVFXPools(float fDeltaT);

native final function PlayEndGameMusic();

native final function bool GetCurrentStreamingChunkName(out Name nmStreamingChunkName);

native function BioPlayerController GetLocalPlayerController();

function Tick(float fDeltaT)
{
    if (TimerList != None)
    {
        TimerList.Tick(fDeltaT);
    }
    UpdateSubtitles(fDeltaT);
    UpdateConversation(fDeltaT);
    if (m_oPropertyEditor != None)
    {
        m_oPropertyEditor.UpdateSystem(fDeltaT);
    }
    UpdateVFXStats(fDeltaT);
    UpdateVFXPools(fDeltaT);
    if (m_oPowerManager != None && bPlayersOnly == false)
    {
        m_oPowerManager.Tick(fDeltaT);
    }
}

native function InitDownloadableContent(bool bFinalAttempt);

native function BioGlobalVariableTable GetGlobalVariables();

event ClearCurrentGame()
{
    CurrentGame.ResetToDefaults();
    GetGlobalVariables().ClearAllVariables();
    m_oQuestProgress.Clear();
    m_oDiscoveredCodex.Clear();
}

event BioConversation GetConversation()
{
    return m_oCurrentConversation;
}

native function bool StartConversation(BioConversation oConv, Actor Owner_, Actor Target);

native function EndCurrentConversation();

native function EndCurrentFaceOnlyVO(BioSeqAct_FaceOnlyVO pFOVO);

function UpdateConversation(float fDeltaT)
{
    if (m_oCurrentConversation == None)
    {
        return;
    }
    if (m_oCurrentConversation.UpdateConversation(fDeltaT) == false)
    {
        EndCurrentConversation();
    }
}

native function InterruptConversation(optional BioConversation oConv);

event bool CheckState(int nState)
{
    local BioGlobalVariableTable gv;
    gv = GetGlobalVariables();
    return gv.GetBool(nState);
}

simulated function PostBeginPlay()
{
    PostBeginPlay();
    TimerList = new(Outer,Class'BioTimerList');
    if (m_oPropertyEditor != None)
    {
        m_oPropertyEditor.Initialize();
    }
    if (m_SkillGame != None)
    {
        m_SkillGame.InitializeObject();
    }
    GetSubtitles();
}

native function SetGlobalTlk(bool bMale, optional bool bPurge);

native function BioSubtitles GetSubtitles();

function UpdateSubtitles(float fDeltaT)
{
    if (m_Subtitles != None)
    {
        m_Subtitles.UpdateSubtitles(fDeltaT);
    }
}

native function UpdateEnvironmentEffects(float fDeltaT);

native function float GetRenderStateOfPlayer(EPlayerRenderStateSetting RenderState);

native function SetRenderStateOfPlayer(EPlayerRenderStateSetting RenderState, float fValue);

native function SetRenderStateOfPlayerToDefault(EPlayerRenderStateSetting RenderState);

native function GetGlobalEvents(class<Object> EventClass, out array<SequenceEvent> aEvents);

static function class<BioBaseSaveObject> GetSaveObjectClass()
{
    return Class'BioWorldInfoSaveObject';
}

function StartMatch()
{
    local BioPawn oPlayer;
    local BioWorldInfo oBWorldInfo;
    local String sStartMapName;
    local String sMapName;
    local int nTemp;
    oBWorldInfo = BioWorldInfo(WorldInfo);
    if (oBWorldInfo != None)
    {
        if (oBWorldInfo.m_playerSquad != None)
        {
            oPlayer = oBWorldInfo.m_playerSquad.m_playerPawn;
            if (oPlayer != None)
            {
                sStartMapName = "EntryMenu";
                sMapName = oBWorldInfo.GetURLMap();
                nTemp = Len(sStartMapName);
                sMapName = Mid(sMapName, 0, nTemp);
                if (sMapName != sStartMapName)
                {
                    oPlayer.SetRichPresence();
                }
            }
        }
    }
}

function AddBrowserWheelStateOverride(SubPageState i_SubStateOverride)
{
    SubPageStateOverrides.AddItem(i_SubStateOverride);
}

function ClearBrowserWheelStateOverride()
{
    SubPageStateOverrides.Remove(0, SubPageStateOverrides.Length);
}

final function BioRemoteLogger GetGLogger()
{
    return Class'BioRemoteLogger'.GetLogger();
}

event SetPlayersControllerId(LocalPlayer Player, int ControllerId)
{
    Player.SetControllerId(ControllerId);
}

defaultproperties
{
    m_bJournalShowingMissions=true
    m_bCodexShowingPrimary=true
    m_bWaitingForStreamingLoadIdle=true
    m_bWaitingForStreamingLoadVisibleComplete=true
    bKismetShowHUD=true
    nMemoryBudgetDLC=1048576
    m_oGlobalVariables=BioGlobalVariableTable'BioGlobalVars0'
    m_oQuestProgress=BioQuestProgressionMap'BioQuestProgress0'
    m_oDiscoveredCodex=BioDiscoveredCodexMap'BioDiscoveredCodex0'
    m_nJournalLastSelectedMission=-1
    m_nJournalLastSelectedAssignment=-1
    m_nCodexLastSelectedPrimary=-1
    m_nCodexLastSelectedSecondary=-1
    EventNotifier=BioEventNotifier'BEN'
    m_oTreasure=SFXPlotTreasure'oPlotTreasure'
    m_bFlushSFHud=true
    m_bPartyMembersImmuneToExternalForce=true
    m_bAllowBrowserWheel=true
    m_fConversationInterruptDistance=999999
    m_fIdleCameraSpeed=1
    m_fNoSkipBuffer=0,7
    m_fLookAtDelays(0)=0,5
    m_fLookAtDelays(1)=0,6
    m_fLookAtDelays(2)=0,7
    m_fLookAtDelays(3)=0,75
    m_fLookAtDelays(4)=0,8
    m_fLookAtDelays(5)=0,9
    m_fLookAtDelays(6)=1
    m_fLookAtDelays(7)=1,05
    m_fLookAtDelays(8)=1,1
    m_fLookAtDelays(9)=1,15
    m_fLookAtNoticeMaxRange=500
    m_fLookAtNoticeInitialDelay=1,5
    m_fLookAtNoticeDuration=6
    m_fLookAtNoticeSpeed=0,2
    m_aCullFXConvList(0)=nor_globalnews_a_dlg
    m_aCullFXConvList(1)=twrhub_systemhack_last_a
    m_aCullFXConvList(2)=twrhub_arrival_ai_a
    m_aCullFXConvList(3)=twrhub_sal_bach_a
    m_aCullFXConvList(4)=twrhub_asariargue_a
    m_aCullFXConvList(5)=twrhub_stocks_a
    m_aCullFXConvList(6)=twrhub_quarturtalk_a
    m_aCullFXConvList(7)=cithub_fake_games_a_dlg
    m_aCullFXConvList(8)=cithub_arrival_ai_a_dlg
    m_aCullFXConvList(9)=cithub_soda_a_dlg
    m_aCullFXConvList(10)=omghub_arrival_ai_a_dlg
    m_aCullFXConvList(11)=cithub_sirta_amb_a_dlg
    m_aCullFXConvList(12)=cithub_saronis_amb_a_dlg
    m_aCullFXConvList(13)=cithub_ware_amb_a_dlg
    m_aCullFXConvList(14)=cithub_citsouv_amb_a_dlg
    m_aCullFXConvList(15)=cithub_zakcafe_amb_a_dlg
    m_aCullFXConvList(16)=cithub_rodam_amb_a_dlg
    m_aCullFXConvList(17)=nor_training_vid_a_dlg
    m_srProfileNotSignedInWarningMsg=System.Byte[]
    m_fMaxVFXBudget=100
    m_PhysicsSound=BioPhysicsSounds'oPhysicsSound01'
    ConditionalClasses(0)="PlotManager.BioAutoConditionals"
    m_UIWorld=BioUIWorld'oUIWorld'
    m_SkillGame=BioSkillGame'BioSkillGame01'
    m_fGameOverPauseTime=3
    m_oPowerManager=BioPowerManager'PowerManager'
    m_pEndGameMusicEvent=WwiseEventPairObject'EndGameMusicWwiseEventPair'
    m_nDesignerEnableDifficultyChecksPlotFlag=-1
    EffectsMaterialPriorities=System.Byte[]
    bNoDefaultInventoryForPlayer=true
    // child object BioDiscoveredCodex0 of type BioDiscoveredCodexMap
    // child object BEN of type BioEventNotifier
    // child object BioGlobalVars0 of type BioGlobalVariableTable
    // child object oPhysicsSound01 of type BioPhysicsSounds
    // child object PowerManager of type BioPowerManager
    // child object BioQuestProgress0 of type BioQuestProgressionMap
    // child object BioSkillGame01 of type BioSkillGame
    // child object oUIWorld of type BioUIWorld
    // child object oPlotTreasure of type SFXPlotTreasure
    // child object EndGameMusicWwiseEventPair of type WwiseEventPairObject
}
