﻿class SFXAI_Critter extends SFXAI_Core
    hidecategories(Navigation)
    config(AI)
    placeable;

var bool m_bUnderAttack;

var Vector m_vCurrentSteeringDirection;

var Vector m_vRepulsor;

function Initialize()
{
    Initialize();
    if (MyBP != None)
    {
        MyBP.bAmbientCreature = true;
    }
}

state Idle
{
Begin:
    if (m_nmCurrentBehavior != 'None')
    {
        PushState(m_nmCurrentBehavior);
    }
}

state WanderingCritter
{
    function BeginState(Name PrevState)
    {
        BeginState(PrevState);
        SetTimer(10, true, 'PlayAmbientVoc');
    }

    function PushedState()
    {
        PushedState();
        SetTimer(10, true, 'PlayAmbientVoc');
    }

    function EndState(Name NextState)
    {
        EndState(NextState);
        ClearTimer('PlayAmbientVoc');
    }

    function PoppedState()
    {
        PoppedState();
        ClearTimer('PlayAmbientVoc');
    }

    function NotifyTakeHit(Controller InstigatedBy, Vector HitLocation, int Damage, class<DamageType> DamageType, Vector Momentum)
    {
        NotifyTakeHit(InstigatedBy, HitLocation, Damage, DamageType, Momentum);
        m_vRepulsor = HitLocation;
        m_bUnderAttack = true;
    }

    function NotifyNearMiss(Vector HitLocation)
    {
        NotifyNearMiss(HitLocation);
        m_vRepulsor = HitLocation;
        m_bUnderAttack = true;
    }

    function GetSteeringDirection(out Vector vSteering)
    {
        if (MyBP != None)
        {
            vSteering = MyBP.Velocity + VRand();
            if (IsZero(m_vRepulsor) == false)
            {
                vSteering += MyBP.Location - m_vRepulsor / 10;
            }
        }
    }

    function bool AdjustSteeringSpeed(Vector vSteering)
    {
        if (IsZero(vSteering))
        {
            Pawn.SetDesiredSpeed(0);
            return false;
        }
        else
        {
            if (IsZero(m_vRepulsor) == false && VSize(m_vRepulsor - Pawn.Location) < 1000)
            {
                Pawn.SetWalking(false);
            }
            else
            {
                m_vRepulsor.X = 0;
                m_vRepulsor.Y = 0;
                m_vRepulsor.Z = 0;
                Pawn.SetWalking(true);
            }
        }
        Pawn.SetDesiredSpeed(1);
        return true;
    }

    while (true)
    {
        m_bUnderAttack = false;
        GetSteeringDirection(m_vCurrentSteeringDirection);
        if (AdjustSteeringSpeed(m_vCurrentSteeringDirection))
        {
            m_vCurrentSteeringDirection = Normal(m_vCurrentSteeringDirection);
            m_bClearVelocityAfterMove = false;
            MovePoint = MyBP.Location + m_vCurrentSteeringDirection * 200;
            FocalPoint = MovePoint;
            Sleep(0,15);
            MoveTimer = 2;
            PushState('MovingToLocation');
            if (!bReachedMoveGoal && !m_bUnderAttack)
            {
                m_vRepulsor = vect(0,0,0);
            }
        }
        else
        {
            Sleep(2);
        }
    }
    jump 0;
    // unresolved reference 0 ;
}

state MovingToLocation
{
    function NotifyTakeHit(Controller InstigatedBy, Vector HitLocation, int Damage, class<DamageType> DamageType, Vector Momentum)
    {
        NotifyTakeHit(InstigatedBy, HitLocation, Damage, DamageType, Momentum);
        if (IsZero(m_vRepulsor))
        {
            m_vRepulsor = HitLocation;
            MoveTimer = -1;
            m_bClearVelocityAfterMove = true;
            m_bUnderAttack = true;
        }
    }

    function NotifyNearMiss(Vector HitLocation)
    {
        NotifyNearMiss(HitLocation);
        if (IsZero(m_vRepulsor))
        {
            m_vRepulsor = HitLocation;
            MoveTimer = -1;
            m_bClearVelocityAfterMove = true;
            m_bUnderAttack = true;
        }
    }

}

defaultproperties
{
    m_nmCurrentBehavior=WanderingCritter
    BehaviourList(0)=WanderingCritter
    AtCover_WeaponRange=Goal_AtCover'AtCov_EvalWeaponRange'
    AtCover_Defensive=Goal_AtCover'AtCov_EvalDefensive'
    AtCover_Aggressive=Goal_AtCover'AtCov_EvalAggressive'
    AtCover_NearMoveGoal=Goal_AtCover'AtCov_EvalNearGoal'
    AtCover_AIGoHere=Goal_AtGoHereCover'AtCov_EvalGoHere'
    // child object AtCov_EvalAggressive of type Goal_AtCover
    // child object AtCov_EvalDefensive of type Goal_AtCover
    // child object AtCov_EvalNearGoal of type Goal_AtCover
    // child object AtCov_EvalWeaponRange of type Goal_AtCover
    // child object AtCov_EvalGoHere of type Goal_AtGoHereCover
}
