﻿class SFXAI_NativeBase extends BioAiController
    hidecategories(Navigation)
    config(AI)
    native
    placeable;

var transient float m_fNextTimeForReachableCheck;

var transient int m_nEnabledFlags;

var transient float LastShotAtTime;

var transient int m_nMantleCostModifier;

var transient bool m_bCanSkipNodes;

var transient bool m_bDisableAIOnRagdoll;

var transient bool m_bAIGoHereTargetArrived;

var transient NavigationPoint m_AIGoHereTarget;

var(CustomActions) transient array<BioCustomAction> CustomActions;

var array<class<BioCustomAction> > CustomActionClasses;

var EAICustomAction CurrentCustomAction;

event BioClearCrossLevelReferences(Level oLevel);

native function bool IsActorInLevel(Actor oActor, Level oLevel);

event bool GetCurrentCustomAction(out BioCustomAction pAction);

event bool CanDoCustomAction(EAICustomAction CAction);

event bool CanInterruptCurrentState()
{
    return true;
}

const ENABLE_AI_REQUESTED_BY_UNKNOWN = 1;
const ENABLE_AI_REQUESTED_BY_CONVERSATION = 2;
const ENABLE_AI_REQUESTED_BY_KISMET = 4;
const ENABLE_AI_REQUESTED_BY_GAME_EFFECT = 8;
const ENABLE_AI_REQUESTED_BY_DEATH = 16;
event bool EnableAI(bool bEnable, int nRequestedBy)
{
    local int nOriginalFlags;
    nOriginalFlags = m_nEnabledFlags;
    if (bEnable)
    {
        m_nEnabledFlags = m_nEnabledFlags & ~nRequestedBy;
    }
    else
    {
        m_nEnabledFlags = m_nEnabledFlags | nRequestedBy;
    }
    if (m_nEnabledFlags == nOriginalFlags)
    {
        return true;
    }
    if (IsInState('Dying'))
    {
        return false;
    }
    if (m_nEnabledFlags != 0)
    {
        if (IsInState('Disabled', true) == false)
        {
            PopState(true);
            GotoState('Disabled');
        }
    }
    else
    {
        FireTarget = None;
        if (IsInState('Disabled', true))
        {
            GotoState('Idle');
        }
    }
    return true;
}

event GetActorToFollow(out Actor oActor, out Vector vLocation);

native function bool GetSteeringVector(out Vector vSteering);

native function bool AdjustSteeringMoveSpeed(Vector vSteering);

native function MoveTowardLocation(Vector vLocation, optional float fOffset);

native final latent function SmoothPathMovement();

native final private function bool CanSkipCurrentPathNode();

native final private function bool IsSpecialMoveAfterMoveTarget();

event UpdateMovementActions();

native function SetMoveTimer(out Vector vMove);

native final function DebugResetNavWeights();

defaultproperties
{
    m_bDisableAIOnRagdoll=true
    m_bCanSkipNodes=true
    m_nMantleCostModifier=2
    LastShotAtTime=-9999
}
