﻿class SFXAmmoContainer extends SFXDroppedAmmo
    hidecategories(Navigation)
    placeable;

var float BonusAmmo;

var float RespawnTime;

var() bool bRespawns;

simulated event SetInitialState()
{
    bScriptInitialized = true;
    GotoState('Auto');
}

function SetRespawn()
{
    if (bRespawns)
    {
        StartSleeping();
    }
    else
    {
        GotoState('Disabled');
    }
}

function StartSleeping()
{
    GotoState('Sleeping');
}

function GiveTo(Pawn P)
{
    GiveAmmo(P.InvManager, BonusAmmo);
    P.PlaySound(AmmoPickupSound);
    SetRespawn();
}

state Sleeping
{
    function StartSleeping();

    event BeginState(Name PreviousStateName)
    {
        if (AmmoMesh != None)
        {
            AmmoMesh.SetHidden(true);
        }
    }

    event EndState(Name NextStateName)
    {
        if (AmmoMesh != None)
        {
            AmmoMesh.SetHidden(false);
        }
    }

Begin:
    Sleep(RespawnTime);
    while (SFXGame(WorldInfo.Game).InCombat() == false)
    {
        Sleep(5);
    }
    GotoState('Pickup');
}

state Disabled
{
    function Reset();

    function StartSleeping();

    simulated event BeginState(Name PreviousStateName)
    {
        SetHidden(true);
        SetCollision(false, false);
        LifeSpan = 5;
    }

}

defaultproperties
{
    RespawnTime=20
    BonusAmmo=0,15
    AmmoMesh=StaticMeshComponent'DroppedAmmoMesh0'
    bDecays=false
    Components=None
    // child object CollisionCylinder of type CylinderComponent
    // child object DroppedAmmoMesh0 of type StaticMeshComponent
}
