﻿class SFXCameraMode extends Object
    abstract
    native;

var transient Vector m_avLockedNewClipPlanePt[8];

var transient Vector m_vLockedNewCameraLocation;

var transient Vector m_avLockedHookPlanePt[8];

var transient Vector m_vLockedHook;

var transient Vector m_avLockedClipPlanePt[8];

var transient Vector m_vLockedCameraLocation;

var transient BioCameraDebugger Debugger;

var transient float m_fAspectRatio;

var transient bool m_bConstrainAspectRatio;

var transient Name LastCameraCollisionActor;

var transient float CollisionDistance;

var transient SFXCameraInput Input;

var transient BioPlayerController Owner;

var transient TPOV m_pov;

var() Name CameraName;

var() float FOV;

var Name HookName;

var Vector HookOffset;

var Vector Offset;

var bool m_bUseCollisionSource;

var bool bCollisionEnabled;

var bool bIsCameraShakeEnabled;

const BIO_CAMERA_UTILITY_COLLISION_POINT_COUNT = 8;
const CAMERA_PITCH_MAX_DEG = 65.0f;
function DoCameraCollision(out Vector V, out Rotator R, Actor A)
{
    DoCameraCollisionNative(GetCollisionCameraHook(), V, R, A);
}

native final function DoCameraCollisionNative(Vector CollisionHook, out Vector V, out Rotator R, Actor A);

native final static function ComputeClipPlaneRect(float fFov, float fNearClipPlane, out float fWidth, out float fHeight);

event ModifyPostProcessSettings(out PostProcessSettings PPSettings);

native final function DrawHook(Vector V, Actor Actor);

function Vector GetCameraLocation()
{
    return GetActorCameraHook() - QuatRotateVector(QuatFromRotator(m_pov.Rotation), Offset);
}

function Tick(float fTimeDelta)
{
    m_pov.Rotation = Owner.Rotation;
    m_pov.Location = GetCameraLocation();
    m_pov.FOV = FOV;
    if (LocalPlayer(Owner.Player) != None)
    {
        BioWorldInfo(Owner.WorldInfo).SetRenderStateOfPlayerToDefault(0);
    }
}

event AimAtPoint(Vector V)
{
    local Vector PawnToPoint;
    local Vector CameraPos;
    local Vector CameraOrth;
    local Vector CameraNorm;
    local Vector Intersection;
    local Vector Yaw;
    local float Opposite;
    local float Adjascent;
    local float Hypotenuse;
    local float CamNormOffset;
    local float YawDiff;
    local float PitchDiff;
    Yaw = m_pov.Rotation;
    PawnToPoint = V - Owner.Pawn.Location;
    CameraPos = GetCameraLocation() - Owner.Pawn.Location;
    CamNormOffset = CameraPos Dot Yaw;
    CameraNorm = Yaw * CamNormOffset;
    CameraOrth = CameraPos - CameraNorm;
    Adjascent = VSize(CameraOrth);
    Hypotenuse = VSize(PawnToPoint);
    if (Hypotenuse * Hypotenuse - Adjascent * Adjascent < 0)
    {
        return;
    }
    Opposite = Sqrt(Hypotenuse * Hypotenuse - Adjascent * Adjascent);
    Intersection = CameraOrth + Yaw * Opposite;
    YawDiff = PawnToPoint.Yaw - Intersection.Yaw;
    PitchDiff = PawnToPoint.Pitch - Intersection.Pitch;
    m_pov.Rotation.Yaw += YawDiff;
    m_pov.Rotation.Pitch += PitchDiff;
    m_pov.Rotation.Roll = 0;
    m_pov.Location = GetCameraLocation();
}

function MakeActive();

function MakeInactive();

function OnPossess(Pawn NewPawn)
{
    m_pov.Location = NewPawn.Location;
}

function OnUnPossess();

function Initialize(BioPlayerController NewOwner)
{
    Owner = NewOwner;
}

function bool IsCollisionEnabled()
{
    return bCollisionEnabled;
}

function Rotator GetCurrentShake()
{
    local BioActorBehavior Behavior;
    local Rotator CurrentShake;
    if (bIsCameraShakeEnabled && BioPawn(Owner.Pawn) != None)
    {
        Behavior = BioPawn(Owner.Pawn).m_oBehavior;
        if (Behavior.m_cameraShakeInterface != None)
        {
            CurrentShake = Behavior.m_cameraShakeInterface.ComputeCameraRotationDelta();
        }
    }
    return CurrentShake;
}

function DrawHUD(BioCheatManager M)
{
    M.DrawProfileText("Owner:" @ Owner);
    M.DrawProfileText("Input:" @ Input);
    M.DrawProfileText("Follow Hook:" @ HookName @ HookOffset);
    M.DrawProfileText("Last collision with:" @ LastCameraCollisionActor);
    M.DrawProfileText("Offset Hook:" @ BioPawn(Owner.Pawn).CalculateOffsetHook(vect(0,0,0), HookName));
    M.DrawProfileText("CameraBoneLocation:" @ BioPawn(Owner.Pawn).Mesh.GetBoneLocation(HookName));
    M.DrawProfileText("CameraBoneRotation:" @ QuatToRotator(BioPawn(Owner.Pawn).Mesh.GetBoneQuaternion(HookName)));
}

function bool CheckLoop(SFXCameraMode M, int RecurseLevel)
{
    return false;
}

function Vector GetCollisionCameraHook()
{
    local bool bIsValid;
    local Vector V;
    if (BioPawn(Owner.Pawn) != None)
    {
        bIsValid = true;
        V = BioPawn(Owner.Pawn).CalculateOffsetHook(HookOffset, HookName);
    }
    else
    {
        if (SVehicle(Owner.Pawn) != None)
        {
            bIsValid = true;
            V = Owner.Pawn.Mesh.GetBoneLocation('Chassis');
            V += QuatRotateVector(QuatFromRotator(Owner.Pawn.Rotation), HookOffset);
        }
    }
    if (bIsValid)
    {
        DrawHook(V, Owner);
        return V;
    }
    else
    {
        return vect(0,0,0);
    }
}

function Vector GetActorCameraHook()
{
    local bool bIsValid;
    local Vector V;
    if (BioPawn(Owner.Pawn) != None)
    {
        bIsValid = true;
        V = BioPawn(Owner.Pawn).CalculateOffsetHook(HookOffset, HookName);
    }
    else
    {
        if (SVehicle(Owner.Pawn) != None)
        {
            bIsValid = true;
            V = Owner.Pawn.Mesh.GetBoneLocation('Chassis');
            V += QuatRotateVector(QuatFromRotator(Owner.Pawn.Rotation), HookOffset);
        }
    }
    if (bIsValid)
    {
        DrawHook(V, Owner);
        return V;
    }
    else
    {
        return vect(0,0,0);
    }
}

defaultproperties
{
    bCollisionEnabled=true
    HookOffset=(X=0,Y=0,Z=98)
    HookName=Camera
    FOV=70
    m_pov=(Location=?,Rotation=?,FOV=?)
    Input=SFXCameraInput's_Input'
    m_fAspectRatio=1,777778
    Debugger=BioCameraDebugger's_pDefaultDebugger'
    // child object s_Input of type SFXCameraInput
    // child object s_pDefaultDebugger of type BioCameraDebugger
}
