﻿class SFXCameraTransition_Animated extends SFXCameraMode_Interpolate;

var() float DefaultBlendOutTime;

var() float DefaultBlendInTime;

var() bool bScalePlayRate;

var() bool bAnimationBegun;

var() CameraAnim Anim;

function InitializeTransition(SFXCameraMode FromMode, SFXCameraMode ToMode, float Time, bool PreserveTarget)
{
    InitializeTransition(FromMode, ToMode, Time, PreserveTarget);
    bAnimationBegun = false;
}

function Tick(float TimeDelta)
{
    local float AnimPlaySpeed;
    Tick(TimeDelta);
    if (!bAnimationBegun)
    {
        bAnimationBegun = true;
        if (bScalePlayRate)
        {
            AnimPlaySpeed = Anim.AnimLength / TotalTime;
        }
        else
        {
            AnimPlaySpeed = 1;
            TotalTime = Anim.AnimLength;
        }
        SFXPlayerCamera(Owner.PlayerCamera).PlayCameraAnim(Anim, AnimPlaySpeed, 0, 0);
    }
}

defaultproperties
{
    Anim=CameraAnim'TestTransition'
    bScalePlayRate=true
    DefaultBlendInTime=0,2
    DefaultBlendOutTime=0,2
}
