﻿class SFXCameraTransition_FaceTarget extends SFXCameraMode_Interpolate;

var Vector StartLocation;

var Rotator StartRotation;

var Vector TargetLocation;

function InitializeTransition(SFXCameraMode FromMode, SFXCameraMode ToMode, float Time, bool PreserveTarget)
{
    From = FromMode;
    To = ToMode;
    StartRotation = From.m_pov.Rotation;
    StartLocation = From.m_pov.Location;
    To.AimAtPoint(TargetLocation);
    To.m_pov.Rotation.Pitch = StartRotation.Pitch;
    Owner.SetRotation(To.m_pov.Rotation);
    bComplete = false;
    CurrentTime = 0;
    TotalTime = Time;
    if (TotalTime == 0)
    {
        TotalTime = 1E-05;
    }
    To.Owner = From.Owner;
}

function Tick(float TimeDelta)
{
    local float T;
    From.Tick(TimeDelta);
    To.Tick(TimeDelta);
    CurrentTime += TimeDelta;
    if (CurrentTime >= TotalTime)
    {
        bComplete = true;
        CurrentTime = TotalTime;
    }
    T = Interpolate(CurrentTime / TotalTime);
    if (From != None && To != None)
    {
        Class'BioInterpolator'.InterpolateVector(m_pov.Location, 0, StartLocation, To.m_pov.Location, T);
        Class'BioInterpolator'.InterpolateRotator(m_pov.Rotation, 0, StartRotation, To.m_pov.Rotation, T);
        Class'BioInterpolator'.InterpolateFloat(m_pov.FOV, 0, From.m_pov.FOV, To.m_pov.FOV, T);
    }
}

defaultproperties
{
    HookOffset=(X=0,Y=0,Z=79)
}
