﻿class SFXCameraTransition_VanguardSlam extends SFXCameraTransition_Animated;

var float FirstPhaseLength;

var transient float FOVChange;

var InterpCurveFloat MovementCurve;

var InterpCurveFloat FOVCurve;

var Actor TargetActor;

var transient float StartFOV;

var transient Rotator StartRotation;

var transient Vector StartLocation;

function InitializeTransition(SFXCameraMode FromMode, SFXCameraMode ToMode, float Time, bool PreserveTarget)
{
    From = FromMode;
    To = ToMode;
    StartRotation = From.m_pov.Rotation;
    StartLocation = From.m_pov.Location;
    StartFOV = From.m_pov.FOV;
    To.AimAtPoint(TargetActor.Location);
    To.m_pov.Rotation.Pitch = StartRotation.Pitch;
    bComplete = false;
    CurrentTime = 0;
    TotalTime = Time;
    if (TotalTime == 0)
    {
        TotalTime = 1E-05;
    }
    To.Owner = From.Owner;
    MovementCurve.Points[1].InVal = FirstPhaseLength / TotalTime;
    FOVCurve.Points[1].InVal = FirstPhaseLength / TotalTime;
}

function Tick(float TimeDelta)
{
    local float T;
    From.Tick(TimeDelta);
    To.Tick(TimeDelta);
    CurrentTime += TimeDelta;
    if (CurrentTime >= TotalTime)
    {
        bComplete = true;
        CurrentTime = TotalTime;
    }
    T = Interpolate(CurrentTime / TotalTime);
    if (From != None && To != None)
    {
        Class'BioInterpolator'.InterpolateFloatCurve(m_pov.Location.X, MovementCurve, StartLocation.X, To.m_pov.Location.X, T);
        Class'BioInterpolator'.InterpolateFloatCurve(m_pov.Location.Y, MovementCurve, StartLocation.Y, To.m_pov.Location.Y, T);
        Class'BioInterpolator'.InterpolateFloatCurve(m_pov.Location.Z, MovementCurve, StartLocation.Z, To.m_pov.Location.Z, T);
        Class'BioInterpolator'.InterpolateRotator(m_pov.Rotation, 0, StartRotation, To.m_pov.Rotation, T);
        Class'BioInterpolator'.InterpolateFloatCurve(m_pov.FOV, FOVCurve, StartFOV, FOVChange, T);
    }
}

defaultproperties
{
    FOVCurve=(Points=?,InterpMethod=?)
    MovementCurve=(Points=?,InterpMethod=?)
    FOVChange=120
    DefaultBlendInTime=0
    bCollisionEnabled=false
}
