﻿class SFXCustomAction_BovineFortitude extends SFXCustomAction_DamageReaction
    config(Game);

var WwiseEvent Moo;

var float HealDuration;

function BodyStanceAnimEndNotification(AnimNodeSequence SeqNode, float PlayedTime, float ExcessTime)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect Effect;
    local float fHealAmount;
    BodyStanceAnimEndNotification(SeqNode, PlayedTime, ExcessTime);
    Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(Effect)
        {
            if (Effect.Category == 'BovineFortitude')
            {
                Effect.CurrentTime = Effect.Duration - HealDuration;
            }
        }
    }
    fHealAmount = SFXGame(oPawn.WorldInfo.Game).BonusList.RchBovineFortitudeCache;
    Class'BioPowerScriptDesign'.ApplyTemporaryGameEffect(oPawn, Class'SFXGameEffect_HealOverTime', HealDuration, oPawn.GetMaxHealth() * fHealAmount, 'BovineFortitude', oPawn.Controller);
    oPawn.SetTimer(HealDuration, false, 'DelayedSoundEffect', self);
}

function DelayedSoundEffect()
{
    SFXGame(oPawn.WorldInfo.Game).PlayTransientSound(Moo, oPawn.Location);
}

defaultproperties
{
    HealDuration=1
    Moo=WwiseEvent'Play_vfx_bovine_fortitude'
    fAnimPlayRate=1,1
    fAnimBlendOutTime=0,1
    bAllowAnimInterrupt=false
    fReactionDuration=0
    ERootMotionMode=RMM_Translate
}
