﻿class SFXCustomAction_MawBurrow extends BioCustomAction
    config(Game);

var EMawBurrowAction m_eCurrentBurrowAction;

var() BodyStance BS_MawRaise;

var() BodyStance BS_MawLower;

enum EMawBurrowAction
{
    EMB_Lower,
    EMB_Raise,
};

function StartCustomAction()
{
    StartCustomAction();
    if (oPawn.PlayBodyStance(BS_MawLower, 1, 0,2, 0, false, true, true) != 0)
    {
        oPawn.SetBodyStanceAnimEndNotification(BS_MawLower, true);
        m_eCurrentBurrowAction = 0;
    }
}

function StopCustomAction()
{
    StopCustomAction();
    switch (m_eCurrentBurrowAction)
    {
        case 0:
            oPawn.StopBodyStance(BS_MawLower, 0,5);
            oPawn.SetBodyStanceAnimEndNotification(BS_MawLower, false);
            break;
        case 1:
            oPawn.StopBodyStance(BS_MawRaise, 0,2);
            oPawn.SetBodyStanceAnimEndNotification(BS_MawRaise, false);
            break;
    }
}

function ContinueCustomAction()
{
    oPawn.BS_UnpauseAnim(BS_MawRaise);
}

function BodyStanceAnimEndNotification(AnimNodeSequence SeqNode, float PlayedTime, float ExcessTime)
{
    if (m_eCurrentBurrowAction == 0)
    {
        m_eCurrentBurrowAction = 1;
        if (oPawn.PlayBodyStance(BS_MawRaise, 1, 0, 1, false, true, true) != 0)
        {
            oPawn.SetBodyStanceAnimEndNotification(BS_MawLower, false);
            oPawn.SetBodyStanceAnimEndNotification(BS_MawRaise, true);
            oPawn.BS_PauseAnim(BS_MawRaise);
        }
    }
    else
    {
        if (SFXAI_Core(oPawn.Controller) != None)
        {
            SFXAI_Core(oPawn.Controller).EndCustomAction();
        }
    }
}

defaultproperties
{
}
