﻿class SFXCustomAction_Melee extends BioCustomAction
    config(Game);

var() float Force;

var() float Damage;

var() ForceFeedbackWaveform HitForceFeedback;

var() ScreenShakeStruct HitShake;

var() AnimSet AnimSet;

var() BodyStance BS_Swipe;

function StartCustomAction()
{
    StartCustomAction();
    oPawn.AddAnimSet(AnimSet);
    oPawn.PlayBodyStance(BS_Swipe, 1, 0,2, 0, true, true, true);
    oPawn.SetTimer(0,5, false, 'Impact', self);
}

function Impact()
{
    local BioPawn HitPawn;
    local BioPower MeleePower;
    local SFXWeapon Weapon;
    oPawn.SetTimer(0,5, false, 'EndAction', self);
    foreach oPawn.VisibleCollidingActors(Class'BioPawn', HitPawn, 150)
    {
        if (oPawn.IsHostile(HitPawn))
        {
            Weapon = SFXWeapon(oPawn.Weapon);
            MeleePower = oPawn.m_oBehavior.FindPower(Weapon.MeleePowerName);
            if (MeleePower != None && MeleePower.Script != None)
            {
                MeleePower.Script.OnImpact(oPawn, 1, HitPawn, 0);
            }
        }
    }
}

function EndAction()
{
    oPawn.StopBodyStance(BS_Swipe, 0,2);
    oPawn.SetBodyStanceAnimEndNotification(BS_Swipe, false);
    oPawn.SetTimer(0,2, false, 'CleanUp', self);
    if (SFXPlayerController(oPawn.Controller) != None)
    {
        SFXPlayerController(oPawn.Controller).EndCustomAction();
    }
    else
    {
        if (SFXAI_Core(oPawn.Controller) != None)
        {
            SFXAI_Core(oPawn.Controller).EndCustomAction();
        }
    }
}

function CleanUp()
{
    oPawn.RmvAnimSet(AnimSet);
}

defaultproperties
{
    AnimSet=AnimSet'HMM_BC_RifleGunButt'
    HitForceFeedback=ForceFeedbackWaveform'HitShakeFF0'
    Damage=10
    Force=400
    // child object HitShakeFF0 of type ForceFeedbackWaveform
}
