﻿class SFXGameEffect_ArmorBonus extends SFXGameEffect
    hidecategories(Object);

function ComputeEffectValue(out float Value)
{
    if (EffectValue > Value)
    {
        Value = EffectValue;
    }
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn oPawn;
    local SFXArmor_Base Armor;
    if (Owner == None)
    {
        return;
    }
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Armor = SFXArmor_Base(oPawn.InvManager.FindInventoryType(Class'SFXArmor_Base', true));
        if (Armor != None)
        {
            Armor.bShowFortifyOnGUI = true;
        }
    }
}

function OnRemoved()
{
    local SFXModule_GameEffectManager Manager;
    local BioPawn oPawn;
    local SFXArmor_Base Armor;
    local SFXGameEffect oEffect;
    if (Owner == None)
    {
        return;
    }
    Manager = Owner.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class == Class'SFXGameEffect_ArmorBonus')
            {
                if (oEffect != self)
                {
                    return;
                }
            }
        }
    }
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Armor = SFXArmor_Base(oPawn.InvManager.FindInventoryType(Class'SFXArmor_Base', true));
        if (Armor != None)
        {
            Armor.bShowFortifyOnGUI = false;
        }
    }
}

defaultproperties
{
}
