﻿class SFXGameEffect_Cloak extends SFXGameEffect
    hidecategories(Object);

delegate OnCloakEnded();

function OnApplied()
{
    local BioPawn oPawn;
    local BioPawn oNearbyPawn;
    local BioPlayerSquad oPlayerSquad;
    local SFXAI_Core oController;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oPawn.bIsStealthed = true;
    oPlayerSquad = BioWorldInfo(Owner.WorldInfo).m_playerSquad;
    foreach Owner.WorldInfo.AllPawns(Class'BioPawn', oNearbyPawn)
    {
        if (BioPlayerSquad(oNearbyPawn.Squad) == oPlayerSquad)
        {
            continue;
        }
        oController = SFXAI_Core(oNearbyPawn.Controller);
        if (oController != None)
        {
            if (oController.GetTarget() == Owner)
            {
                oController.SelectTarget();
                if (oController.Focus == Owner || oController.MoveTarget == Owner)
                {
                    oController.Focus = None;
                    oController.MoveTarget = None;
                }
            }
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local float fDelay;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (CurrentTime < Duration)
    {
        fDelay = FMin(Duration - CurrentTime, 1);
        oPawn.SetTimer(fDelay, false, 'DelayedRemoval', self);
    }
    else
    {
        DelayedRemoval();
    }
}

function DelayedRemoval()
{
    local BioPawn oPawn;
    local SFXAI_Core C;
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oPawn.bIsStealthed = false;
    foreach Owner.WorldInfo.AllControllers(Class'SFXAI_Core', C)
    {
        if (C.IsHostile(oPawn.Controller) && C.EnemyList.Find('Pawn', oPawn) != -1)
        {
            SFXGame(Owner.WorldInfo.Game).TriggerVocalizationEvent(88, BioPawn(C.Pawn), oPawn);
        }
    }
    OnCloakEnded();
}

function OnCombatEnd()
{
    CurrentTime = Duration;
}

defaultproperties
{
}
