﻿class SFXGameEffect_CloakDamageBonus extends SFXGameEffect
    hidecategories(Object);

function ComputeEffectValue(out float Value)
{
    if (EffectValue > Value)
    {
        Value = EffectValue;
    }
}

function OnApplied()
{
    local BioPawn oPawn;
    local InventoryManager oInventoryManager;
    local SFXWeapon oWeapon;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oInventoryManager = oPawn.InvManager;
    if (oInventoryManager != None)
    {
        foreach oInventoryManager.InventoryActors(Class'SFXWeapon', oWeapon)
        {
            if (oWeapon != None)
            {
                oWeapon.StealthDamageIncrease = EffectValue;
            }
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local float fDelay;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (CurrentTime < Duration)
    {
        fDelay = FMin(Duration - CurrentTime, 1);
        oPawn.SetTimer(fDelay, false, 'RemoveDamageBonuses', self);
    }
    else
    {
        RemoveDamageBonuses();
    }
}

function RemoveDamageBonuses()
{
    local BioPawn oPawn;
    local InventoryManager oInventoryManager;
    local SFXWeapon oWeapon;
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oInventoryManager = oPawn.InvManager;
    if (oInventoryManager != None)
    {
        foreach oInventoryManager.InventoryActors(Class'SFXWeapon', oWeapon)
        {
            if (oWeapon != None)
            {
                oWeapon.StealthDamageIncrease = 0;
            }
        }
    }
}

function OnCombatEnd()
{
    CurrentTime = Duration;
}

defaultproperties
{
}
