﻿class SFXGameEffect_CloakTargetable extends SFXGameEffect
    hidecategories(Object);

function OnApplied()
{
    local BioPawn oPawn;
    local BioPawnBehavior oBPB;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oBPB = BioPawnBehavior(oPawn.oBioComponent);
    if (oBPB != None)
    {
        oBPB.m_bCombatTargetableOverride = true;
        oBPB.m_bCombatTargetable = false;
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local float fDelay;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (CurrentTime < Duration)
    {
        fDelay = FMin(Duration - CurrentTime, 1);
        oPawn.SetTimer(fDelay, false, 'DelayedRemoval', self);
    }
    else
    {
        DelayedRemoval();
    }
}

function DelayedRemoval()
{
    local BioPawn oPawn;
    local BioPawnBehavior oBPB;
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oBPB = BioPawnBehavior(oPawn.oBioComponent);
    if (oBPB != None)
    {
        oBPB.m_bCombatTargetableOverride = false;
        oBPB.m_bCombatTargetable = true;
    }
}

function OnCombatEnd()
{
    CurrentTime = Duration;
}

defaultproperties
{
}
