﻿class SFXGameEffect_DelayedCryoFreeze extends SFXGameEffect
    hidecategories(Object);

var BioVisualEffect CrustEffect;

var WwiseEvent FreezingSound;

var BioVFXTemplate CrustTemplate;

var BioVFXTemplate DeathEffect;

var bool bReactionPlayed;

var array<EAICustomAction> AnimatedReactions;

function OnApplied()
{
    local BioPawn oPawn;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        oPawn.StopVocalization();
        oPawn.UnCrouch();
        if (Class'BioPowerScriptDesign'.PlayRandomReaction(oPawn, Instigator, AnimatedReactions))
        {
            bReactionPlayed = true;
            jump 119;
        }
    }
    CrustEffect = Class'BioVisualEffect'.CreateCrustEffect(CrustTemplate, Owner, Duration + EffectValue, true);
    if (CrustEffect != None)
    {
        CrustEffect.SetState(0, true);
    }
    Owner.PlaySound(FreezingSound);
    return;
}

function OnUpdate(float DeltaSeconds)
{
    OnUpdate(DeltaSeconds);
    if (bReactionPlayed && Duration > 0)
    {
        Owner.CustomTimeDilation = FClamp(1 - CurrentTime / Duration, 0,05, 1);
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local BioVisualEffect VFXInstance;
    local SFXGameEffect_CryoFreeze FreezeEffect;
    local SFXGameEffect_HealthRegenPenalty HoTDebuffEffect;
    local SFXModule_GameEffectManager Manager;
    OnRemoved();
    Owner.CustomTimeDilation = 1;
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (oPawn.IsDead() && oPawn.CanPlayDeathEffect(self))
    {
        VFXInstance = oPawn.CreateDeathEffect(DeathEffect, true, true);
        if (VFXInstance != None)
        {
            VFXInstance.SetVectorParameter('BlastDirection', Normal(oPawn.Velocity));
        }
        return;
    }
    Class'BioPowerScriptDesign'.RemoveBioticEffects(oPawn, true);
    if (oPawn.GetCurrentShields() > 0)
    {
        return;
    }
    else
    {
        Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            FreezeEffect = SFXGameEffect_CryoFreeze(Manager.CreateEffect(Class'SFXGameEffect_CryoFreeze', Category, EffectValue, 1, 1, Instigator));
            if (FreezeEffect != None)
            {
                FreezeEffect.CrustEffect = CrustEffect;
                CrustEffect = None;
                FreezeEffect.OnApplied();
            }
            HoTDebuffEffect = SFXGameEffect_HealthRegenPenalty(Manager.CreateEffect(Class'SFXGameEffect_HealthRegenPenalty', Category, EffectValue, 1, 1, Instigator));
            if (HoTDebuffEffect != None)
            {
                HoTDebuffEffect.OnApplied();
            }
        }
    }
}

defaultproperties
{
    AnimatedReactions(0)=AI_CustomAction_Freezing
    DeathEffect=BioVFXTemplate'Cryo_Shatter_VFX'
    CrustTemplate=BioVFXTemplate'Cryo_Freeze_VFX'
    FreezingSound=WwiseEvent'Play_vfx_cryo_freeze'
}
