﻿class SFXGameEffect_HealthBonus extends SFXGameEffect
    hidecategories(Object);

var float PercentHealthBonus;

function ComputeEffectValue(out float Value)
{
    Value += PercentHealthBonus - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local SFXModule_Damage DmgModule;
    local float fBaseMaxHealth;
    OnApplied();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            fBaseMaxHealth = Lerp(DmgModule.MaxHealth.X, DmgModule.MaxHealth.Y, DmgModule.MaxHealth.Level / DmgModule.MaxHealth.MaxLevel);
            if (fBaseMaxHealth > 0)
            {
                PercentHealthBonus = fBaseMaxHealth + EffectValue / fBaseMaxHealth;
                DmgModule.MaxHealth.Bonuses.AddItem(self);
                Class'SFXGame'.ReCalculate(DmgModule.MaxHealth);
                DmgModule.MaxHealth.Value = DmgModule.MaxHealth.Value + 0,5;
                DmgModule.CurrentHealth += EffectValue;
            }
        }
    }
}

function OnRemoved()
{
    local SFXModule_Damage DmgModule;
    OnRemoved();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            DmgModule.MaxHealth.Bonuses.RemoveItem(self);
            Class'SFXGame'.ReCalculate(DmgModule.MaxHealth);
            DmgModule.CurrentHealth = FClamp(DmgModule.CurrentHealth, DmgModule.CurrentHealth, DmgModule.MaxHealth.Value);
        }
    }
}

defaultproperties
{
}
