﻿class SFXGameEffect_PassiveHealthBonus extends SFXGameEffect
    hidecategories(Object);

var float AppliedBonus;

function ComputeEffectValue(out float Value)
{
    Value += EffectValue - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local SFXModule_Damage DmgModule;
    OnApplied();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            DmgModule.MaxHealth.Bonuses.AddItem(self);
            Class'SFXGame'.ReCalculate(DmgModule.MaxHealth);
            DmgModule.MaxHealth.Value = DmgModule.MaxHealth.Value + 0,5;
            DmgModule.CurrentHealth += AppliedBonus;
        }
    }
}

function OnRemoved()
{
    local SFXModule_Damage DmgModule;
    OnRemoved();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            DmgModule.MaxHealth.Bonuses.RemoveItem(self);
            Class'SFXGame'.ReCalculate(DmgModule.MaxHealth);
        }
    }
}

defaultproperties
{
}
