﻿class SFXGameEffect_PassiveMovementSpeedBonus extends SFXGameEffect
    hidecategories(Object);

var bool bRemoved;

function ComputeEffectValue(out float Value)
{
    if (bRemoved == false)
    {
        Value += EffectValue;
    }
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn oPawn;
    local BioPawnType PawnType;
    local SFXMovementData MoveData;
    local SFXModule_GameEffectManager Manager;
    local float fModifier;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager == None)
        {
            return;
        }
        PawnType = BioPawnType(oPawn.ActorType);
        if (PawnType != None && PawnType.m_oAppearance != None && PawnType.m_oAppearance.MovementInfo != None)
        {
            MoveData = PawnType.m_oAppearance.MovementInfo;
            fModifier = Manager.GetEffectValue(Class'SFXGameEffect_PassiveMovementSpeedBonus', 1);
            oPawn.WalkSpeed = MoveData.WalkSpeed * fModifier;
            oPawn.GroundSpeed = MoveData.GroundSpeed * fModifier;
            oPawn.CombatWalkSpeed = MoveData.CombatWalkSpeed * fModifier;
            oPawn.CombatGroundSpeed = MoveData.CombatGroundSpeed * fModifier;
            oPawn.CoverGroundSpeed = MoveData.CoverGroundSpeed * fModifier;
            oPawn.CoverCrouchGroundSpeed = MoveData.CoverCrouchGroundSpeed * fModifier;
            oPawn.CrouchGroundSpeed = MoveData.CrouchGroundSpeed * fModifier;
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local BioPawnType PawnType;
    local SFXMovementData MoveData;
    local SFXModule_GameEffectManager Manager;
    local float fModifier;
    OnRemoved();
    bRemoved = true;
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager == None)
        {
            return;
        }
        PawnType = BioPawnType(oPawn.ActorType);
        if (PawnType != None && PawnType.m_oAppearance != None && PawnType.m_oAppearance.MovementInfo != None)
        {
            MoveData = PawnType.m_oAppearance.MovementInfo;
            fModifier = Manager.GetEffectValue(Class'SFXGameEffect_PassiveMovementSpeedBonus', 1);
            oPawn.WalkSpeed = MoveData.WalkSpeed * fModifier;
            oPawn.GroundSpeed = MoveData.GroundSpeed * fModifier;
            oPawn.CombatWalkSpeed = MoveData.CombatWalkSpeed * fModifier;
            oPawn.CombatGroundSpeed = MoveData.CombatGroundSpeed * fModifier;
            oPawn.CoverGroundSpeed = MoveData.CoverGroundSpeed * fModifier;
            oPawn.CoverCrouchGroundSpeed = MoveData.CoverCrouchGroundSpeed * fModifier;
            oPawn.CrouchGroundSpeed = MoveData.CrouchGroundSpeed * fModifier;
        }
    }
}

defaultproperties
{
    EffectValue=0,1
}
