﻿class SFXGameEffect_PassiveShieldBonus extends SFXGameEffect
    hidecategories(Object);

function ComputeEffectValue(out float Value)
{
    Value += EffectValue - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    local float fShieldsBefore;
    OnApplied();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            fShieldsBefore = Shields.MaxShields.Value;
            Shields.MaxShields.Bonuses.AddItem(self);
            Shields.ScaleShields();
            Shields.MaxShields.Value = Shields.MaxShields.Value + 0,5;
            if (Shields.MaxShields.Value - fShieldsBefore > 0)
            {
                Shields.CurrentShields += Shields.MaxShields.Value - fShieldsBefore;
            }
        }
    }
}

function OnRemoved()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    OnRemoved();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            Shields.MaxShields.Bonuses.RemoveItem(self);
            Shields.ScaleShields();
            Shields.CurrentShields = FClamp(Shields.CurrentShields, 0, Shields.MaxShields.Value);
        }
    }
}

defaultproperties
{
}
