﻿class SFXGameEffect_PassiveStormSpeedBonus extends SFXGameEffect
    hidecategories(Object);

var bool bRemoved;

function ComputeEffectValue(out float Value)
{
    if (bRemoved == false)
    {
        Value += EffectValue;
    }
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn oPawn;
    local BioPawnType PawnType;
    local SFXMovementData MoveData;
    local SFXModule_GameEffectManager Manager;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager == None)
        {
            return;
        }
        PawnType = BioPawnType(oPawn.ActorType);
        if (PawnType != None && PawnType.m_oAppearance != None && PawnType.m_oAppearance.MovementInfo != None)
        {
            MoveData = PawnType.m_oAppearance.MovementInfo;
            oPawn.StormSpeed = MoveData.StormSpeed * Manager.GetEffectValue(Class'SFXGameEffect_PassiveStormSpeedBonus', 1);
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local BioPawnType PawnType;
    local SFXMovementData MoveData;
    local SFXModule_GameEffectManager Manager;
    OnRemoved();
    bRemoved = true;
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager == None)
        {
            return;
        }
        PawnType = BioPawnType(oPawn.ActorType);
        if (PawnType != None && PawnType.m_oAppearance != None && PawnType.m_oAppearance.MovementInfo != None)
        {
            MoveData = PawnType.m_oAppearance.MovementInfo;
            oPawn.StormSpeed = MoveData.StormSpeed * Manager.GetEffectValue(Class'SFXGameEffect_PassiveStormSpeedBonus', 1);
        }
    }
}

defaultproperties
{
}
