﻿class SFXGameEffect_ShieldBonus extends SFXGameEffect
    hidecategories(Object);

var float PercentShieldBonus;

function ComputeEffectValue(out float Value)
{
    Value += PercentShieldBonus - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    local float fMaxBaseShields;
    OnApplied();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            fMaxBaseShields = Lerp(Shields.MaxShields.X, Shields.MaxShields.Y, Shields.MaxShields.Level / Shields.MaxShields.MaxLevel);
            if (fMaxBaseShields > 0)
            {
                PercentShieldBonus = fMaxBaseShields + EffectValue / fMaxBaseShields;
                Shields.MaxShields.Bonuses.AddItem(self);
                Shields.ScaleShields();
                Shields.MaxShields.Value = Shields.MaxShields.Value + 0,5;
                Shields.CurrentShields += EffectValue;
            }
        }
    }
}

function OnRemoved()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    OnRemoved();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            Shields.MaxShields.Bonuses.RemoveItem(self);
            Shields.ScaleShields();
            Shields.CurrentShields = FClamp(Shields.CurrentShields, 0, Shields.MaxShields.Value);
        }
    }
}

defaultproperties
{
}
