﻿class SFXGameEffect_ShieldBoost extends SFXGameEffect
    hidecategories(Object);

function OnApplied()
{
    local BioPawn oPawn;
    local SFXShield_Base oShields;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oShields = oPawn.GetShields();
    if (oShields == None)
    {
        return;
    }
    if (IsShieldBoosted(oPawn))
    {
        return;
    }
    oShields.BoostedShieldMax = oPawn.GetMaxShields() + EffectValue;
    oShields.CurrentShields = oPawn.GetMaxShields();
}

function OnRemoved()
{
    local BioPawn oPawn;
    local SFXShield_Base oShields;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (IsShieldBoosted(oPawn))
    {
        return;
    }
    oShields = oPawn.GetShields();
    if (oShields == None)
    {
        return;
    }
    oShields.BoostedShieldMax = 0;
    if (oShields.CurrentShields > oPawn.GetMaxShields())
    {
        oShields.CurrentShields = oPawn.GetMaxShields();
    }
}

function bool IsShieldBoosted(BioPawn oPawn)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    if (oPawn == None)
    {
        return false;
    }
    Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class == Class'SFXGameEffect_ShieldBoost' && oEffect != self)
            {
                return true;
            }
        }
    }
    return false;
}

defaultproperties
{
}
