﻿class SFXGameEffect_TimeDilation extends SFXGameEffect
    hidecategories(Object);

var float TimeRemainingBeforePause;

var InterpCurveFloat SlowDown;

function OnApplied()
{
    SlowDown.Points[1].OutVal = 1 - EffectValue;
    SlowDown.Points[2].OutVal = 1 - EffectValue;
    Duration = Duration * 1 - EffectValue;
    SFXGame(Owner.WorldInfo.Game).RequestTimeDilation(SlowDown, Duration, Category);
}

function OnUpdate(float TimeDelta)
{
    local float WorldTimeDilation;
    OnUpdate(TimeDelta);
    if (Owner != None)
    {
        WorldTimeDilation = Owner.WorldInfo.TimeDilation;
        if (WorldTimeDilation > 0)
        {
            Owner.CustomTimeDilation = 1 / WorldTimeDilation;
            if (Pawn(Owner) != None)
            {
                Pawn(Owner).Controller.CustomTimeDilation = 1 / WorldTimeDilation;
            }
        }
    }
}

function OnRemoved()
{
    OnRemoved();
    if (Owner != None)
    {
        Owner.CustomTimeDilation = 1;
        if (Pawn(Owner) != None)
        {
            Pawn(Owner).Controller.CustomTimeDilation = 1;
        }
        if (Owner.WorldInfo != None && Owner.WorldInfo.Game != None)
        {
            SFXGame(Owner.WorldInfo.Game).CancelTimeDilation(Category);
        }
    }
}

function OnPaused()
{
    TimeRemainingBeforePause = Duration - CurrentTime;
    if (TimeRemainingBeforePause < 0)
    {
        TimeRemainingBeforePause = 0;
    }
    OnRemoved();
}

function OnUnpaused()
{
    Duration = TimeRemainingBeforePause;
    OnApplied();
}

defaultproperties
{
    SlowDown=(Points=?,InterpMethod=?)
}
