﻿class SFXGameEffect_WeaponVFXChange extends SFXGameEffect
    hidecategories(Object);

var SFXWeapon CastAtWeapon;

var ParticleSystem oImpactVFX;

var ParticleSystem oMuzzleLoopVFX;

var ParticleSystem oMuzzleVFX;

var StaticMesh Tracer;

var bool bModifyImpactVFX;

var bool bModifyMuzzleFlash;

var bool bModifyTracer;

function OnApplied()
{
    OnApplied();
    if (CastAtWeapon == None)
    {
        return;
    }
    if (bModifyTracer)
    {
        CastAtWeapon.TracerInfo.StaticMesh = Tracer;
    }
    if (bModifyImpactVFX && oImpactVFX != None)
    {
        CastAtWeapon.PS_DefaultImpactEffect = oImpactVFX;
    }
    if (bModifyMuzzleFlash)
    {
        if (UseLoopingMuzzleVFX(CastAtWeapon))
        {
            CastAtWeapon.PSC_MuzFlashEmitter.SetTemplate(oMuzzleLoopVFX);
        }
        else
        {
            CastAtWeapon.PSC_MuzFlashEmitter.SetTemplate(oMuzzleVFX);
        }
    }
}

function OnRemoved()
{
    OnRemoved();
    if (CastAtWeapon == None)
    {
        return;
    }
    CastAtWeapon.TracerInfo.StaticMesh = CastAtWeapon.Default.TracerInfo.StaticMesh;
    CastAtWeapon.PS_DefaultImpactEffect = CastAtWeapon.Default.PS_DefaultImpactEffect;
    if (CastAtWeapon.PSC_MuzFlashEmitter != None)
    {
        CastAtWeapon.PSC_MuzFlashEmitter.SetTemplate(CastAtWeapon.PSC_MuzFlashEmitter.Default.Template);
    }
}

function bool UseLoopingMuzzleVFX(SFXWeapon Weapon)
{
    if (Weapon == None)
    {
        return false;
    }
    if (SFXWeapon_AssaultRifle_Base(Weapon) != None)
    {
        return true;
    }
    if (SFXWeapon_AutoPistol_Base(Weapon) != None)
    {
        return true;
    }
    return false;
}

defaultproperties
{
}
