﻿class SFXGameModeCinematic extends SFXGameModeBase
    within BioPlayerController
    config(Input);

function Activated()
{
    local Actor A;
    local SFXSelectionModule SelMod;
    Activated();
    Outer.m_oPlayerSelection.SelectionFlareComp.SetHidden(true);
    foreach BioWorldInfo(Outer.WorldInfo).SelectableActors(A)
    {
        SelMod = A.GetModule(Class'SFXSelectionModule');
        if (SelMod != None && SelMod.LensFlareComp != None)
        {
            SelMod.LensFlareComp.SetHidden(true);
        }
    }
    RemoveTimeDilationEffects();
}

exec function SkipCinematic()
{
    local BioWorldInfo BWI;
    BWI = BioWorldInfo(Outer.WorldInfo);
    if (BWI != None && BWI.m_bDisableCinematicSkip == false)
    {
        BWI.m_bCinematicSkip = true;
        BWI.TriggerCinematicSkippedEvent();
    }
    else
    {
        Outer.GetScaleFormManager().PlayGuiSound('CinematicSkipError');
    }
}

defaultproperties
{
    Bindings=System.Byte[]
    bShowSubtitle=true
    bHasMouseAuthority=true
    bMergeNotifications=true
    bQueueAndSuppressNotifications=true
    bEnforce16x9Subtitiles=true
}
