﻿class SFXHeavyWeapon extends SFXWeapon
    hidecategories(Navigation)
    config(Weapon)
    abstract;

simulated function ConsumeAmmo(byte FireModeNum)
{
    if (Instigator.IsHumanControlled())
    {
        ConsumeAmmo(FireModeNum);
    }
}

function int AddAmmo(int Amount)
{
    return 0;
}

simulated function float GetCurrentSpareAmmo()
{
    return 0;
}

function ScaleWeapon(int Level)
{
    if (SFXPawn_Player(Owner) != None || SFXPawn_Henchman(Owner) != None)
    {
        MagSize.StaticBonus = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHWAmmoCache;
    }
    ScaleWeapon(Level);
}

final function int AddHeavyAmmo(int Ammo)
{
    local int OldCount;
    OldCount = AmmoUsedCount;
    AmmoUsedCount = FMax(0, AmmoUsedCount - Ammo);
    return AmmoUsedCount - OldCount;
}

function PlayLowAmmoVocalization();

defaultproperties
{
    bInfiniteAmmo=false
    bCanDropAmmo=false
    AI_AimDelay=(X=0,75,Y=0,75)
    SwitchPriority=-1
    AnimType=WeaponAnimType_Rifle
    AttachSlot=EASlot_CenterBack
    WeaponFireWaveForm=ForceFeedbackWaveform'ForceFeedbackWaveformBase'
    PSC_ReloadVent=ParticleSystemComponent'ReloadVent0'
    SteamSoundThreshold=-1
    Range_Medium=2000
    Range_Long=3000
    GUIClassName=System.Byte[]
    GUIClassDescription=System.Byte[]
    AmmoPowerPSCO=ParticleSystemComponent'AmmoPowerHologram'
    AmmoPowerIconPSCO=ParticleSystemComponent'AmmoPowerIconHologram'
    VocalizationType=SFXVocalizationWeapon_HeavyWeapon
    // child object ForceFeedbackWaveformBase of type ForceFeedbackWaveform
    // child object AmmoPowerHologram of type ParticleSystemComponent
    // child object AmmoPowerIconHologram of type ParticleSystemComponent
    // child object ReloadVent0 of type ParticleSystemComponent
    // child object WeaponMesh of type SkeletalMeshComponent
}
