﻿class SFXInterpTrackAttachCrustEffect extends SFXGameInterpTrackCustom
    hidecategories(Object)
    native
    collapsecategories;

struct native SFXAttachCrustEffectTrackData
{
    var() bool m_bAttach;

    var() float m_fLifeTime;

}

var() array<BioSeqVar_ObjectFindByTag> m_aTarget;

var() BioVFXTemplate oEffect;

var() array<SFXAttachCrustEffectTrackData> m_aCrustEffectKeyData;

static event bool AllowKeyNaming()
{
    return true;
}

static event String NewKeyDefaultName()
{
    return "CrustEffectAttach";
}

static event String KeyDataArrayName()
{
    return "m_aCrustEffectKeyData";
}

static event String KeyDataDisplayName()
{
    return "Crust Effect Key Data";
}

event TriggerKey(BioInterpTrackInst pTrackInst, bool bAttach, float fLifeTime)
{
    local BioSeqAct_AttachCrustEffect Seq;
    local Actor CurrentTarget;
    local int I;
    Seq = new(Outer,Class'BioSeqAct_AttachCrustEffect');
    Seq.oEffect = oEffect;
    Seq.fLifeTime = fLifeTime;
    if (bAttach)
    {
        Seq.InputLinks[0].bHasImpulse = true;
        Seq.InputLinks[1].bHasImpulse = false;
    }
    else
    {
        Seq.InputLinks[0].bHasImpulse = false;
        Seq.InputLinks[1].bHasImpulse = true;
    }
    if (m_aTarget.Length > 0)
    {
        I = 0;
        while (I < m_aTarget.Length)
        {
            CurrentTarget = Actor(GetObjectRef(m_aTarget[I]));
            Seq.Target = CurrentTarget;
            if (CurrentTarget != None)
            {
                Seq.Activated();
                jump 312;
            }
            I++;
        }
    }
    else
    {
        if (pTrackInst != None)
        {
            CurrentTarget = GetGroupLinkedActor(pTrackInst);
            Seq.Target = CurrentTarget;
            if (CurrentTarget != None)
            {
                Seq.Activated();
            }
        }
    }
    return;
}

defaultproperties
{
    TrackInstClass=None
    TrackTitle="Attach Crust Effect"
}
