﻿class SFXInterpTrackAttachToActor extends SFXGameInterpTrackCustom
    hidecategories(Object)
    native
    collapsecategories;

var() Rotator RelativeRotation;

var() Vector RelativeOffset;

var() Name BoneName;

var() bool bUseRelativeRotation;

var() bool bUseRelativeOffset;

var() bool bHardAttach;

var() bool bDetach;

var() array<BioSeqVar_ObjectFindByTag> m_aTarget;

static event bool AllowKeyNaming()
{
    return true;
}

static event String NewKeyDefaultName()
{
    return "AttachToActor";
}

static event String KeyDataArrayName()
{
    return "";
}

static event String KeyDataDisplayName()
{
    return "AttachToActorKeyData";
}

event TriggerKey(BioInterpTrackInst pTrackInst)
{
    local SeqAct_AttachToActor Seq;
    local Actor CurrentTarget;
    local int I;
    Seq = new(Outer,Class'SeqAct_AttachToActor');
    if (m_aTarget.Length > 0)
    {
        I = 0;
        while (I < m_aTarget.Length)
        {
            CurrentTarget = Actor(GetObjectRef(m_aTarget[I]));
            if (CurrentTarget != None)
            {
                CurrentTarget.OnAttachToActor(Seq);
                jump 125;
            }
            I++;
        }
    }
    else
    {
        if (pTrackInst != None)
        {
            CurrentTarget = GetGroupLinkedActor(pTrackInst);
            if (CurrentTarget != None)
            {
                CurrentTarget.OnAttachToActor(Seq);
            }
        }
    }
    return;
}

defaultproperties
{
    TrackInstClass=None
    TrackTitle="Attach To Actor Track"
}
