﻿class SFXInterpTrackAttachVFXToObject extends SFXGameInterpTrackCustom
    hidecategories(Object)
    native
    collapsecategories;

var() array<BioSeqVar_ObjectFindByTag> m_aAttachToTarget;

var() BioVFXTemplate m_oEffect;

var() Vector m_vOffset;

var() Name m_nmSocketOrBone;

static event bool AllowKeyNaming()
{
    return true;
}

static event String NewKeyDefaultName()
{
    return "AttachVFX";
}

static event String KeyDataArrayName()
{
    return "";
}

static event String KeyDataDisplayName()
{
    return "Attach VFX Key Data";
}

event TriggerKey(BioInterpTrackInst pTrackInst)
{
    local BioSeqAct_AttachVisualEffect Seq;
    local Actor CurrentTarget;
    local int I;
    Seq = new(Outer,Class'BioSeqAct_AttachVisualEffect');
    Seq.m_nmSocketOrBone = m_nmSocketOrBone;
    Seq.m_vOffset = m_vOffset;
    Seq.m_oEffect = m_oEffect;
    Seq.m_oAttachTo.Length = 0;
    if (m_aAttachToTarget.Length > 0)
    {
        I = 0;
        while (I < m_aAttachToTarget.Length)
        {
            CurrentTarget = Actor(GetObjectRef(m_aAttachToTarget[I]));
            if (CurrentTarget != None)
            {
                Seq.m_oAttachTo.AddItem(CurrentTarget);
            }
            I++;
        }
    }
    else
    {
        if (pTrackInst != None)
        {
            CurrentTarget = GetGroupLinkedActor(pTrackInst);
            if (CurrentTarget != None)
            {
                Seq.m_oAttachTo.AddItem(CurrentTarget);
            }
        }
    }
    Seq.Activated();
}

defaultproperties
{
    TrackInstClass=None
    TrackTitle="Attach VFX"
}
