﻿class SFXKActor extends KActor
    native
    placeable;

var(Physics) bool bKinematicUntilMoved;

var(Physics) bool bImmovable;

var transient Actor m_aLastCollidedActor;

var transient float m_fPhysicsSoundLastTimePlayed;

event ExceededPhysicsThreshold(Actor InstigatedBy)
{
    local int idx;
    local SFXSeqEvt_ExceededPhysicsThreshold exceededPhysicsEvent;
    ExceededPhysicsThreshold(InstigatedBy);
    SetPhysics(10);
    idx = 0;
    while (idx < GeneratedEvents.Length)
    {
        exceededPhysicsEvent = SFXSeqEvt_ExceededPhysicsThreshold(GeneratedEvents[idx]);
        if (exceededPhysicsEvent != None)
        {
            exceededPhysicsEvent.CheckActivate(self, InstigatedBy);
        }
        idx++;
    }
}

simulated function TakeRadiusDamage(Controller InstigatedBy, float BaseDamage, float DamageRadius, class<DamageType> DamageType, float Momentum, Vector HurtOrigin, bool bFullDamage, Actor DamageCauser)
{
    if (Momentum * DamageType.Default.KDamageImpulse > m_fPhysicsThreshold)
    {
        ExceededPhysicsThreshold(InstigatedBy);
    }
    else
    {
        Momentum = 0;
    }
    TakeRadiusDamage(InstigatedBy, BaseDamage, DamageRadius, DamageType, Momentum, HurtOrigin, bFullDamage, DamageCauser);
}

event TakeDamage(float Damage, Controller InstigatedBy, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
{
    if (VSize(Momentum) * DamageType.Default.KDamageImpulse > m_fPhysicsThreshold)
    {
        ExceededPhysicsThreshold(InstigatedBy);
    }
    else
    {
        Momentum = vect(0,0,0);
    }
    TakeDamage(Damage, InstigatedBy, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
}

native function ImpulseFragments(Vector Source, Vector Momentum, Vector Extent, optional bool bVelChange);

defaultproperties
{
    bImmovable=true
    StaticMeshComponent=None
    LightEnvironment=None
    Components=None
    // child object MyLightEnvironment of type DynamicLightEnvironmentComponent
    // child object StaticMeshComponent0 of type StaticMeshComponent
}
