﻿class SFXOnlineComponentUI extends SFXOnlineComponent
    implements(ISFXOnlineComponentUserInterface)
    native;

var Name HandlerId;

var transient SFXSFHandler_EANetworking m_oGUI;

var const native Pointer VfTable_IISFXOnlineComponentUserInterface;

native function OnInitialize(SFXOnlineSubsystem oOnlineSubsystem);

native function OnRelease();

native function Name GetAPIName();

native final private function OnTick(SFXOnlineEvent oEvent);

function SetGui(SFXSFHandler_EANetworking i_NetworkingGUI)
{
    m_oGUI = i_NetworkingGUI;
    m_oGUI.__GuiCallback_SubmitIntroPage__Delegate = SubmitIntroPage;
    m_oGUI.__GuiCallback_SubmitNucleusLogin__Delegate = SubmitNucleusLogin;
    m_oGUI.__GuiCallback_SubmitMessageBox__Delegate = SubmitMessageBox;
    m_oGUI.__GuiCallback_SubmitEmailPasswordMismatch__Delegate = SubmitEmailPasswordMismatch;
    m_oGUI.__GuiCallback_SubmitCreateNucleusAccount__Delegate = SubmitCreateNucleusAccount;
    m_oGUI.__GuiCallback_SubmitTermsOfService__Delegate = SubmitTermsOfService;
    m_oGUI.__GuiCallback_SubmitNucleusWelcomeMessage__Delegate = SubmitNucleusWelcomeMessage;
    m_oGUI.__GuiCallback_SubmitCerberusIntro__Delegate = SubmitCerberusIntro;
    m_oGUI.__GuiCallback_SubmitRedeemCode__Delegate = SubmitRedeemCode;
    m_oGUI.__GuiCallback_SubmitAccountDemographics__Delegate = SubmitAccountDemographics;
    m_oGUI.__GuiCallback_SubmitParentEmail__Delegate = SubmitParentEmail;
    m_oGUI.__GuiCallback_SubmitCerberusWelcomeMessage__Delegate = SubmitCerberusWelcomeMessage;
    m_oGUI.__GuiCallback_SubmitCreateNucleusAccountEx__Delegate = SubmitCreateNucleusAccountEx;
}

function ClearGui()
{
    m_oGUI.ClearDelegates();
    m_oGUI = None;
}

native function Connect(SFXOnlineConnectMode connectMode);

native function Disconnect();

native function DownloadContent(bool bCerberusContent);

native function AcceptTOS(bool bAccept);

delegate ExternalCallback_OnDisplayNotification(SFXOnlineConnection_MessageType Type, String MessageData, String Title, String Image);

delegate ExternalCallback_ClearNotifications();

delegate ExternalCallback_SetState(SFXOnlineConnectionState eState);

delegate ExternalCallback_CloseEANetworking();

delegate ExternalCallback_HasCerberusDLC(bool bVal);

delegate ExternalCallback_ShowStore(array<SFXOfferDescriptor> aOffers);

native function ShowIntroPage();

native function ShowNucleusLogin(String Email, String Password, int eScreenState);

native function ShowMessageBox(String sTitle, String sMessage, optional String sButton1Text, optional String sButton2Text, optional String sButton3Text);

native function ShowCreateNucleusAccount(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bRegisterProduct, bool bBioWareProducts, bool bUnderage);

native function ShowTermsOfService(String i_sTermsOfService, optional bool bTOSChanged);

native function ShowNucleusWelcomeMessage();

native function ShowCerberusIntro();

native function ShowRedeemCode();

native function ShowCerberusWelcomeMessage();

native function ShowCreateNucleusAccountEx(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bBioWareProducts, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode, array<String> m_CountryCodeList, array<String> m_CountryDisplayList);

native function ShowEmailPasswordMismatch(String Email, String Password);

native function ShowAccountDemographics(array<String> m_CountryCodeList, array<String> m_CountryDisplayList);

native function ShowParentEmail();

native function SubmitIntroPage(bool bContinue);

native function SubmitNucleusLogin(String Email, String Password, EAGUI_NucleusLoginResult eReturnCode);

native function SubmitMessageBox(EAGUI_MsgBoxResult eReturnEnum);

native function SubmitCreateNucleusAccount(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bRegisterProduct, bool bBioWareProducts, bool bSubmit);

native function SubmitTermsOfService(bool bAccept);

native function SubmitNucleusWelcomeMessage();

native function SubmitCerberusIntro(EAGUI_CerberusIntroResult eReturnCode);

native function SubmitRedeemCode(bool bContinue, String i_sCode);

native function SubmitCerberusWelcomeMessage();

native function SubmitCreateNucleusAccountEx(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bBioWareProducts, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode, bool bSubmit);

native function SubmitStore(array<int> aiChosen);

native function SubmitEmailPasswordMismatch(String Email, String Password, EAGUI_EmailPswdMismatchResult eReturnCode);

native function SubmitAccountDemographics(bool bContinue, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode);

native function SubmitParentEmail(bool bContinue, String ParentEmail);

event CloseEANetworking()
{
    if (__ExternalCallback_CloseEANetworking__Delegate != None)
    {
        ExternalCallback_CloseEANetworking();
    }
}

event SetState(SFXOnlineConnectionState eState)
{
    if (__ExternalCallback_SetState__Delegate != None)
    {
        ExternalCallback_SetState(eState);
    }
}

event OnDisplayNotification(SFXOnlineConnection_MessageType Type, String MessageData, String Title, String Image)
{
    if (__ExternalCallback_OnDisplayNotification__Delegate != None)
    {
        ExternalCallback_OnDisplayNotification(Type, MessageData, Title, Image);
    }
}

event ClearNotifications()
{
    if (__ExternalCallback_ClearNotifications__Delegate != None)
    {
        ExternalCallback_ClearNotifications();
    }
}

event HasCerberusDLC(bool bVal)
{
    if (__ExternalCallback_HasCerberusDLC__Delegate != None)
    {
        ExternalCallback_HasCerberusDLC(bVal);
    }
}

event ShowStore(array<SFXOfferDescriptor> aOffers)
{
    if (__ExternalCallback_ShowStore__Delegate != None)
    {
        ExternalCallback_ShowStore(aOffers);
    }
}

function ClearDelegates()
{
    __ExternalCallback_OnDisplayNotification__Delegate = None;
    __ExternalCallback_ClearNotifications__Delegate = None;
    __ExternalCallback_SetState__Delegate = None;
    __ExternalCallback_CloseEANetworking__Delegate = None;
    __ExternalCallback_HasCerberusDLC__Delegate = None;
    __ExternalCallback_ShowStore__Delegate = None;
}

defaultproperties
{
    HandlerId=NetworkRegistration
    EventSubscriberTable=None
}
