﻿class SFXPath_AvoidFireFromCover extends PathConstraint
    native;

var array<EnemyCoverInfo> EnemyList;

var SFXAI_Core AI;

struct native EnemyCoverInfo
{
    var BioPawn Enemy;

    var CoverInfo Cover;

}

static function bool AvoidFireFromCover(Pawn P, bool bCheckPlayerOnly)
{
    local SFXPath_AvoidFireFromCover Con;
    local SFXAI_Core oAI;
    local BioPawn Enemy;
    local EnemyCoverInfo EnemyInfo;
    local int I;
    oAI = SFXAI_Core(P.Controller);
    if (oAI != None)
    {
        Con = SFXPath_AvoidFireFromCover(P.CreatePathConstraint(Default.Class));
        Con.AI = oAI;
        I = 0;
        while (I < oAI.EnemyList.Length)
        {
            Enemy = BioPawn(oAI.EnemyList[I].Pawn);
            if (Enemy != None && Enemy.IsValidTargetFor(oAI) && oAI.GetPawnCover(Enemy, EnemyInfo.Cover))
            {
                if (!bCheckPlayerOnly || Enemy.IsPlayerOwned())
                {
                    EnemyInfo.Enemy = Enemy;
                    Con.EnemyList.AddItem(EnemyInfo);
                }
            }
            I++;
        }
        if (Con.EnemyList.Length > 0)
        {
            P.AddPathConstraint(Con);
        }
        return true;
    }
    return false;
}

function Recycle()
{
    Recycle();
    AI = None;
    EnemyList.Length = 0;
}

defaultproperties
{
    CacheIdx=10
}
