﻿class SFXPlayerController extends BioPlayerController
    hidecategories(Navigation)
    config(Game);

var EAICustomAction CurrentCustomAction;

function CheckNearMiss(Pawn Shooter, Weapon W, Vector WeapLoc, Vector LineDir, Vector HitLocation)
{
    local SFXGame GameInfo;
    local BioPawn ChkPawn;
    local BioAiController AI;
    CheckNearMiss(Shooter, W, WeapLoc, LineDir, HitLocation);
    GameInfo = SFXGame(WorldInfo.Game);
    if (GameInfo != None && GameInfo.bInCombat == false)
    {
        ChkPawn = BioPawn(Pawn);
        if (ChkPawn != None)
        {
            foreach ChkPawn.Squad.SquadMembers(AI)
            {
                AI.AddEnemy(Shooter);
            }
        }
    }
}

function bool NotifyBump(Actor Other, Vector HitNormal)
{
    local BioCustomAction Action;
    local BioPawn MyBP;
    local SFXWeapon Weapon;
    local BioPower MeleePower;
    if (GetCurrentCustomAction(Action) && Action.NotifyBump(Other, HitNormal))
    {
        return true;
    }
    MyBP = BioPawn(Pawn);
    if (bStorming && BioPawn(Other) != None)
    {
        Weapon = SFXWeapon(MyBP.Weapon);
        MeleePower = MyBP.m_oBehavior.FindPower(Weapon.MeleePowerName);
        if (MeleePower != None && MeleePower.Script != None)
        {
            if (MeleePower.GetCooldownRemaining() <= 0)
            {
                MeleePower.SetCooldownRemaining(1);
                MeleePower.Script.OnImpact(MyBP, 1, Other, 0);
            }
        }
    }
    return NotifyBump(Other, HitNormal);
}

function bool NotifyHitWall(Vector HitNormal, Actor Wall)
{
    local BioCustomAction Action;
    if (GetCurrentCustomAction(Action) && Action.NotifyHitWall(HitNormal, Wall))
    {
        return true;
    }
    return NotifyHitWall(HitNormal, Wall);
}

final event DoCustomAction(EAICustomAction NewAction)
{
    local BioPawn MyPawn;
    local BioActivePower Active;
    MyPawn = BioPawn(Pawn);
    if (MyPawn != None && MyPawn.m_oBehavior != None)
    {
        Active = BioActivePower(MyPawn.m_oBehavior.m_oCurrentModalActive);
        if (Active != None)
        {
            Active.CancelPower(false);
            MyPawn.m_oBehavior.ReleaseActiveByClass(Class'BioActivePower');
        }
        if (NewAction != 0)
        {
            SetZoomed(false);
        }
    }
    if (CurrentCustomAction != 0 && CurrentCustomAction != NewAction)
    {
        CustomActionEnded(CurrentCustomAction);
    }
    CurrentCustomAction = NewAction;
    CustomActionStarted(CurrentCustomAction);
}

final function EndCustomAction()
{
    DoCustomAction(0);
}

event bool CanDoCustomAction(EAICustomAction CAction)
{
    if (CAction != 0 && CAction < CustomActionClasses.Length && CustomActionClasses[CAction] != None)
    {
        if (VerifyCAHasBeenInstanced(CAction))
        {
            return CustomActions[CAction].CanDoCustomAction();
        }
    }
    return false;
}

final function bool VerifyCAHasBeenInstanced(EAICustomAction CAction)
{
    if (CAction > 0)
    {
        if (CAction >= CustomActions.Length || CustomActions[CAction] == None)
        {
            if (CAction < CustomActionClasses.Length && CustomActionClasses[CAction] != None)
            {
                CustomActions[CAction] = new(Outer,CustomActionClasses[CAction]);
                CustomActions[CAction].oPawn = BioPawn(Pawn);
            }
            else
            {
                CustomActions[CAction] = None;
                return false;
            }
        }
        return true;
    }
    return false;
}

final function CustomActionStarted(EAICustomAction NewAction)
{
    local BioPawn pBioPawn;
    pBioPawn = BioPawn(Pawn);
    if (pBioPawn != None)
    {
        if (CanDoCustomAction(NewAction))
        {
            CustomActions[NewAction].StartCustomAction();
        }
    }
}

final function CustomActionEnded(EAICustomAction PrevAction)
{
    if (PrevAction != 0)
    {
        if (CustomActions[PrevAction] != None)
        {
            CustomActions[PrevAction].StopCustomAction();
            jump 65;
        }
    }
    return;
}

function bool GetCurrentCustomAction(out BioCustomAction pAction)
{
    if (CurrentCustomAction > 0 && CurrentCustomAction < CustomActions.Length)
    {
        pAction = CustomActions[CurrentCustomAction];
        return true;
    }
    return false;
}

final exec function bool TryClimbOrMantleCover()
{
    local CovPosInfo CoverInfo;
    local BioPawn oPawn;
    oPawn = BioPawn(Pawn);
    if (oPawn != None && oPawn.CurrentLink != None)
    {
        CoverInfo.Link = oPawn.CurrentLink;
        CoverInfo.LtSlotIdx = oPawn.LeftSlotIdx;
        CoverInfo.RtSlotIdx = oPawn.RightSlotIdx;
        CoverInfo.LtToRtPct = oPawn.CurrentSlotPct;
        if (CanPerformClimb(CoverInfo))
        {
            ClimbCover(CoverInfo);
            return true;
        }
        else
        {
            if (CanPerformMantle(CoverInfo))
            {
                MantleCover(CoverInfo);
                return true;
            }
        }
    }
    return false;
}

function ClimbCover(CovPosInfo CovInfo)
{
    local BioPawn BioPawn;
    local BioCustomAction_CoverClimbMantleBase CustomAction;
    if (!IsLocalPlayerController())
    {
        ScriptTrace();
        return;
    }
    BioPawn = BioPawn(Pawn);
    if (BioPawn == None)
    {
        return;
    }
    VerifyCAHasBeenInstanced(9);
    CustomAction = BioCustomAction_CoverClimbMantleBase(CustomActions[9]);
    if (CustomAction != None)
    {
        CustomAction.CacheCoverInfo(CovInfo);
        DoCustomAction(9);
    }
}

function MantleCover(CovPosInfo CovInfo)
{
    local BioPawn BioPawn;
    local BioCustomAction_CoverClimbMantleBase CustomAction;
    if (!IsLocalPlayerController())
    {
        ScriptTrace();
        return;
    }
    BioPawn = BioPawn(Pawn);
    if (BioPawn == None)
    {
        return;
    }
    VerifyCAHasBeenInstanced(10);
    CustomAction = BioCustomAction_CoverClimbMantleBase(CustomActions[10]);
    if (CustomAction != None)
    {
        CustomAction.CacheCoverInfo(CovInfo);
        DoCustomAction(10);
    }
}

net netreliable netserver function ServerBecomeActivePlayer()
{
    local SFXGame Game;
    Game = SFXGame(WorldInfo.Game);
    BroadcastLocalizedMessage(Game.GameMessageClass, 1, PlayerReplicationInfo);
    if (!Game.bDelayedStart)
    {
        Game.RestartPlayer(self);
    }
    else
    {
        Game.RestartPlayer(self);
    }
}

defaultproperties
{
    AimAssist=SFXModule_AimAssist'AimAssist'
    CustomActionClasses(0)=None
    CustomActionClasses(1)=None
    CustomActionClasses(2)=None
    CustomActionClasses(3)=None
    CustomActionClasses(4)=None
    CustomActionClasses(5)=class'SFXCustomAction_StaggerImpact'
    CustomActionClasses(6)=class'SFXCustomAction_BovineFortitude'
    CustomActionClasses(7)=None
    CustomActionClasses(8)=None
    CustomActionClasses(9)=class'BioCustomAction_CoverClimb'
    CustomActionClasses(10)=class'BioCustomAction_CoverMantle'
    CustomActionClasses(11)=None
    CustomActionClasses(12)=None
    CustomActionClasses(13)=None
    CustomActionClasses(14)=None
    CustomActionClasses(15)=None
    CustomActionClasses(16)=None
    CustomActionClasses(17)=class'SFXCustomAction_PlayerStagger'
    CustomActionClasses(18)=None
    CustomActionClasses(19)=None
    CustomActionClasses(20)=None
    CustomActionClasses(21)=None
    CustomActionClasses(22)=None
    CustomActionClasses(23)=None
    CustomActionClasses(24)=None
    CustomActionClasses(25)=None
    CustomActionClasses(26)=None
    CustomActionClasses(27)=None
    CustomActionClasses(28)=None
    CustomActionClasses(29)=None
    CustomActionClasses(30)=None
    CustomActionClasses(31)=None
    CustomActionClasses(32)=None
    CustomActionClasses(33)=None
    CustomActionClasses(34)=None
    CustomActionClasses(35)=None
    CustomActionClasses(36)=None
    CustomActionClasses(37)=None
    CustomActionClasses(38)=None
    CustomActionClasses(39)=None
    CustomActionClasses(40)=None
    CustomActionClasses(41)=None
    CustomActionClasses(42)=None
    CustomActionClasses(43)=class'SFXCustomAction_HeavyPunchLunge'
    CustomActionClasses(44)=None
    CustomActionClasses(45)=None
    CustomActionClasses(46)=None
    CustomActionClasses(47)=class'SFXCustomAction_PlayerStagger'
    CustomActionClasses(48)=class'SFXCustomAction_PlayerMeleed'
    CustomActionClasses(49)=class'SFXCustomAction_PlayerMeleedII'
    CustomActionClasses(50)=class'SFXCustomAction_PlayerMeleedNoRotate'
    CustomActionClasses(51)=class'SFXCustomAction_PlayerStandardImpact'
    CustomActionClasses(52)=class'SFXCustomAction_PlayerKnockback'
    CustomActionClasses(53)=None
    CustomActionClasses(54)=None
    CustomActionClasses(55)=None
    CustomActionClasses(56)=None
    CustomActionClasses(57)=None
    CustomActionClasses(58)=None
    CustomActionClasses(59)=None
    CustomActionClasses(60)=None
    CustomActionClasses(61)=None
    CustomActionClasses(62)=None
    CustomActionClasses(63)=class'SFXCustomAction_BloodyPlayerStandardImpact'
    CustomActionClasses(64)=class'SFXCustomAction_PlayerOnFire'
    CustomActionClasses(65)=None
    CustomActionClasses(66)=None
    CustomActionClasses(67)=None
    CustomActionClasses(68)=None
    CustomActionClasses(69)=None
    CustomActionClasses(70)=None
    CustomActionClasses(71)=class'SFXCustomAction_ElectricStandardImpact'
    CustomActionClasses(72)=None
    CustomActionClasses(73)=None
    CustomActionClasses(74)=None
    CustomActionClasses(75)=None
    CustomActionClasses(76)=None
    CustomActionClasses(77)=class'SFXCustomAction_Utilize'
    CustomActionClasses(78)=None
    CustomActionClasses(79)=None
    CustomActionClasses(80)=class'SFXCustomAction_PlayerStumbleForward'
    CustomActionClasses(81)=None
    CustomActionClasses(82)=None
    CustomActionClasses(83)=class'SFXCustomAction_Exploration_Comm'
    CustomActionClasses(84)=None
    CustomActionClasses(85)=None
    CustomActionClasses(86)=class'SFXCustomAction_PlayerStandardImpact'
    CustomActionClasses(87)=class'SFXCustomAction_PlayerMeleed'
    CustomActionClasses(88)=class'SFXCustomAction_PlayerStagger'
    CustomActionClasses(89)=None
    CustomActionClasses(90)=class'SFXCustomAction_PlayerKnockback'
    HintSystem=BioHintSystem'HintSys0'
    m_oPlayerSelection=BioPlayerSelection'oSelection'
    CylinderComponent=None
    Components=None
    // child object HintSys0 of type BioHintSystem
    // child object oSelection of type BioPlayerSelection
    // child object CollisionCylinder of type CylinderComponent
    // child object AimAssist of type SFXModule_AimAssist
    // child object AimAssist of type SFXModule_AimAssist
}
