﻿class SFXPlotTreasure extends BioPlotTreasure
    config(Plot);

struct STreasure
{
    var int nTreasureId;

    var Name nmLevel;

    var Name nmTreasure;

    var Name nmTech;

    var EInventoryResourceTypes Resource;

    var int ResourcePrice;

    var Name nmRequiredTech;

    var int RequiredTechLevel;

    var int DiscoverTechLevel;

    var bool bNoAnimation;

    var bool bMultiLevel;

}

struct STech
{
    var Name nmTech;

    var Name nmResearch;

    var String sImage;

    var String sLargeImage;

// srTitle: StringRefProperty[44]
// srName: StringRefProperty[44]
// srMessage: StringRefProperty[44]
// srDescription: StringRefProperty[44]
    var int nLevels;

    var int UnlockId;

}

struct SResourceBudget
{
    var Name nmLevel;

    var int nCredits;

    var int nEezo;

    var int nIridium;

    var int nPlatinum;

    var int nPalladium;

    var int nID;

}

var const int srCanAffordResearch;

var const int StateNewUpgradesAvailable;

var const int StateNewResearchAvailable;

// srLabClosedResearchMessage: StringRefProperty[44]
// srLabOpenResearchMessage: StringRefProperty[44]
var const int nProfessorIsDeadId;

var const int nProfessorInPartyId;

// srMultiLevelUpgradeName: StringRefProperty[44]
var const int nLastUnlockedTech;

var const float fFullPriceMultiplier;

function SResourceBudget BudgetFromId(int nID)
{
    local SResourceBudget stResource;
    local Name nmLevel;
    local int I;
    local int nCredits;
    local int Eezo;
    local int Palladium;
    local int Platinum;
    local int Iridium;
    local int Id;
    I = 0;
    while (I != oPlotTreasureResources2DA.GetNumRows())
    {
        oPlotTreasureResources2DA.GetIntEntryIN(I, 'Id', Id);
        if (Id == nID)
        {
            nmLevel = oPlotTreasureResources2DA.GetRowName(I);
            oPlotTreasureResources2DA.GetIntEntryIN(I, 'Credits', nCredits);
            oPlotTreasureResources2DA.GetIntEntryIN(I, 'Eezo', Eezo);
            oPlotTreasureResources2DA.GetIntEntryIN(I, 'Palladium', Palladium);
            oPlotTreasureResources2DA.GetIntEntryIN(I, 'Platinum', Platinum);
            oPlotTreasureResources2DA.GetIntEntryIN(I, 'Iridium', Iridium);
            stResource.nID = Id;
            stResource.nCredits = nCredits;
            stResource.nEezo = Eezo;
            stResource.nIridium = Iridium;
            stResource.nmLevel = nmLevel;
            stResource.nPalladium = Palladium;
            stResource.nPlatinum = Platinum;
            return stResource;
        }
        ++I;
    }
    return stResource;
}

function SResourceBudget Budget(optional Name nmLevel)
{
    local SResourceBudget stBudget;
    local int nBudgetValue;
    if (nmLevel == 'None')
    {
        nmLevel = CurrentLevel();
    }
    stBudget.nmLevel = nmLevel;
    stBudget.nCredits = 0;
    stBudget.nEezo = 0;
    stBudget.nIridium = 0;
    stBudget.nPalladium = 0;
    stBudget.nPlatinum = 0;
    stBudget.nmLevel = nmLevel;
    if (GetPlotTreasureResourcesInt(nmLevel, 'Id', nBudgetValue))
    {
        stBudget.nID = nBudgetValue;
    }
    if (GetPlotTreasureResourcesInt(nmLevel, 'Credits', nBudgetValue))
    {
        stBudget.nCredits = nBudgetValue;
    }
    if (GetPlotTreasureResourcesInt(nmLevel, 'Eezo', nBudgetValue))
    {
        stBudget.nEezo = nBudgetValue;
    }
    if (GetPlotTreasureResourcesInt(nmLevel, 'Iridium', nBudgetValue))
    {
        stBudget.nIridium = nBudgetValue;
    }
    if (GetPlotTreasureResourcesInt(nmLevel, 'Palladium', nBudgetValue))
    {
        stBudget.nPalladium = nBudgetValue;
    }
    if (GetPlotTreasureResourcesInt(nmLevel, 'Platinum', nBudgetValue))
    {
        stBudget.nPlatinum = nBudgetValue;
    }
    return stBudget;
}

function STreasure TREASURE(int nTreasureId)
{
    local STreasure stTreasure;
    local Name nmTreasureValue;
    local Name nmResource;
    local int ResourcePrice;
    local Name nmRequiredTech;
    local int RequiredTechLevel;
    local int DiscoverTechLevel;
    local int nNoAnimation;
    local int nMultiLevel;
    stTreasure.nTreasureId = nTreasureId;
    if (GetPlotTreasureTreasureName(nTreasureId, 'nmLevel', nmTreasureValue))
    {
        stTreasure.nmLevel = nmTreasureValue;
    }
    if (GetPlotTreasureTreasureName(nTreasureId, 'nmTreasure', nmTreasureValue))
    {
        stTreasure.nmTreasure = nmTreasureValue;
    }
    if (GetPlotTreasureTreasureName(nTreasureId, 'nmTech', nmTreasureValue))
    {
        stTreasure.nmTech = nmTreasureValue;
    }
    if (GetPlotTreasureTreasureName(nTreasureId, 'nmResource', nmResource))
    {
        if (nmResource == 'Credits')
        {
            stTreasure.Resource = 0;
        }
        else
        {
            if (nmResource == 'Iridium')
            {
                stTreasure.Resource = 5;
            }
            else
            {
                if (nmResource == 'Palladium')
                {
                    stTreasure.Resource = 6;
                }
                else
                {
                    if (nmResource == 'Platinum')
                    {
                        stTreasure.Resource = 7;
                    }
                    else
                    {
                        if (nmResource == 'Eezo')
                        {
                            stTreasure.Resource = 4;
                        }
                        else
                        {
                            if (nmResource == 'Probes')
                            {
                                stTreasure.Resource = 8;
                            }
                        }
                    }
                }
            }
        }
    }
    if (GetPlotTreasureTreasureInt(nTreasureId, 'nPrice', ResourcePrice))
    {
        stTreasure.ResourcePrice = ResourcePrice;
    }
    if (GetPlotTreasureTreasureName(nTreasureId, 'nmRequiredTech', nmRequiredTech))
    {
        stTreasure.nmRequiredTech = nmRequiredTech;
    }
    if (GetPlotTreasureTreasureInt(nTreasureId, 'nRequiredTechLevel', RequiredTechLevel))
    {
        stTreasure.RequiredTechLevel = RequiredTechLevel;
    }
    if (GetPlotTreasureTreasureInt(nTreasureId, 'nDiscoverTechLevel', DiscoverTechLevel))
    {
        stTreasure.DiscoverTechLevel = DiscoverTechLevel;
    }
    if (GetPlotTreasureTreasureInt(nTreasureId, 'nNoAnimation', nNoAnimation))
    {
        stTreasure.bNoAnimation = nNoAnimation > 0;
    }
    if (GetPlotTreasureTreasureInt(nTreasureId, 'nMultiLevel', nMultiLevel))
    {
        stTreasure.bMultiLevel = nMultiLevel > 0;
    }
    return stTreasure;
}

function STech tech(Name nmTech)
{
    local STech stTech;
    local int N;
    local Name nmTmp;
    if (nmTech == 'None')
    {
        return stTech;
    }
    GetPlotTreasureTechName(nmTech, 'nmTech', stTech.nmTech);
    GetPlotTreasureTechName(nmTech, 'nmResearch', stTech.nmResearch);
    GetPlotTreasureTechName(nmTech, 'sImage', nmTmp);
    stTech.sImage = nmTmp;
    GetPlotTreasureTechName(nmTech, 'sLargeImage', nmTmp);
    stTech.sLargeImage = nmTmp;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'srTitle', N);
    stTech.srTitle = N;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'srName', N);
    stTech.srName = N;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'srMessage', N);
    stTech.srMessage = N;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'srDescription', N);
    stTech.srDescription = N;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'nLevels', N);
    stTech.nLevels = N;
    GetPlotTreasureTechInt(nmTech, 'nmTech', 'UnlockId', N);
    stTech.UnlockId = N;
    return stTech;
}

function Name CurrentLevel()
{
    local String sMapName;
    if (GetMapName(sMapName))
    {
        return sMapName;
    }
    return 'None';
}

final private function LogWarning(String msg);

function bool AwardTreasure(int nTreasureId, optional bool bDiscount = false)
{
    local STreasure stTreasure;
    local bool bResult;
    local BioRemoteLogger GLogger;
    local String sMapName;
    local Pawn PlayerPawn;
    local bool bStorePurchase;
    GetMapName(sMapName);
    bResult = false;
    stTreasure = self.TREASURE(nTreasureId);
    if (stTreasure.nmTech == 'None')
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " in " $ sMapName $ " -- does not exist");
        return false;
    }
    if (BioWorldInfo(Outer).GetGlobalVariables().GetBool(nTreasureId) && stTreasure.bMultiLevel == false)
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " in " $ sMapName $ " -- attempted duplicate award");
        return false;
    }
    if (!CanAffordTreasure(nTreasureId, bDiscount))
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " player Can not afford");
        return false;
    }
    if (!QualifiesForTreasure(nTreasureId))
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " player does not qualify");
        return false;
    }
    if (!ChargeForTreasure(nTreasureId, bDiscount))
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " failed to charge player for treasure");
        return false;
    }
    bStorePurchase = stTreasure.Resource == 0 && stTreasure.ResourcePrice > 0;
    bResult = AwardTech(stTreasure.nmTech, stTreasure.bNoAnimation, bStorePurchase);
    if (!bResult)
    {
        LogWarning("Treasure: treasure_id=" $ nTreasureId $ " failed to increase tech level");
        return false;
    }
    GLogger = Class'BioRemoteLogger'.GetLogger();
    if (GLogger != None)
    {
        GLogger.SendPlayerEvent(38, "", "C", "Awarded Treasure", "nTreasureId=" $ nTreasureId, nTreasureId, -1, 6, 0);
    }
    if (stTreasure.bMultiLevel == false)
    {
        BioWorldInfo(Outer).GetGlobalVariables().SetBool(nTreasureId, true);
    }
    if (stTreasure.bNoAnimation == false)
    {
        PlayerPawn = BioWorldInfo(Outer).GetLocalPlayerController().Pawn;
        SFXGame(BioWorldInfo(Outer).Game).TriggerVocalizationEvent(109, BioPawn(PlayerPawn));
    }
    return true;
}

static function Name FindTechByResearch(Name nmTech)
{
    local Name nmRequiredTech;
    local int I;
    I = 0;
    while (I != Default.oPlotTreasureTreasure2DA.GetNumRows())
    {
        Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmRequiredTech', nmRequiredTech);
        if (nmRequiredTech == nmTech)
        {
            Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTech);
            return nmTech;
        }
        ++I;
    }
    return 'None';
}

function bool AwardTech(Name nmTech, optional bool bNoAnimation = false, optional bool bStorePurchase = false)
{
    local int nLevel;
    local int nResearchLevel;
    local String sMapName;
    local Texture2D oImage;
    local bool bFoundResearch;
    local bool bLabOpen;
    local bool bFoundWeapon;
    local String sName;
    local String sMessage;
    local STech stTech;
    local BioGlobalVariableTable oGV;
    local BioPlayerController oController;
    GetMapName(sMapName);
    stTech = tech(nmTech);
    if (stTech.nmTech == 'None')
    {
        stTech = tech(FindTechByResearch(nmTech));
        bFoundResearch = true;
    }
    if (stTech.nmTech == 'None')
    {
        return false;
    }
    nLevel = BioWorldInfo(Outer).GetGlobalVariables().GetIntByName(stTech.nmTech) + 1;
    if (nLevel > 10)
    {
        return false;
    }
    sName = GetTechName(stTech, true);
    ClearCustomTokens();
    SetCustomToken(0, nLevel);
    SetCustomToken(1, nLevel * 5);
    SetCustomToken(2, nLevel * 10);
    SetCustomToken(3, nLevel * 15);
    SetCustomToken(4, nLevel * 20);
    SetCustomToken(5, nLevel * 25);
    SetCustomToken(6, nLevel * 35);
    SetCustomToken(7, nLevel * 50);
    bFoundWeapon = Locs(Left(stTech.nmTech, 4)) == "wpn_";
    oGV = BioWorldInfo(Outer).GetGlobalVariables();
    if (bFoundResearch)
    {
        bLabOpen = oGV.GetBool(nProfessorInPartyId);
        nResearchLevel = oGV.GetIntByName(nmTech) + 1;
        nResearchLevel = nLevel > nResearchLevel ? nLevel : nResearchLevel;
        oImage = FindImage(stTech.sImage);
        sMessage = bLabOpen ? srLabOpenResearchMessage : srLabClosedResearchMessage;
        BioHintSystem(BioWorldInfo(Outer).GetLocalPlayerController().HintSystem).AddNotification_ResearchRecovered(stTech.srName, sMessage, oImage);
        BioWorldInfo(Outer).GetGlobalVariables().SetIntByName(nmTech, nResearchLevel);
        SetNewResearchAvailable(true);
    }
    else
    {
        oImage = FindImage(stTech.sImage);
        if (bFoundWeapon == false)
        {
            BioHintSystem(BioWorldInfo(Outer).GetLocalPlayerController().HintSystem).AddNotification_Tech(sName, stTech.srTitle, stTech.srMessage, oImage);
        }
        else
        {
            BioHintSystem(BioWorldInfo(Outer).GetLocalPlayerController().HintSystem).AddNotification_Weapon(sName, stTech.srTitle, stTech.srMessage, oImage);
        }
        oGV.SetIntByName(stTech.nmTech, nLevel);
        SFXGame(BioWorldInfo(Outer).Game).BonusList.AwardTechBonus(nmTech, BioWorldInfo(Outer));
        SetNewUpgradesAvailable(true);
    }
    if (bStorePurchase && stTech.nmResearch != 'None')
    {
        nResearchLevel = oGV.GetIntByName(stTech.nmResearch);
        oGV.SetIntByName(stTech.nmResearch, nResearchLevel + 1);
    }
    oController = BioWorldInfo(Outer).GetLocalPlayerController();
    if (bNoAnimation == false)
    {
        SFXPawn(BioWorldInfo(Outer).GetLocalPlayerController().Pawn).PlayAnimatedReaction(77, oController);
    }
    if (bFoundResearch == false)
    {
        oController.ProfileSettings.GrinderAchievementIncrement(45, oController);
    }
    CheckForUpgradedWeaponAchievement();
    ReLockTech(stTech);
    return true;
}

function ReLockTech(STech stTech)
{
    if (stTech.nLevels <= 1)
    {
        return;
    }
    if (stTech.UnlockId <= 0)
    {
        return;
    }
    BioWorldInfo(Outer).GetGlobalVariables().SetBool(stTech.UnlockId, false);
}

function CheckForUpgradedWeaponAchievement()
{
    local GrinderAchievement G;
    local BioPlayerController oController;
    local int ARpoints;
    local int APpoints;
    local int SGpoints;
    local int SRpoints;
    local int HPpoints;
    local int Points;
    local int gPoints;
    local BioGlobalVariableTable oGV;
    local int idx;
    oController = BioWorldInfo(Outer).GetLocalPlayerController();
    oController.ProfileSettings.GetGrinderAchievement(46, G);
    oController.ProfileSettings.GetProfileSettingValueInt(G.ProfileSettingId, gPoints);
    oGV = BioWorldInfo(Outer).GetGlobalVariables();
    ARpoints = oGV.GetInt(68) + oGV.GetInt(453) + oGV.GetInt(451);
    APpoints = oGV.GetInt(426) + oGV.GetInt(456) + oGV.GetInt(457);
    SGpoints = oGV.GetInt(71) + oGV.GetInt(470) + oGV.GetInt(471);
    SRpoints = oGV.GetInt(72) + oGV.GetInt(474) + oGV.GetInt(475);
    HPpoints = oGV.GetInt(69) + oGV.GetInt(462) + oGV.GetInt(463);
    Points = ARpoints;
    Points = Points < APpoints ? APpoints : Points;
    Points = Points < SGpoints ? SGpoints : Points;
    Points = Points < SRpoints ? SRpoints : Points;
    Points = Points < HPpoints ? HPpoints : Points;
    idx = gPoints;
    while (idx < Points)
    {
        oController.ProfileSettings.GrinderAchievementIncrement(46, oController);
        oController.ProfileSettings.GetProfileSettingValueInt(G.ProfileSettingId, gPoints);
        idx++;
    }
}

function String GetTechName(STech stTech, optional bool bAddOne = false)
{
    local String sName;
    local int nLevel;
    local int nMaxLevel;
    if (stTech.nLevels > 1)
    {
        ClearCustomTokens();
        nLevel = BioWorldInfo(Outer).GetGlobalVariables().GetIntByName(stTech.nmTech) + bAddOne ? 1 : 0;
        nMaxLevel = nLevel <= stTech.nLevels ? stTech.nLevels : nLevel;
        SetCustomToken(0, stTech.srName);
        SetCustomToken(1, "" $ nLevel);
        SetCustomToken(2, "" $ nMaxLevel);
        sName = srMultiLevelUpgradeName;
    }
    else
    {
        sName = stTech.srName;
    }
    return sName;
}

function bool CanAffordTreasure(int nTreasureId, optional bool bDiscount = false)
{
    local STreasure stTreasure;
    local SFXInventoryManager oInv;
    local bool bCanAfford;
    local int RealPrice;
    local int RealCredits;
    stTreasure = self.TREASURE(nTreasureId);
    oInv = SFXInventoryManager(SFXPawn(BioWorldInfo(Outer).GetLocalPlayerController().Pawn).InvManager);
    RealPrice = Price(nTreasureId, bDiscount);
    RealCredits = oInv.GetResource(stTreasure.Resource);
    bCanAfford = RealCredits >= RealPrice;
    return bCanAfford;
}

function bool DiscoveredResearch(int nTreasureId)
{
    local STreasure stTreasure;
    if (BioWorldInfo(Outer).GetGlobalVariables().GetBool(nTreasureId))
    {
        return true;
    }
    stTreasure = self.TREASURE(nTreasureId);
    if (stTreasure.DiscoverTechLevel <= 0 || BioWorldInfo(Outer).GetGlobalVariables().GetIntByName(stTreasure.nmRequiredTech) >= stTreasure.DiscoverTechLevel)
    {
        return true;
    }
    return false;
}

function bool QualifiesForTreasure(int nTreasureId)
{
    local STreasure stTreasure;
    local STech stTech;
    local int nRequiredTechLevel;
    local BioGlobalVariableTable oGV;
    stTreasure = self.TREASURE(nTreasureId);
    stTech = self.tech(stTreasure.nmTech);
    nRequiredTechLevel = stTreasure.RequiredTechLevel;
    oGV = BioWorldInfo(Outer).GetGlobalVariables();
    if (stTech.nLevels <= 1 && oGV.GetBool(nTreasureId))
    {
        return false;
    }
    if (stTreasure.bMultiLevel)
    {
        nRequiredTechLevel = oGV.GetIntByName(stTech.nmTech) + 1;
    }
    if (nRequiredTechLevel > 0 && oGV.GetIntByName(stTreasure.nmRequiredTech) < nRequiredTechLevel)
    {
        return false;
    }
    return true;
}

function bool ChargeForTreasure(int nTreasureId, optional bool bDiscount = false)
{
    local STreasure stTreasure;
    local SFXInventoryManager oInv;
    if (!CanAffordTreasure(nTreasureId, bDiscount))
    {
        return false;
    }
    stTreasure = self.TREASURE(nTreasureId);
    oInv = SFXInventoryManager(BioWorldInfo(Outer).GetLocalPlayerController().Pawn.InvManager);
    oInv.AdjustResource(stTreasure.Resource, -1 * Price(nTreasureId, bDiscount), false);
    return true;
}

function int CalculateResearchLevelMultiplier(Name nmTech)
{
    local int I;
    local int nLevel;
    local BioGlobalVariableTable oGV;
    local Name nmTreasureTech;
    local Name nmTreasureResource;
    oGV = BioWorldInfo(Outer).GetGlobalVariables();
    nLevel = oGV.GetIntByName(nmTech);
    I = 0;
    while (I != Default.oPlotTreasureTreasure2DA.GetNumRows())
    {
        if (oGV.GetBool(oPlotTreasureTreasure2DA.GetRowNumber(I)))
        {
            Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTreasureTech);
            if (nmTreasureTech == nmTech)
            {
                Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmResource', nmTreasureResource);
                if (nmTreasureResource == 'Credits')
                {
                    nLevel--;
                }
            }
        }
        ++I;
    }
    return nLevel;
}

function float Price(int nTreasureId, optional bool bDiscount = false)
{
    local STreasure stTreasure;
    local BioPlayerController PC;
    local SFXModule_GameEffectManager Manager;
    local float EngineerReduction;
    local int nPrice;
    local int nLevel;
    local float fProfessorIsDeadPenalty;
    stTreasure = self.TREASURE(nTreasureId);
    fProfessorIsDeadPenalty = 0;
    nPrice = 1;
    if (stTreasure.Resource != 0)
    {
        if (BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables().GetBool(nProfessorIsDeadId))
        {
            fProfessorIsDeadPenalty = 0,5;
        }
        PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
        if (PC != None)
        {
            Manager = PC.Pawn.GetModule(Class'SFXModule_GameEffectManager');
            if (Manager != None)
            {
                EngineerReduction = Manager.GetEffectValue(Class'SFXGameEffect_ResearchCostMultiplier', 1) - 1;
            }
            if (EngineerReduction < 0)
            {
                fProfessorIsDeadPenalty = 0;
            }
        }
        nLevel = CalculateResearchLevelMultiplier(stTreasure.nmTech) + 1;
        nPrice *= nLevel;
    }
    if (bDiscount)
    {
        nPrice = nPrice * stTreasure.ResourcePrice * 1 + fProfessorIsDeadPenalty + EngineerReduction;
    }
    else
    {
        nPrice = nPrice * stTreasure.ResourcePrice * fFullPriceMultiplier + fProfessorIsDeadPenalty + EngineerReduction;
    }
    return nPrice;
}

static function String GetTreasureImageResourcePath(int nTreasureId)
{
    local int I;
    local int J;
    local Name nmTech;
    local String sImagePath;
    local String sLargeImagePath;
    I = 0;
    while (I != Default.oPlotTreasureTreasure2DA.GetNumRows())
    {
        J = Default.oPlotTreasureTreasure2DA.GetRowNumber(I);
        if (nTreasureId == J)
        {
            Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTech);
            break;
        }
        ++I;
    }
    if (nmTech == 'None')
    {
        return "";
    }
    GetTechImageResourcePath(nmTech, sImagePath, sLargeImagePath);
    return sImagePath;
}

static function String GetTreasureLargeImageResourcePath(int nTreasureId)
{
    local int I;
    local int J;
    local Name nmTech;
    local String sImagePath;
    local String sLargeImagePath;
    I = 0;
    while (I != Default.oPlotTreasureTreasure2DA.GetNumRows())
    {
        J = Default.oPlotTreasureTreasure2DA.GetRowNumber(I);
        if (nTreasureId == J)
        {
            Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTech);
            break;
        }
        ++I;
    }
    if (nmTech == 'None')
    {
        return "";
    }
    GetTechImageResourcePath(nmTech, sImagePath, sLargeImagePath);
    return sLargeImagePath;
}

static function GetTechImageResourcePath(Name nmTech, out String sImagePath, out String sLargeImagePath, optional bool bNoLookup = false)
{
    local int I;
    local Name nmTmp;
    I = 0;
    while (I != Default.oPlotTreasureTech2DA.GetNumRows())
    {
        Default.oPlotTreasureTech2DA.GetNameEntryIN(I, 'nmTech', nmTmp);
        if (nmTech == nmTmp)
        {
            Default.oPlotTreasureTech2DA.GetNameEntryIN(I, 'sImage', nmTmp);
            sImagePath = "" $ nmTmp;
            Default.oPlotTreasureTech2DA.GetNameEntryIN(I, 'sLargeImage', nmTmp);
            sLargeImagePath = "" $ nmTmp;
        }
        ++I;
    }
    if (sImagePath == "" && bNoLookup == false)
    {
        nmTech = FindTechByResearch(nmTech);
        if (nmTech != 'None')
        {
            GetTechImageResourcePath(nmTech, sImagePath, sLargeImagePath, true);
        }
    }
}

static function Texture2D FindImage(String Path)
{
    local Texture2D Image;
    Image = Texture2D(FindObject(Path, Class'Texture2D'));
    if (Image == None && Class'SFXEngine'.IsSeekFreeObjectSupported(Path))
    {
        Image = Texture2D(Class'SFXEngine'.LoadSeekFreeObject(Path, Class'Texture2D'));
    }
    if (Image == None)
    {
        Image = Texture2D(DynamicLoadObject(Path, Class'Texture2D'));
    }
    return Image;
}

function SetNewResearchAvailable(bool bResearchAvailable)
{
    BioWorldInfo(Outer).GetGlobalVariables().SetBool(StateNewResearchAvailable, bResearchAvailable);
}

function SetNewUpgradesAvailable(bool bUpgadesAvailable)
{
    BioWorldInfo(Outer).GetGlobalVariables().SetBool(StateNewUpgradesAvailable, bUpgadesAvailable);
}

function TriggerResourceHint(EInventoryResourceTypes InvType, int nAmount)
{
    local Name nmTmp;
    local int I;
    local int nCurrentAmount;
    local int nNewAmount;
    local int nTmp;
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    local MassEffectGuiManager oGuiMan;
    local STech stTech;
    if (InvType == 0)
    {
        return;
    }
    oController = BioWorldInfo(Outer).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    nCurrentAmount = oInventory.GetResource(InvType);
    nNewAmount = nCurrentAmount + nAmount;
    I = 0;
    while (I != Default.oPlotTreasureTreasure2DA.GetNumRows())
    {
        Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmResource', nmTmp);
        if (nmTmp == 'None' || nmTmp == 'Credits')
        {
        }
        else
        {
            if (InvType == 4 && nmTmp != 'Eezo' || InvType == 5 && nmTmp != 'Iridium' || InvType == 6 && nmTmp != 'Palladium' || InvType == 7 && nmTmp != 'Platinum')
            {
            }
            else
            {
                Default.oPlotTreasureTreasure2DA.GetIntEntryIN(I, 'nPrice', nTmp);
                if (nNewAmount < nTmp || nCurrentAmount > nTmp)
                {
                }
                else
                {
                    nTmp = Default.oPlotTreasureTreasure2DA.GetRowNumber(I);
                    if (QualifiesForTreasure(nTmp) == false)
                    {
                    }
                    else
                    {
                        Default.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTmp);
                        stTech = tech(nmTmp);
                        ClearCustomTokens();
                        SetCustomToken(0, stTech.srName);
                        oGuiMan = MassEffectGuiManager(oController.GetScaleFormManager());
                        oGuiMan.ShowHint(srCanAffordResearch, 6);
                    }
                }
            }
        }
        ++I;
    }
}

defaultproperties
{
    fFullPriceMultiplier=1,2
    nLastUnlockedTech=580
    srMultiLevelUpgradeName=System.Byte[]
    nProfessorInPartyId=790
    nProfessorIsDeadId=203
    srLabOpenResearchMessage=System.Byte[]
    srLabClosedResearchMessage=System.Byte[]
    StateNewResearchAvailable=6149
    StateNewUpgradesAvailable=6150
    srCanAffordResearch=346051
}
