﻿class SFXPower_PassivePower extends SFXPower;

var array<float> CharmIntimidateModifier;

function ModifyCharmSkill(out float fCharmSkill, optional int nRankToUse = -1)
{
    local float Modifier;
    Modifier = 1 + GetNegotiationBonus();
    if (nRankToUse < 0)
    {
        nRankToUse = Rank;
    }
    if (nRankToUse > 0)
    {
        Modifier += GetArrayValue(CharmIntimidateModifier, nRankToUse);
    }
    fCharmSkill *= Modifier;
}

function ModifyIntimidateSkill(out float fIntimidateSkill, optional int nRankToUse = -1)
{
    local float Modifier;
    Modifier = 1 + GetNegotiationBonus();
    if (nRankToUse < 0)
    {
        nRankToUse = Rank;
    }
    if (nRankToUse > 0)
    {
        Modifier += GetArrayValue(CharmIntimidateModifier, nRankToUse);
    }
    fIntimidateSkill *= Modifier;
}

function float GetNegotiationBonus()
{
    local SFXModule_GameEffectManager Manager;
    if (MyPawn != None)
    {
        Manager = MyPawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            return Manager.GetEffectValue(Class'SFXGameEffect_PassiveNegotiationBonus', 0);
        }
    }
    return 0;
}

defaultproperties
{
    CharmIntimidateModifier(0)=0,2
    CharmIntimidateModifier(1)=0,4
    CharmIntimidateModifier(2)=0,7
    CharmIntimidateModifier(3)=0,7
}
