﻿class SFXSFHandler_PowerWheel extends BioSFHandler
    config(UI)
    transient
    native;

const WEAPON_NONE = 0;
const WEAPON_FAIL = 1;
enum SFXPowerWheelMode
{
    PWM_NONE,
    PWM_Powers,
    PWM_Weapons,
    PWM_PC,
};

enum SFXPowerWheelPawnID
{
    PWPID_Player,
    PWPID_Hench1,
    PWPID_Hench2,
};

enum SFXPowerWheelMapButtonIcon
{
    PWBI_Icon_NONE,
    PWBI_FaceButtonTop,
    PWBI_FaceButtonLeft,
    PWBI_DPadLeft,
    PWBI_DPadRight,
    PWBI_ShoulderLeft,
    PWBI_ShoulderRight,
    PWBI_ICON_COUNT,
};

struct native SFXPowerWheelButtonIcon
{
    var SFXPowerWheelMapButtonIcon eIcon;

    var String sPath;

}

enum SFXPowerWheelPowerState
{
    PWPS_Selectable,
    PWPS_Selected,
    PWPS_Inactive,
    PWPS_Activated,
    PWPS_Overload,
    PWPS_EmptySelectable,
    PWPS_EmptySelected,
    PWPS_NotSuggested,
    PWPS_STATE_COUNT,
};

struct native SFXPowerWheelIcon
{
    var String sPath;

    var String sID;

    var float fBoundary;

}

struct native SFXPowerWheelIconPower extends SFXPowerWheelIcon
{
    var SFXPowerWheelPowerState eState;

    var SFXPowerWheelPowerState eDesiredState;

    var SFXPower pPower;

    var BioPawn pPawn;

    var bool bSelected;

    var bool bVisible;

    var bool bDelayedFlash;

    var int nIcon;

    var int nCooldownValue;

    var bool bMapped;

    var String sName;

    var String sDescription;

    var Name nmPowerName;

    var bool bDragHover;

    var int nPowerID;

    var bool bQuickSlotIcon;

    var SFXPowerWheelButtonIcon oMappedIcon;

    var String sMappedBGPath;

}

enum SFXPowerWheelWeaponState
{
    PWWS_Normal,
    PWWS_Hover,
    PWWS_Disabled,
    PWWS_Selected,
    PWWS_WEAPSTATE_COUNT,
};

struct native SFXPowerWheelIconWeapon extends SFXPowerWheelIcon
{
    var SFXPowerWheelWeaponState eWeaponState;

    var int nWeaponIcon;

    var int nAmmo;

    var String sName;

    var String sDescription;

    var bool bEquipped;

    var class<SFXWeapon> oWeaponClass;

    var String sIconResource;

    var bool bHenchIcon;

}

struct native SFXPowerWheelPawnIndices
{
    var array<int> aPlayer;

    var array<int> aHench1;

    var array<int> aHench2;

}

struct native SFXRadarElementData
{
    var Vector vActorLocation;

    var Vector vPosition;

    var int nSize;

    var bool bLocked;

    var EBioRadarType eRadarType;

    var int nRelativeZ;

    var int nID;

    var bool bUpdate;

    var bool bUpdateLock;

}

var config float m_fRadarObjectiveUpdateInterval;

var config float m_fVehicleRadarUpdateInterval;

var config String m_sMapHench2Token;

var config String m_sMapHench1Token;

var config String m_sMap2Token;

var config String m_sMap1Token;

var config String m_sNotSuggestedSuffix;

var config String m_sNotSuggestedPrefix;

var config float m_fBoundaryShrinkFactor;

var config Vector2D m_vBoundaryDimensions;

var config float m_fRadarRadius;

var config float m_fRadarElementLocationChangeDelta;

var config float m_fRadarDirectionChangeDelta;

// m_srObjective: StringRefProperty[44]
// m_srNorthText: StringRefProperty[44]
// m_srRadarRangeUnits: StringRefProperty[44]
// m_srUnavailable: StringRefProperty[44]
// m_srRecharging: StringRefProperty[44]
// m_srOverheated: StringRefProperty[44]
// m_srMap: StringRefProperty[44]
// m_srUse: StringRefProperty[44]
// m_srEquip: StringRefProperty[44]
// m_srPowerWheelDisplayTitle: StringRefProperty[44]
// m_srWeaponWheelDisplayTitle: StringRefProperty[44]
// m_srDisplayTitle: StringRefProperty[44]
// m_srWeaponReloading: StringRefProperty[44]
// m_srWeaponOverheating: StringRefProperty[44]
// m_srWeaponSwitching: StringRefProperty[44]
// m_srPawnIncapacitated: StringRefProperty[44]
// m_srBlocked: StringRefProperty[44]
var float m_fCacheRadarBoundaryRotation;

var Vector2D m_vCacheRadarBoundaryBottomRight;

var Vector2D m_vCacheRadarBoundaryTopLeft;

var float m_fCachePathDirection;

var float m_fCacheNorthDirection;

var float m_fCacheTargetDirection;

var String m_sWheelArrowPath;

var String m_sTeam2PowerTextPath;

var String m_sTeam2StatusTextPath;

var String m_sTeam1PowerTextPath;

var String m_sTeam1StatusTextPath;

var String m_sRadarPath;

var String m_sHench2BlockerPath;

var String m_sHench1BlockerPath;

var String m_sShepardBlockerPath;

var array<String> m_aRadarIconFramePaths;

var String m_sMapText2Path;

var String m_sMapButton2Path;

var String m_sMapText1Path;

var String m_sMapButton1Path;

var String m_sUseTextPath;

var String m_sUseButtonPath;

var String m_sInfoTextBGPath;

var String m_sInfoTextPath;

var String m_sNameTextPath;

var String m_sTitleTextPath;

var String m_aMappingIconPaths[7];

var SFXPowerWheelButtonIcon m_oMapTextIcon2;

var SFXPowerWheelButtonIcon m_oMapTextIcon1;

var Actor m_pCurrentPlayerSelection;

var array<SFXRadarElementData> m_aRadarElementData;

var BioPawn m_pHench2Pawn;

var BioPawn m_pHench1Pawn;

var BioPawn m_pShepardPawn;

var SFXPowerWheelPawnIndices m_oWeaponIndices;

var SFXPowerWheelPawnIndices m_oPowerIndices;

var int m_nCurrentSelectedWeapon;

var int m_aWeaponStateFrames[4];

var String m_aPowerStatePaths[8];

var array<SFXPowerWheelIconWeapon> m_aWeaponIcons;

var array<SFXPowerWheelIconPower> m_aPowerIcons;

var int m_nCurrentWeaponIconIndex;

var int m_nCurrentPowerIconIndex;

var config float m_fLStickAngleDeltaDeg;

var float m_fLastStickDeflection;

var float m_fLastProcessedStickAngle;

var Vector m_vLStickInput;

var float m_fTimeToNextObjectiveUpdate;

var float m_fTimeToNextVehicleRadarUpdate;

var float m_fRemainingInfoTextChangeDelay;

var float m_fInfoTextChangeDelay;

var float m_fRemainingRadarPulseTime;

var SFXPowerWheelMode m_ePowerWheelMode;

var Vector2D m_vViewportOffsets;

var float m_fMovieHeight;

var float m_fMovieWidth;

var float m_fButtonTextPadding;

var int m_nProcessedSquadPopulation;

var BioPlayerSquad m_pPlayerSquad;

var BioPlayerController m_pPlayerController;

var bool m_bSquadChanged;

var bool m_bPulsingRadar;

var bool m_bObjectiveRadarOn;

var bool m_bWheelArrowVisible;

var bool m_bDesiredInfoTextBackgroundVisibility;

var bool m_bInfoTextBackgroundVisible;

var bool m_bPingPathAssistArrow;

var bool m_bHavePathAssistGoal;

var bool m_bCanMapPlayerPowers;

var bool m_bInOutTransition;

var bool m_bRadarOn;

var bool m_bRadarVisible;

var bool m_bVisible;

native function SetWheelVisible(bool bVisible);

native function SetupPlayerPowers();

function CleanupReferences()
{
    local int nIcon;
    m_pPlayerController = None;
    m_pPlayerSquad = None;
    m_pShepardPawn = None;
    m_pHench1Pawn = None;
    m_pHench2Pawn = None;
    m_pCurrentPlayerSelection = None;
    nIcon = 0;
    while (nIcon < m_aPowerIcons.Length)
    {
        m_aPowerIcons[nIcon].pPower = None;
        m_aPowerIcons[nIcon].pPawn = None;
        ++nIcon;
    }
}

event OnPanelRemoved()
{
    CleanupReferences();
    OnPanelRemoved();
}

function GameSessionEnded()
{
    CleanupReferences();
    GameSessionEnded();
}

function OnAllowCameraRotation(bool i_bValue);

native function RemoveHenchman(BioPawn pPawn);

native function BioPawn GetPawnFromName(Name nmPawn, optional bool bUseUniqueTag);

event bool CanIssueImmediateOrder(Pawn pPawn)
{
    local SFXAI_Henchman pHenchman;
    local BioPlayerController pPlayer;
    if (pPawn != None)
    {
        pHenchman = SFXAI_Henchman(pPawn.Controller);
        pPlayer = BioPlayerController(pPawn.Controller);
    }
    if (pHenchman != None)
    {
        return pHenchman.CanStartImmediateOrder();
    }
    else
    {
        if (pPlayer != None)
        {
            return pPlayer.CanStartImmediateOrder();
        }
    }
    return false;
}

event bool CanIssueQueuedOrder(Pawn pPawn)
{
    local SFXAI_Henchman pHenchman;
    local BioPlayerController pPlayer;
    if (pPawn != None)
    {
        pHenchman = SFXAI_Henchman(pPawn.Controller);
        pPlayer = BioPlayerController(pPawn.Controller);
    }
    if (pHenchman != None)
    {
        return pHenchman.CanQueueOrder();
    }
    else
    {
        if (pPlayer != None)
        {
            return pPlayer.CanQueueOrder();
        }
    }
    return false;
}

event doHotKey(int nIndex);

event InitDisplay()
{
    local int nIcon;
    local float fTemp;
    oPanel.SetTextFieldText(m_sTitleTextPath, "");
    nIcon = 0;
    while (nIcon < m_aWeaponIcons.Length)
    {
        HideWeaponIcon(oPanel, m_aWeaponIcons[nIcon].sPath);
        ++nIcon;
    }
    fTemp = oPanel.GetVariableFloat(m_sUseButtonPath $ "._x");
    m_fButtonTextPadding = oPanel.GetVariableFloat(m_sUseTextPath $ "._x") - fTemp;
    oPanel.SetTextFieldText(m_sRadarPath $ ".NorthIndicator.CompassMC.text", "");
}

function bool IsPawnBlocked(BioPawn pPawn)
{
    if (pPawn == None)
    {
        return false;
    }
    if (pPawn.Physics == 10)
    {
        return true;
    }
    if (CanIssueImmediateOrder(pPawn) == false && CanIssueQueuedOrder(pPawn) == false)
    {
        return true;
    }
    return false;
}

native function HidePowerIconByIndex(int nIconIndex);

static function HideWeaponIcon(BioSFPanel pPanel, String sPath)
{
    pPanel.SetClipVisibility(sPath, false);
    pPanel.SetTextFieldText(sPath $ ".txtAmmo", "");
}

event WheelVisibilityChanged(bool bVisible)
{
    local int nIcon;
    local bool bPowerWheel;
    local bool bWeaponWheel;
    if (bVisible == false)
    {
        if (m_ePowerWheelMode == 2 || m_ePowerWheelMode == 3)
        {
            LeaveWeaponIcon(m_nCurrentWeaponIconIndex);
            nIcon = 0;
            while (nIcon < m_aWeaponIcons.Length)
            {
                oPanel.SetClipVisibility(m_aWeaponIcons[nIcon].sPath, false);
                ++nIcon;
            }
        }
        if (m_ePowerWheelMode == 1 || m_ePowerWheelMode == 3)
        {
            LeavePowerIcon(m_nCurrentPowerIconIndex, true);
            nIcon = 0;
            while (nIcon < m_aPowerIcons.Length)
            {
                SetPowerIconSelected(nIcon, false);
                HidePowerIconByIndex(nIcon);
                ++nIcon;
            }
        }
        oPanel.GotoLabelAndPlay("Wheel", "OUT");
        m_bInOutTransition = true;
        m_fLastProcessedStickAngle = -1;
        oPanel.SetClipVisibility(m_sTitleTextPath, false);
        SetInformationText("", "");
        SetUseText("");
        SetMapText("", 0, "", 0);
        oPanel.SetClipVisibility(m_sShepardBlockerPath, false);
        oPanel.SetClipVisibility(m_sHench1BlockerPath, false);
        oPanel.SetClipVisibility(m_sHench2BlockerPath, false);
        SetStatusAndPowerText(None, 1);
        SetStatusAndPowerText(None, 2);
        BioHintSystem(m_pPlayerController.HintSystem).HintEvent('ClearTutorialHint');
        m_pPlayerController.GenerateTutorialEvent(7);
    }
    else
    {
        if (m_ePowerWheelMode == 2 || m_ePowerWheelMode == 3)
        {
            bWeaponWheel = true;
            nIcon = 0;
            while (nIcon < m_aWeaponIcons.Length)
            {
                oPanel.SetClipVisibility(m_aWeaponIcons[nIcon].sPath, true);
                ++nIcon;
            }
        }
        if (m_ePowerWheelMode == 1 || m_ePowerWheelMode == 3)
        {
            bPowerWheel = true;
            nIcon = 0;
            while (nIcon < m_aPowerIcons.Length)
            {
                oPanel.SetClipVisibility(m_aPowerIcons[nIcon].sPath, true);
                ++nIcon;
            }
        }
        oPanel.GotoLabelAndPlay("Wheel", "IN");
        oPanel.SetClipVisibility(m_sTitleTextPath, true);
        SetStatusAndPowerText(m_pHench1Pawn, 1);
        SetStatusAndPowerText(m_pHench2Pawn, 2);
        BioHintSystem(m_pPlayerController.HintSystem).GeneratePowerWheelTutorialHint(bPowerWheel, bWeaponWheel);
    }
}

function SetStatusAndPowerText(BioPawn pPawn, SFXPowerWheelPawnID ePawnID)
{
    local int nStatusFlags;
    local String sStatus;
    local String sPowerStatus;
    local String sStatusPath;
    local String sPowerPath;
    switch (ePawnID)
    {
        case 1:
            sStatusPath = m_sTeam1StatusTextPath;
            sPowerPath = m_sTeam1PowerTextPath;
            break;
        case 2:
            sStatusPath = m_sTeam2StatusTextPath;
            sPowerPath = m_sTeam2PowerTextPath;
            break;
        default:
            return;
    }
    sStatus = "";
    sPowerStatus = "";
    if (pPawn != None)
    {
        nStatusFlags = Class'SFXSFHandler_HUD'.GetTargetStatusFlags(pPawn);
        sStatus = Class'SFXSFHandler_HUD'.GetStatusText(pPawn, nStatusFlags);
        if (pPawn.PowerManager != None)
        {
            if (pPawn.PowerManager.GetSharedCooldownRemaining() > 0,01)
            {
                sPowerStatus = m_srRecharging;
            }
        }
    }
    oPanel.SetClipVisibility(sStatusPath, sStatus != "");
    oPanel.SetTextFieldText(sStatusPath, sStatus);
    oPanel.SetClipVisibility(sPowerPath, sPowerStatus != "");
    oPanel.SetTextFieldText(sPowerPath, sPowerStatus);
}

event SetUseText(String sText)
{
    oPanel.SetTextFieldText(m_sUseTextPath, sText);
    if (sText != "")
    {
        oPanel.SetClipVisibility(m_sUseButtonPath, true);
    }
    else
    {
        oPanel.SetClipVisibility(m_sUseButtonPath, false);
    }
}

event SetMapText(String sText1, SFXPowerWheelMapButtonIcon eIcon1, optional String sText2 = "", optional SFXPowerWheelMapButtonIcon eIcon2 = 0)
{
    oPanel.SetTextFieldText(m_sMapText1Path, sText1);
    if (sText1 != "")
    {
        oPanel.SetClipVisibility(m_sMapButton1Path, true);
        SetMappingIcon(m_oMapTextIcon1, eIcon1);
    }
    else
    {
        oPanel.SetClipVisibility(m_sMapButton1Path, false);
        SetMappingIcon(m_oMapTextIcon1, 0);
    }
    oPanel.SetTextFieldText(m_sMapText2Path, sText2);
    if (sText2 != "")
    {
        oPanel.SetClipVisibility(m_sMapButton2Path, true);
        SetMappingIcon(m_oMapTextIcon2, eIcon2);
    }
    else
    {
        oPanel.SetClipVisibility(m_sMapButton2Path, false);
        SetMappingIcon(m_oMapTextIcon2, 0);
    }
}

native function SetPowerIconState(int nIconIndex, SFXPowerWheelPowerState eNewState);

native function SetPowerIconSelected(int nIconIndex, bool bSelected);

native function bool EvaluatePowerForTarget(SFXPowerWheelIconPower oIcon, Actor pTarget, out String sText);

event HoverPowerIcon(int nIconIndex, bool bSkipTransition)
{
    local SFXPowerWheelIconPower oIcon;
    local Name nmPower;
    if (nIconIndex < 0 || nIconIndex >= m_aPowerIcons.Length)
    {
        return;
    }
    if (m_nCurrentPowerIconIndex == nIconIndex)
    {
        return;
    }
    LeavePowerIcon(m_nCurrentPowerIconIndex, bSkipTransition);
    oIcon = m_aPowerIcons[nIconIndex];
    if (bSkipTransition == false)
    {
        oPanel.GotoLabelAndPlay(oIcon.sPath, "grow");
    }
    else
    {
        oPanel.GotoLabelAndStop(oIcon.sPath, "opened");
    }
    SetPowerIconSelected(nIconIndex, true);
    UpdateTextDisplayForIcon(nIconIndex);
    PlayGuiSound('HUDPowerWheelChangeHighlightedPower');
    m_nCurrentPowerIconIndex = nIconIndex;
    if (oIcon.pPower != None)
    {
        nmPower = oIcon.pPower.BaseName;
    }
    else
    {
        nmPower = oIcon.nmPowerName;
    }
    BioHintSystem(m_pPlayerController.HintSystem).UpdatePowerWheelTutorialHint(nmPower);
}

event UpdateTextDisplayForIcon(int nIconIndex)
{
    local SFXPowerWheelIconPower oIcon;
    local String sUseText;
    local String sMap1Text;
    local String sMap2Text;
    local String sIcon1Token;
    local String sIcon2Token;
    local SFXPowerWheelMapButtonIcon eIcon1;
    local SFXPowerWheelMapButtonIcon eIcon2;
    if (nIconIndex < 0 || nIconIndex >= m_aPowerIcons.Length)
    {
        return;
    }
    oIcon = m_aPowerIcons[nIconIndex];
    if (m_oPowerIndices.aPlayer.Find(nIconIndex) != -1)
    {
        sIcon1Token = m_sMap1Token;
        sIcon2Token = m_sMap2Token;
        eIcon1 = 5;
        eIcon2 = 6;
        if (oIcon.oMappedIcon.eIcon == 5)
        {
            sIcon1Token = "";
            eIcon1 = 0;
        }
        else
        {
            if (oIcon.oMappedIcon.eIcon == 6)
            {
                sIcon2Token = "";
                eIcon2 = 0;
            }
        }
    }
    else
    {
        if (GetHenchmanMappedPower(oIcon.pPawn) != oIcon.nmPowerName)
        {
            if (oIcon.pPawn == m_pHench1Pawn)
            {
                sIcon1Token = m_sMapHench1Token;
                eIcon1 = 3;
            }
            else
            {
                sIcon1Token = m_sMapHench2Token;
                eIcon1 = 4;
            }
        }
    }
    sUseText = "";
    sMap1Text = "";
    sMap2Text = "";
    if (oIcon.eState != 5 && oIcon.eState != 6)
    {
        if (oIcon.eState != 3 && oIcon.eState != 4)
        {
            SetCustomToken(0, oIcon.sName);
            sUseText = Class'SFXGame'.GetSimpleString(m_srUse, true);
            ClearCustomTokens();
        }
        if (eIcon1 != 0)
        {
            SetCustomToken(0, oIcon.sName);
            SetCustomToken(1, sIcon1Token);
            sMap1Text = Class'SFXGame'.GetSimpleString(m_srMap, true);
            ClearCustomTokens();
        }
        if (eIcon2 != 0)
        {
            SetCustomToken(0, oIcon.sName);
            SetCustomToken(1, sIcon2Token);
            sMap2Text = Class'SFXGame'.GetSimpleString(m_srMap, true);
            ClearCustomTokens();
        }
    }
    SetUseText(sUseText);
    SetMapText(sMap1Text, eIcon1, sMap2Text, eIcon2);
    UpdatePowerInformationText(oIcon);
}

event UpdatePowerInformationText(SFXPowerWheelIconPower oIcon)
{
    local String sDescriptionText;
    local String sEvaluationText;
    local bool bGoodEval;
    bGoodEval = EvaluatePowerForTarget(oIcon, m_pCurrentPlayerSelection, sEvaluationText);
    if (sEvaluationText != "")
    {
        if (bGoodEval == false)
        {
            sDescriptionText = m_sNotSuggestedPrefix $ sEvaluationText $ m_sNotSuggestedSuffix $ "\n";
        }
        else
        {
            sDescriptionText = sEvaluationText $ "\n";
        }
    }
    sDescriptionText = sDescriptionText $ oIcon.sDescription;
    SetInformationText(oIcon.sName, sDescriptionText);
}

function SetInformationText(String sName, String sDesc)
{
    if (sName != "")
    {
        oPanel.SetTextFieldText(m_sNameTextPath, sName);
        oPanel.SetClipVisibility(m_sNameTextPath, true);
    }
    else
    {
        oPanel.SetClipVisibility(m_sNameTextPath, false);
        oPanel.SetTextFieldText(m_sNameTextPath, "");
    }
    if (sDesc != "")
    {
        oPanel.SetVariableString(m_sInfoTextPath $ ".htmlText", sDesc);
        oPanel.SetClipVisibility(m_sInfoTextPath, true);
        if (m_bDesiredInfoTextBackgroundVisibility == false)
        {
            m_bDesiredInfoTextBackgroundVisibility = true;
            m_fRemainingInfoTextChangeDelay = m_fInfoTextChangeDelay;
        }
    }
    else
    {
        oPanel.SetClipVisibility(m_sInfoTextPath, false);
        oPanel.SetTextFieldText(m_sInfoTextPath, "");
        if (m_bDesiredInfoTextBackgroundVisibility != false)
        {
            m_bDesiredInfoTextBackgroundVisibility = false;
            m_fRemainingInfoTextChangeDelay = m_fInfoTextChangeDelay;
        }
    }
}

event LeavePowerIcon(int nIconIndex, bool bSkipTransition)
{
    local SFXPowerWheelIconPower oIcon;
    if (nIconIndex < 0 || nIconIndex >= m_aPowerIcons.Length)
    {
        return;
    }
    if (m_nCurrentPowerIconIndex != nIconIndex)
    {
        return;
    }
    oIcon = m_aPowerIcons[nIconIndex];
    if (bSkipTransition == false)
    {
        oPanel.GotoLabelAndPlay(oIcon.sPath, "shrink");
    }
    else
    {
        oPanel.GotoLabelAndStop(oIcon.sPath, "normal");
    }
    SetPowerIconSelected(nIconIndex, false);
    SetInformationText("", "");
    m_nCurrentPowerIconIndex = -1;
}

event Name GetCurrentHenchmanOrder(BioPawn pPawn)
{
    local SFXAI_Henchman pHenchController;
    local HenchmanOrder oNextOrder;
    if (pPawn == None)
    {
        return 'None';
    }
    pHenchController = SFXAI_Henchman(pPawn.Controller);
    if (pHenchController == None)
    {
        return 'None';
    }
    oNextOrder = pHenchController.GetNextOrder(1);
    return oNextOrder.nmPower;
}

native function SelectCurrentPower();

native function MapCurrentPower(SFXPowerWheelMapButtonIcon eIcon);

event SetWeaponType(int nWeapIndex, String sWeaponIconResource, int nNewWeapIcon)
{
    local SFXPowerWheelIconWeapon oIcon;
    if (nWeapIndex < 0 || nWeapIndex >= m_aWeaponIcons.Length)
    {
        return;
    }
    if (nNewWeapIcon == 0)
    {
        m_aWeaponIcons[nWeapIndex].nAmmo = 0;
        m_aWeaponIcons[nWeapIndex].sName = "";
        m_aWeaponIcons[nWeapIndex].sDescription = "";
        m_aWeaponIcons[nWeapIndex].bEquipped = false;
        m_aWeaponIcons[nWeapIndex].oWeaponClass = None;
        m_aWeaponIcons[nWeapIndex].sIconResource = "";
    }
    oIcon = m_aWeaponIcons[nWeapIndex];
    if (nNewWeapIcon != oIcon.nWeaponIcon)
    {
        SetWeaponTypeDisplay(oPanel, oIcon.sPath, oIcon.sIconResource, nNewWeapIcon);
    }
    m_aWeaponIcons[nWeapIndex].nWeaponIcon = nNewWeapIcon;
    oIcon = m_aWeaponIcons[nWeapIndex];
    UpdateWeaponIconDisplay(oIcon);
}

static function SetWeaponTypeDisplay(BioSFPanel pPanel, String sIconPath, String sIconResource, int nNewType)
{
    local array<ASParams> aParams;
    aParams.Length = 2;
    aParams[0].Type = 2;
    aParams[0].sVar = sIconResource;
    aParams[1].Type = 0;
    aParams[1].nVar = nNewType;
    pPanel.InvokeMethodArgs(sIconPath $ ".SetIcon", aParams);
}

event SetWeaponState(int nWeapIndex, SFXPowerWheelWeaponState eNewWeapState)
{
    local array<ASParams> aParams;
    local SFXPowerWheelIconWeapon oIcon;
    if (nWeapIndex < 0 || nWeapIndex >= m_aWeaponIcons.Length)
    {
        return;
    }
    oIcon = m_aWeaponIcons[nWeapIndex];
    if (oIcon.nWeaponIcon == 0)
    {
        return;
    }
    if (eNewWeapState == oIcon.eWeaponState)
    {
        return;
    }
    if (eNewWeapState == 3)
    {
        if (m_aWeaponIcons[nWeapIndex].bEquipped != true)
        {
            SelectWeapon(nWeapIndex);
        }
    }
    else
    {
        if (eNewWeapState != 1 || oIcon.eWeaponState != 3)
        {
            m_aWeaponIcons[nWeapIndex].bEquipped = false;
        }
    }
    aParams.Length = 1;
    aParams[0].Type = 0;
    aParams[0].nVar = m_aWeaponStateFrames[eNewWeapState];
    oPanel.InvokeMethodArgs(oIcon.sPath $ ".SetFrame", aParams);
    m_aWeaponIcons[nWeapIndex].eWeaponState = eNewWeapState;
}

function SelectWeapon(int nWeaponIndex)
{
    if (nWeaponIndex < 0 || nWeaponIndex >= m_aWeaponIcons.Length)
    {
        return;
    }
    m_aWeaponIcons[nWeaponIndex].bEquipped = true;
    m_nCurrentSelectedWeapon = m_aWeaponIcons[nWeaponIndex].nWeaponIcon;
}

event UpdateWeaponIconDisplay(SFXPowerWheelIconWeapon oIcon, optional String sAltPath = "")
{
    local String sAmmoCount;
    local String sPath;
    sPath = oIcon.sPath;
    if (sAltPath != "")
    {
        sPath = sAltPath;
    }
    sAmmoCount = "";
    if (oIcon.bHenchIcon == false)
    {
        if (oIcon.nAmmo != -1 && oIcon.nWeaponIcon != 0)
        {
            sAmmoCount = oIcon.nAmmo;
        }
    }
    oPanel.SetTextFieldText(sPath $ ".txtAmmo", sAmmoCount);
}

event HoverWeaponIcon(int nIconIndex, optional bool bForceUpdate = false)
{
    local String sName;
    local String sInfo;
    sName = "";
    sInfo = "";
    if (m_nCurrentWeaponIconIndex == nIconIndex && bForceUpdate == false)
    {
        return;
    }
    LeaveWeaponIcon(m_nCurrentWeaponIconIndex);
    if (nIconIndex >= 0 && nIconIndex < m_aWeaponIcons.Length)
    {
        if (m_aWeaponIcons[nIconIndex].eWeaponState != 2 && m_aWeaponIcons[nIconIndex].nWeaponIcon != 0)
        {
            SetWeaponState(nIconIndex, 1);
            sName = m_aWeaponIcons[nIconIndex].sName;
            sInfo = m_aWeaponIcons[nIconIndex].sDescription;
            PlayGuiSound('HUDWeaponPadNewHighlight');
            if (m_aWeaponIcons[nIconIndex].bEquipped == false)
            {
                SetCustomToken(0, sName);
                SetUseText(Class'SFXGame'.GetSimpleString(m_srEquip, true));
                ClearCustomTokens();
            }
            else
            {
                SetUseText("");
            }
            BioHintSystem(m_pPlayerController.HintSystem).UpdateWeaponWheelTutorialHint(m_aWeaponIcons[nIconIndex].nWeaponIcon);
        }
        SetInformationText(sName, sInfo);
    }
    m_nCurrentWeaponIconIndex = nIconIndex;
}

event LeaveWeaponIcon(int nIconIndex)
{
    if (m_nCurrentWeaponIconIndex != nIconIndex)
    {
        return;
    }
    if (nIconIndex >= 0 && nIconIndex < m_aWeaponIcons.Length)
    {
        if (m_aWeaponIcons[nIconIndex].eWeaponState != 2 && m_aWeaponIcons[nIconIndex].nWeaponIcon != 0)
        {
            if (m_aWeaponIcons[nIconIndex].bEquipped == false)
            {
                SetWeaponState(nIconIndex, 0);
            }
            else
            {
                SetWeaponState(nIconIndex, 3);
            }
        }
    }
    m_nCurrentWeaponIconIndex = -1;
}

event SetupWeaponDisplayForPawn(BioPawn pPawn, SFXPowerWheelPawnID ePawn)
{
    local SFXWeapon pWeap;
    local int nWeaponSlot;
    local array<int> aIconIndices;
    local int nSlotIndex;
    local String sBlockingLabel;
    local bool bImmediateOrder;
    local bool bQueuedOrder;
    local String sBlockerClipPath;
    local bool bNoWeapons;
    local array<SFXWeapon> aWeapons;
    local int nWeap;
    bNoWeapons = false;
    if (pPawn == None || SFXInventoryManager(pPawn.InvManager) == None)
    {
        bNoWeapons = true;
    }
    switch (ePawn)
    {
        case 0:
            aIconIndices = m_oWeaponIndices.aPlayer;
            sBlockerClipPath = m_sShepardBlockerPath;
            break;
        case 1:
            aIconIndices = m_oWeaponIndices.aHench1;
            sBlockerClipPath = m_sHench1BlockerPath;
            break;
        case 2:
            aIconIndices = m_oWeaponIndices.aHench2;
            sBlockerClipPath = m_sHench2BlockerPath;
            break;
    }
    sBlockingLabel = "";
    nWeaponSlot = 0;
    if (bNoWeapons == false)
    {
        foreach pPawn.InvManager.InventoryActors(Class'SFXWeapon', pWeap)
        {
            aWeapons[aWeapons.Length] = pWeap;
        }
        SortWeapons(pPawn, aWeapons);
        nWeap = 0;
        while (nWeap < aWeapons.Length)
        {
            pWeap = aWeapons[nWeap];
            if (nWeaponSlot >= aIconIndices.Length)
            {
                break;
            }
            nSlotIndex = aIconIndices[nWeaponSlot];
            SetWeaponIcon(pWeap, nSlotIndex, pPawn);
            ++nWeaponSlot;
            ++nWeap;
        }
        if (pPawn.Physics == 10)
        {
            sBlockingLabel = m_srPawnIncapacitated;
        }
        bImmediateOrder = CanIssueImmediateOrder(pPawn);
        bQueuedOrder = CanIssueQueuedOrder(pPawn);
        if (bImmediateOrder == false && bQueuedOrder == false)
        {
            sBlockingLabel = m_srBlocked;
        }
    }
    while (nWeaponSlot < aIconIndices.Length)
    {
        nSlotIndex = aIconIndices[nWeaponSlot];
        SetWeaponType(nSlotIndex, "", 0);
        ++nWeaponSlot;
    }
    if (sBlockingLabel != "")
    {
        nWeaponSlot = 0;
        while (nWeaponSlot < aIconIndices.Length)
        {
            SetWeaponState(aIconIndices[nWeaponSlot], 2);
            ++nWeaponSlot;
        }
        if (m_bVisible)
        {
            oPanel.SetClipVisibility(sBlockerClipPath, true);
            oPanel.SetTextFieldText(sBlockerClipPath $ ".txtBlocker", sBlockingLabel);
        }
    }
    else
    {
        oPanel.SetClipVisibility(sBlockerClipPath, false);
        oPanel.SetTextFieldText(sBlockerClipPath $ ".txtBlocker", "");
    }
}

function SetWeaponIcon(SFXWeapon pWeap, int nSlotIndex, BioPawn pPawn)
{
    if (nSlotIndex < 0 || nSlotIndex > m_aWeaponIcons.Length)
    {
        return;
    }
    m_aWeaponIcons[nSlotIndex].sName = pWeap.GetPrettyName();
    m_aWeaponIcons[nSlotIndex].sDescription = pWeap.GetShortDescription();
    m_aWeaponIcons[nSlotIndex].oWeaponClass = pWeap.Class;
    m_aWeaponIcons[nSlotIndex].nAmmo = pWeap.GetCurrentTotalAmmo();
    m_aWeaponIcons[nSlotIndex].bEquipped = false;
    m_aWeaponIcons[nSlotIndex].sIconResource = PathName(pWeap.IconResource);
    SetWeaponState(nSlotIndex, 0);
    SetWeaponType(nSlotIndex, PathName(pWeap.IconResource), pWeap.IconRef);
    if (pWeap == pPawn.Weapon)
    {
        SetWeaponState(nSlotIndex, 3);
    }
}

function SortWeapons(BioPawn pPawn, out array<SFXWeapon> aWeapons);

function SelectCurrentWeapon()
{
    local SFXPowerWheelIconWeapon oWeaponIcon;
    local BioPawn pPawn;
    local SFXWeapon pWeapon;
    local SFXInventoryManager pInvManager;
    local array<int> aIconIndices;
    local int nIcon;
    if (m_nCurrentWeaponIconIndex < 0 || m_nCurrentWeaponIconIndex >= m_aWeaponIcons.Length)
    {
        PlayGuiSound('GuiError');
        return;
    }
    oWeaponIcon = m_aWeaponIcons[m_nCurrentWeaponIconIndex];
    if (oWeaponIcon.eWeaponState == 2 || oWeaponIcon.nWeaponIcon == 0 || oWeaponIcon.nWeaponIcon == 1)
    {
        PlayGuiSound('GuiError');
        return;
    }
    if (m_oWeaponIndices.aPlayer.Find(m_nCurrentWeaponIconIndex) != -1)
    {
        pPawn = m_pShepardPawn;
        aIconIndices = m_oWeaponIndices.aPlayer;
    }
    else
    {
        if (m_oWeaponIndices.aHench1.Find(m_nCurrentWeaponIconIndex) != -1)
        {
            pPawn = m_pHench1Pawn;
            aIconIndices = m_oWeaponIndices.aHench1;
        }
        else
        {
            if (m_oWeaponIndices.aHench2.Find(m_nCurrentWeaponIconIndex) != -1)
            {
                pPawn = m_pHench2Pawn;
                aIconIndices = m_oWeaponIndices.aHench2;
            }
        }
    }
    if (pPawn == None)
    {
        PlayGuiSound('GuiError');
        return;
    }
    pInvManager = SFXInventoryManager(pPawn.InvManager);
    if (pInvManager != None)
    {
        foreach pPawn.InvManager.InventoryActors(Class'SFXWeapon', pWeapon)
        {
            if (pWeapon.Class == oWeaponIcon.oWeaponClass)
            {
                pInvManager.CurrentWeaponSelection = pWeapon.Class;
                m_pPlayerController.OrderWeaponSwitch(pPawn, pWeapon);
                PlayGuiSound('HUDPowerWheelQueueingHighlightedPowerForActivation');
                nIcon = 0;
                while (nIcon < aIconIndices.Length)
                {
                    if (m_aWeaponIcons[aIconIndices[nIcon]].bEquipped == true)
                    {
                        SetWeaponState(aIconIndices[nIcon], 0);
                        break;
                    }
                    ++nIcon;
                }
                SetWeaponState(m_nCurrentWeaponIconIndex, 3);
                break;
            }
        }
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 2:
            m_vLStickInput.X = fValue;
            break;
        case 3:
            m_vLStickInput.Y = fValue;
            break;
        case 12:
            SelectCurrentWheelItem(m_ePowerWheelMode);
            break;
        case 14:
            if (m_ePowerWheelMode == 1)
            {
                MapCurrentPower(5);
            }
            break;
        case 13:
            if (m_ePowerWheelMode == 1)
            {
                MapCurrentPower(6);
            }
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function SelectCurrentWheelItem(SFXPowerWheelMode eMode)
{
    if (eMode == 2)
    {
        SelectCurrentWeapon();
    }
    else
    {
        if (eMode == 1)
        {
            SelectCurrentPower();
        }
    }
}

event RadarVisibilityChanged(bool bVisible, optional bool bObjectiveMode = false)
{
    if (m_bRadarVisible == bVisible)
    {
        return;
    }
    m_bRadarVisible = bVisible;
    if (bVisible == false)
    {
        oPanel.InvokeMethod("ClearRadar");
        oPanel.GotoLabelAndPlay("Radar", "hide");
        return;
    }
    else
    {
        oPanel.GotoLabelAndPlay("Radar", "show");
    }
    UpdateRadarDisplay(bObjectiveMode);
}

event UpdateRadarDisplay(bool bObjectiveMode)
{
    local bool bInVehicle;
    local array<ASParams> aParams;
    local String sElementPath;
    local int nElement;
    local SFXRadarElementData oTempData;
    local String sTemp;
    local int nTemp;
    oPanel.InvokeMethod("ClearRadar");
    if (bObjectiveMode == false)
    {
        if (m_pPlayerController != None)
        {
            m_pPlayerController.RefreshRadarData();
            bInVehicle = m_pPlayerController.GameModeManager2.IsActive(4);
        }
        else
        {
            bInVehicle = false;
        }
    }
    if (bObjectiveMode == false)
    {
        oPanel.SetTextFieldText(m_sRadarPath $ ".txtRange", m_pPlayerController.GetRadarRange() * 0,01 $ m_srRadarRangeUnits);
    }
    else
    {
        oPanel.SetTextFieldText(m_sRadarPath $ ".txtRange", "");
    }
    if (m_pPlayerController.m_bRadarIsJammed != false)
    {
        oPanel.SetClipVisibility(m_sRadarPath $ ".FOV1", false);
        oPanel.SetClipVisibility(m_sRadarPath $ ".FOV2", false);
        oPanel.SetClipVisibility(m_sRadarPath $ ".TeamLock", false);
        oPanel.GotoLabelAndStop(m_sRadarPath $ ".Background", "jammed");
        oPanel.GotoFrameAndPlay(m_sRadarPath $ ".Background.Jammed", 2);
    }
    else
    {
        if (bInVehicle == false)
        {
            if (bObjectiveMode != false)
            {
                sTemp = "objective";
            }
            else
            {
                sTemp = "hud";
            }
        }
        else
        {
            sTemp = "mako";
        }
        oPanel.GotoLabelAndStop(m_sRadarPath $ ".Background", sTemp);
        oPanel.SetVariableFloat(m_sRadarPath $ ".FOV1._rotation", -m_pPlayerController.GetRadarFOV());
        oPanel.SetVariableFloat(m_sRadarPath $ ".FOV2._rotation", m_pPlayerController.GetRadarFOV());
        oPanel.SetClipVisibility(m_sRadarPath $ ".FOV1", bObjectiveMode == false);
        oPanel.SetClipVisibility(m_sRadarPath $ ".FOV2", bObjectiveMode == false);
        oPanel.SetClipVisibility(m_sRadarPath $ ".TeamLock", bObjectiveMode == false);
        if (bObjectiveMode == false)
        {
            CollectRadarElementData(m_aRadarElementData);
            aParams.Length = 1;
            aParams[0].Type = 0;
            aParams[0].nVar = m_aRadarElementData.Length;
            oPanel.InvokeMethodArgs("InitRadarElements", aParams);
            nElement = 0;
            while (nElement < m_aRadarElementData.Length)
            {
                sElementPath = m_sRadarPath $ ".Elements.RadarElement" $ nElement;
                oTempData = m_aRadarElementData[nElement];
                sTemp = m_aRadarIconFramePaths[oTempData.eRadarType - 1];
                if (oTempData.eRadarType == 1 || oTempData.eRadarType == 2 || oTempData.eRadarType == 3)
                {
                    if (oTempData.nSize == 0)
                    {
                        sTemp = sTemp $ "Small";
                    }
                    else
                    {
                        if (oTempData.nSize == 1)
                        {
                            sTemp = sTemp $ "Medium";
                        }
                        else
                        {
                            sTemp = sTemp $ "Large";
                        }
                    }
                }
                if (oTempData.eRadarType != 1 && oTempData.eRadarType != 2)
                {
                    if (oTempData.eRadarType == 3 && oTempData.nSize == 1)
                    {
                        oPanel.SetClipVisibility(sElementPath, false);
                        jump 1786;
                    }
                    else
                    {
                        oPanel.SetClipVisibility(sElementPath, true);
                    }
                    oPanel.GotoLabelAndStop(sElementPath, sTemp);
                    oPanel.GotoFrameAndStop(sElementPath $ ".subElementMC", 1);
                    nTemp = oTempData.vPosition.Z * 100;
                    if (nTemp < 0)
                    {
                        nTemp = -nTemp;
                    }
                    oPanel.GotoFrameAndStop(sElementPath $ ".subElementMC.altitudeMC", nTemp + 1);
                    nTemp = 1;
                    if (oTempData.nRelativeZ == -1)
                    {
                        nTemp = 2;
                    }
                    else
                    {
                        if (oTempData.nRelativeZ == 1)
                        {
                            nTemp = 3;
                        }
                    }
                    oPanel.GotoFrameAndStop(sElementPath $ ".charHeight", nTemp);
                }
                else
                {
                    oPanel.SetClipVisibility(sElementPath, false);
                }
                ++nElement;
            }
            UpdateRadarElementPositions(m_aRadarElementData);
            oPanel.SetVariableString("g_sRadarText", "");
        }
        else
        {
            oPanel.SetVariableString("g_sRadarText", m_bHavePathAssistGoal ? m_srObjective : "");
        }
        m_fCacheTargetDirection = 999;
        m_fCacheNorthDirection = 999;
        m_fCachePathDirection = 999;
        UpdateRadarArrows();
        if (m_bHavePathAssistGoal != false && m_bPingPathAssistArrow != false)
        {
            oPanel.GotoLabelAndPlay(m_sRadarPath $ ".PathIndicator.CompassMC.ArrowBurstMC", "start");
            m_bPingPathAssistArrow = false;
        }
        UpdateRadarMapBoundaries();
    }
    return;
}

event UpdateRadarElementPositions(out array<SFXRadarElementData> aRadarData)
{
    local int nElement;
    local SFXRadarElementData oTempData;
    local String sPath;
    nElement = 0;
    while (nElement < aRadarData.Length)
    {
        sPath = m_sRadarPath $ ".Elements.RadarElement" $ nElement;
        oTempData = aRadarData[nElement];
        if (oTempData.bUpdate != false)
        {
            oPanel.SetClipLocation(sPath, oTempData.vPosition.X * m_fRadarRadius, oTempData.vPosition.Y * m_fRadarRadius);
            aRadarData[nElement].bUpdate = false;
        }
        if (oTempData.bUpdateLock != false)
        {
            if (oTempData.bLocked != false)
            {
                oPanel.GotoLabelAndPlay(sPath $ ".lockMC", "start");
            }
            else
            {
                oPanel.GotoFrameAndStop(sPath $ ".lockMC", 1);
            }
            aRadarData[nElement].bUpdateLock = false;
        }
        ++nElement;
    }
}

event UpdateRadarArrows()
{
    local float fTargetDirection;
    local float fNorthDirection;
    local float fPathDirection;
    GetRadarDirectionValues(fTargetDirection, fNorthDirection, fPathDirection);
    if (m_pPlayerController.m_bRadarArrow != false)
    {
        if (Abs(fTargetDirection - m_fCacheTargetDirection) > m_fRadarDirectionChangeDelta)
        {
            oPanel.SetClipVisibility(m_sRadarPath $ ".DirectionIndicator", true);
            oPanel.SetVariableFloat(m_sRadarPath $ ".DirectionIndicator._rotation", fTargetDirection);
            m_fCacheTargetDirection = fTargetDirection;
        }
    }
    else
    {
        oPanel.SetClipVisibility(m_sRadarPath $ ".DirectionIndicator", false);
    }
    if (Abs(fNorthDirection - m_fCacheNorthDirection) > m_fRadarDirectionChangeDelta)
    {
        oPanel.SetVariableFloat(m_sRadarPath $ ".NorthIndicator._rotation", fNorthDirection);
        m_fCacheNorthDirection = fNorthDirection;
    }
    if (m_bHavePathAssistGoal != false)
    {
        if (Abs(fPathDirection - m_fCachePathDirection) > m_fRadarDirectionChangeDelta)
        {
            oPanel.SetClipVisibility(m_sRadarPath $ ".PathIndicator", true);
            oPanel.SetVariableFloat(m_sRadarPath $ ".PathIndicator._rotation", fPathDirection);
            m_fCachePathDirection = fPathDirection;
        }
    }
    else
    {
        oPanel.SetClipVisibility(m_sRadarPath $ ".PathIndicator", false);
    }
}

event UpdateRadarMapBoundaries()
{
    local Vector2D vTopLeft;
    local Vector2D vBottomRight;
    local float fBoundaryRotation;
    local Vector2D vDimensions;
    local Vector2D vScale;
    local Vector2D vTopLine;
    if (GetMapBoundaryValues(vTopLeft, vBottomRight, fBoundaryRotation) != false)
    {
        vDimensions.X = vBottomRight.X + vTopLeft.X;
        vDimensions.Y = vBottomRight.Y + vTopLeft.Y;
        vScale.X = vDimensions.X * 1 / m_vBoundaryDimensions.X;
        vScale.Y = vDimensions.Y * 1 / m_vBoundaryDimensions.Y;
        oPanel.SetVariableFloat(m_sRadarPath $ ".Elements.ElementsBoundary.boundaryMC._xscale", vScale.X);
        oPanel.SetVariableFloat(m_sRadarPath $ ".Elements.ElementsBoundary.boundaryMC._yscale", vScale.Y);
        vTopLine.X = vScale.X * m_fBoundaryShrinkFactor;
        vTopLine.Y = vScale.Y * m_fBoundaryShrinkFactor;
        vTopLine.X -= vTopLeft.X;
        vTopLine.Y -= vTopLeft.Y;
        oPanel.SetClipLocation(m_sRadarPath $ ".Elements.ElementsBoundary.boundaryMC", vTopLine.X, vTopLine.Y);
        oPanel.SetVariableFloat(m_sRadarPath $ ".Elements.ElementsBoundary.boundaryMC._rotation", fBoundaryRotation);
        m_vCacheRadarBoundaryTopLeft = vTopLeft;
        m_vCacheRadarBoundaryBottomRight = vBottomRight;
        m_fCacheRadarBoundaryRotation = fBoundaryRotation;
    }
}

native function PulseRadar(float fPulseTime);

native function CollectRadarElementData(out array<SFXRadarElementData> aRadarData);

native function GetRadarDirectionValues(out float fArrowDirection, out float fNorthDirection, out float fPathingArrowDirection);

native function bool GetMapBoundaryValues(out Vector2D vTopLeft, out Vector2D vBottomRight, out float fBoundaryRotation);

function ExInt_WheelTransitionOutDone()
{
    m_ePowerWheelMode = 0;
    m_bInOutTransition = false;
}

native function SetMappingIcon(out SFXPowerWheelButtonIcon oIcon, SFXPowerWheelMapButtonIcon eNewIcon, optional bool bClear);

event Name GetHenchmanMappedPower(BioPawn pPawn)
{
    if (SFXPawn_Henchman(pPawn) != None)
    {
        return SFXPawn_Henchman(pPawn).m_nmMappedPower;
    }
    return 'None';
}

event bool SetHenchmanMappedPower(BioPawn pPawn, Name nmPower)
{
    if (SFXPawn_Henchman(pPawn) != None)
    {
        SFXPawn_Henchman(pPawn).m_nmMappedPower = nmPower;
        return true;
    }
    return false;
}

defaultproperties
{
    m_bCanMapPlayerPowers=true
    m_fInfoTextChangeDelay=0,1
    m_fLStickAngleDeltaDeg=0,25
    m_nCurrentPowerIconIndex=-1
    m_nCurrentWeaponIconIndex=-1
    m_aPowerIcons=System.Byte[]
    m_aWeaponIcons=System.Byte[]
    m_aPowerStatePaths="selectable"
    m_aPowerStatePaths="selected"
    m_aPowerStatePaths="inactive"
    m_aPowerStatePaths="activated"
    m_aPowerStatePaths="overload"
    m_aPowerStatePaths="emptyUnselected"
    m_aPowerStatePaths="emptySelected"
    m_aPowerStatePaths="notSuggested"
    m_aWeaponStateFrames=1
    m_aWeaponStateFrames=2
    m_aWeaponStateFrames=3
    m_aWeaponStateFrames=4
    m_aMappingIconPaths="Y"
    m_aMappingIconPaths="X"
    m_aMappingIconPaths="LDpad"
    m_aMappingIconPaths="RDpad"
    m_aMappingIconPaths="LB"
    m_aMappingIconPaths="RB"
    m_sTitleTextPath="txtTitle"
    m_sNameTextPath="txtName"
    m_sInfoTextPath="txtInfo"
    m_sInfoTextBGPath="PowerTextBG"
    m_sUseButtonPath="ButtonUse"
    m_sUseTextPath="txtUse"
    m_sMapButton1Path="ButtonMap2"
    m_sMapText1Path="txtMap2"
    m_sMapButton2Path="ButtonMap1"
    m_sMapText2Path="txtMap1"
    m_aRadarIconFramePaths(0)="friendly"
    m_aRadarIconFramePaths(1)="neutral"
    m_aRadarIconFramePaths(2)="hostile"
    m_aRadarIconFramePaths(3)="vehicle"
    m_aRadarIconFramePaths(4)="store"
    m_aRadarIconFramePaths(5)="mapPin"
    m_aRadarIconFramePaths(6)="plot"
    m_aRadarIconFramePaths(7)="mineral"
    m_aRadarIconFramePaths(8)="anomaly"
    m_aRadarIconFramePaths(9)="interest"
    m_aRadarIconFramePaths(10)="debris"
    m_aRadarIconFramePaths(11)="surveyed"
    m_aRadarIconFramePaths(12)="henchmen"
    m_aRadarIconFramePaths(13)="transition"
    m_sShepardBlockerPath="BlockerShepard"
    m_sHench1BlockerPath="BlockerTeam1"
    m_sHench2BlockerPath="BlockerTeam2"
    m_sRadarPath="Radar.Radar"
    m_sTeam1StatusTextPath="txtTeam1Status"
    m_sTeam1PowerTextPath="txtTeam1Power"
    m_sTeam2StatusTextPath="txtTeam2Status"
    m_sTeam2PowerTextPath="txtTeam2Power"
    m_sWheelArrowPath="Wheel.Wheel.Arrow"
    m_srBlocked=System.Byte[]
    m_srPawnIncapacitated=System.Byte[]
    m_srWeaponSwitching=System.Byte[]
    m_srWeaponOverheating=System.Byte[]
    m_srWeaponReloading=System.Byte[]
    m_srDisplayTitle=System.Byte[]
    m_srWeaponWheelDisplayTitle=System.Byte[]
    m_srPowerWheelDisplayTitle=System.Byte[]
    m_srEquip=System.Byte[]
    m_srUse=System.Byte[]
    m_srMap=System.Byte[]
    m_srOverheated=System.Byte[]
    m_srRecharging=System.Byte[]
    m_srUnavailable=System.Byte[]
    m_srRadarRangeUnits=System.Byte[]
    m_srObjective=System.Byte[]
    m_fRadarDirectionChangeDelta=0,5
    m_fRadarElementLocationChangeDelta=0,01
    m_fRadarRadius=69
    m_vBoundaryDimensions=(X=160,Y=160)
    m_fBoundaryShrinkFactor=0,8
    m_sNotSuggestedPrefix="<font color='#FF3333'>"
    m_sNotSuggestedSuffix="</font>"
    m_sMap1Token="[XBoxB_Btn_LB]"
    m_sMap2Token="[XBoxB_Btn_RB]"
    m_sMapHench1Token="[XBoxB_Btn_DPadL]"
    m_sMapHench2Token="[XBoxB_Btn_DPadR]"
    m_fVehicleRadarUpdateInterval=2
    m_fRadarObjectiveUpdateInterval=0,25
    bSetGameMode=false
}
