﻿class SFXSFHandler_Reticle extends BioSFHandler
    config(UI)
    transient
    native;

const CROSSHAIR_SMOOTHING_BUFFER = 3;
enum SFXReticleCrosshair
{
    SFXRC_None,
    SFXRC_Standard,
    SFXRC_HeavyWeapon,
    SFXRC_Sniper,
    SFXRC_COUNT,
};

var config float m_fCrosshairAccuracyModifier;

// m_srDistanceUnit: StringRefProperty[44]
var config float m_fScreenChangeDelta;

var config float m_fSelectionBoxScalingFactor;

var config float m_fUpdateInterval;

var int m_nMaxReticleDistance;

var float m_fScrn2SF_XScale;

var float m_fScrn2SF_YScale;

var float m_fScrn2SF_YOffset;

var float m_fSFHeight;

var float m_fSFWidth;

var array<SFXSF_ReticleBase> m_aReticles;

var array<Actor> m_aTargets;

var String m_aCrosshairPaths[4];

var SFXReticleCrosshair m_eCurrentCrosshair;

var int m_nCacheSniperDistance;

var int m_nCacheSniperZoom;

var int m_nCacheWeaponAmmo;

var int m_nCrosshairBufferIndex;

var float m_aCrosshairRawBuffer[3];

var float m_fCacheCrosshairRadius;

var bool m_bShowSniperDetails;

var bool m_bShowHeavyDetails;

var bool m_bReticleVisible;

var bool m_fCacheTargetInSights;

var bool m_bSelectionInvalidated;

var BioPlayerSquad m_pPlayerSquad;

var BioEpicPawnBehavior m_pPlayerBehavior;

var BioPlayerInput m_pPlayerInput;

var BioPlayerController m_pPlayerController;

var SFXCameraNativeBase m_pCameraManager;

var float m_fTimeSinceLastUpdate;

event OnPanelRemoved()
{
    CleanupReferences();
    OnPanelRemoved();
}

function CleanupReferences()
{
    m_pCameraManager = None;
    m_pPlayerController = None;
    m_pPlayerInput = None;
    m_pPlayerBehavior = None;
    m_aReticles.Length = 0;
    m_aTargets.Length = 0;
    m_pPlayerSquad = None;
}

function GameSessionEnded()
{
    CleanupReferences();
    GameSessionEnded();
}

function Reset()
{
    m_fTimeSinceLastUpdate = m_fUpdateInterval + 1;
}

event float GetCrosshairRadius()
{
    local SFXInventoryManager pInvManager;
    if (m_pPlayerController == None || m_pPlayerController.GetBioPawn() == None)
    {
        return 0;
    }
    pInvManager = SFXInventoryManager(m_pPlayerController.GetBioPawn().InvManager);
    if (pInvManager != None)
    {
        return pInvManager.GetPlayerCrosshairValue();
    }
    return 0;
}

event SFXReticleCrosshair GetDesiredCrosshairFromWeapon()
{
    local SFXWeapon pWeapon;
    if (m_pPlayerController == None || m_pPlayerController.GetBioPawn() == None || m_pPlayerBehavior == None)
    {
        return 0;
    }
    pWeapon = SFXWeapon(m_pPlayerController.GetBioPawn().Weapon);
    if (m_pPlayerBehavior.m_eCurrentActionState == 1)
    {
        if (SFXHeavyWeapon(pWeapon) != None)
        {
            return 2;
        }
        else
        {
            if (m_pPlayerController.IsZoomed() != false && SFXWeapon_SniperRifle_Base(pWeapon) != None)
            {
                return 3;
            }
            else
            {
                return 1;
            }
        }
    }
    return 0;
}

event String GetWeaponAmmoString(optional bool bClipOnly = true)
{
    local SFXWeapon oWeapon;
    local int nAmmo;
    if (m_pPlayerController.GetBioPawn() == None)
    {
        return "";
    }
    oWeapon = SFXWeapon(m_pPlayerController.GetBioPawn().Weapon);
    if (oWeapon != None)
    {
        nAmmo = GetWeaponAmmo(bClipOnly);
        if (oWeapon.AmmoPerShot > 1)
        {
            nAmmo = nAmmo * 100 / oWeapon.AmmoPerShot;
            return "" $ nAmmo $ "%";
        }
        else
        {
            return "" $ nAmmo;
        }
    }
    return "";
}

event int GetWeaponAmmo(optional bool bClipOnly = true)
{
    local SFXWeapon oWeapon;
    if (m_pPlayerController.GetBioPawn() == None)
    {
        return -1;
    }
    oWeapon = SFXWeapon(m_pPlayerController.GetBioPawn().Weapon);
    if (oWeapon != None)
    {
        if (!oWeapon.bInfiniteAmmo)
        {
            if (bClipOnly != false)
            {
                return oWeapon.GetAmmoCountInMagazine();
            }
            else
            {
                return oWeapon.GetCurrentTotalAmmo();
            }
        }
    }
    return -1;
}

function ExInt_InTransitionComplete(String sPath);

function ExInt_OutTransitionComplete(String sPath)
{
    local int nReticle;
    nReticle = 0;
    while (nReticle < m_aReticles.Length)
    {
        if (m_aReticles[nReticle].m_sSFPath == sPath)
        {
            m_aReticles[nReticle].ClearReticle(false);
        }
        ++nReticle;
    }
}

function ExInt_ReticleVisible()
{
    m_bReticleVisible = true;
}

defaultproperties
{
    m_aCrosshairPaths="crossHair"
    m_aCrosshairPaths="heavyWeapon"
    m_aCrosshairPaths="sniper"
    m_nMaxReticleDistance=400
    m_fUpdateInterval=0,0166
    m_fScreenChangeDelta=0,5
    m_srDistanceUnit=System.Byte[]
    m_fCrosshairAccuracyModifier=-17
    bSetGameMode=false
}
