﻿class SFXSeqAct_AIGoHere extends BioSequenceLatentAction
    hidecategories(Object)
    native;

var transient float m_UpdateTimer;

var transient float m_TimeRemaining;

var transient NavigationPoint m_TargetNavAtInvalidation;

var transient bool m_bTargetInvalidated;

var transient bool m_bArrivedPinFired;

var transient NavigationPoint m_TargetNav;

var transient BioPawn m_Pawn;

var() bool m_bInstanceLogging;

var() bool m_bInvalidateOnFlank;

var() float m_fInvalidateRange;

var() float m_fTimeOut;

event Activated()
{
    local SFXAI_Core oAI;
    if (m_Pawn == None)
    {
        if (m_bInstanceLogging)
        {
        }
        OutputLinks[2].bHasImpulse = true;
    }
    oAI = SFXAI_Core(m_Pawn.Controller);
    if (oAI != None)
    {
        oAI.AssignGoHereDelegates(TryInvalidateTargetRange, TryInvalidateTargetFlank);
        if (InputLinks[0].bHasImpulse)
        {
            if (m_bInstanceLogging)
            {
            }
            if (m_TargetNav != None)
            {
                oAI.m_AIGoHereTarget = m_TargetNav;
                oAI.m_bAIGoHereTargetArrived = false;
                m_bArrivedPinFired = false;
                m_TimeRemaining = m_fTimeOut;
                m_bTargetInvalidated = false;
                LatentActors.Length = 0;
                ScriptPreActorHandle(m_Pawn);
            }
            else
            {
                if (m_bInstanceLogging)
                {
                }
                OutputLinks[2].bHasImpulse = true;
            }
        }
        else
        {
            if (InputLinks[1].bHasImpulse)
            {
                ClearGoHereTarget();
            }
        }
    }
    else
    {
        if (m_bInstanceLogging)
        {
        }
        OutputLinks[2].bHasImpulse = true;
    }
    OutputLinks[0].bHasImpulse = true;
}

event Deactivated()
{
    local SFXAI_Core oAI;
    if (m_Pawn != None)
    {
        oAI = SFXAI_Core(m_Pawn.Controller);
        if (oAI != None)
        {
            oAI.ClearGoHereDelegates();
        }
    }
}

event bool UpdateOp(float DeltaTime)
{
    local SFXAI_Core oAI;
    if (InputLinks[1].bHasImpulse)
    {
        ClearGoHereTarget();
        return true;
    }
    m_UpdateTimer -= DeltaTime;
    if (m_UpdateTimer >= 0)
    {
        return false;
    }
    else
    {
        ResetUpdateTimer();
    }
    if (m_bInstanceLogging)
    {
    }
    if (m_Pawn == None)
    {
        if (m_bInstanceLogging)
        {
        }
        OutputLinks[2].bHasImpulse = true;
        return true;
    }
    oAI = SFXAI_Core(m_Pawn.Controller);
    if (m_bTargetInvalidated)
    {
        if (m_TargetNavAtInvalidation == oAI.m_AIGoHereTarget)
        {
            ClearGoHereTarget();
        }
    }
    m_TimeRemaining -= DeltaTime;
    if (m_TimeRemaining < 0 && oAI.m_bAIGoHereTargetArrived == false)
    {
        if (m_bInstanceLogging)
        {
        }
        OutputLinks[2].bHasImpulse = true;
        return true;
    }
    if (m_Pawn != None && m_Pawn.Squad != None && m_TargetNav != None && m_Pawn.Squad.HasPlaypen() && m_Pawn.Squad.IsPositionInPlaypen(m_TargetNav.Location) == false)
    {
        if (m_bInstanceLogging)
        {
        }
        if (oAI.m_bAIGoHereTargetArrived)
        {
            InvalidateGoHereTarget();
        }
        else
        {
            OutputLinks[2].bHasImpulse = true;
            return true;
        }
    }
    if (oAI != None)
    {
        if (oAI.m_bAIGoHereTargetArrived == true && m_bArrivedPinFired == false)
        {
            if (m_bInstanceLogging)
            {
            }
            m_bArrivedPinFired = true;
            OutputLinks[1].bHasImpulse = true;
        }
    }
    return false;
}

function InvalidateGoHereTarget()
{
    local SFXAI_Core oAI;
    oAI = SFXAI_Core(m_Pawn.Controller);
    if (m_bInstanceLogging)
    {
    }
    m_bTargetInvalidated = true;
    m_TargetNavAtInvalidation = oAI.m_AIGoHereTarget;
    OutputLinks[3].bHasImpulse = true;
    ResetUpdateTimer();
}

function ClearGoHereTarget()
{
    local SFXAI_Core oAI;
    oAI = SFXAI_Core(m_Pawn.Controller);
    if (m_bInstanceLogging)
    {
    }
    oAI.m_AIGoHereTarget = None;
    AbortFor(m_Pawn, true);
}

function ResetUpdateTimer()
{
    m_UpdateTimer = 1;
}

function bool TryInvalidateTargetRange(float fRangeToTargetInUU)
{
    if (fRangeToTargetInUU / 100 < m_fInvalidateRange)
    {
        if (m_bInstanceLogging)
        {
        }
        InvalidateGoHereTarget();
        return true;
    }
    return false;
}

function bool TryInvalidateTargetFlank()
{
    if (m_bInvalidateOnFlank)
    {
        if (m_bInstanceLogging)
        {
        }
        InvalidateGoHereTarget();
        return true;
    }
    return false;
}

native function ScriptPreActorHandle(Actor inActor);

defaultproperties
{
    m_fTimeOut=120
    m_bInvalidateOnFlank=true
    bManualHandleOutputs=true
    InputLinks=None
}
