﻿class SFXSeqAct_ChooseLoadoutBase extends SeqAct_Latent
    hidecategories(Object)
    config(Game)
    abstract;

var transient array<int> WeaponMenuEnabledWeaponIDs;

var transient array<Name> AvailableHenchmen;

var transient int CurrentPawn;

var transient array<LoadoutWeaponInfo> SubMenuEnabledWeapons;

var transient array<class<SFXWeapon> > LoadoutWeapons;

var String ShepardImage;

var WwiseEvent WeaponEquipSound;

// WeaponDescriptionTokenString: StringRefProperty[44]
// SingleCustomToken: StringRefProperty[44]
// ShepardNameString: StringRefProperty[44]
// PawnActiveWeaponsString: StringRefProperty[44]
// ClassDescriptionTokenString: StringRefProperty[44]
// WeaponClassTokenString: StringRefProperty[44]
// RightBracketToken: StringRefProperty[44]
// LeftBracketToken: StringRefProperty[44]
// WeaponMenuSubHeading: StringRefProperty[44]
// ButtonText_Back: StringRefProperty[44]
// ButtonText_Accept: StringRefProperty[44]
// ButtonText_CustomizeWeapons: StringRefProperty[44]
// ButtonText_CustomizeSquadWeapons: StringRefProperty[44]
// ButtonText_SquadWeapons: StringRefProperty[44]
// ButtonText_Exit: StringRefProperty[44]
// ButtonText_Choose: StringRefProperty[44]
var transient int SubMenuWeaponIdx;

var transient BioSFHandler_ChoiceGUI SpecialWeaponToggleMenu;

var transient BioSFHandler_ChoiceGUI SubMenu;

var transient BioSFHandler_ChoiceGUI TopMenu;

var transient bool m_bAllHenchmen;

var transient bool m_bFinished;

function PlayEquipSound()
{
    local BioPlayerController PC;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    PC.PlaySound(WeaponEquipSound);
}

function SubMenuHandler(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        LoadoutWeapons[SubMenuWeaponIdx] = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(SubMenuEnabledWeapons[nContext].ClassName);
        PlayEquipSound();
    }
    SubMenu.HideChoiceGUI(true);
    ShowWeaponsTopMenu();
}

function ShowWeaponSubMenu(int GroupIdx)
{
    local SFXGameChoiceGUIData Data;
    local SFXChoiceEntry entry;
    local class<SFXWeapon> WClass;
    local int idx;
    local BioPlayerController PC;
    local BioGlobalVariableTable VarTable;
    local array<LoadoutWeaponInfo> WeaponGroup;
    local SFXTokenMapping TokenMapping;
    local String WeaponPrettyName;
    local int WeaponGroupID;
    local int WeaponID;
    VarTable = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables();
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    SubMenu = MassEffectGuiManager(PC.GetScaleFormManager()).CreateChoiceGUI();
    WeaponGroup = Class'SFXPlayerSquadLoadoutData'.GetWeaponGroup(GroupIdx);
    Data = new(SubMenu,Class'SFXGameChoiceGUIData');
    SubMenuEnabledWeapons.Length = 0;
    idx = 0;
    while (idx < WeaponGroup.Length)
    {
        if (WeaponGroup[idx].UnlockPlotId == 'None' || VarTable.GetIntByName(WeaponGroup[idx].UnlockPlotId) != 0)
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(WeaponGroup[idx].ClassName);
            if (WClass == None)
            {
            }
            else
            {
                if (WClass.Default.bNotRegularWeaponGUI)
                {
                    if (CanPawnUseSpecialWeapon(CurrentPawn, WClass) == false)
                    {
                    }
                }
                else
                {
                    Class'SFXPlayerSquadLoadoutData'.GetWeaponCategory(WClass, WeaponGroupID, WeaponID);
                    WeaponPrettyName = WClass.GetPrettyName();
                    TokenMapping.TokenId = 0;
                    TokenMapping.Data = "" $ WeaponPrettyName;
                    entry.m_mapTokenIDToActual.AddItem(TokenMapping);
                    TokenMapping.TokenId = 2;
                    TokenMapping.Data = "" $ WClass.Default.GeneralDescription;
                    entry.m_mapTokenIDToActual.AddItem(TokenMapping);
                    TokenMapping.TokenId = 9;
                    TokenMapping.Data = "" $ WeaponPrettyName;
                    entry.m_mapTokenIDToActual.AddItem(TokenMapping);
                    entry.srChoiceName = SingleCustomToken;
                    entry.srChoiceTitle = SingleCustomToken;
                    entry.srChoiceDescription = WeaponDescriptionTokenString;
                    entry.bDefaultSelection = WClass == LoadoutWeapons[GroupIdx];
                    entry.oChoiceImage = FindImage(WClass.Default.GUIImage);
                    Data.AddChoice(entry);
                    SubMenuEnabledWeapons.AddItem(WeaponGroup[idx]);
                }
            }
        }
        idx++;
    }
    Data.m_srAText = ButtonText_Accept;
    Data.m_srBText = ButtonText_Back;
    Data.m_srSubTitle = WeaponMenuSubHeading;
    Data.m_srTitle = CurrentPawn == 0 ? ShepardNameString : GetHenchmanInfo(AvailableHenchmen[CurrentPawn]).PrettyName;
    SubMenu.__InputCallback__Delegate = SubMenuHandler;
    SubMenu.Initialize(Data);
    SubMenu.ShowChoiceGUI();
}

function LoadoutInfo GetPlayerLoadoutData()
{
    local LoadoutInfo PlayerData;
    local BioPlayerController PlayerController;
    local int Index;
    PlayerController = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    Index = 0;
    while (Index < Class'SFXPlayerSquadLoadoutData'.Default.PlayerLoadoutInfo.Length)
    {
        PlayerData = Class'SFXPlayerSquadLoadoutData'.Default.PlayerLoadoutInfo[Index];
        if (PlayerController.Pawn.Class.Name == PlayerData.ClassName)
        {
            return PlayerData;
        }
        Index++;
    }
    return PlayerData;
}

function bool CanPawnUseWeaponClass(int PawnID, ELoadoutWeapons WeaponGroupID)
{
    if (PawnID == 0)
    {
        return Class'SFXPlayerSquadLoadoutData'.CanPlayerUseWeaponGroup(WeaponGroupID);
    }
    else
    {
        return Class'SFXPlayerSquadLoadoutData'.CanHenchmanUseWeaponGroup(GetHenchmanInfo(AvailableHenchmen[PawnID]).Tag, WeaponGroupID);
    }
    return false;
}

function bool CanPawnUseSpecialWeapon(int PawnID, class<SFXWeapon> WeaponClass)
{
    if (PawnID == 0)
    {
        return Class'SFXPlayerSquadLoadoutData'.CanPlayerUseWeaponClass(WeaponClass);
    }
    else
    {
        return Class'SFXPlayerSquadLoadoutData'.CanHenchmanUseWeaponClass(GetHenchmanInfo(AvailableHenchmen[PawnID]).Tag, WeaponClass);
    }
    return false;
}

function int GetWeaponClassUnlockedCount(int GroupIdx)
{
    local int idx;
    local BioGlobalVariableTable VarTable;
    local array<LoadoutWeaponInfo> WeaponGroup;
    local int Count;
    local class<SFXWeapon> WClass;
    VarTable = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables();
    WeaponGroup = Class'SFXPlayerSquadLoadoutData'.GetWeaponGroup(GroupIdx);
    Count = 0;
    idx = 0;
    while (idx < WeaponGroup.Length)
    {
        if (WeaponGroup[idx].UnlockPlotId == 'None' || VarTable.GetIntByName(WeaponGroup[idx].UnlockPlotId) != 0)
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(WeaponGroup[idx].ClassName);
            if (WClass == None)
            {
            }
            else
            {
                if (WClass != None && WClass.Default.bNotRegularWeaponGUI)
                {
                    if (CanPawnUseSpecialWeapon(CurrentPawn, WClass) == false)
                    {
                    }
                }
                else
                {
                    Count++;
                }
            }
        }
        idx++;
    }
    return Count;
}

function ApplyPlayerLoadout()
{
    local BioPlayerController PC;
    local SFXEngine Engine;
    local int idx;
    PC = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    idx = 0;
    while (idx < 6)
    {
        if (Engine.PlayerLoadoutWeapons[idx] != PathName(LoadoutWeapons[idx]))
        {
            Engine.PlayerLoadoutWeapons[idx] = PathName(LoadoutWeapons[idx]);
            Class'BioTelemetry'.SendEventString('PLAYER_SELECT_WEAPON', Engine.PlayerLoadoutWeapons[idx]);
        }
        idx++;
    }
}

function ApplyHenchmanLoadout(int HenchIdx)
{
    local BioPlayerController PC;
    local SFXEngine Engine;
    local int idx;
    PC = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    idx = 0;
    while (idx < 6)
    {
        if (Engine.HenchmanRecords[HenchIdx].LoadoutWeapons[idx] != PathName(LoadoutWeapons[idx]))
        {
            Engine.HenchmanRecords[HenchIdx].LoadoutWeapons[idx] = PathName(LoadoutWeapons[idx]);
        }
        idx++;
    }
}

function TopMenuHandler(bool bAPressed, int nContext)
{
    local BioPlayerController PC;
    local SFXEngine Engine;
    local int idx;
    local BioBaseSquad Squad;
    local BioPawn SquadMember;
    if (bAPressed)
    {
        SubMenuWeaponIdx = WeaponMenuEnabledWeaponIDs[nContext];
        ShowWeaponSubMenu(WeaponMenuEnabledWeaponIDs[nContext]);
    }
    else
    {
        PC = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
        Engine = SFXEngine(PC.Player.Outer);
        if (CurrentPawn == 0)
        {
            ApplyPlayerLoadout();
        }
        else
        {
            idx = 0;
            while (idx < Engine.HenchmanRecords.Length)
            {
                if (GetHenchmanInfo(AvailableHenchmen[CurrentPawn]).Tag == Engine.HenchmanRecords[idx].Tag)
                {
                    ApplyHenchmanLoadout(idx);
                    break;
                }
                idx++;
            }
        }
        Squad = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).m_playerSquad;
        idx = 0;
        while (idx < Squad.GetSquadSize())
        {
            SquadMember = BioPawn(Squad.GetMember(idx));
            SquadMember.CreateWeapons(SquadMember.Loadout);
            if (SFXPawn_Player(SquadMember) != None)
            {
                SFXPawn_Player(SquadMember).UpdateWeaponVisibility();
            }
            idx++;
        }
        TopMenu.HideChoiceGUI(true);
        ShowCharacterMenu();
    }
}

function ShowWeaponsTopMenu()
{
    local SFXGameChoiceGUIData Data;
    local SFXChoiceEntry entry;
    local int idx;
    local BioPlayerController PC;
    local class<SFXWeapon> WClass;
    local SFXTokenMapping TokenMapping;
    local int WeaponClassUnlockCount;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    TopMenu = MassEffectGuiManager(PC.GetScaleFormManager()).CreateChoiceGUI();
    Data = new(TopMenu,Class'SFXGameChoiceGUIData');
    WeaponMenuEnabledWeaponIDs.Length = 0;
    idx = 0;
    while (idx < 6)
    {
        if (CanPawnUseWeaponClass(CurrentPawn, idx) == false)
        {
        }
        else
        {
            WClass = LoadoutWeapons[idx];
            WeaponClassUnlockCount = GetWeaponClassUnlockedCount(idx);
            TokenMapping.TokenId = 0;
            TokenMapping.Data = "" $ WClass.GetPrettyName();
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            TokenMapping.TokenId = 1;
            TokenMapping.Data = "" $ WeaponClassUnlockCount > 1 ? LeftBracketToken : "";
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            TokenMapping.TokenId = 2;
            TokenMapping.Data = "" $ WeaponClassUnlockCount > 1 ? WeaponClassUnlockCount : "";
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            TokenMapping.TokenId = 3;
            TokenMapping.Data = "" $ WeaponClassUnlockCount > 1 ? RightBracketToken : "";
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            entry.bDisabled = WeaponClassUnlockCount <= 1;
            TokenMapping.TokenId = 4;
            TokenMapping.Data = "" $ WClass.GetPrettyName();
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            TokenMapping.TokenId = 6;
            TokenMapping.Data = "" $ WClass.Default.GeneralDescription;
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
            entry.srChoiceName = WeaponClassTokenString;
            entry.srChoiceTitle = WeaponClassTokenString;
            entry.srChoiceDescription = ClassDescriptionTokenString;
            entry.bDefaultSelection = idx == SubMenuWeaponIdx;
            entry.oChoiceImage = FindImage(WClass.Default.GUIImage);
            Data.AddChoice(entry);
            WeaponMenuEnabledWeaponIDs.AddItem(idx);
        }
        idx++;
    }
    Data.m_srAText = ButtonText_Choose;
    Data.m_srBText = ButtonText_Back;
    Data.m_srTitle = CurrentPawn == 0 ? ShepardNameString : GetHenchmanInfo(AvailableHenchmen[CurrentPawn]).PrettyName;
    Data.m_srSubTitle = ButtonText_CustomizeWeapons;
    TopMenu.__InputCallback__Delegate = TopMenuHandler;
    TopMenu.Initialize(Data);
    TopMenu.ShowChoiceGUI();
}

function Texture2D FindImage(String Path)
{
    local Texture2D Image;
    Image = Texture2D(FindObject(Path, Class'Texture2D'));
    if (Image == None && Class'SFXEngine'.IsSeekFreeObjectSupported(Path))
    {
        Image = Texture2D(Class'SFXEngine'.LoadSeekFreeObject(Path, Class'Texture2D'));
    }
    if (Image == None)
    {
        Image = Texture2D(DynamicLoadObject(Path, Class'Texture2D'));
    }
    return Image;
}

function PrepareHenchmanLoadout(int HenchIdx)
{
    local int idx;
    local class<SFXWeapon> WClass;
    local BioPlayerController PC;
    local SFXEngine Engine;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    idx = 0;
    while (idx < 6)
    {
        if (Engine.HenchmanRecords[HenchIdx].LoadoutWeapons[idx] == "")
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(Class'SFXPlayerSquadLoadoutData'.GetWeaponGroup(idx)[0].ClassName);
        }
        else
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(Engine.HenchmanRecords[HenchIdx].LoadoutWeapons[idx]);
        }
        LoadoutWeapons[idx] = WClass;
        idx++;
    }
}

function PreparePlayerLoadout()
{
    local int idx;
    local class<SFXWeapon> WClass;
    local BioPlayerController PC;
    local SFXEngine Engine;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    idx = 0;
    while (idx < 6)
    {
        if (Engine.PlayerLoadoutWeapons[idx] == "")
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(Class'SFXPlayerSquadLoadoutData'.GetWeaponGroup(idx)[0].ClassName);
        }
        else
        {
            WClass = Class'SFXPlayerSquadLoadoutData'.FindWeaponClass(Engine.PlayerLoadoutWeapons[idx]);
        }
        LoadoutWeapons[idx] = WClass;
        idx++;
    }
}

function CharacterMenuHandler(bool bAPressed, int nContext)
{
    local BioPlayerController PC;
    local SFXEngine Engine;
    local int idx;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    if (bAPressed)
    {
        if (nContext == 0)
        {
            PreparePlayerLoadout();
        }
        else
        {
            idx = 0;
            while (idx < Engine.HenchmanRecords.Length)
            {
                if (GetHenchmanInfo(AvailableHenchmen[nContext]).Tag == Engine.HenchmanRecords[idx].Tag)
                {
                    PrepareHenchmanLoadout(idx);
                }
                idx++;
            }
        }
        CurrentPawn = nContext;
        ShowWeaponsTopMenu();
    }
    else
    {
        m_bFinished = true;
    }
}

function ShowCharacterMenu()
{
    local SFXGameChoiceGUIData Data;
    local SFXChoiceEntry entry;
    local int idx;
    local BioPlayerController PC;
    local BioGlobalVariableTable VarTable;
    local HenchmanInfoStruct HenchInfo;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    VarTable = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables();
    TopMenu = MassEffectGuiManager(PC.GetScaleFormManager()).CreateChoiceGUI();
    Data = new(TopMenu,Class'SFXGameChoiceGUIData');
    entry.srChoiceName = ShepardNameString;
    entry.srChoiceTitle = ShepardNameString;
    BuildPawnWeaponList(0, entry);
    entry.srChoiceDescription = PawnActiveWeaponsString;
    entry.bDefaultSelection = CurrentPawn == 0;
    entry.oChoiceImage = FindImage(ShepardImage);
    Data.AddChoice(entry);
    idx = 1;
    while (idx < AvailableHenchmen.Length)
    {
        HenchInfo = GetHenchmanInfo(AvailableHenchmen[idx]);
        if (HenchInfo.AlternateHenchNamePlotFlag != 'None' && VarTable.GetBoolByName(HenchInfo.AlternateHenchNamePlotFlag))
        {
            entry.srChoiceName = HenchInfo.AlternatePrettyName;
            entry.srChoiceTitle = HenchInfo.AlternatePrettyName;
        }
        else
        {
            entry.srChoiceName = HenchInfo.PrettyName;
            entry.srChoiceTitle = HenchInfo.PrettyName;
        }
        BuildPawnWeaponList(idx, entry);
        entry.srChoiceDescription = PawnActiveWeaponsString;
        entry.bDefaultSelection = CurrentPawn == idx;
        entry.oChoiceImage = FindImage(HenchInfo.HenchmanImage);
        Data.AddChoice(entry);
        idx++;
    }
    Data.m_srAText = ButtonText_Choose;
    Data.m_srBText = ButtonText_Exit;
    Data.m_srTitle = ButtonText_SquadWeapons;
    Data.m_srSubTitle = ButtonText_CustomizeSquadWeapons;
    TopMenu.__InputCallback__Delegate = CharacterMenuHandler;
    TopMenu.Initialize(Data);
    TopMenu.ShowChoiceGUI();
}

function BuildPawnWeaponList(int PawnID, out SFXChoiceEntry entry)
{
    local SFXTokenMapping TokenMapping;
    local int idx;
    local int ListIndex;
    local class<SFXWeapon> WClass;
    local BioPlayerController PC;
    local SFXEngine Engine;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    if (PawnID == 0)
    {
        PreparePlayerLoadout();
    }
    else
    {
        idx = 0;
        while (idx < Engine.HenchmanRecords.Length)
        {
            if (GetHenchmanInfo(AvailableHenchmen[PawnID]).Tag == Engine.HenchmanRecords[idx].Tag)
            {
                PrepareHenchmanLoadout(idx);
            }
            idx++;
        }
    }
    idx = 0;
    while (idx < 6)
    {
        if (CanPawnUseWeaponClass(PawnID, idx))
        {
            WClass = LoadoutWeapons[idx];
            TokenMapping.TokenId = ListIndex++;
            TokenMapping.Data = "" $ WClass.GetPrettyName();
            entry.m_mapTokenIDToActual.AddItem(TokenMapping);
        }
        idx++;
    }
    idx = ListIndex;
    while (idx < 6)
    {
        TokenMapping.TokenId = idx;
        TokenMapping.Data = "";
        entry.m_mapTokenIDToActual.AddItem(TokenMapping);
        idx++;
    }
}

function PrepareHenchmanRecords(Name Tag)
{
    local int HenchIdx;
    local BioPlayerController PC;
    local SFXEngine Engine;
    local HenchmanSaveRecord SaveInfo;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    Engine = SFXEngine(PC.Player.Outer);
    HenchIdx = Engine.HenchmanRecords.Find('Tag', Tag);
    if (HenchIdx == -1)
    {
        SaveInfo.Tag = Tag;
        SaveInfo.TalentPoints = 0;
        SaveInfo.CharacterLevel = 0;
        Class'SFXPawn_Henchman'.GetDefaultLoadout(Tag, SaveInfo.LoadoutWeapons);
        Engine.HenchmanRecords.AddItem(SaveInfo);
    }
}

function HenchmanInfoStruct GetHenchmanInfo(Name HenchClassName)
{
    local HenchmanInfoStruct HenchInfo;
    foreach Class'SFXPawn_Henchman'.Default.HenchmenInfo(HenchInfo)
    {
        if (HenchInfo.ClassName == HenchClassName)
        {
            return HenchInfo;
        }
    }
    return HenchInfo;
}

function LoadoutInfo GetHenchmanLoadoutData(Name HenchClassName)
{
    local LoadoutInfo HenchInfo;
    foreach Class'SFXPlayerSquadLoadoutData'.Default.HenchLoadoutInfo(HenchInfo)
    {
        if (HenchInfo.ClassName == HenchClassName)
        {
            return HenchInfo;
        }
    }
    return HenchInfo;
}

event Deactivated()
{
    local BioPlayerController PC;
    local BioWorldInfo WorldInfo;
    WorldInfo = BioWorldInfo(GetWorldInfo());
    if (WorldInfo != None)
    {
        PC = WorldInfo.GetLocalPlayerController();
        if (PC != None)
        {
            PC.GameModeManager2.DisableMode(7, 'ChoiceGUI');
        }
    }
}

function Activated()
{
    local int idx;
    local BioGlobalVariableTable VarTable;
    local BioPlayerController PC;
    local SFXEngine Engine;
    local HenchmanInfoStruct HenchInfo;
    PC = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    if (PC != None)
    {
        PC.GameModeManager2.EnableMode(7, 'ChoiceGUI');
    }
    Engine = SFXEngine(PC.Player.Outer);
    VarTable = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables();
    m_bFinished = false;
    OutputLinks[0].bHasImpulse = false;
    AvailableHenchmen.Length = 0;
    AvailableHenchmen.AddItem('None');
    idx = 0;
    while (idx < Class'SFXPawn_Henchman'.Default.HenchmenInfo.Length)
    {
        HenchInfo = Class'SFXPawn_Henchman'.Default.HenchmenInfo[idx];
        if (m_bAllHenchmen)
        {
            if (!VarTable.GetBool(HenchInfo.HenchAcquiredPlotID))
            {
                jump 424;
            }
        }
        else
        {
            if (!VarTable.GetBool(HenchInfo.HenchInSquadPlotID))
            {
                jump 424;
            }
        }
        PrepareHenchmanRecords(HenchInfo.Tag);
        AvailableHenchmen.AddItem(HenchInfo.ClassName);
        idx++;
    }
    Engine.CurrentSaveGame.SaveHenchmen(Engine.CurrentUserID);
    ShowCharacterMenu();
    return;
}

event bool Update(float DeltaTime)
{
    if (m_bFinished)
    {
        m_bFinished = false;
        TopMenu.HideChoiceGUI(true);
        TopMenu = None;
        OutputLinks[0].bHasImpulse = true;
        return false;
    }
    return true;
}

defaultproperties
{
    ButtonText_Choose=System.Byte[]
    ButtonText_Exit=System.Byte[]
    ButtonText_SquadWeapons=System.Byte[]
    ButtonText_CustomizeSquadWeapons=System.Byte[]
    ButtonText_CustomizeWeapons=System.Byte[]
    ButtonText_Accept=System.Byte[]
    ButtonText_Back=System.Byte[]
    WeaponMenuSubHeading=System.Byte[]
    LeftBracketToken=System.Byte[]
    RightBracketToken=System.Byte[]
    WeaponClassTokenString=System.Byte[]
    ClassDescriptionTokenString=System.Byte[]
    PawnActiveWeaponsString=System.Byte[]
    ShepardNameString=System.Byte[]
    SingleCustomToken=System.Byte[]
    WeaponDescriptionTokenString=System.Byte[]
    WeaponEquipSound=WwiseEvent'Play_gui_console_confirmweapon'
    ShepardImage="GUI_Codex_Images.TalentPoints_512"
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
