﻿class SFXSeqAct_LinkLighting extends SequenceAction
    hidecategories(Object);

var() bool bLinkEnvironment;

var() bool bLinkShadows;

event Activated()
{
    local int nChildIdx;
    local MeshComponent oCurComponent;
    local Actor oCurChild;
    local Actor oTargetActor;
    local BioPawn oTargetPawn;
    local SkeletalMeshActor oTargetSkelMesh;
    local MeshComponent oShadowParent;
    local LightEnvironmentComponent oLightEnvironment;
    if (VariableLinks[1].LinkedVariables.Length == 1)
    {
        oTargetActor = Actor(SeqVar_Object(VariableLinks[1].LinkedVariables[0]).GetObjectValue());
    }
    else
    {
        oTargetPawn = None;
    }
    if (oTargetActor != None)
    {
        oTargetPawn = BioPawn(oTargetActor);
        oTargetSkelMesh = SkeletalMeshActor(oTargetActor);
        if (oTargetPawn != None)
        {
            oShadowParent = oTargetPawn.Mesh;
            oLightEnvironment = oTargetPawn.LightEnvironment;
        }
        else
        {
            if (oTargetSkelMesh != None)
            {
                oShadowParent = oTargetSkelMesh.SkeletalMeshComponent;
                oLightEnvironment = oTargetSkelMesh.LightEnvironment;
            }
            else
            {
                foreach oTargetActor.ComponentList(Class'MeshComponent', oShadowParent)
                {
                    break;
                }
                foreach oTargetActor.ComponentList(Class'LightEnvironmentComponent', oLightEnvironment)
                {
                    break;
                }
            }
        }
    }
    else
    {
        oShadowParent = None;
        oLightEnvironment = None;
    }
    nChildIdx = 0;
    while (nChildIdx < VariableLinks[0].LinkedVariables.Length)
    {
        oCurChild = Actor(SeqVar_Object(VariableLinks[0].LinkedVariables[nChildIdx]).GetObjectValue());
        if (oCurChild != None)
        {
            foreach oCurChild.ComponentList(Class'MeshComponent', oCurComponent)
            {
                if (bLinkShadows)
                {
                    if (oShadowParent == oCurChild)
                    {
                        oCurComponent.SetShadowParent(None);
                    }
                    else
                    {
                        oCurComponent.SetShadowParent(oShadowParent);
                    }
                }
                if (bLinkEnvironment)
                {
                    oCurComponent.SetLightEnvironment(oLightEnvironment);
                }
            }
        }
        ++nChildIdx;
    }
}

defaultproperties
{
    bLinkShadows=true
    bLinkEnvironment=true
    VariableLinks=None
}
