﻿class SFXSeqAct_ResearchChoiceGUI extends BioSequenceLatentAction
    hidecategories(Object)
    config(UI);

var config array<ResearchMenu> ResearchSubMenus;

var() EResearchMode InitialResearchMode;

var() eMode InitialMode;

var EResearchMode RMode;

var eMode Mode;

// srTopLevelAButton: StringRefProperty[44]
// srTokenizedResearchCategoryCounter: StringRefProperty[44]
// srTokenizedResearchCategory: StringRefProperty[44]
// srUpgradeTokenizedDescription: StringRefProperty[44]
// srResearchTokenizedDescriptionResources: StringRefProperty[44]
// srResearchTokenizedDescriptionSingular: StringRefProperty[44]
// srResearchTokenizedDescriptionPlural: StringRefProperty[44]
// srResearchDescription: StringRefProperty[44]
var const int nLastUnlockedTech;

var const int nLastUnlockedResearch;

// srIridium: StringRefProperty[44]
// srPalladium: StringRefProperty[44]
// srPlatinum: StringRefProperty[44]
// srEezo: StringRefProperty[44]
// srResearchCancel: StringRefProperty[44]
// srResearchConfirm: StringRefProperty[44]
// srResearchConfirmMessage: StringRefProperty[44]
// srTechNameLabel: StringRefProperty[44]
// srErrorKnown: StringRefProperty[44]
// srErrorDoNotQualify: StringRefProperty[44]
// srErrorCanNotAfford: StringRefProperty[44]
// srErrorAButton: StringRefProperty[44]
// srText: StringRefProperty[44]
var BioSFHandler_MessageBox m_oMsgBox;

var transient TechData m_ChosenTechData;

var config array<SFXChoiceEntry> m_ResearchTopChoices;

var config array<SFXChoiceEntry> m_TechTopChoices;

var config array<SFXChoiceEntry> m_TopLevelChoices;

var transient array<TechData> m_ResearchSubMenuChoices;

var transient array<TechData> m_ResearchChoices;

var transient array<TechData> m_TechChoices;

var transient SFXGameChoiceGUIData_Research m_ChoiceGUIData;

var transient BioSFHandler_ChoiceGUI m_ChoiceGUIHandler;

var transient bool m_bMessageBoxActivated;

var transient bool bDidResearch;

var transient bool m_bWasPaused;

var transient bool m_bAborted;

var transient bool m_bFinished;

enum eMode
{
    MODE_TOPLEVEL,
    MODE_RESEARCH,
    MODE_TECH,
};

enum EResearchMode
{
    MODE_RESEARCH_TOP,
    MODE_RESEARCH_WEAPON,
    MODE_RESEARCH_ARMOR,
    MODE_RESEARCH_SHIP,
    MODE_RESEARCH_GEAR,
};

struct ResearchMenu
{
    var int Index;

// srTitle: StringRefProperty[44]
// srSubtitle: StringRefProperty[44]
// srAboutLabel: StringRefProperty[44]
// srAboutText: StringRefProperty[44]
    var String sImagePath;

    var transient array<TechData> m_ResearchChoices;

}

event Deactivated()
{
    local BioPlayerController PC;
    local BioWorldInfo WorldInfo;
    WorldInfo = BioWorldInfo(GetWorldInfo());
    if (WorldInfo != None)
    {
        PC = WorldInfo.GetLocalPlayerController();
        if (PC != None)
        {
            PC.GameModeManager2.DisableMode(7, 'ChoiceGUI');
        }
    }
}

event Activated()
{
    local BioPlayerController PC;
    local BioWorldInfo WorldInfo;
    WorldInfo = BioWorldInfo(GetWorldInfo());
    if (WorldInfo != None)
    {
        PC = WorldInfo.GetLocalPlayerController();
        if (PC != None)
        {
            PC.GameModeManager2.EnableMode(7, 'ChoiceGUI');
        }
    }
    OutputLinks[0].bHasImpulse = false;
    OutputLinks[1].bHasImpulse = false;
    bDidResearch = false;
    m_bFinished = false;
    m_bMessageBoxActivated = false;
    m_ChosenTechData = Default.m_ChosenTechData;
    if (m_ChoiceGUIData == None)
    {
        m_bAborted = true;
        return;
    }
    Mode = InitialMode;
    RMode = InitialResearchMode;
    m_bWasPaused = BioWorldInfo(GetWorldInfo()).bPlayersOnly;
    SetupTreasureData();
    Reset();
}

function SetupTreasureData()
{
    local SFXPlotTreasure oTreasure;
    local int I;
    oTreasure = BioWorldInfo(GetWorldInfo()).m_oTreasure;
    I = 0;
    while (I < m_ChoiceGUIData.tech.Length)
    {
        m_ChoiceGUIData.tech[I].stTech = oTreasure.tech(m_ChoiceGUIData.tech[I].PlotName);
        I++;
    }
    I = 0;
    while (I < m_ChoiceGUIData.Research.Length)
    {
        m_ChoiceGUIData.Research[I].stTech = oTreasure.tech(m_ChoiceGUIData.Research[I].PlotName);
        m_ChoiceGUIData.Research[I].stTreasure = oTreasure.TREASURE(m_ChoiceGUIData.Research[I].TreasureId);
        I++;
    }
}

function Reset()
{
    local BioPlayerController Controller;
    local MassEffectGuiManager Manager;
    local BioWorldInfo WorldInfo;
    local int idx;
    local bool bResult;
    m_TechChoices.Remove(0, m_TechChoices.Length);
    m_TechChoices.Length = 0;
    m_ResearchChoices.Remove(0, m_ResearchChoices.Length);
    m_ResearchChoices.Length = 0;
    idx = 0;
    while (idx < ResearchSubMenus.Length)
    {
        ResearchSubMenus[idx].m_ResearchChoices.Remove(0, ResearchSubMenus[idx].m_ResearchChoices.Length);
        ResearchSubMenus[idx].m_ResearchChoices.Length = 0;
        idx++;
    }
    m_ResearchSubMenuChoices.Remove(0, m_ResearchSubMenuChoices.Length);
    m_ResearchSubMenuChoices.Length = 0;
    m_ChoiceGUIData.lstChoices.Remove(0, m_ChoiceGUIData.lstChoices.Length);
    m_ChoiceGUIData.lstChoices.Length = 0;
    SetupChoiceGUI();
    bResult = false;
    switch (Mode)
    {
        case 0:
            bResult = RenderModeTopLevel();
            break;
        case 2:
            bResult = RenderModeTech();
            break;
        case 1:
            bResult = RenderModeResearch();
            break;
    }
    if (!bResult)
    {
        m_bAborted = true;
        return;
    }
    WorldInfo = BioWorldInfo(GetWorldInfo());
    if (WorldInfo != None)
    {
        Controller = WorldInfo.GetLocalPlayerController();
        if (Controller != None)
        {
            Manager = MassEffectGuiManager(Controller.GetScaleFormManager());
            if (Manager != None)
            {
                m_ChoiceGUIHandler = Manager.CreateChoiceGUI();
                if (m_ChoiceGUIHandler != None)
                {
                    m_ChoiceGUIHandler.SetInputDelegate(ChoiceGUIInputPressed);
                    m_ChoiceGUIHandler.Initialize(m_ChoiceGUIData);
                    m_ChoiceGUIHandler.ShowChoiceGUI();
                    WorldInfo.bPlayersOnly = true;
                }
            }
        }
    }
}

function bool RenderModeTopLevel()
{
    SetupTop();
    if (m_ChoiceGUIData.lstChoices.Length == 0)
    {
        m_bAborted = true;
        return false;
    }
    m_ChoiceGUIData.m_srTitle = m_ChoiceGUIData.Default.m_srTitle;
    m_ChoiceGUIData.m_srSubTitle = m_ChoiceGUIData.Default.m_srSubTitle;
    m_ChoiceGUIData.m_srAText = m_ChoiceGUIData.Default.m_srAText;
    m_ChoiceGUIData.m_srBText = m_ChoiceGUIData.Default.m_srBText;
    return true;
}

function bool RenderModeTech()
{
    SetupTech();
    if (m_ChoiceGUIData.lstChoices.Length == 0)
    {
        m_bAborted = true;
        return false;
    }
    m_ChoiceGUIData.m_srTitle = m_ChoiceGUIData.m_srTechTitle;
    m_ChoiceGUIData.m_srSubTitle = m_ChoiceGUIData.m_srTechSubTitle;
    m_ChoiceGUIData.m_srAText = m_ChoiceGUIData.m_srTechAText;
    m_ChoiceGUIData.m_srBText = m_ChoiceGUIData.m_srTechBText;
    return true;
}

function bool RenderModeResearch()
{
    local ResearchMenu Menu;
    local int idx;
    idx = 0;
    while (idx < ResearchSubMenus.Length)
    {
        if (ResearchSubMenus[idx].Index == RMode)
        {
            Menu = ResearchSubMenus[idx];
        }
        idx++;
    }
    SetupResearch(Menu);
    m_ChoiceGUIData.m_srTitle = ResearchSubMenus[RMode].srTitle;
    m_ChoiceGUIData.m_srSubTitle = ResearchSubMenus[RMode].srSubtitle;
    m_ChoiceGUIData.m_srAText = RMode == 0 ? srTopLevelAButton : m_ChoiceGUIData.Default.m_srResearchAText;
    m_ChoiceGUIData.m_srBText = m_ChoiceGUIData.Default.m_srResearchBText;
    return true;
}

function SetupChoiceGUI()
{
    local TechData Data;
    foreach m_ChoiceGUIData.tech(Data)
    {
        m_TechChoices.AddItem(Data);
    }
    foreach m_ChoiceGUIData.Research(Data)
    {
        m_ResearchChoices.AddItem(Data);
    }
}

function SetupTop()
{
    local SFXChoiceEntry Choice;
    m_ChoiceGUIData.lstChoices.Remove(0, m_ChoiceGUIData.lstChoices.Length);
    m_ChoiceGUIData.lstChoices.Length = 0;
    foreach m_TopLevelChoices(Choice)
    {
        m_ChoiceGUIData.lstChoices.AddItem(Choice);
    }
    m_ChoiceGUIData.m_ShowOptionalPane = false;
}

function TokenizeTechData(out TechData Data, int nLevel)
{
    local SFXTokenMapping TokenMapping;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    TokenMapping.TokenId = 0;
    TokenMapping.Data = "" $ nLevel;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 1;
    TokenMapping.Data = "" $ nLevel * 5;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 2;
    TokenMapping.Data = "" $ nLevel * 10;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 3;
    TokenMapping.Data = "" $ nLevel * 15;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 4;
    TokenMapping.Data = "" $ nLevel * 20;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 5;
    TokenMapping.Data = "" $ nLevel * 25;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 6;
    TokenMapping.Data = "" $ nLevel * 35;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 7;
    TokenMapping.Data = "" $ nLevel * 50;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 8;
    TokenMapping.Data = Class'SFXGame'.GetSimpleString(Data.stTech.srName);
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 9;
    TokenMapping.Data = oWorldInfo.GetGlobalVariables().GetIntByName(Data.stTech.nmTech);
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
    TokenMapping.TokenId = 10;
    TokenMapping.Data = "" $ Data.stTech.nLevels;
    Data.ChoiceEntry.m_mapTokenIDToActual.AddItem(TokenMapping);
}

function SetupResearch(ResearchMenu Menu)
{
    local TechData ResearchData;
    local BioWorldInfo oWorldInfo;
    local SFXPlotTreasure oTreasure;
    local SFXChoiceEntry Choice;
    local BioGlobalVariableTable oGV;
    local int I;
    local int J;
    local int nTechLevel;
    local int nResearchLevel;
    local bool bInOrder;
    local ResearchMenu TmpMenu;
    local String sTmp;
    local String sLargeImage;
    m_ChoiceGUIData.lstChoices.Remove(0, m_ChoiceGUIData.lstChoices.Length);
    m_ChoiceGUIData.lstChoices.Length = 0;
    m_ChoiceGUIData.m_ShowOptionalPane = true;
    if (Menu.Index != 0)
    {
        Choice = m_ResearchTopChoices[0];
        Choice.srChoiceDescription = Menu.srAboutText;
        Choice.srChoiceName = Menu.srAboutLabel;
        Choice.bDisabled = true;
        Choice.bOptionalPaneHideCost = true;
        Choice.oChoiceImage = Class'SFXPlotTreasure'.FindImage(Menu.sImagePath);
        Choice.srChoiceImageTitle = Menu.srAboutLabel;
        m_ChoiceGUIData.lstChoices.AddItem(Choice);
    }
    else
    {
        Choice.bOptionalPaneHideCost = false;
    }
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oTreasure = oWorldInfo.m_oTreasure;
    oTreasure.SetNewResearchAvailable(false);
    oGV = BioWorldInfo(GetWorldInfo()).GetGlobalVariables();
    I = 0;
    while (I < m_ResearchChoices.Length)
    {
        ResearchData = m_ResearchChoices[I];
        nTechLevel = oGV.GetIntByName(ResearchData.stTech.nmTech);
        nResearchLevel = oGV.GetIntByName(ResearchData.stTreasure.nmRequiredTech);
        if (ResearchData.stTech.nLevels <= 1 && nTechLevel > 0)
        {
        }
        else
        {
            if (oGV.GetBool(ResearchData.DisableId))
            {
            }
            else
            {
                if (ResearchData.stTech.nLevels > 1 && nTechLevel >= nResearchLevel)
                {
                }
                else
                {
                    if (oTreasure.DiscoveredResearch(ResearchData.TreasureId) == false)
                    {
                    }
                    else
                    {
                        TokenizeTechData(ResearchData, 1);
                        ResearchData.ChoiceEntry.srChoiceImageTitle = ResearchData.stTech.srTitle;
                        ResearchData.ChoiceEntry.srChoiceTitle = ResearchData.stTech.srName;
                        ResearchData.ChoiceEntry.sChoiceDescription = GetResearchDescription(ResearchData);
                        ResearchData.ChoiceEntry.sChoiceName = oTreasure.GetTechName(ResearchData.stTech, true);
                        ResearchData.ChoiceEntry.bDisabled = !oTreasure.CanAffordTreasure(ResearchData.TreasureId, true);
                        ResearchData.ChoiceEntry.bDisabled = ResearchData.ChoiceEntry.bDisabled || !oTreasure.QualifiesForTreasure(ResearchData.TreasureId);
                        ResearchData.ChoiceEntry.eResource = ResearchData.stTreasure.Resource;
                        ResearchData.ChoiceEntry.nOptionalPaneItemValue = oTreasure.Price(ResearchData.TreasureId, true);
                        ResearchData.ChoiceEntry.bDefaultSelection = ResearchData.TreasureId == oGV.GetInt(nLastUnlockedResearch);
                        sLargeImage = Class'SFXPlotTreasure'.GetTreasureLargeImageResourcePath(ResearchData.TreasureId);
                        ResearchData.ChoiceEntry.oChoiceImage = Class'SFXPlotTreasure'.FindImage(sLargeImage);
                        if (ResearchData.RMode == Menu.Index)
                        {
                            m_ChoiceGUIData.lstChoices.AddItem(ResearchData.ChoiceEntry);
                        }
                        ResearchSubMenus[ResearchData.RMode].m_ResearchChoices.AddItem(ResearchData);
                    }
                }
            }
        }
        I++;
    }
    I = 1;
    while (I < m_ChoiceGUIData.lstChoices.Length)
    {
        J = I + 1;
        while (J < m_ChoiceGUIData.lstChoices.Length)
        {
            if (m_ChoiceGUIData.lstChoices[I].bDisabled == m_ChoiceGUIData.lstChoices[J].bDisabled)
            {
                bInOrder = m_ChoiceGUIData.lstChoices[I].sChoiceName <= m_ChoiceGUIData.lstChoices[J].sChoiceName;
            }
            else
            {
                bInOrder = m_ChoiceGUIData.lstChoices[J].bDisabled;
            }
            if (!bInOrder)
            {
                ResearchData = ResearchSubMenus[Menu.Index].m_ResearchChoices[I - 1];
                Choice = m_ChoiceGUIData.lstChoices[I];
                ResearchSubMenus[Menu.Index].m_ResearchChoices[I - 1] = ResearchSubMenus[Menu.Index].m_ResearchChoices[J - 1];
                m_ChoiceGUIData.lstChoices[I] = m_ChoiceGUIData.lstChoices[J];
                ResearchSubMenus[Menu.Index].m_ResearchChoices[J - 1] = ResearchData;
                m_ChoiceGUIData.lstChoices[J] = Choice;
            }
            J++;
        }
        I++;
    }
    if (Menu.Index == 0)
    {
        foreach ResearchSubMenus(TmpMenu)
        {
            if (TmpMenu.m_ResearchChoices.Length == 0)
            {
                if (RMode == 0 && TmpMenu.Index == 0)
                {
                    sTmp = TmpMenu.srAboutLabel;
                }
                else
                {
                    sTmp = TmpMenu.srTitle;
                }
                Choice.bDisabled = true;
            }
            else
            {
                ClearCustomTokens();
                SetCustomToken(0, "" $ TmpMenu.m_ResearchChoices.Length);
                sTmp = srTokenizedResearchCategoryCounter;
                SetCustomToken(0, TmpMenu.srTitle);
                SetCustomToken(1, sTmp);
                sTmp = srTokenizedResearchCategory;
                Choice.bDisabled = false;
            }
            Choice = m_ResearchTopChoices[0];
            Choice.srChoiceDescription = TmpMenu.srAboutText;
            Choice.sChoiceName = sTmp;
            Choice.oChoiceImage = Class'SFXPlotTreasure'.FindImage(TmpMenu.sImagePath);
            Choice.srChoiceImageTitle = TmpMenu == ResearchSubMenus[0] ? TmpMenu.srAboutLabel : TmpMenu.srTitle;
            Choice.bDisabled = TmpMenu.m_ResearchChoices.Length == 0;
            m_ChoiceGUIData.lstChoices.AddItem(Choice);
        }
        m_ChoiceGUIData.m_ShowOptionalPane = false;
        return;
    }
}

function String TokenizeResearchString(int nLevel)
{
    ClearCustomTokens();
    SetCustomToken(0, nLevel);
    SetCustomToken(1, nLevel * 5);
    SetCustomToken(2, nLevel * 10);
    SetCustomToken(3, nLevel * 15);
    SetCustomToken(4, nLevel * 20);
    SetCustomToken(5, nLevel * 25);
    SetCustomToken(6, nLevel * 35);
    SetCustomToken(7, nLevel * 50);
    return srString;
}

function String GetResearchQualifiesForString(TechData ResearchData)
{
    local SFXPlotTreasure oTreasure;
    local STreasure stTreasure;
    local STech stRequiredTech;
    local int nTechLevel;
    local int nRequiredTechLevel;
    local String sDescription;
    local bool bQualifiesFor;
    oTreasure = BioWorldInfo(GetWorldInfo()).m_oTreasure;
    bQualifiesFor = oTreasure.QualifiesForTreasure(ResearchData.TreasureId);
    if (bQualifiesFor)
    {
        return "";
    }
    stTreasure = oTreasure.TREASURE(ResearchData.TreasureId);
    stRequiredTech = oTreasure.tech(stTreasure.nmRequiredTech);
    nTechLevel = BioWorldInfo(GetWorldInfo()).GetGlobalVariables().GetIntByName(stTreasure.nmRequiredTech);
    nRequiredTechLevel = stTreasure.RequiredTechLevel;
    bQualifiesFor = oTreasure.QualifiesForTreasure(ResearchData.TreasureId);
    ClearCustomTokens();
    SetCustomToken(0, "" $ nRequiredTechLevel - nTechLevel);
    SetCustomToken(1, stRequiredTech.srName);
    if (nRequiredTechLevel - nTechLevel == 1)
    {
        sDescription = srResearchTokenizedDescriptionSingular;
    }
    else
    {
        sDescription = srResearchTokenizedDescriptionPlural;
    }
    return sDescription;
}

function String GetResearchCanAffordString(TechData ResearchData)
{
    local SFXPlotTreasure oTreasure;
    local STreasure stTreasure;
    local int nPlayerCash;
    local int nResearchCost;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oTreasure = oWorldInfo.m_oTreasure;
    if (oTreasure.CanAffordTreasure(ResearchData.TreasureId, true))
    {
        return "";
    }
    stTreasure = oTreasure.TREASURE(ResearchData.TreasureId);
    ClearCustomTokens();
    nResearchCost = oTreasure.Price(ResearchData.TreasureId, true);
    nPlayerCash = SFXInventoryManager(SFXPawn(oWorldInfo.GetLocalPlayerController().Pawn).InvManager).GetResource(stTreasure.Resource);
    SetCustomToken(0, "" $ nResearchCost - nPlayerCash);
    switch (stTreasure.Resource)
    {
        case 4:
            SetCustomToken(1, srEezo);
            break;
        case 5:
            SetCustomToken(1, srIridium);
            break;
        case 6:
            SetCustomToken(1, srPalladium);
            break;
        case 7:
            SetCustomToken(1, srPlatinum);
            break;
        default:
            break;
    }
    return srResearchTokenizedDescriptionResources;
}

function String GetResearchDescription(TechData ResearchData)
{
    local String sQualifiesFor;
    local String sCanAfford;
    local String sDescription;
    local int nNewTechLevel;
    sQualifiesFor = GetResearchQualifiesForString(ResearchData);
    sCanAfford = GetResearchCanAffordString(ResearchData);
    nNewTechLevel = BioWorldInfo(GetWorldInfo()).GetGlobalVariables().GetIntByName(ResearchData.stTech.nmTech) + 1;
    sDescription = TokenizeResearchString(nNewTechLevel, ResearchData.stTech.srDescription);
    if (sQualifiesFor == "" && sCanAfford == "")
    {
        return sDescription;
    }
    else
    {
        ClearCustomTokens();
        SetCustomToken(0, sQualifiesFor);
        SetCustomToken(1, sCanAfford);
        SetCustomToken(2, sDescription);
        sDescription = srResearchDescription;
    }
    return sDescription;
}

function SetupTech()
{
    local TechData TechData;
    local SFXChoiceEntry Choice;
    local int nLevel;
    local int I;
    local int J;
    local BioGlobalVariableTable oGV;
    local SFXPlotTreasure oTreasure;
    local STech stTech;
    local bool bInOrder;
    local String sTechSmallImagePath;
    local String sTechLargeImagePath;
    oTreasure = BioWorldInfo(GetWorldInfo()).m_oTreasure;
    oTreasure.SetNewUpgradesAvailable(false);
    m_ChoiceGUIData.lstChoices.Remove(0, m_ChoiceGUIData.lstChoices.Length);
    m_ChoiceGUIData.lstChoices.Length = 0;
    foreach m_TechTopChoices(Choice)
    {
        m_ChoiceGUIData.lstChoices.AddItem(Choice);
    }
    oGV = BioWorldInfo(GetWorldInfo()).GetGlobalVariables();
    foreach m_TechChoices(TechData)
    {
        nLevel = BioWorldInfo(GetWorldInfo()).GetGlobalVariables().GetIntByName(TechData.stTech.nmTech);
        if (nLevel <= 0)
        {
            continue;
        }
        TokenizeTechData(TechData, nLevel);
        if (TechData.stTech.nLevels > 1)
        {
            stTech = oTreasure.tech(TechData.PlotName);
            TechData.ChoiceEntry.sChoiceName = oTreasure.GetTechName(stTech);
        }
        else
        {
            TechData.ChoiceEntry.sChoiceName = TechData.stTech.srName;
        }
        TechData.ChoiceEntry.srChoiceTitle = TechData.stTech.srName;
        TechData.ChoiceEntry.srChoiceImageTitle = TechData.stTech.srTitle;
        Class'SFXPlotTreasure'.GetTechImageResourcePath(TechData.PlotName, sTechSmallImagePath, sTechLargeImagePath);
        TechData.ChoiceEntry.oChoiceImage = Class'SFXPlotTreasure'.FindImage(sTechLargeImagePath);
        TechData.ChoiceEntry.srChoiceDescription = TechData.stTech.srDescription;
        TechData.ChoiceEntry.bDefaultSelection = TechData.TreasureId == oGV.GetInt(nLastUnlockedTech);
        m_ChoiceGUIData.lstChoices.AddItem(TechData.ChoiceEntry);
    }
    m_ChoiceGUIData.m_ShowOptionalPane = false;
    I = 1;
    while (I < m_ChoiceGUIData.lstChoices.Length)
    {
        J = I + 1;
        while (J < m_ChoiceGUIData.lstChoices.Length)
        {
            bInOrder = m_ChoiceGUIData.lstChoices[I].sChoiceName <= m_ChoiceGUIData.lstChoices[J].sChoiceName;
            if (!bInOrder)
            {
                Choice = m_ChoiceGUIData.lstChoices[I];
                m_ChoiceGUIData.lstChoices[I] = m_ChoiceGUIData.lstChoices[J];
                m_ChoiceGUIData.lstChoices[J] = Choice;
            }
            J++;
        }
        I++;
    }
    if (m_ChoiceGUIData.lstChoices.Length > 0)
    {
        m_ChoiceGUIData.lstChoices[0].oChoiceImage = Class'SFXPlotTreasure'.FindImage(ResearchSubMenus[0].sImagePath);
    }
}

function bool UpdateOp(float fDeltaT)
{
    if (m_bAborted != false)
    {
        OutputLinks[0].bHasImpulse = true;
    }
    if (m_bFinished)
    {
        OutputLinks[0].bHasImpulse = bDidResearch;
        OutputLinks[1].bHasImpulse = !bDidResearch;
    }
    if (m_bAborted || m_bFinished)
    {
        if (m_ChoiceGUIHandler != None)
        {
            m_ChoiceGUIHandler.HideChoiceGUI(true);
            m_ChoiceGUIHandler = None;
        }
        return true;
    }
    return false;
}

final function ChoiceGUIInputPressed(bool bAPressed, int nContext)
{
    switch (Mode)
    {
        case 0:
            HandleInput_TopLevel(bAPressed, nContext);
            break;
        case 2:
            HandleInput_Tech(bAPressed, nContext);
            break;
        case 1:
            HandleInput_Research(bAPressed, nContext);
            break;
    }
}

function ExitGui()
{
    m_bFinished = true;
    GetWorldInfo().bPlayersOnly = m_bWasPaused;
}

final function HandleInput_TopLevel(bool bAPressed, int nContext)
{
    if (!bAPressed && !m_bFinished)
    {
        ExitGui();
        return;
    }
    if (bAPressed && !m_bFinished)
    {
        if (nContext == 0)
        {
            Mode = 2;
            Reset();
        }
        else
        {
            if (nContext == 1)
            {
                Mode = 1;
                Reset();
            }
        }
        return;
    }
}

final function HandleInput_Tech(bool bAPressed, int nContext)
{
    if (!bAPressed && !m_bFinished)
    {
        ExitGui();
    }
}

final function HandleInput_Research(bool bAPressed, int nContext)
{
    local SFXPlotTreasure oTreasure;
    local STreasure stTreasure;
    if (!bAPressed && !m_bFinished)
    {
        if (RMode == 0)
        {
            ExitGui();
            return;
        }
        else
        {
            RMode = 0;
            Reset();
            return;
        }
    }
    if (bAPressed && !m_bFinished)
    {
        if (nContext == 0)
        {
            return;
        }
        if (RMode == 0)
        {
            RMode = nContext;
            Reset();
        }
        else
        {
            if (!m_bMessageBoxActivated)
            {
                m_ChosenTechData = ResearchSubMenus[RMode].m_ResearchChoices[nContext - 1];
                oTreasure = BioWorldInfo(GetWorldInfo()).m_oTreasure;
                if (oTreasure == None || oTreasure.QualifiesForTreasure(m_ChosenTechData.TreasureId) == false)
                {
                    ShowErrorMessageBox(srErrorDoNotQualify);
                }
                else
                {
                    if (oTreasure.CanAffordTreasure(m_ChosenTechData.TreasureId, true) == false)
                    {
                        ShowErrorMessageBox(srErrorCanNotAfford);
                    }
                    else
                    {
                        stTreasure = oTreasure.TREASURE(m_ChosenTechData.TreasureId);
                        ShowResearchMessageBox(stTreasure, m_ChosenTechData.stTech);
                    }
                }
            }
        }
        return;
    }
}

function ShowErrorMessageBox()
{
    local BioMessageBoxOptionalParams stParams;
    m_oMsgBox = MassEffectGuiManager(BioWorldInfo(GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager()).CreateMessageBox();
    m_oMsgBox.SetInputDelegate(MessageInputPressedError);
    stParams.srAText = srErrorAButton;
    stParams.bNoFade = true;
    m_oMsgBox.DisplayMessageBox(srError, stParams);
    m_bMessageBoxActivated = true;
}

function ShowResearchMessageBox(STreasure stTreasure, STech stTech)
{
    local BioMessageBoxOptionalParams stParams;
    ClearCustomTokens();
    SetCustomToken(0, stTech.srName);
    SetCustomToken(1, stTreasure.ResourcePrice);
    switch (stTreasure.Resource)
    {
        case 4:
            SetCustomToken(2, srEezo);
            break;
        case 5:
            SetCustomToken(2, srIridium);
            break;
        case 6:
            SetCustomToken(2, srPalladium);
            break;
        case 7:
            SetCustomToken(2, srPlatinum);
            break;
    }
    m_oMsgBox = MassEffectGuiManager(BioWorldInfo(GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager()).CreateMessageBox();
    m_oMsgBox.SetInputDelegate(MessageInputPressedResearch);
    stParams.srAText = srResearchConfirm;
    stParams.srBText = srResearchCancel;
    stParams.bNoFade = true;
    m_oMsgBox.DisplayMessageBoxEx(srResearchConfirmMessage, stParams);
    m_bMessageBoxActivated = true;
}

final function MessageInputPressedError(bool bAPressed, int nContext)
{
    m_bMessageBoxActivated = false;
}

final function MessageInputPressedResearch(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        DoResearch();
        ExitGui();
    }
    if (m_oMsgBox != None)
    {
        m_oMsgBox.HideMessageBox();
    }
    m_bMessageBoxActivated = false;
}

final function MessageInputPressed(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
    }
    if (m_oMsgBox != None)
    {
        m_oMsgBox.HideMessageBox();
    }
    m_bMessageBoxActivated = false;
}

function ResearchMenuChosen();

function TechMenuChosen();

function TechChosen();

function DoResearch()
{
    local SFXPlotTreasure oTreasure;
    local BioPlayerController oController;
    oTreasure = BioWorldInfo(GetWorldInfo()).m_oTreasure;
    oTreasure.AwardTreasure(m_ChosenTechData.TreasureId, true);
    bDidResearch = true;
    oController = BioWorldInfo(GetWorldInfo()).GetLocalPlayerController();
    oController.UnlockAchievement(47);
}

function ExitChosen();

function TopLevelChosen();

defaultproperties
{
    m_ChoiceGUIData=SFXGameChoiceGUIData_Research'ChoiceGUIData'
    m_TopLevelChoices=System.Byte[]
    m_TechTopChoices=System.Byte[]
    m_ResearchTopChoices=System.Byte[]
    m_ChosenTechData=(TechId=26200,ChoiceEntry=?,PlotName=?,PlotID=?,TreasureId=?,UnlockId=?,stTech=?,stTreasure=?,nContextId=?,RMode=?,DisableId=?)
    srErrorAButton=System.Byte[]
    srErrorCanNotAfford=System.Byte[]
    srErrorDoNotQualify=System.Byte[]
    srErrorKnown=System.Byte[]
    srTechNameLabel=System.Byte[]
    srResearchConfirmMessage=System.Byte[]
    srResearchConfirm=System.Byte[]
    srResearchCancel=System.Byte[]
    srEezo=System.Byte[]
    srPlatinum=System.Byte[]
    srPalladium=System.Byte[]
    srIridium=System.Byte[]
    nLastUnlockedResearch=579
    nLastUnlockedTech=580
    srResearchDescription=System.Byte[]
    srResearchTokenizedDescriptionPlural=System.Byte[]
    srResearchTokenizedDescriptionSingular=System.Byte[]
    srResearchTokenizedDescriptionResources=System.Byte[]
    srUpgradeTokenizedDescription=System.Byte[]
    srTokenizedResearchCategory=System.Byte[]
    srTokenizedResearchCategoryCounter=System.Byte[]
    srTopLevelAButton=System.Byte[]
    ResearchSubMenus=System.Byte[]
    bHasTargets=false
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
    // child object ChoiceGUIData of type SFXGameChoiceGUIData_Research
}
