﻿class SFXSeqAct_ShowCharacterRecordGUI extends BioSequenceLatentAction
    hidecategories(Object);

var bool m_bIsFinished;

event Activated()
{
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    local MassEffectGuiManager oMgr;
    local BioSFPanel oNewPanel;
    bAborted = false;
    m_bIsFinished = false;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    if (oController != None)
    {
        oMgr = MassEffectGuiManager(oController.GetScaleFormManager());
        oNewPanel = oMgr.CreatePanel('CharacterRecord', true);
        if (oNewPanel != None)
        {
            oNewPanel.bFullScreen = true;
            BioSFHandler_CharacterRecord2(oNewPanel.GetDefaultHandler()).SetOnCloseCallback(onScreenClosed);
        }
        else
        {
            bAborted = true;
            m_bIsFinished = true;
        }
    }
}

function bool UpdateOp(float fDeltaT)
{
    if (m_bIsFinished)
    {
        if (!bAborted)
        {
            OutputLinks[0].bHasImpulse = true;
            OutputLinks[1].bHasImpulse = false;
            OutputLinks[2].bHasImpulse = false;
        }
        else
        {
            OutputLinks[0].bHasImpulse = false;
            OutputLinks[1].bHasImpulse = true;
            OutputLinks[2].bHasImpulse = true;
        }
    }
    return m_bIsFinished;
}

function onScreenClosed()
{
    m_bIsFinished = true;
}

event Deactivated()
{
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    local MassEffectGuiManager oMgr;
    local BioSFPanel oPanel;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    if (oController != None)
    {
        oMgr = MassEffectGuiManager(oController.GetScaleFormManager());
        if (oMgr != None)
        {
            oPanel = oMgr.GetPanelByTag('CharacterRecord');
            if (oPanel != None)
            {
                oMgr.RemovePanel(oPanel);
            }
        }
    }
}

defaultproperties
{
    bHasTargets=false
    bManualHandleOutputs=true
    VariableLinks=None
}
