﻿class SFXWeapon extends SFXWeapon_NativeBase
    hidecategories(Navigation)
    config(Weapon)
    abstract;

struct native CoverLeanPosition
{
    var Vector Offset;

    var ECoverDirection Direction;

    var ECoverType Type;

    var array<WeaponAnimType> WeaponTypes;

}

delegate OnWeaponImpact(SFXWeapon Weapon, ImpactInfo Impact);

delegate float GetDamageVocProbabilityMod();

delegate OnWeaponReload(SFXWeapon Weapon);

delegate OnWeaponEquip(SFXWeapon Weapon);

delegate OnWeaponUnequip(SFXWeapon Weapon);

var config array<CoverLeanPosition> CoverLeanPositions;

var const array<int> ResearchUpgradeIds;

var const int DamageUpgradeId;

var const array<???> ResearchUpgradeTokens;

var const array<???> DamageUpgradeTokens;

var transient byte FireModeToBegin;

var config array<Name> FadingParameters;

var transient String AmmoPowerName;

var() /* 00000008 */ ParticleSystemComponent AmmoPowerIconPSCO;

var() /* 00000008 */ ParticleSystemComponent AmmoPowerPSCO;

var() config float ZoomSnapDuration;

var() config float MaxZoomSnapDistance;

var() config float MinZoomSnapDistance;

var() config array<ZoomSnapInfo> ZoomSnapList;

var() config float AimCorrectionAmount;

var() config Vector2D AdhesionRot;

var() config float MaxLateralAdhesionDist;

var() config float CamInputAdhesionDamping;

var() config float MinAdhesionVelocity;

var() config float MaxAdhesionDistance;

var() config float MinAdhesionDistance;

var() config Vector FrictionTargetOffset;

var() config float PeakFrictionHeightScale;

var() config float PeakFrictionRadiusScale;

var() config Vector2D FrictionMultiplierRange;

var() config float PeakFrictionDistance;

var() config float MaxFrictionDistance;

var() config float MinFrictionDistance;

var() String AmmoRTPCName;

var() WwiseEvent SteamReloadNotifySound;

var() WwiseEvent NeedReloadNotifySound;

var() WwiseEvent WeaponCollapseSound;

var() WwiseEvent WeaponExpandSound;

var() WwiseEvent WeaponReloadSound;

var() WwiseEvent WeaponWhipSoundRight;

var() WwiseEvent WeaponWhipSoundLeft;

var() WwiseEvent FireNoAmmoSound;

var WwiseEvent WeaponPowerFireSound;

var() WwiseEvent PlayerFireSound;

var() WwiseEvent FireSound;

var() WwiseEvent DefaultImpactSound;

var config String GUIImage;

// GeneralDescription: StringRefProperty[44]
// ShortDescription: StringRefProperty[44]
// AmmoPrettyName: StringRefProperty[44]
// GUIClassDescription: StringRefProperty[44]
// GUIClassName: StringRefProperty[44]
// PrettyName: StringRefProperty[44]
var() config int IconRef;

var() Object IconResource;

var() Vector MuzzleIdlePosition;

var float AmmoUsedCount;

var int CurrentSpareAmmo;

var config float DamageMod_LongRange;

var config float DamageMod_MediumRange;

var config float DamageMod_ShortRange;

var config float DamageMod_MeleeRange;

var const config float Range_Long;

var const config float Range_Medium;

var const config float Range_Short;

var const config float Range_Melee;

var() config Vector2D ZoomCrosshairRange;

var() config Vector2D CrosshairRange;

var config float MaxMagneticCorrectionAngle;

var config float MagneticCorrectionThresholdAngle;

var() config float ZoomAccFireInterpSpeed;

var() config float ZoomAccFirePenalty;

var() config float AccFireInterpSpeed;

var() config float AccFirePenalty;

var() config float TraceRange;

var() config float RecoilPitchFrequency;

var() config float RecoilYawFrequency;

var() config float RecoilYawBias;

var() config float RecoilYawScale;

var() config float ZoomRecoilCap;

var() config float RecoilCap;

var() config float RecoilMinFadeYaw;

var() config float RecoilMinFadePitch;

var() config float RecoilZoomFadeSpeed;

var() config float RecoilFadeSpeed;

var() config float RecoilInterpSpeed;

var() config float RecoilPitchOscillation;

var() config ScaledFloat ZoomRecoil;

var() config ScaledFloat Recoil;

var() config float MinRefireTime;

var() transient float BurstCount;

var() config float BurstRefireTime;

var() config float BurstRounds;

var config float AmmoPerShot;

var() config float RateOfFireAI;

var() config ScaledFloat RateOfFire;

var() config ScaledFloat MaxZoomAimError;

var() config ScaledFloat MinZoomAimError;

var() config ScaledFloat MaxAimError;

var() config ScaledFloat MinAimError;

var() config float NoAmmoFireSoundDelay;

var() config float SteamSoundThreshold;

var() config float LowAmmoSoundThreshold;

var() config int InitialMagazines;

var() config ScaledFloat MaxSpareAmmo;

var() config ScaledFloat MagSize;

var() config float DamageHench;

var() config float DamageAI;

var() config ScaledFloat Damage;

var transient float StealthDamageIncrease;

var config float LastBulletStrongerPercent;

var transient bool WaitingToBeginFire;

var transient bool bFiringAnimationPlaying;

var transient bool bHolsteringWeapon;

var transient bool bDrawingWeapon;

var transient bool bQuickReloadSucceeded;

var() config float ReloadFailureDuration;

var() config float ReloadSuccessDuration;

var() config float ReloadReactionWindow;

var() config float EjectShellCasingTimeRatio;

var class<DroppedPickup> DroppedAmmoClass;

var float WeaponLevel;

var() Name ShellCasingSocketName;

var() Name MuzzleSocketName;

var float TimeToHideMuzzleFlashPSC;

var() /* 00000008 */ ParticleSystemComponent PSC_MuzFlashEmitter;

var() config float TracerSpawnOffset;

var() /* 00000008 */ ParticleSystemComponent PSC_ReloadVent;

var() /* 00000008 */ ParticleSystemComponent PSC_ShellCasing;

var() TracerSpec TracerInfo;

var config float ShowTracerDistance;

var() MaterialInterface DefaultDecalMaterial;

var /* 00000008 */ transient DecalComponent DefaultDecalProperties;

var() float ImpactScale;

var() ParticleSystem PS_DefaultMaterialImpactEffect;

var() ParticleSystem PS_DefaultImpactEffect;

var config float ImpactRelevanceDistance;

var ForceFeedbackWaveform WeaponFireWaveForm;

var const array<Name> AimOffsetProfileNames;

var byte FireOnceFiringMode;

var EAttachSlot CharacterSlot;

var const EAttachSlot AttachSlot;

var() WeaponAnimType AnimType;

var config float fAmmoMultiplier;

var const int SwitchPriority;

var transient float fHeatDissipationCooldown;

var transient float fHeatDissipation;

var() config float ZoomFOV;

var(AI) config Vector2D AI_AimDelay;

var(AI) config Vector2D AI_HenchBurstFireMultiplier;

var(AI) config Vector2D AI_BurstFireMovingDelay;

var(AI) config Vector2D AI_BurstFireDelay;

var(AI) config Vector2D AI_BurstFireCount;

var(AI) config Vector2D AI_AccCone_Max;

var(AI) config Vector2D AI_AccCone_Min;

var(MELEE) Name MeleePowerName;

var bool bScaleAnimDurationByFireRate;

var() config bool bZoomSnapEnabled;

var() config bool bAdhesionDuringCam;

var() config bool bAdhesionEnabled;

var() config bool bFrictionDistanceScalingEnabled;

var() config bool bFrictionEnabled;

var config bool bNotRegularWeaponGUI;

var() bool bWeaponCanBeReloaded;

var() config bool bCanDropAmmo;

var() config bool bCanDropWeapon;

var() config bool bIsAutomatic;

var bool bForceSpawnTracer;

var config bool bUseSniperCam;

var bool bEarlyReload;

var bool bPlayerUsable;

var config bool bUpgradesBasicWeapon;

var(Debug) bool bSuppressDecal;

var(Debug) bool bSuppressAudio;

var(Debug) bool bSuppressImpactFX;

var(Debug) bool bSuppressTracers;

var(Debug) bool bSuppressMuzzleFlash;

var(Debug) config bool bInfiniteAmmo;

var(Debug) bool bSuperDamage;

var(Debug) Rotator DebugShotAimRot;

var(Debug) Vector DebugShotStartLoc;

enum FireModes
{
    FireMode_Firing,
    FireMode_Reload,
    FireMode_Failed,
};

enum WeaponAnimType
{
    WeaponAnimType_Pistol,
    WeaponAnimType_Shotgun,
    WeaponAnimType_Rifle,
    WeaponAnimType_Sniper,
    WeaponAnimType_GrenadeLauncher,
    WeaponAnimType_MissileLauncher,
    WeaponAnimType_NukeLauncher,
    WeaponAnimType_ParticleBeam,
    WeaponAnimType_RepulsorBeam,
    WeaponAnimType_AutoShotgun,
    WeaponAnimType_AutoSniper,
    WeaponAnimType_AutoPistol,
};

struct TracerSpec
{
    var() StaticMesh StaticMesh;

    var() ParticleSystem PSTemplate;

    var() Vector Scale3D;

    var() float AccelRate;

    var() float Speed;

    var() float MaxSpeed;

}

struct ZoomSnapInfo
{
    var() config EAimNodes AimNode;

    var() config float OuterSnapAngle;

    var() config float InnerSnapAngle;

    var() config float SnapOffsetMag;

}

simulated function PostBeginPlay()
{
    PostBeginPlay();
    ScaleWeapon(0);
    InitializeAmmo();
    InitDefaultDecalProperties();
    CoverLeanPositions.Length = 0;
}

function float CalculateStaticBonus()
{
    return 1;
}

function ScaleWeapon(int Level)
{
    WeaponLevel = 0;
    Damage.Level = WeaponLevel;
    Damage.StaticBonus = CalculateStaticBonus();
    MinAimError.Level = WeaponLevel;
    MaxAimError.Level = WeaponLevel;
    MinZoomAimError.Level = WeaponLevel;
    MaxZoomAimError.Level = WeaponLevel;
    RateOfFire.Level = WeaponLevel;
    Recoil.Level = WeaponLevel;
    ZoomRecoil.Level = WeaponLevel;
    MagSize.Level = WeaponLevel;
    MaxSpareAmmo.Level = WeaponLevel;
    Class'SFXGame'.ReCalculate(Damage);
    Class'SFXGame'.ReCalculate(MinAimError);
    Class'SFXGame'.ReCalculate(MaxAimError);
    Class'SFXGame'.ReCalculate(MinZoomAimError);
    Class'SFXGame'.ReCalculate(MaxZoomAimError);
    Class'SFXGame'.ReCalculate(RateOfFire);
    Class'SFXGame'.ReCalculate(Recoil);
    Class'SFXGame'.ReCalculate(ZoomRecoil);
    Class'SFXGame'.ReCalculate(MagSize);
    Class'SFXGame'.ReCalculate(MaxSpareAmmo);
}

simulated function InitDefaultDecalProperties()
{
    DefaultDecalProperties = new(self,Class'DecalComponent');
    DefaultDecalProperties.Width = 9;
    DefaultDecalProperties.Height = 9;
    DefaultDecalProperties.Thickness = 10;
    DefaultDecalProperties.bNoClip = false;
    DefaultDecalProperties.DecalMaterial = DefaultDecalMaterial;
}

function BurstRefireTimer();

simulated function StartBurstFire(byte FireModeNum)
{
    local float fBurstTime;
    if (MinRefireTime > 0 && FireModeNum == 0)
    {
        if (IsTimerActive('BurstRefireTimer'))
        {
            return;
        }
        fBurstTime = BurstRounds * GetFireInterval(0);
        SetTimer(MinRefireTime + fBurstTime, false, 'BurstRefireTimer');
    }
    StartFire(FireModeNum);
}

simulated function EndFire(byte FireModeNum)
{
    EndFire(FireModeNum);
    BurstCount = 0;
    ClearTimer('RefireBurst');
    WaitingToBeginFire = false;
}

simulated function ForceEndFire()
{
    ClearTimer('PlayNoAmmoFireSound');
    ForceEndFire();
}

simulated function Projectile ProjectileFire()
{
    local BioPlayerController PC;
    local Vector ProjLoc;
    local Vector ProjDir;
    local SFXProjectile SpawnedProjectile;
    if (Instigator != None && Instigator.IsHumanControlled())
    {
        PC = BioPlayerController(Instigator.Controller);
        if (PC != None)
        {
            PC.HintSystem.HintEvent('Fire', Class.Name);
        }
    }
    IncrementFlashCount();
    if (WorldInfo.NetMode != 3)
    {
        GetProjectileFirePosition(ProjLoc, ProjDir);
        SpawnedProjectile = SFXProjectile(SFXGame(WorldInfo.Game).ObjectPool.GetProjectile(GetProjectileClass(), self, self.Instigator, ProjLoc, ProjDir));
        if (SpawnedProjectile != None && !SpawnedProjectile.bDeleteMe)
        {
            SpawnedProjectile.Init(ProjDir);
            SpawnedProjectile.bSuppressAudio = bSuppressAudio;
        }
        return SpawnedProjectile;
    }
    return None;
}

simulated function Vector GetPhysicalFireStartLoc(optional Vector AimDir)
{
    return GetMuzzleLoc();
}

simulated function GetProjectileFirePosition(out Vector out_ProjLoc, out Vector out_ProjDir)
{
    local Vector StartTrace;
    local Vector EndTrace;
    local ImpactInfo TestImpact;
    StartTrace = Instigator.GetWeaponStartTraceLocation();
    out_ProjDir = GetAdjustedAim(StartTrace);
    out_ProjLoc = GetPhysicalFireStartLoc(out_ProjDir);
    if (StartTrace != out_ProjLoc)
    {
        EndTrace = StartTrace + out_ProjDir * GetTraceRange();
        TestImpact = CalcWeaponFire(StartTrace, EndTrace);
        if (!FastTrace(TestImpact.HitLocation, out_ProjLoc))
        {
            out_ProjLoc = StartTrace;
        }
        out_ProjDir = Normal(TestImpact.HitLocation - out_ProjLoc);
    }
}

simulated function bool UseFirstPersonCamera()
{
    return false;
}

function NotifyUnpossessed();

simulated function float GetFireModeBaseDamage()
{
    local float BaseDamage;
    BaseDamage = Damage.Value;
    if (Instigator != None && Instigator.IsHumanControlled() == false)
    {
        if (SFXPawn_Henchman(Instigator) != None)
        {
            BaseDamage *= DamageHench;
        }
        else
        {
            BaseDamage *= DamageAI;
        }
    }
    return BaseDamage;
}

simulated function ModifyDamage(out float Multiplier, Vector HitLocation, optional Actor HitActor)
{
    local float Range;
    local float RangeMultiplier;
    local SFXPRI OwnerPRI;
    OwnerPRI = SFXPRI(Instigator.Controller.PlayerReplicationInfo);
    GetRangeMultiplier(RangeMultiplier, Range, HitLocation, HitActor);
    Multiplier += RangeMultiplier - 1;
    OwnerPRI.LastDamageCalculation.RangeMultiplier = RangeMultiplier;
    OwnerPRI.LastDamageCalculation.LastBulletMultiplier = 1;
    if (Instigator != None && Instigator.IsHumanControlled() && GetMagazineSize() - AmmoUsedCount == 0 && Range <= Range_Melee)
    {
        Multiplier += LastBulletStrongerPercent;
        OwnerPRI.LastDamageCalculation.LastBulletMultiplier = 1 + LastBulletStrongerPercent;
    }
    OwnerPRI.LastDamageCalculation.StealthMultiplier = 1;
    if (StealthDamageIncrease > 0)
    {
        Multiplier += StealthDamageIncrease;
        OwnerPRI.LastDamageCalculation.StealthMultiplier = 1 + StealthDamageIncrease;
    }
    Multiplier += OwnerPRI.WeaponPassiveDamageBonus - 1;
    OwnerPRI.LastDamageCalculation.PassiveGEMultiplier = OwnerPRI.WeaponPassiveDamageBonus;
    if (bSuperDamage)
    {
        Multiplier = 100;
    }
}

simulated function GetRangeMultiplier(out float RangeMultiplier, out float Range, Vector HitLocation, optional Actor HitActor)
{
    if (Instigator != None)
    {
        Range = VSize(HitLocation - Instigator.Location);
    }
    else
    {
        Range = VSize(HitLocation - Location);
    }
    RangeMultiplier = 1;
    if (Range <= Range_Melee)
    {
        RangeMultiplier = GetRangeValueByPct(vect2d(DamageMod_MeleeRange, DamageMod_ShortRange), Range / Range_Melee);
    }
    else
    {
        if (Range <= Range_Short)
        {
            RangeMultiplier = GetRangeValueByPct(vect2d(DamageMod_ShortRange, DamageMod_MediumRange), Range - Range_Melee / Range_Short - Range_Melee);
        }
        else
        {
            if (Range <= Range_Medium)
            {
                RangeMultiplier = GetRangeValueByPct(vect2d(DamageMod_MediumRange, DamageMod_LongRange), Range - Range_Short / Range_Medium - Range_Short);
            }
            else
            {
                if (Range <= Range_Long)
                {
                    RangeMultiplier = DamageMod_LongRange;
                }
                else
                {
                    RangeMultiplier = DamageMod_LongRange * Range_Long / Range;
                }
            }
        }
    }
}

simulated function class<SFXDamageType> GetDamageType(byte FiringMode)
{
    return Class<SFXDamageType>(InstantHitDamageTypes[FiringMode]);
}

simulated function bool OutOfAmmo()
{
    return GetCurrentTotalAmmo() == 0;
}

simulated function float GetMagazineSize()
{
    return MagSize.Value;
}

simulated function float GetMaxSpareAmmo()
{
    return MaxSpareAmmo.Value;
}

simulated function float GetCurrentSpareAmmo()
{
    return CurrentSpareAmmo;
}

simulated function float GetCurrentTotalAmmo()
{
    return GetCurrentSpareAmmo() + GetAmmoCountInMagazine();
}

simulated function ResetAmmoOnHolster()
{
    if (bInfiniteAmmo)
    {
        AmmoUsedCount = 0;
    }
}

simulated function float GetWeaponRecoil()
{
    local float fRecoil;
    local SFXPRI OwnerPRI;
    if (bIsZoomed)
    {
        fRecoil = ZoomRecoil.Value;
    }
    else
    {
        fRecoil = Recoil.Value;
    }
    OwnerPRI = SFXPRI(Instigator.Controller.PlayerReplicationInfo);
    if (OwnerPRI != None)
    {
        fRecoil *= OwnerPRI.RecoilBonus;
    }
    if (!WorldInfo.IsConsoleBuild())
    {
        fRecoil *= 1,75;
    }
    return fRecoil;
}

simulated function Vector2D GetWeaponAimErrorRange()
{
    local Vector2D AimErrorRange;
    local BioPawn Pawn;
    if (bIsZoomed)
    {
        AimErrorRange.X = MinZoomAimError.Value;
        AimErrorRange.Y = MaxZoomAimError.Value;
    }
    else
    {
        AimErrorRange.X = MinAimError.Value;
        AimErrorRange.Y = MaxAimError.Value;
    }
    Pawn = BioPawn(Owner);
    if (Pawn != None && Pawn.IsHumanControlled())
    {
        if (!Pawn.IsInCover())
        {
            AimErrorRange.X *= SFXGame(WorldInfo.Game).gameconfig.CoverAimBonus;
            AimErrorRange.Y *= SFXGame(WorldInfo.Game).gameconfig.CoverAimBonus;
        }
    }
    return AimErrorRange;
}

simulated function float GetTraceRange()
{
    return TraceRange;
}

simulated function float GetRateOfFire()
{
    local float fRateOfFire;
    fRateOfFire = RateOfFire.Value;
    if (Instigator != None && Instigator.IsHumanControlled() == false)
    {
        fRateOfFire *= RateOfFireAI;
    }
    return fRateOfFire;
}

simulated function Rotator GetAdjustedAim(Vector StartFireLoc)
{
    local Rotator AimRot;
    local float AimingError;
    AimRot = Instigator.GetAdjustedAimFor(self, StartFireLoc);
    if (Instigator.IsHumanControlled())
    {
        AimingError = GetPlayerAimError() * 182,0444;
        if (AimingError > 0)
        {
            AimRot.Pitch += AimingError * 0,5 - FRand();
            AimRot.Yaw += AimingError * 0,5 - FRand();
        }
    }
    return AimRot;
}

simulated function float GetPlayerAimError()
{
    local float Accuracy;
    Accuracy = SFXInventoryManager(InvManager).GetPlayerNormalizedAccuracy();
    return GetAimError(Accuracy);
}

simulated function float GetAimError(float Accuracy)
{
    local float AdjustedAimError;
    local Vector2D AimErrorRange;
    AimErrorRange = GetWeaponAimErrorRange();
    AdjustedAimError = Lerp(AimErrorRange.X, AimErrorRange.Y, Accuracy);
    return AdjustedAimError;
}

function float GetAIAimDelay()
{
    local float AimMultiplier;
    local SFXPRI PRI;
    PRI = Class'SFXPRI'.FindLocalPRI();
    if (PRI != None)
    {
        AimMultiplier = SFXGame(WorldInfo.Game).Difficulty.Default.EnemyAimMultiplier;
    }
    else
    {
        AimMultiplier = 1;
    }
    return AimMultiplier * RandRange(AI_AimDelay.X, AI_AimDelay.Y);
}

simulated function SetZoomed(bool bState)
{
    local BioPlayerController PC;
    bIsZoomed = bState;
    if (bState)
    {
        PC = BioPlayerController(Instigator.Controller);
        if (PC != None)
        {
            PC.HintSystem.HintEvent('Zoom', Class.Name);
        }
    }
}

simulated function SetWeaponRecoil(float PitchRecoil)
{
    local SFXInventoryManager Inv;
    Inv = SFXInventoryManager(InvManager);
    if (Inv != None)
    {
        Inv.SetWeaponRecoil(PitchRecoil);
    }
}

simulated function Vector GetMuzzleLoc()
{
    local SkeletalMeshComponent WeapMesh;
    local Vector Loc;
    local Vector X;
    local Vector Y;
    local Vector Z;
    local Rotator Rot;
    local SFXPawn Pawn;
    Pawn = SFXPawn(Instigator);
    if (Pawn != None && Pawn.bSupportsVisibleWeapons == false)
    {
        if (Pawn.Mesh.GetSocketWorldLocationAndRotation(Pawn.nmMuzzleSocketName, Loc, Rot))
        {
            return Loc;
        }
        else
        {
            return Instigator.Location;
        }
    }
    WeapMesh = SkeletalMeshComponent(Mesh);
    if (WeapMesh != None && MuzzleSocketName != 'None')
    {
        if (WeapMesh.GetSocketWorldLocationAndRotation(MuzzleSocketName, Loc, Rot))
        {
            return Loc;
        }
    }
    if (BioPawn(Instigator) != None && BioPawn(Instigator).GetWeaponHandPosition(Loc, Rot))
    {
        GetAxes(Rot, X, Y, Z);
        return Loc + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
    }
    return Instigator.Location;
}

simulated function bool GetModifiedFOV(out float FOV)
{
    if (bIsZoomed)
    {
        FOV = GetZoomFOV(FOV);
        return true;
    }
    return false;
}

simulated function float GetZoomFOV(float BaseFOV)
{
    if (ZoomFOV <= 0)
    {
        return BaseFOV;
    }
    else
    {
        return ZoomFOV;
    }
}

function InitializeAmmo()
{
    AddAmmo(InitialMagazines * GetMagazineSize());
}

simulated function ConsumeAmmo(byte FireModeNum)
{
    local Name nmStreamingChunk;
    local bool bWasLowAmmo;
    local float fVOThreshLowAmmo;
    local float fCurrentAmmoRatio;
    local float MagazineSize;
    local BioPlayerController PC;
    fVOThreshLowAmmo = 0,2;
    bWasLowAmmo = GetMagazineSize() - AmmoUsedCount / GetMagazineSize() <= fVOThreshLowAmmo ? true : false;
    AmmoUsedCount += AmmoPerShot;
    if (Instigator != None && Instigator.IsHumanControlled())
    {
        PC = BioPlayerController(Instigator.Controller);
        if (PC != None)
        {
            PC.HintSystem.HintEvent('Fire', Class.Name);
        }
        Class'WwiseAudioComponent'.SetGlobalRTPCFromScript(AmmoRTPCName, 1 - AmmoUsedCount / GetMagazineSize());
    }
    if (Instigator != None && SFXPRI(Instigator.PlayerReplicationInfo) != None)
    {
        SFXPRI(Instigator.PlayerReplicationInfo).ShotsFired++;
        SFXPRI(Instigator.PlayerReplicationInfo).ShotsFiredCurrentTarget++;
    }
    if (BurstRounds > 0 && BurstRefireTime > 0)
    {
        BurstCount += 1;
        if (BurstCount >= BurstRounds)
        {
            SetTimer(BurstRefireTime, false, 'RefireBurst');
        }
    }
    if (GetMagazineSize() - AmmoUsedCount < LowAmmoSoundThreshold && Instigator.IsHumanControlled())
    {
        WeaponPlayWwiseEvent(NeedReloadNotifySound, 0);
        if (GetMagazineSize() - AmmoUsedCount == 0 && MaxSpareAmmo.Value == 0)
        {
            SFXGame(WorldInfo.Game).TriggerVocalizationEvent(106, BioPawn(Instigator));
        }
    }
    if (GetMagazineSize() - AmmoUsedCount < SteamSoundThreshold && Instigator.IsHumanControlled())
    {
        WeaponPlayWwiseEvent(SteamReloadNotifySound, 0);
    }
    if (Instigator.IsHumanControlled())
    {
        fCurrentAmmoRatio = GetMagazineSize() - AmmoUsedCount / GetMagazineSize();
        if (!bWasLowAmmo && fCurrentAmmoRatio <= fVOThreshLowAmmo)
        {
            PlayLowAmmoVocalization();
        }
    }
    MagazineSize = GetMagazineSize();
    if (MagazineSize >= 0 && AmmoUsedCount + AmmoPerShot > MagazineSize)
    {
        if (SFXPawn_Player(Owner) != None && SFXPawn_Player(Owner).OutOfAmmoTimestamp == 0)
        {
            SFXPawn_Player(Owner).OutOfAmmoTimestamp = WorldInfo.TimeSeconds;
        }
        if (Instigator.IsHumanControlled())
        {
            BioWorldInfo(WorldInfo).GetCurrentStreamingChunkName(nmStreamingChunk);
            Class'BioTelemetry'.SendEventName('PLAYER_OUT_OF_AMMO', nmStreamingChunk);
        }
    }
}

function PlayLowAmmoVocalization()
{
    SFXGame(WorldInfo.Game).TriggerVocalizationEvent(105, BioPawn(Instigator));
}

function int AddAmmo(int Amount)
{
    local int OldTotalAmmo;
    if (GetMaxSpareAmmo() <= 0)
    {
        return 0;
    }
    OldTotalAmmo = GetCurrentSpareAmmo();
    CurrentSpareAmmo = Max(0, Min(GetCurrentSpareAmmo() + Amount, GetMaxSpareAmmo()));
    return CurrentSpareAmmo - OldTotalAmmo;
}

simulated function bool HasSpareAmmo()
{
    if (Instigator.IsHumanControlled() == false)
    {
        return true;
    }
    return bInfiniteAmmo || GetCurrentSpareAmmo() > 0;
}

simulated function bool HasBurstAmmo(byte FireModeNum)
{
    if (FireModeNum == 1)
    {
        return true;
    }
    if (BurstRounds > 0 && BurstCount >= BurstRounds)
    {
        return false;
    }
    return true;
}

simulated function bool HasAmmo(byte FireModeNum, optional int Amount)
{
    local float MagazineSize;
    if (FireModeNum == 1)
    {
        return true;
    }
    if (!Pawn(Owner).IsHumanControlled())
    {
        return true;
    }
    if (Amount < AmmoPerShot)
    {
        Amount = AmmoPerShot;
    }
    MagazineSize = GetMagazineSize();
    if (MagazineSize >= 0 && AmmoUsedCount + Amount > MagazineSize)
    {
        return false;
    }
    return true;
}

simulated function bool HasAnyAmmo()
{
    return HasAmmo(0) || HasSpareAmmo();
}

simulated function float GetFireInterval(byte FireModeNum)
{
    return 60 / GetRateOfFire();
}

simulated function int GetAmmoCountInMagazine()
{
    return GetMagazineSize() - AmmoUsedCount;
}

simulated function int GetMaximumAllowedAmmo()
{
    return GetMagazineSize() * InitialMagazines + 1;
}

simulated function InstantFire()
{
    InstantFire();
    fHeatDissipationCooldown = GetFireInterval(0) + 0,25;
    SFXInventoryManager(InvManager).bWeaponFired = true;
}

simulated function ImpactInfo CalcWeaponFire(Vector StartTrace, Vector EndTrace, optional out array<ImpactInfo> ImpactList)
{
    local SFXPlayerCamera Camera;
    local Vector ToPC;
    local Vector CamRot;
    DrawDebugShot(StartTrace, EndTrace);
    if (Instigator != None && Instigator.IsHumanControlled())
    {
        Camera = SFXPlayerCamera(PlayerController(Instigator.Controller).PlayerCamera);
        if (Camera != None)
        {
            ToPC = Instigator.Location - StartTrace;
            CamRot = Camera.CameraCache.POV.Rotation;
            StartTrace += CamRot * ToPC Dot CamRot;
        }
    }
    return Class'SFXGame'.CalcWeaponFire(self, StartTrace, EndTrace, ImpactList);
}

simulated function ProcessInstantHit(byte FiringMode, ImpactInfo Impact)
{
    local Controller CheckPlayer;
    local Vector LineDir;
    local Vector WeapLoc;
    local BioPawn PossiblyHitPawn;
    local BioPlayerController PC;
    local class<SFXDamageType> DamageTypeToUse;
    local BioAiController AI;
    local Vector ClosestPoint;
    local float MomentumMag;
    OnWeaponImpact(self, Impact);
    DamageTypeToUse = GetDamageType(FiringMode);
    MomentumMag = FMax(1, InstantHitMomentum[FiringMode]);
    if (DamageTypeToUse.Default.bRadiusDamage)
    {
        Impact.HitActor.TakeRadiusDamage(Instigator != None ? Instigator.Controller : None, GetFireModeBaseDamage(), DamageTypeToUse.Default.DamageRadius, DamageTypeToUse, MomentumMag, Impact.HitLocation, true, self);
    }
    else
    {
        if (Impact.HitActor != None)
        {
            Impact.HitActor.TakeDamage(GetFireModeBaseDamage(), Instigator != None ? Instigator.Controller : None, Impact.HitLocation, MomentumMag * Impact.RayDir, DamageTypeToUse, Impact.HitInfo, self);
        }
    }
    if (Trigger(Impact.HitActor) != None || TriggerVolume(Impact.HitActor) != None)
    {
        return;
    }
    if (WorldInfo.NetMode != 3)
    {
        if (BioPawn(Impact.HitActor) == None && Instigator != None && Instigator.Controller != None)
        {
            WeapLoc = Instigator != None ? Instigator.Location : Location;
            LineDir = Normal(Impact.HitLocation - WeapLoc);
            PC = BioPlayerController(Instigator.Controller);
            if (PC != None)
            {
                foreach WorldInfo.AllControllers(Class'Controller', CheckPlayer)
                {
                    if (CheckPlayer.Pawn == Instigator || BioPawn(CheckPlayer.Pawn) == None)
                    {
                        continue;
                    }
                    CheckPlayer.CheckNearMiss(Instigator, self, WeapLoc, LineDir, Impact.HitLocation);
                }
            }
            else
            {
                AI = BioAiController(Instigator.Controller);
                if (AI != None && Pawn(AI.FireTarget) != None)
                {
                    CheckPlayer = Pawn(AI.FireTarget).Controller;
                }
                if (CheckPlayer != None)
                {
                    CheckPlayer.CheckNearMiss(Instigator, self, WeapLoc, LineDir, Impact.HitLocation);
                    if (CheckPlayer.Pawn.IsHumanControlled())
                    {
                        if (PointDistToLine(CheckPlayer.Pawn.Location, LineDir, WeapLoc, ClosestPoint) <= 200 || VSize(Impact.HitLocation - CheckPlayer.Pawn.Location) < 200)
                        {
                            if (GetVectorSide(WeapLoc - CheckPlayer.Location, LineDir) == 1)
                            {
                                if (WeaponWhipSoundLeft != None)
                                {
                                    WeaponPlayWwiseEvent(WeaponWhipSoundLeft, 1, CheckPlayer.Location);
                                }
                            }
                            else
                            {
                                if (WeaponWhipSoundRight != None)
                                {
                                    WeaponPlayWwiseEvent(WeaponWhipSoundRight, 1, CheckPlayer.Location);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    if (WorldInfo.NetMode != 1)
    {
        if (Impact.HitActor != None && EffectIsRelevant(Impact.HitLocation, false, ImpactRelevanceDistance))
        {
            PossiblyHitPawn = BioPawn(Impact.HitActor);
            if (PossiblyHitPawn == None)
            {
                SpawnImpactEffects(Impact);
                SpawnImpactSounds(Impact);
                SpawnADecal(Impact);
            }
        }
    }
}

simulated function SpawnImpactEffects(ImpactInfo Impact)
{
    local PhysicalMaterial ParentPhysMaterial;
    local ParticleSystem ImpactEffect;
    if (bSuppressImpactFX)
    {
        return;
    }
    if (Impact.HitInfo.PhysMaterial != None)
    {
        ImpactEffect = GetImpactEffect(Impact.HitInfo.PhysMaterial);
        ParentPhysMaterial = Impact.HitInfo.PhysMaterial.Parent;
    }
    else
    {
        if (Impact.HitInfo.Material != None)
        {
            ImpactEffect = GetImpactEffect(Impact.HitInfo.Material.PhysMaterial);
            if (Impact.HitInfo.Material.PhysMaterial != None)
            {
                ParentPhysMaterial = Impact.HitInfo.Material.PhysMaterial.Parent;
            }
        }
    }
    while (ImpactEffect == None && ParentPhysMaterial != None)
    {
        ImpactEffect = GetImpactEffect(ParentPhysMaterial);
        ParentPhysMaterial = ParentPhysMaterial.Parent;
    }
    if (ImpactEffect == None)
    {
        ImpactEffect = PS_DefaultMaterialImpactEffect;
    }
    ActivateImpactPSC(PS_DefaultImpactEffect, Impact);
    ActivateImpactPSC(ImpactEffect, Impact);
}

final simulated private function ActivateImpactPSC(ParticleSystem Template, ImpactInfo Impact)
{
    local SFXObjectPool Pool;
    local ParticleSystemComponent ImpactPSC;
    Pool = SFXGame(WorldInfo.Game).ObjectPool;
    if (Pool != None)
    {
        ImpactPSC = Pool.GetImpactParticleSystemComponent(Template);
        if (ImpactPSC != None)
        {
            Pool.AttachParticleSystemComponent(ImpactPSC, Impact.HitActor, Impact.HitInfo.HitComponent, Impact.HitInfo.BoneName, Impact.HitLocation, Impact.HitNormal, false);
            ImpactPSC.SetScale(ImpactScale);
            Pool.ApplyLODLevel(ImpactPSC, Impact.HitLocation);
            Pool.ApplyBloodColor(ImpactPSC, Impact.HitActor);
            ImpactPSC.SetActive(true);
        }
    }
}

simulated function ParticleSystem GetImpactEffect(PhysicalMaterial PhysMat)
{
    if (PhysMat == None || PhysMat.PhysicalMaterialProperty == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialImpactEffects == None)
    {
        return None;
    }
    return GetWeaponSpecificImpactEffect(SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialImpactEffects);
}

simulated function ParticleSystem GetWeaponSpecificImpactEffect(SFXPhysicalMaterialImpactEffects ImpactEffects);

simulated function SpawnImpactSounds(ImpactInfo Impact)
{
    local PhysicalMaterial ParentPhysMaterial;
    local WwiseEvent ImpactSound;
    if (bSuppressImpactFX || bSuppressAudio)
    {
        return;
    }
    if (Impact.HitInfo.PhysMaterial != None)
    {
        ImpactSound = GetImpactSound(Impact.HitInfo.PhysMaterial);
        ParentPhysMaterial = Impact.HitInfo.PhysMaterial.Parent;
    }
    else
    {
        if (Impact.HitInfo.Material != None)
        {
            ImpactSound = GetImpactSound(Impact.HitInfo.Material.PhysMaterial);
            if (Impact.HitInfo.Material.PhysMaterial != None)
            {
                ParentPhysMaterial = Impact.HitInfo.Material.PhysMaterial.Parent;
            }
        }
    }
    while (ImpactSound == None && ParentPhysMaterial != None)
    {
        ImpactSound = GetImpactSound(ParentPhysMaterial);
        ParentPhysMaterial = ParentPhysMaterial.Parent;
    }
    if (ImpactSound == None)
    {
        ImpactSound = DefaultImpactSound;
    }
    WeaponPlayWwiseEvent(ImpactSound, 1, Impact.HitLocation);
}

simulated function WwiseEvent GetImpactSound(PhysicalMaterial PhysMat)
{
    if (PhysMat == None || PhysMat.PhysicalMaterialProperty == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialImpactSounds == None)
    {
        return None;
    }
    return GetWeaponSpecificImpactSound(SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialImpactSounds);
}

simulated function WwiseEvent GetWeaponSpecificImpactSound(SFXPhysicalMaterialImpactSounds ImpactSounds);

simulated function SpawnADecal(ImpactInfo Impact)
{
    local PhysicalMaterial ParentPhysMaterial;
    local DecalComponent ImpactDecal;
    local float Rand;
    local float RandScaling;
    local float RandRotation;
    local float FadeTime;
    local MaterialInstanceTimeVarying MITV;
    local Name FadeParam;
    if (bSuppressImpactFX || bSuppressDecal)
    {
        return;
    }
    Rand = FRand();
    RandScaling = 1 + Rand * 0,5;
    RandRotation = Rand * 360;
    if (Impact.HitInfo.PhysMaterial != None)
    {
        ImpactDecal = GetDecalData(Impact.HitInfo.PhysMaterial, FadeTime);
        ParentPhysMaterial = Impact.HitInfo.PhysMaterial.Parent;
    }
    else
    {
        if (Impact.HitInfo.Material != None)
        {
            ImpactDecal = GetDecalData(Impact.HitInfo.Material.PhysMaterial, FadeTime);
            if (Impact.HitInfo.Material.PhysMaterial != None)
            {
                ParentPhysMaterial = Impact.HitInfo.Material.PhysMaterial.Parent;
            }
        }
    }
    while (ImpactDecal == None && ParentPhysMaterial != None)
    {
        ImpactDecal = GetDecalData(ParentPhysMaterial, FadeTime);
        ParentPhysMaterial = ParentPhysMaterial.Parent;
    }
    if (ImpactDecal == None)
    {
        ImpactDecal = DefaultDecalProperties;
    }
    if (MaterialInstanceTimeVarying(ImpactDecal.DecalMaterial) != None)
    {
        MITV = new(Class'MaterialInstanceTimeVarying');
        MITV.SetParent(ImpactDecal.DecalMaterial);
        WorldInfo.MyDecalManager.SpawnDecal(MITV, Impact.HitLocation, -Impact.HitNormal, ImpactDecal.Width * RandScaling, ImpactDecal.Height * RandScaling, ImpactDecal.Thickness, ImpactDecal.bNoClip, RandRotation, Impact.HitInfo.HitComponent, false, false, Impact.HitInfo.BoneName, Impact.HitInfo.Item, Impact.HitInfo.LevelIndex);
        MITV.SetScalarStartTime('fade_off', FadeTime);
        foreach FadingParameters(FadeParam)
        {
            MITV.SetScalarStartTime(FadeParam, 0);
        }
    }
    else
    {
        WorldInfo.MyDecalManager.SpawnDecal(ImpactDecal.DecalMaterial, Impact.HitLocation, -Impact.HitNormal, ImpactDecal.Width * RandScaling, ImpactDecal.Height * RandScaling, ImpactDecal.Thickness, ImpactDecal.bNoClip, RandRotation, Impact.HitInfo.HitComponent, false, false, Impact.HitInfo.BoneName, Impact.HitInfo.Item, Impact.HitInfo.LevelIndex);
    }
}

simulated function DecalComponent GetDecalData(PhysicalMaterial PhysMat, out float FadeTime)
{
    if (PhysMat == None || PhysMat.PhysicalMaterialProperty == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) == None || SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialDecals == None)
    {
        return None;
    }
    return GetWeaponSpecificDecalData(SFXPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).PhysicalMaterialDecals, FadeTime);
}

simulated function DecalComponent GetWeaponSpecificDecalData(SFXPhysicalMaterialDecals DecalEffects, out float FadeTime);

simulated event PrecacheVFX()
{
    local SFXGame Game;
    local SFXObjectPool Pool;
    local PhysicalMaterial PhysMat;
    local ParticleSystem PhysMatEffect;
    local ParticleSystem ProjTemplate;
    local StaticMesh ProjMesh;
    Game = SFXGame(WorldInfo.Game);
    if (Game != None)
    {
        Pool = Game.ObjectPool;
        if (Pool != None)
        {
            Pool.PrecacheImpactParticleSystemComponent(PS_DefaultMaterialImpactEffect);
            Pool.PrecacheImpactParticleSystemComponent(PS_DefaultImpactEffect);
            foreach Class'PhysicalMaterial'.AllPhysicalMaterials(PhysMat)
            {
                PhysMatEffect = GetImpactEffect(PhysMat);
                while (PhysMatEffect == None && PhysMat.Parent != None)
                {
                    PhysMat = PhysMat.Parent;
                    PhysMatEffect = GetImpactEffect(PhysMat);
                }
                if (PhysMatEffect != None)
                {
                    Pool.PrecacheImpactParticleSystemComponent(PhysMatEffect);
                }
            }
            ProjTemplate = Class'SFXTracer_Bullet'.Default.ProjEffectsTrailTemplate;
            ProjMesh = TracerInfo.StaticMesh;
            if (ProjMesh == None)
            {
                ProjMesh = StaticMeshComponent(Class'SFXTracer_Bullet'.Default.Mesh).StaticMesh;
            }
            Pool.PrecacheTracer(ProjMesh, ProjTemplate);
        }
    }
}

simulated function PlayFireEffectsOnce(byte FireModeNum, optional Vector HitLocation)
{
    PlayFireEffects(FireModeNum, HitLocation);
    FireOnceFiringMode = FireModeNum;
    SetTimer(GetFireInterval(FireModeNum), false, 'CheckTimerFireOnce');
}

simulated function CheckTimerFireOnce()
{
    StopFireEffects(FireOnceFiringMode);
}

simulated function PlayFireEffects(byte FireModeNum, optional Vector HitLocation)
{
    if (Instigator != None && Instigator.IsHumanControlled())
    {
        if (BioPlayerController(Instigator.Controller) != None)
        {
            BioPlayerController(Instigator.Controller).ClientPlayForceFeedbackWaveform(WeaponFireWaveForm);
        }
    }
    PlayMuzzleFlashEffect();
    PlayOwnedFireEffects(FireModeNum, HitLocation);
}

simulated function PlayMuzzleFlashEffect()
{
    if (!bSuppressMuzzleFlash && IsMuzzleFlashRelevant())
    {
        if (PSC_MuzFlashEmitter != None)
        {
            ClearTimer('HideMuzzleFlashEmitter');
            PSC_MuzFlashEmitter.SetHidden(false);
            PSC_MuzFlashEmitter.ActivateSystem();
        }
    }
}

simulated function bool IsMuzzleFlashRelevant()
{
    if (Instigator == None || Instigator.IsHumanControlled())
    {
        return true;
    }
    if (WorldInfo.bAggressiveLOD && TimeSince(Instigator.LastRenderTime) > 1)
    {
        return false;
    }
    if (TimeSince(Instigator.LastRenderTime) > 2 && IsCameraWithinRadius(Instigator.Location, 256) == false)
    {
        return false;
    }
    return true;
}

simulated function bool IsCameraWithinRadius(Vector TestLocation, float Radius)
{
    local PlayerController PC;
    local Vector CamLoc;
    local Rotator CamRot;
    foreach LocalPlayerControllers(Class'PlayerController', PC)
    {
        PC.GetPlayerViewPoint(CamLoc, CamRot);
        if (VSize(TestLocation - CamLoc) <= Radius)
        {
            return true;
        }
    }
    return false;
}

simulated function StopMuzzleFlashEffect()
{
    if (PSC_MuzFlashEmitter != None)
    {
        PSC_MuzFlashEmitter.SetActive(false);
        SetTimer(TimeToHideMuzzleFlashPSC, false, 'HideMuzzleFlashEmitter');
    }
}

simulated function HideMuzzleFlashEmitter()
{
    PSC_MuzFlashEmitter.SetHidden(true);
}

simulated function HideReloadEmitters()
{
    PSC_ShellCasing.SetHidden(true);
    PSC_ShellCasing.RewindEmitterInstances();
    PSC_ReloadVent.SetHidden(true);
    PSC_ReloadVent.RewindEmitterInstances();
}

simulated function PlayOwnedFireEffects(byte FireModeNum, Vector HitLocation)
{
    if (bForceSpawnTracer || ShouldSpawnTracerFX() && IsZero(HitLocation) == false)
    {
        if (Instigator != None)
        {
            SpawnTracerEffect(HitLocation, VSize(HitLocation - Instigator.Location));
        }
        else
        {
            SpawnTracerEffect(HitLocation, VSize(HitLocation - GetMuzzleLoc()));
        }
    }
    if (WeaponPowerFireSound != None)
    {
        WeaponPlayWwiseEvent(WeaponPowerFireSound, 1);
    }
    if (Instigator != None && Instigator.IsHumanControlled())
    {
        SetWeaponRecoil(GetWeaponRecoil() * 182,0444);
        if (PlayerFireSound != None)
        {
            WeaponPlayWwiseEvent(PlayerFireSound, 1);
            return;
        }
    }
    WeaponPlayWwiseEvent(FireSound, 1);
}

simulated function bool ShouldSpawnTracerFX()
{
    return !bSuppressTracers;
}

simulated function SpawnTracerEffect(Vector HitLocation, float HitDistance)
{
    local SFXObjectPool Pool;
    local ParticleSystem ProjTemplate;
    local StaticMesh ProjMesh;
    local SFXTracer_Bullet SpawnedProjectile;
    local Vector SpawnLoc;
    if (HitDistance > ShowTracerDistance)
    {
        Pool = SFXGame(WorldInfo.Game).ObjectPool;
        if (Pool != None)
        {
            ProjTemplate = Class'SFXTracer_Bullet'.Default.ProjEffectsTrailTemplate;
            ProjMesh = TracerInfo.StaticMesh;
            if (ProjMesh == None)
            {
                ProjMesh = StaticMeshComponent(Class'SFXTracer_Bullet'.Default.Mesh).StaticMesh;
            }
            SpawnedProjectile = SFXTracer_Bullet(Pool.GetTracer(ProjMesh, ProjTemplate));
            if (SpawnedProjectile != None)
            {
                SpawnedProjectile.Speed = TracerInfo.Speed > 0 ? TracerInfo.Speed : SpawnedProjectile.Default.Speed;
                SpawnedProjectile.DesiredScale = TracerInfo.Scale3D;
                SpawnedProjectile.Speed = TracerInfo.Speed;
                SpawnLoc = GetMuzzleLoc() + VRand() * TracerSpawnOffset;
                SpawnedProjectile.InitTracer(SpawnLoc, HitLocation);
            }
        }
    }
}

simulated function WeaponPlayWwiseEvent(WwiseEvent Sound, optional float NoiseLoudness, optional Vector SoundLoc)
{
    if (Sound == None || bSuppressAudio)
    {
        return;
    }
    if (!IsZero(SoundLoc))
    {
        SFXGame(WorldInfo.Game).PlayTransientSound(Sound, SoundLoc);
    }
    else
    {
        if (Instigator != None)
        {
            Instigator.PlaySound(Sound);
        }
        else
        {
            PlaySound(Sound);
        }
    }
    if (NoiseLoudness > 0 && Instigator != None)
    {
        Instigator.MakeNoise(NoiseLoudness);
    }
}

simulated function StopFireEffects(byte FireModeNum)
{
    StopMuzzleFlashEffect();
}

simulated function PlayReloadEject()
{
    PSC_ShellCasing.SetHidden(false);
    PSC_ShellCasing.ActivateSystem();
    if (PSC_ShellCasing.DepthPriorityGroup != Mesh.DepthPriorityGroup)
    {
        PSC_ShellCasing.SetDepthPriorityGroup(Mesh.DepthPriorityGroup);
    }
    PSC_ReloadVent.SetHidden(false);
    PSC_ReloadVent.ActivateSystem();
    if (PSC_ReloadVent.DepthPriorityGroup != Mesh.DepthPriorityGroup)
    {
        PSC_ReloadVent.SetDepthPriorityGroup(Mesh.DepthPriorityGroup);
    }
    SetTimer(5, false, 'HideReloadEmitters');
}

simulated function bool EffectIsRelevant(Vector SpawnLocation, bool bForceDedicated, optional float CullDistance)
{
    if (Instigator == None)
    {
        return true;
    }
    else
    {
        return EffectIsRelevant(SpawnLocation, bForceDedicated, CullDistance);
    }
}

simulated function bool CanReload()
{
    local BioPawn Pawn;
    if (SFXGame(WorldInfo.Game) != None && SFXGame(WorldInfo.Game).gameconfig != None)
    {
        if (SFXGame(WorldInfo.Game).gameconfig.WeaponsUseHeat && AmmoUsedCount < MagSize.Value)
        {
            return false;
        }
    }
    Pawn = BioPawn(Instigator);
    if (Pawn != None && Pawn.CanReload() == false)
    {
        return false;
    }
    return bWeaponCanBeReloaded && AmmoUsedCount > 0 && HasSpareAmmo();
}

simulated function bool ShouldAutoReload()
{
    return CanReload() && GetMagazineSize() > 0 && AmmoUsedCount >= GetMagazineSize();
}

simulated function float GetReloadDuration()
{
    return bQuickReloadSucceeded ? ReloadSuccessDuration : ReloadFailureDuration;
}

simulated function DoEarlyReload()
{
    bEarlyReload = true;
}

simulated function DoReload()
{
    local float Amount;
    OnWeaponReload(self);
    bEarlyReload = false;
    if (bInfiniteAmmo && SFXGame(WorldInfo.Game).gameconfig.WeaponsUseHeat == false || Instigator.IsHumanControlled() == false)
    {
        AmmoUsedCount = 0;
    }
    else
    {
        if (GetMaxSpareAmmo() > 0 && GetCurrentSpareAmmo() > 0)
        {
            Amount = GetCurrentSpareAmmo() - FMax(GetCurrentSpareAmmo() - AmmoUsedCount, 0);
            AmmoUsedCount -= Amount;
            CurrentSpareAmmo -= Amount;
        }
    }
    PlayReloadEject();
    if (SFXPawn_Player(Owner) != None)
    {
        SFXGame(Owner.WorldInfo.Game).gameconfig.bIsFullAmmo = false;
    }
    if (SFXPawn_Player(Owner) != None)
    {
        SFXPawn_Player(Owner).OutOfAmmoTimestamp = 0;
    }
}

simulated function DissipateHeat(float DeltaTime)
{
    if (SFXGame(WorldInfo.Game).gameconfig.WeaponsUseHeat == false || bInfiniteAmmo == false)
    {
        return;
    }
    if (fHeatDissipationCooldown > 0)
    {
        fHeatDissipationCooldown -= DeltaTime;
        return;
    }
    if (AmmoUsedCount == 0)
    {
        fHeatDissipation = 0;
        return;
    }
    fHeatDissipation += MagSize.Value * DeltaTime / SFXGame(WorldInfo.Game).gameconfig.HeatDissipationRate;
    if (fHeatDissipation > 1)
    {
        AmmoUsedCount -= 1;
        fHeatDissipation -= 1;
    }
}

simulated function TryReload(optional bool bDisplayHint = true)
{
    local BioPlayerController PC;
    if (CanReload())
    {
        if (bDisplayHint)
        {
            PC = BioPlayerController(Instigator.Controller);
            if (PC != None)
            {
                PC.HintSystem.HintEvent('ManualReload', Class.Name);
            }
        }
        StartFire(1);
    }
}

simulated function PlayNoAmmoEffects()
{
    PlayNoAmmoFireSound();
    if (NoAmmoFireSoundDelay > 0)
    {
        SetTimer(NoAmmoFireSoundDelay, true, 'PlayNoAmmoFireSound');
    }
}

state Active
{
    simulated function BeginState(Name PreviousStateName)
    {
        local BioPawn MyPawn;
        local int I;
        MyPawn = BioPawn(Owner);
        if (MyPawn != None)
        {
            if (MyPawn.m_oBehavior == None || BioActivePower(MyPawn.m_oBehavior.m_oCurrentModalActive) == None)
            {
                MyPawn.bPortArmsEnabled = true;
            }
        }
        if (bWeaponPutDown)
        {
            PutDownWeapon();
        }
        else
        {
            if (PreviousStateName != 'Reloading' && PendingFire(1) || ShouldAutoReload())
            {
                BeginFire(1);
            }
            else
            {
                if (InvManager != None)
                {
                    I = 0;
                    while (I < InvManager.PendingFire.Length)
                    {
                        if (PendingFire(I))
                        {
                            BeginFire(I);
                        }
                        I++;
                    }
                }
            }
        }
    }

    simulated function BeginFire(byte FireModeNum)
    {
        local BioPawn MyPawn;
        MyPawn = BioPawn(Owner);
        if (MyPawn != None)
        {
            MyPawn.bPortArmsEnabled = false;
            if (MyPawn.bPlayingPortArmsAnim)
            {
                WaitingToBeginFire = true;
                FireModeToBegin = FireModeNum;
                return;
            }
        }
        BeginFireForReal(FireModeNum);
    }

    simulated function BeginFireForReal(byte FireModeNum)
    {
        if (bDeleteMe == false && Instigator != None)
        {
            Global.BeginFire(FireModeNum);
            if (PendingFire(FireModeNum))
            {
                if (HasAnyAmmo())
                {
                    if (HasAmmo(FireModeNum) && HasBurstAmmo(FireModeNum))
                    {
                        SendToFiringState(FireModeNum);
                    }
                    else
                    {
                        if (FireModeNum != 1 && ShouldAutoReload())
                        {
                            SendToFiringState(1);
                        }
                    }
                }
                else
                {
                    PlayNoAmmoEffects();
                }
            }
        }
    }

    simulated function EndFire(byte FireModeNum)
    {
        Global.EndFire(FireModeNum);
        ClearTimer('PlayNoAmmoFireSound');
    }

    function bool IsInPortArms()
    {
        local BioPawn MyPawn;
        MyPawn = BioPawn(Owner);
        if (MyPawn != None)
        {
            return MyPawn.bPlayingPortArmsAnim;
        }
        return false;
    }

Begin:
    while (true)
    {
        while (IsInPortArms())
        {
            Sleep(0,1);
        }
        if (WaitingToBeginFire)
        {
            WaitingToBeginFire = false;
            BeginFireForReal(FireModeToBegin);
        }
        Sleep(0,1);
    }
}

simulated function PlayNoAmmoFireSound()
{
    WeaponPlayWwiseEvent(FireNoAmmoSound);
}

simulated function bool ShouldRefire()
{
    local BioAiController AI;
    if (HasAmmo(0) && BurstRounds != 0 && AmmoUsedCount % BurstRounds != 0)
    {
        return true;
    }
    if (HasBurstAmmo(0) == false)
    {
        return false;
    }
    AI = BioAiController(Instigator.Controller);
    if (AI != None && AI.ShouldRefire() == false)
    {
        return false;
    }
    return ShouldRefire();
}

simulated function RefireBurst()
{
    BurstCount = 0;
    StartFire(0);
}

state StartReload
{
    function TryReload(optional bool bDisplayHint);

    simulated function BeginState(Name PreviousStateName)
    {
        SetCurrentFireMode(1);
        bQuickReloadSucceeded = false;
        WaitForReload();
    }

    simulated function EndState(Name NextStateName)
    {
        ClearTimer('TransitionToReload');
        ClearTimer('WaitForReload');
    }

    simulated function TransitionToReload()
    {
        local BioPlayerController PC;
        PC = BioPlayerController(Instigator.Controller);
        if (PC != None)
        {
            PC.GenerateTutorialEvent(0);
            PC.HintSystem.HintEvent('Reload', Class.Name);
        }
        GotoState('Reloading');
    }

    simulated function WaitForReload()
    {
        local BioPawn Pawn;
        Pawn = BioPawn(Instigator);
        if (Pawn != None && Instigator.IsHumanControlled())
        {
            if (Pawn.IsInCoverLeaning() || Pawn.IsInAnimatedTransition())
            {
                SetTimer(0,1, false, 'WaitForReload');
            }
            else
            {
                TransitionToReload();
            }
        }
        else
        {
            TransitionToReload();
        }
    }

    simulated function bool TryPutDown()
    {
        SetCurrentFireMode(0);
        PutDownWeapon();
        return true;
    }

}

function CancelReload();

simulated function ReloadNearFinished();

state Reloading
{
    function TryReload(optional bool bDisplayHint);

    simulated function BeginState(Name PreviousStateName)
    {
        local float ReloadTime;
        local float ReloadDuration;
        ReloadDuration = GetReloadDuration();
        ReloadTime = ReloadDuration * EjectShellCasingTimeRatio;
        fHeatDissipationCooldown = 999;
        bReloadWeaponBlendOut = false;
        SetTimer(ReloadTime * 0,6, false, 'DoEarlyReload');
        SetTimer(ReloadTime, false, 'DoReload');
        SetTimer(ReloadDuration, false, 'FinishReloading');
    }

    simulated function EndState(Name NextStateName)
    {
        EndFire(1);
        SetCurrentFireMode(0);
        if (AIController(Instigator.Controller) != None)
        {
            AIController(Instigator.Controller).NotifyWeaponFinishedFiring(self, 1);
        }
        bReloadWeaponBlendOut = false;
        ClearTimer('DoEarlyReload');
        ClearTimer('DoReload');
        ClearTimer('FinishReloading');
    }

    simulated function ReloadNearFinished()
    {
        bReloadWeaponBlendOut = true;
    }

    simulated function bool TryPutDown()
    {
        PutDownWeapon();
        return true;
    }

    simulated function FinishReloading()
    {
        GotoState('Active');
        fHeatDissipationCooldown = 0;
    }

    simulated function CancelReload()
    {
        if (bEarlyReload)
        {
            DoReload();
        }
        ClearTimer('DoEarlyReload');
        ClearTimer('DoReload');
        ClearTimer('FinishReloading');
        GotoState('Active');
    }

}

simulated function UnEquipFinished();

simulated function UnEquipTimedOut();

state WeaponPuttingDown
{
    function bool TryPutDown();

    simulated function UnEquipTimedOut()
    {
        bHolsteringWeapon = false;
    }

    simulated function BeginState(Name PreviousStateName)
    {
        bWeaponPutDown = false;
        bHolsteringWeapon = true;
        ForceEndFire();
        OnWeaponUnequip(self);
        SetTimer(2, false, 'UnEquipTimedOut');
    }

    simulated function UnEquipFinished()
    {
        bHolsteringWeapon = false;
    }

Begin:
    while (bHolsteringWeapon)
    {
        Sleep(0,1);
    }
    ClearTimer('UnEquipTimedOut');
    DetachWeapon();
    AttachWeaponTo(BioPawn(Instigator).Mesh, BioPawn(Instigator).AttachSlots[CharacterSlot]);
    if (bWeaponExpanded)
    {
        bInstantExpansion = true;
        Collapse();
    }
    if (InvManager.PendingWeapon == None)
    {
        BioPawn(Instigator).AddWeaponAnimSets(None, SFXWeapon(Instigator.Weapon));
        BioPawn(Instigator).ActionState = 0;
        BioPawn(Instigator).m_oBehavior.m_ePreviousActionState = 1;
        BioPawn(Instigator).m_oBehavior.m_eCurrentActionState = 0;
        Instigator.Controller.BioOnPawnActionStateChanged();
    }
    InvManager.ChangedWeapon();
    GotoState('Inactive');
}

simulated function Expand()
{
    bWeaponExpanded = true;
    if (bInstantExpansion == false)
    {
    }
}

simulated function Collapse()
{
    bWeaponExpanded = false;
    if (bInstantExpansion == false)
    {
    }
}

simulated function EquipNearFinished();

simulated function EquipFinished();

simulated function EquipTimedOut();

state WeaponEquipping
{
    function Activate();

    function bool TryPutDown();

    simulated function EquipTimedOut()
    {
        bDrawingWeapon = false;
    }

    simulated function BeginState(Name PreviousStateName)
    {
        local BioPawn Pawn;
        bWeaponPutDown = false;
        bDrawingWeapon = true;
        bDrawingWeaponBlendOut = false;
        Pawn = BioPawn(Instigator);
        if (Pawn != None)
        {
            if (Pawn.WeaponFromLastGameState == None)
            {
                Pawn.AddWeaponAnimSets(self, None, false);
            }
            else
            {
                Pawn.AddWeaponAnimSets(self, None, true);
            }
        }
        SetTimer(3, false, 'EquipTimedOut');
    }

    simulated function EquipNearFinished()
    {
        bDrawingWeaponBlendOut = true;
    }

    simulated function EquipFinished()
    {
        bDrawingWeapon = false;
        OnWeaponEquip(self);
    }

    simulated function ForceAnimSets()
    {
        local BioPawn BP;
        local SFXWeapon PrevWeapon;
        BP = BioPawn(Instigator);
        PrevWeapon = SFXWeapon(BP.WeaponFromLastGameState);
        BP.AddWeaponAnimSets(self, PrevWeapon, false);
    }

    while (bDrawingWeapon)
    {
        Sleep(0,1);
    }
    ClearTimer('EquipTimedOut');
    DetachWeapon();
    AttachWeaponTo(BioPawn(Instigator).Mesh, BioPawn(Instigator).GetRightHandSocketName());
    ForceAnimSets();
    if (bWeaponExpanded == false)
    {
        bInstantExpansion = true;
        Expand();
    }
    GotoState('Active');
    // invalid native function 205 ;
}

function GivenTo(Pawn thisPawn, optional bool bDoNotActivate)
{
    if (SFXInventoryManager(InvManager) != None)
    {
        if (SFXInventoryManager(InvManager).GetWeaponInSlot(AttachSlot, true) == None)
        {
            bInstantExpansion = true;
            AssignToSlot(AttachSlot);
            jump 79;
        }
    }
    GivenTo(thisPawn, true);
    return;
}

function AssignToSlot(EAttachSlot Slot)
{
    local BioPawn Pawn;
    Pawn = BioPawn(Instigator);
    if (Pawn != None)
    {
        if (Slot != 5)
        {
            AttachWeaponTo(Pawn.Mesh, Pawn.AttachSlots[Slot]);
            CharacterSlot = Slot;
        }
    }
}

simulated function AttachWeaponTo(SkeletalMeshComponent MeshCpnt, optional Name SocketName)
{
    local SkeletalMeshComponent WeaponSkelMesh;
    local SFXPawn Pawn;
    Pawn = SFXPawn(Instigator);
    WeaponSkelMesh = SkeletalMeshComponent(Mesh);
    if (Pawn == None || Pawn.bSupportsVisibleWeapons)
    {
        if (Mesh != None && MeshCpnt.IsComponentAttached(Mesh, SocketName) == false)
        {
            Mesh.SetShadowParent(MeshCpnt);
            Mesh.SetLightEnvironment(BioPawn(Instigator).LightEnvironment);
            Mesh.SetDepthPriorityGroup(MeshCpnt.DepthPriorityGroup);
            if (MeshCpnt.GetSocketByName(SocketName) != None)
            {
                MeshCpnt.AttachComponentToSocket(WeaponSkelMesh, SocketName);
            }
            AttachMuzzleEffectsComponents(WeaponSkelMesh, MuzzleSocketName, ShellCasingSocketName);
        }
    }
    else
    {
        if (Pawn != None)
        {
            AttachMuzzleEffectsComponents(MeshCpnt, Pawn.nmMuzzleSocketName, Pawn.nmShellCasingSocketName);
        }
    }
}

simulated event AttachMuzzleEffectsComponents(SkeletalMeshComponent SkelMesh, optional Name MuzzleSocket, optional Name CasingSocket)
{
    if (SkelMesh != None)
    {
        if (MuzzleSocket != 'None' && PSC_MuzFlashEmitter != None && PSC_MuzFlashEmitter.Owner != SkelMesh)
        {
            if (SkelMesh.GetSocketByName(MuzzleSocket) != None)
            {
                SkelMesh.AttachComponentToSocket(PSC_MuzFlashEmitter, MuzzleSocket);
            }
            else
            {
                SkelMesh.AttachComponent(PSC_MuzFlashEmitter, 'root');
            }
            PSC_MuzFlashEmitter.SetDepthPriorityGroup(SkelMesh.DepthPriorityGroup);
            PSC_MuzFlashEmitter.SetTickGroup(3);
            HideMuzzleFlashEmitter();
        }
        if (CasingSocket != 'None')
        {
            if (PSC_ShellCasing != None && PSC_ShellCasing.Owner != SkelMesh)
            {
                if (SkelMesh.GetSocketByName(CasingSocket) != None)
                {
                    SkelMesh.AttachComponentToSocket(PSC_ShellCasing, CasingSocket);
                }
                else
                {
                    SkelMesh.AttachComponent(PSC_ShellCasing, 'root');
                }
                PSC_ShellCasing.SetDepthPriorityGroup(SkelMesh.DepthPriorityGroup);
                PSC_ShellCasing.SetTickGroup(3);
            }
            if (PSC_ReloadVent != None && PSC_ReloadVent.Owner != SkelMesh)
            {
                if (SkelMesh.GetSocketByName(CasingSocket) != None)
                {
                    SkelMesh.AttachComponentToSocket(PSC_ReloadVent, CasingSocket);
                }
                else
                {
                    SkelMesh.AttachComponent(PSC_ReloadVent, 'root');
                }
                PSC_ReloadVent.SetDepthPriorityGroup(SkelMesh.DepthPriorityGroup);
                PSC_ReloadVent.SetTickGroup(3);
            }
            HideReloadEmitters();
        }
    }
}

simulated function DetachWeapon()
{
    local SkeletalMeshComponent PawnMesh;
    if (Mesh != None)
    {
        if (Instigator != None && Instigator.Mesh != None)
        {
            PawnMesh = Instigator.Mesh;
            if (PawnMesh != None && PawnMesh.IsComponentAttached(Mesh))
            {
                PawnMesh.DetachComponent(Mesh);
            }
        }
        Mesh.SetShadowParent(None);
        Mesh.SetLightEnvironment(None);
    }
}

simulated function bool CanThrow()
{
    return bCanDropWeapon || bCanDropAmmo;
}

function DropFrom(Vector StartLocation, Vector StartVelocity)
{
    local SFXDroppedPickup P;
    local SFXDroppedAmmo Ammo;
    local Pawn PlayerPawn;
    local PlayerController PC;
    if (!CanThrow())
    {
        return;
    }
    ForceEndFire();
    DetachWeapon();
    GotoState('Inactive');
    if (Instigator != None && Instigator.InvManager != None)
    {
        Instigator.InvManager.RemoveFromInventory(self);
    }
    if (DroppedPickupClass == None && DroppedAmmoClass == None)
    {
        Destroy();
        return;
    }
    if (bCanDropWeapon && DroppedPickupClass != None)
    {
        P = SFXDroppedPickup(Spawn(DroppedPickupClass, StartLocation));
        if (P == None)
        {
            Destroy();
            return;
        }
        P.SetPhysics(2);
        P.Inventory = self;
        P.InventoryClass = Class;
        P.Velocity = StartVelocity;
        P.Instigator = Instigator;
        P.SetPickupMesh(Mesh);
        P.SetPickupParticles(DroppedPickupParticles);
        Instigator = None;
        GotoState('None');
    }
    PlayerPawn = BioWorldInfo(WorldInfo).GetLocalPlayerController().Pawn;
    if (PlayerPawn != None)
    {
        PC = PlayerController(PlayerPawn.Controller);
    }
    if (bCanDropAmmo && DroppedAmmoClass != None && Class'SFXDroppedAmmo'.ShouldDropAmmo(self, PC))
    {
        Ammo = SFXDroppedAmmo(SFXGame(WorldInfo.Game).ObjectPool.GetDroppedAmmo(DroppedAmmoClass, StartLocation));
        if (Ammo == None)
        {
            Destroy();
            return;
        }
        Ammo.SetPhysics(2);
        Ammo.Inventory = self;
        Ammo.InventoryClass = Class;
        Ammo.Velocity = StartVelocity;
        Ammo.Instigator = Instigator;
        Ammo.LifeSpan = Ammo.Default.LifeSpan * SFXGame(WorldInfo.Game).Difficulty.Default.AmmoDecayMultiplier;
        Ammo.SetCollisionCylinderSize(12, 2);
        Instigator = None;
        GotoState('None');
    }
}

function HolderDied()
{
    HolderDied();
    GotoState('Inactive');
}

simulated event Destroyed()
{
    Destroyed();
    HideMuzzleFlashEmitter();
    HideReloadEmitters();
}

function EnableAmmoPowerHologram(ParticleSystem Template, ParticleSystem IconTemplate)
{
    local SFXGame oGame;
    local SkeletalMeshComponent oSkeletalMesh;
    oGame = SFXGame(WorldInfo.Game);
    if (oGame == None || Template == None)
    {
        return;
    }
    oSkeletalMesh = SkeletalMeshComponent(Mesh);
    if (oSkeletalMesh == None)
    {
        return;
    }
    if (AmmoPowerPSCO != None)
    {
        AmmoPowerPSCO.SetTemplate(Template);
        oSkeletalMesh.AttachComponentToSocket(AmmoPowerPSCO, 'Modal');
        AmmoPowerPSCO.SetDepthPriorityGroup(oSkeletalMesh.DepthPriorityGroup);
        SFXGame(Owner.WorldInfo.Game).ObjectPool.ApplyLODLevel(AmmoPowerPSCO, Location);
        AmmoPowerPSCO.SetActive(true);
    }
    if (SFXPawn_Player(Owner) != None && AmmoPowerIconPSCO != None)
    {
        AmmoPowerIconPSCO.SetTemplate(IconTemplate);
        oSkeletalMesh.AttachComponentToSocket(AmmoPowerIconPSCO, 'Ammo');
        AmmoPowerIconPSCO.SetDepthPriorityGroup(oSkeletalMesh.DepthPriorityGroup);
        SFXGame(Owner.WorldInfo.Game).ObjectPool.ApplyLODLevel(AmmoPowerIconPSCO, Location);
        AmmoPowerIconPSCO.SetActive(true);
    }
}

function DisableAmmoPowerHologram()
{
    if (AmmoPowerPSCO != None)
    {
        AmmoPowerPSCO.SetActive(false);
    }
    if (AmmoPowerIconPSCO != None)
    {
        AmmoPowerIconPSCO.SetActive(false);
    }
}

simulated function DrawDebugShot(Vector StartLocation, Vector EndLocation);

simulated function GetWeaponDebug(out array<String> DebugInfo);

static function String GetPrettyName()
{
    local int I;
    local int nDamage;
    local int nResearch;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    nDamage = oWorldInfo.GetGlobalVariables().GetInt(Default.DamageUpgradeId);
    I = 0;
    while (I < Default.ResearchUpgradeIds.Length)
    {
        if (oWorldInfo.GetGlobalVariables().GetInt(Default.ResearchUpgradeIds[I]) > 0)
        {
            nResearch = I + 1;
        }
        I++;
    }
    ClearCustomTokens();
    if (nDamage > 0)
    {
        SetCustomToken(0, Class'SFXGame'.GetSimpleString(Default.DamageUpgradeTokens[nDamage - 1]));
    }
    else
    {
        SetCustomToken(0, "");
    }
    if (nResearch < Default.ResearchUpgradeTokens.Length)
    {
        SetCustomToken(1, Caps(Class'SFXGame'.GetSimpleString(Default.ResearchUpgradeTokens[nResearch])));
    }
    else
    {
        SetCustomToken(1, "");
    }
    return Default.PrettyName;
}

static function String GetShortDescription()
{
    return Class'SFXGame'.GetSimpleString(Default.ShortDescription);
}

static function String GetGeneralDescription()
{
    return Class'SFXGame'.GetSimpleString(Default.GeneralDescription);
}

event bool CalculateCoverLeanOutOffset(out Vector Offset, ECoverDirection Direction, ECoverType Type)
{
    local int I;
    local int J;
    I = 0;
    while (I < Default.CoverLeanPositions.Length)
    {
        if (Default.CoverLeanPositions[I].Direction == Direction && Default.CoverLeanPositions[I].Type == Type)
        {
            J = 0;
            while (J < Default.CoverLeanPositions[I].WeaponTypes.Length)
            {
                if (Default.CoverLeanPositions[I].WeaponTypes[J] == AnimType)
                {
                    Offset = Default.CoverLeanPositions[I].Offset;
                    return true;
                }
                ++J;
            }
        }
        ++I;
    }
    return false;
}

defaultproperties
{
    bInfiniteAmmo=true
    bPlayerUsable=true
    bIsAutomatic=true
    bCanDropAmmo=true
    bFrictionEnabled=true
    bAdhesionEnabled=true
    bAdhesionDuringCam=true
    bZoomSnapEnabled=true
    MeleePowerName=Rifle_Butt
    AI_AccCone_Min=(X=1,2,Y=1,2)
    AI_AccCone_Max=(X=1,2,Y=1,2)
    AI_BurstFireCount=(X=1,Y=4)
    AI_HenchBurstFireMultiplier=(X=0,75,Y=0,75)
    AI_AimDelay=(X=0,4,Y=0,4)
    ZoomFOV=40
    fAmmoMultiplier=1
    AttachSlot=EASlot_RightShoulder
    CharacterSlot=None
    AimOffsetProfileNames(0)=Default
    WeaponFireWaveForm=ForceFeedbackWaveform'ForceFeedbackWaveformBase'
    ImpactRelevanceDistance=8000
    PS_DefaultImpactEffect=ParticleSystem'Generic_Imp'
    PS_DefaultMaterialImpactEffect=ParticleSystem'Generic_Material_Imp'
    ImpactScale=1
    DefaultDecalMaterial=MaterialInstanceTimeVarying'DECAL_Blast_Generic_TINST'
    ShowTracerDistance=350
    TracerInfo=(StaticMesh=StructProperty'HitInfo',PSTemplate=None,Scale3D=?,AccelRate=?,Speed=?,MaxSpeed=?)
    PSC_ReloadVent=ParticleSystemComponent'ReloadVent0'
    TimeToHideMuzzleFlashPSC=2
    MuzzleSocketName=Flash
    ShellCasingSocketName=Cooldown
    DroppedAmmoClass=class'SFXDroppedAmmo'
    EjectShellCasingTimeRatio=0,5
    ReloadReactionWindow=0,001
    ReloadSuccessDuration=1,5
    ReloadFailureDuration=1,5
    Damage=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=3,7)
    DamageAI=1
    DamageHench=1
    MagSize=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=34)
    MaxSpareAmmo=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=0)
    MinAimError=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=1,2)
    MaxAimError=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=3,2)
    MinZoomAimError=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=0,2)
    MaxZoomAimError=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=0,6)
    RateOfFire=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=850)
    RateOfFireAI=1
    AmmoPerShot=1
    BurstRounds=1
    Recoil=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=2)
    ZoomRecoil=(X=3,864781E-41,Y=0,MaxLevel=10594,Level=0,Value=5,605194E-45,Bonuses=UnHood.Engine.UnPropertyArray,StaticBonus=1)
    RecoilInterpSpeed=10
    RecoilFadeSpeed=0,88
    RecoilZoomFadeSpeed=0,95
    RecoilCap=10
    ZoomRecoilCap=10
    RecoilYawScale=0,05
    RecoilYawFrequency=4
    TraceRange=8000
    AccFirePenalty=18
    AccFireInterpSpeed=16
    ZoomAccFirePenalty=3,75
    ZoomAccFireInterpSpeed=3,4
    MagneticCorrectionThresholdAngle=2
    MaxMagneticCorrectionAngle=1
    CrosshairRange=(X=35,Y=80)
    ZoomCrosshairRange=(X=25,Y=40)
    Range_Melee=300
    Range_Short=800
    Range_Medium=1500
    Range_Long=2000
    DamageMod_MeleeRange=2
    DamageMod_ShortRange=1,25
    DamageMod_MediumRange=1
    DamageMod_LongRange=1
    MuzzleIdlePosition=(X=80,Y=0,Z=30)
    IconResource=GFxMovieInfo'ME2_Weapon_Icons'
    IconRef=1
    ShortDescription=System.Byte[]
    GeneralDescription=System.Byte[]
    WeaponWhipSoundLeft=WwiseEvent'Play_weapon_whizz_left'
    WeaponWhipSoundRight=WwiseEvent'Play_weapon_whizz_right'
    AmmoRTPCName="Current_Ammo"
    MaxFrictionDistance=5000
    PeakFrictionDistance=2000
    FrictionMultiplierRange=(X=0,28,Y=0,28)
    PeakFrictionRadiusScale=1,25
    PeakFrictionHeightScale=0,4
    FrictionTargetOffset=(X=0,Y=0,Z=22)
    MinAdhesionDistance=100
    MaxAdhesionDistance=6000
    MinAdhesionVelocity=80
    CamInputAdhesionDamping=0,4
    MaxLateralAdhesionDist=125
    AdhesionRot=(X=0,Y=1)
    ZoomSnapList=System.Byte[]
    MinZoomSnapDistance=500
    MaxZoomSnapDistance=4000
    ZoomSnapDuration=0,15
    AmmoPowerPSCO=ParticleSystemComponent'AmmoPowerHologram'
    AmmoPowerIconPSCO=ParticleSystemComponent'AmmoPowerIconHologram'
    FadingParameters(0)=glow
    FadingParameters(1)=inner_glow
    FadingParameters(2)=fade_off
    DamageUpgradeTokens=System.Byte[]
    ResearchUpgradeTokens=System.Byte[]
    CoverLeanPositions=System.Byte[]
    WeaponFireTypes=None
    // child object WeaponMesh of type SkeletalMeshComponent
    // child object ReloadVent0 of type ParticleSystemComponent
    // child object AmmoPowerHologram of type ParticleSystemComponent
    // child object AmmoPowerIconHologram of type ParticleSystemComponent
    // child object ForceFeedbackWaveformBase of type ForceFeedbackWaveform
}
