﻿class SFXWeapon_AutoPistol_Base extends SFXWeapon
    hidecategories(Navigation)
    config(Weapon)
    abstract;

simulated function ModifyDamage(out float BaseDamage, Vector HitLocation, optional Actor HitActor)
{
    ModifyDamage(BaseDamage, HitLocation, HitActor);
    if (Pawn(Owner).InPlayerParty())
    {
        BaseDamage += SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAutoPistolCache - 1;
        SFXPRI(Instigator.PlayerReplicationInfo).LastDamageCalculation.AchievementBonusDamage = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAutoPistolCache;
    }
}

function ScaleWeapon(int Level)
{
    if (Pawn(Owner) != None && Pawn(Owner).InPlayerParty())
    {
        MaxSpareAmmo.StaticBonus = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAutoPistolMaxAmmoCache;
    }
    ScaleWeapon(Level);
}

defaultproperties
{
    WeaponFireWaveForm=ForceFeedbackWaveform'ForceFeedbackWaveformBase'
    PSC_ReloadVent=ParticleSystemComponent'ReloadVent0'
    AmmoPowerPSCO=ParticleSystemComponent'AmmoPowerHologram'
    AmmoPowerIconPSCO=ParticleSystemComponent'AmmoPowerIconHologram'
    VocalizationType=SFXVocalizationWeapon_SMG
    // child object ForceFeedbackWaveformBase of type ForceFeedbackWaveform
    // child object AmmoPowerHologram of type ParticleSystemComponent
    // child object AmmoPowerIconHologram of type ParticleSystemComponent
    // child object ReloadVent0 of type ParticleSystemComponent
    // child object WeaponMesh of type SkeletalMeshComponent
}
