﻿class SFXWeapon_HeavyPistol_Base extends SFXWeapon
    hidecategories(Navigation)
    config(Weapon)
    abstract;

simulated function ModifyDamage(out float BaseDamage, Vector HitLocation, optional Actor HitActor)
{
    ModifyDamage(BaseDamage, HitLocation, HitActor);
    if (Pawn(Owner).InPlayerParty())
    {
        BaseDamage += SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHeavyPistolCache - 1;
        SFXPRI(Instigator.PlayerReplicationInfo).LastDamageCalculation.AchievementBonusDamage = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHeavyPistolCache;
        if (SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHPistolBonusShotCache > 0 && FRand() < SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHPistolBonusShotChance)
        {
            BaseDamage += SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchHPistolBonusShotCache;
        }
    }
}

defaultproperties
{
    WeaponFireWaveForm=ForceFeedbackWaveform'ForceFeedbackWaveformBase'
    PSC_ReloadVent=ParticleSystemComponent'ReloadVent0'
    AmmoPowerPSCO=ParticleSystemComponent'AmmoPowerHologram'
    AmmoPowerIconPSCO=ParticleSystemComponent'AmmoPowerIconHologram'
    VocalizationType=SFXVocalizationWeapon_Pistol
    // child object ForceFeedbackWaveformBase of type ForceFeedbackWaveform
    // child object AmmoPowerHologram of type ParticleSystemComponent
    // child object AmmoPowerIconHologram of type ParticleSystemComponent
    // child object ReloadVent0 of type ParticleSystemComponent
    // child object WeaponMesh of type SkeletalMeshComponent
}
